/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["exports","require","vs/base/common/lifecycle","vs/base/browser/dom","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/nls","vs/base/browser/window","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/map","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/browser/iframe","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],we=function(le){for(var t=[],v=0,T=le.length;v<T;v++)t[v]=$e[le[v]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:Ht,isFrozen:ei,getPrototypeOf:ti,getOwnPropertyDescriptor:ii}=Object;let{freeze:it,seal:ht,create:ni}=Object,{apply:Ft,construct:Ot}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,v,T){return t.apply(v,T)}),it||(it=function(t){return t}),ht||(ht=function(t){return t}),Ot||(Ot=function(t,v){return new t(...v)});const si=lt(Array.prototype.forEach),Ut=lt(Array.prototype.pop),$t=lt(Array.prototype.push),Et=lt(String.prototype.toLowerCase),Tt=lt(String.prototype.toString),ri=lt(String.prototype.match),ut=lt(String.prototype.replace),oi=lt(String.prototype.indexOf),li=lt(String.prototype.trim),ot=lt(RegExp.prototype.test),pt=ai(TypeError);function lt(le){return function(t){for(var v=arguments.length,T=new Array(v>1?v-1:0),i=1;i<v;i++)T[i-1]=arguments[i];return Ft(le,t,T)}}function ai(le){return function(){for(var t=arguments.length,v=new Array(t),T=0;T<t;T++)v[T]=arguments[T];return Ot(le,v)}}function ze(le,t,v){var T;v=(T=v)!==null&&T!==void 0?T:Et,Ht&&Ht(le,null);let i=t.length;for(;i--;){let U=t[i];if(typeof U=="string"){const w=v(U);w!==U&&(ei(t)||(t[i]=w),U=w)}le[U]=!0}return le}function mt(le){const t=ni(null);for(const[v,T]of zt(le))t[v]=T;return t}function At(le,t){for(;le!==null;){const T=ii(le,t);if(T){if(T.get)return lt(T.get);if(typeof T.value=="function")return lt(T.value)}le=ti(le)}function v(T){return console.warn("fallback value for",T),null}return v}const Wt=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Rt=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),hi=it(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),ui=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Vt=it(["#text"]),qt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),_t=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),kt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ci=ht(/\{\{[\w\W]*|[\w\W]*\}\}/gm),fi=ht(/<%[\w\W]*|[\w\W]*%>/gm),di=ht(/\${[\w\W]*}/gm),gi=ht(/^data-[\-\w.\u00B7-\uFFFF]/),mi=ht(/^aria-[\-\w]+$/),Kt=ht(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),bi=ht(/^(?:\w+script|data):/i),$i=ht(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ht(/^html$/i);var xt=Object.freeze({__proto__:null,MUSTACHE_EXPR:ci,ERB_EXPR:fi,TMPLIT_EXPR:di,DATA_ATTR:gi,ARIA_ATTR:mi,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:bi,ATTR_WHITESPACE:$i,DOCTYPE_NAME:Qt});const pi=()=>typeof window>"u"?null:window,wi=function(t,v){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let T=null;const i="data-tt-policy-suffix";v&&v.hasAttribute(i)&&(T=v.getAttribute(i));const U="dompurify"+(T?"#"+T:"");try{return t.createPolicy(U,{createHTML(w){return w},createScriptURL(w){return w}})}catch{return console.warn("TrustedTypes policy "+U+" could not be created."),null}};function Gt(){let le=arguments.length>0&&arguments[0]!==void 0?arguments[0]:pi();const t=Le=>Gt(Le);if(t.version="3.0.5",t.removed=[],!le||!le.document||le.document.nodeType!==9)return t.isSupported=!1,t;const v=le.document,T=v.currentScript;let{document:i}=le;const{DocumentFragment:U,HTMLTemplateElement:w,Node:y,Element:c,NodeFilter:g,NamedNodeMap:f=le.NamedNodeMap||le.MozNamedAttrMap,HTMLFormElement:L,DOMParser:s,trustedTypes:a}=le,e=c.prototype,h=At(e,"cloneNode"),l=At(e,"nextSibling"),m=At(e,"childNodes"),n=At(e,"parentNode");if(typeof w=="function"){const Le=i.createElement("template");Le.content&&Le.content.ownerDocument&&(i=Le.content.ownerDocument)}let r,b="";const{implementation:u,createNodeIterator:o,createDocumentFragment:F,getElementsByTagName:j}=i,{importNode:R}=v;let d={};t.isSupported=typeof zt=="function"&&typeof n=="function"&&u&&u.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:D,ERB_EXPR:B,TMPLIT_EXPR:H,DATA_ATTR:X,ARIA_ATTR:P,IS_SCRIPT_OR_DATA:O,ATTR_WHITESPACE:Q}=xt;let{IS_ALLOWED_URI:te}=xt,re=null;const fe=ze({},[...Wt,...Lt,...Rt,...It,...Vt]);let ie=null;const oe=ze({},[...qt,...Mt,..._t,...kt]);let be=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Se=null,Te=null,Fe=!0,de=!0,ne=!1,ce=!0,Z=!1,V=!1,Y=!1,C=!1,q=!1,$=!1,W=!1,_=!0,p=!1;const A="user-content-";let E=!0,M=!1,k={},I=null;const S=ze({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let N=null;const z=ze({},["audio","video","img","source","image","track"]);let x=null;const ee=ze({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",ge="http://www.w3.org/2000/svg",pe="http://www.w3.org/1999/xhtml";let Pe=pe,Ae=!1,De=null;const Re=ze({},[se,ge,pe],Tt);let Oe;const _e=["application/xhtml+xml","text/html"],He="text/html";let Me,Ke=null;const J=i.createElement("form"),he=function(ue){return ue instanceof RegExp||ue instanceof Function},ve=function(ue){if(!(Ke&&Ke===ue)){if((!ue||typeof ue!="object")&&(ue={}),ue=mt(ue),Oe=_e.indexOf(ue.PARSER_MEDIA_TYPE)===-1?Oe=He:Oe=ue.PARSER_MEDIA_TYPE,Me=Oe==="application/xhtml+xml"?Tt:Et,re="ALLOWED_TAGS"in ue?ze({},ue.ALLOWED_TAGS,Me):fe,ie="ALLOWED_ATTR"in ue?ze({},ue.ALLOWED_ATTR,Me):oe,De="ALLOWED_NAMESPACES"in ue?ze({},ue.ALLOWED_NAMESPACES,Tt):Re,x="ADD_URI_SAFE_ATTR"in ue?ze(mt(ee),ue.ADD_URI_SAFE_ATTR,Me):ee,N="ADD_DATA_URI_TAGS"in ue?ze(mt(z),ue.ADD_DATA_URI_TAGS,Me):z,I="FORBID_CONTENTS"in ue?ze({},ue.FORBID_CONTENTS,Me):S,Se="FORBID_TAGS"in ue?ze({},ue.FORBID_TAGS,Me):{},Te="FORBID_ATTR"in ue?ze({},ue.FORBID_ATTR,Me):{},k="USE_PROFILES"in ue?ue.USE_PROFILES:!1,Fe=ue.ALLOW_ARIA_ATTR!==!1,de=ue.ALLOW_DATA_ATTR!==!1,ne=ue.ALLOW_UNKNOWN_PROTOCOLS||!1,ce=ue.ALLOW_SELF_CLOSE_IN_ATTR!==!1,Z=ue.SAFE_FOR_TEMPLATES||!1,V=ue.WHOLE_DOCUMENT||!1,q=ue.RETURN_DOM||!1,$=ue.RETURN_DOM_FRAGMENT||!1,W=ue.RETURN_TRUSTED_TYPE||!1,C=ue.FORCE_BODY||!1,_=ue.SANITIZE_DOM!==!1,p=ue.SANITIZE_NAMED_PROPS||!1,E=ue.KEEP_CONTENT!==!1,M=ue.IN_PLACE||!1,te=ue.ALLOWED_URI_REGEXP||Kt,Pe=ue.NAMESPACE||pe,be=ue.CUSTOM_ELEMENT_HANDLING||{},ue.CUSTOM_ELEMENT_HANDLING&&he(ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(be.tagNameCheck=ue.CUSTOM_ELEMENT_HANDLING.tagNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&he(ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(be.attributeNameCheck=ue.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),ue.CUSTOM_ELEMENT_HANDLING&&typeof ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(be.allowCustomizedBuiltInElements=ue.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),Z&&(de=!1),$&&(q=!0),k&&(re=ze({},[...Vt]),ie=[],k.html===!0&&(ze(re,Wt),ze(ie,qt)),k.svg===!0&&(ze(re,Lt),ze(ie,Mt),ze(ie,kt)),k.svgFilters===!0&&(ze(re,Rt),ze(ie,Mt),ze(ie,kt)),k.mathMl===!0&&(ze(re,It),ze(ie,_t),ze(ie,kt))),ue.ADD_TAGS&&(re===fe&&(re=mt(re)),ze(re,ue.ADD_TAGS,Me)),ue.ADD_ATTR&&(ie===oe&&(ie=mt(ie)),ze(ie,ue.ADD_ATTR,Me)),ue.ADD_URI_SAFE_ATTR&&ze(x,ue.ADD_URI_SAFE_ATTR,Me),ue.FORBID_CONTENTS&&(I===S&&(I=mt(I)),ze(I,ue.FORBID_CONTENTS,Me)),E&&(re["#text"]=!0),V&&ze(re,["html","head","body"]),re.table&&(ze(re,["tbody"]),delete Se.tbody),ue.TRUSTED_TYPES_POLICY){if(typeof ue.TRUSTED_TYPES_POLICY.createHTML!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof ue.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw pt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');r=ue.TRUSTED_TYPES_POLICY,b=r.createHTML("")}else r===void 0&&(r=wi(a,T)),r!==null&&typeof b=="string"&&(b=r.createHTML(""));it&&it(ue),Ke=ue}},Ee=ze({},["mi","mo","mn","ms","mtext"]),Ce=ze({},["foreignobject","desc","title","annotation-xml"]),Be=ze({},["title","style","font","a","script"]),Ue=ze({},Lt);ze(Ue,Rt),ze(Ue,hi);const Ze=ze({},It);ze(Ze,ui);const Je=function(ue){let ke=n(ue);(!ke||!ke.tagName)&&(ke={namespaceURI:Pe,tagName:"template"});const Ne=Et(ue.tagName),We=Et(ke.tagName);return De[ue.namespaceURI]?ue.namespaceURI===ge?ke.namespaceURI===pe?Ne==="svg":ke.namespaceURI===se?Ne==="svg"&&(We==="annotation-xml"||Ee[We]):!!Ue[Ne]:ue.namespaceURI===se?ke.namespaceURI===pe?Ne==="math":ke.namespaceURI===ge?Ne==="math"&&Ce[We]:!!Ze[Ne]:ue.namespaceURI===pe?ke.namespaceURI===ge&&!Ce[We]||ke.namespaceURI===se&&!Ee[We]?!1:!Ze[Ne]&&(Be[Ne]||!Ue[Ne]):!!(Oe==="application/xhtml+xml"&&De[ue.namespaceURI]):!1},Qe=function(ue){$t(t.removed,{element:ue});try{ue.parentNode.removeChild(ue)}catch{ue.remove()}},Ve=function(ue,ke){try{$t(t.removed,{attribute:ke.getAttributeNode(ue),from:ke})}catch{$t(t.removed,{attribute:null,from:ke})}if(ke.removeAttribute(ue),ue==="is"&&!ie[ue])if(q||$)try{Qe(ke)}catch{}else try{ke.setAttribute(ue,"")}catch{}},tt=function(ue){let ke,Ne;if(C)ue="<remove></remove>"+ue;else{const rt=ri(ue,/^[\r\n\t ]+/);Ne=rt&&rt[0]}Oe==="application/xhtml+xml"&&Pe===pe&&(ue='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+ue+"</body></html>");const We=r?r.createHTML(ue):ue;if(Pe===pe)try{ke=new s().parseFromString(We,Oe)}catch{}if(!ke||!ke.documentElement){ke=u.createDocument(Pe,"template",null);try{ke.documentElement.innerHTML=Ae?b:We}catch{}}const et=ke.body||ke.documentElement;return ue&&Ne&&et.insertBefore(i.createTextNode(Ne),et.childNodes[0]||null),Pe===pe?j.call(ke,V?"html":"body")[0]:V?ke.documentElement:et},nt=function(ue){return o.call(ue.ownerDocument||ue,ue,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},dt=function(ue){return ue instanceof L&&(typeof ue.nodeName!="string"||typeof ue.textContent!="string"||typeof ue.removeChild!="function"||!(ue.attributes instanceof f)||typeof ue.removeAttribute!="function"||typeof ue.setAttribute!="function"||typeof ue.namespaceURI!="string"||typeof ue.insertBefore!="function"||typeof ue.hasChildNodes!="function")},ct=function(ue){return typeof y=="object"?ue instanceof y:ue&&typeof ue=="object"&&typeof ue.nodeType=="number"&&typeof ue.nodeName=="string"},ft=function(ue,ke,Ne){d[ue]&&si(d[ue],We=>{We.call(t,ke,Ne,Ke)})},St=function(ue){let ke;if(ft("beforeSanitizeElements",ue,null),dt(ue))return Qe(ue),!0;const Ne=Me(ue.nodeName);if(ft("uponSanitizeElement",ue,{tagName:Ne,allowedTags:re}),ue.hasChildNodes()&&!ct(ue.firstElementChild)&&(!ct(ue.content)||!ct(ue.content.firstElementChild))&&ot(/<[/\w]/g,ue.innerHTML)&&ot(/<[/\w]/g,ue.textContent))return Qe(ue),!0;if(!re[Ne]||Se[Ne]){if(!Se[Ne]&&gt(Ne)&&(be.tagNameCheck instanceof RegExp&&ot(be.tagNameCheck,Ne)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Ne)))return!1;if(E&&!I[Ne]){const We=n(ue)||ue.parentNode,et=m(ue)||ue.childNodes;if(et&&We){const rt=et.length;for(let xe=rt-1;xe>=0;--xe)We.insertBefore(h(et[xe],!0),l(ue))}}return Qe(ue),!0}return ue instanceof c&&!Je(ue)||(Ne==="noscript"||Ne==="noembed"||Ne==="noframes")&&ot(/<\/no(script|embed|frames)/i,ue.innerHTML)?(Qe(ue),!0):(Z&&ue.nodeType===3&&(ke=ue.textContent,ke=ut(ke,D," "),ke=ut(ke,B," "),ke=ut(ke,H," "),ue.textContent!==ke&&($t(t.removed,{element:ue.cloneNode()}),ue.textContent=ke)),ft("afterSanitizeElements",ue,null),!1)},Ct=function(ue,ke,Ne){if(_&&(ke==="id"||ke==="name")&&(Ne in i||Ne in J))return!1;if(!(de&&!Te[ke]&&ot(X,ke))){if(!(Fe&&ot(P,ke))){if(!ie[ke]||Te[ke]){if(!(gt(ue)&&(be.tagNameCheck instanceof RegExp&&ot(be.tagNameCheck,ue)||be.tagNameCheck instanceof Function&&be.tagNameCheck(ue))&&(be.attributeNameCheck instanceof RegExp&&ot(be.attributeNameCheck,ke)||be.attributeNameCheck instanceof Function&&be.attributeNameCheck(ke))||ke==="is"&&be.allowCustomizedBuiltInElements&&(be.tagNameCheck instanceof RegExp&&ot(be.tagNameCheck,Ne)||be.tagNameCheck instanceof Function&&be.tagNameCheck(Ne))))return!1}else if(!x[ke]){if(!ot(te,ut(Ne,Q,""))){if(!((ke==="src"||ke==="xlink:href"||ke==="href")&&ue!=="script"&&oi(Ne,"data:")===0&&N[ue])){if(!(ne&&!ot(O,ut(Ne,Q,"")))){if(Ne)return!1}}}}}}return!0},gt=function(ue){return ue.indexOf("-")>0},wt=function(ue){let ke,Ne,We,et;ft("beforeSanitizeAttributes",ue,null);const{attributes:rt}=ue;if(!rt)return;const xe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ie};for(et=rt.length;et--;){ke=rt[et];const{name:at,namespaceURI:vt}=ke;if(Ne=at==="value"?ke.value:li(ke.value),We=Me(at),xe.attrName=We,xe.attrValue=Ne,xe.keepAttr=!0,xe.forceKeepAttr=void 0,ft("uponSanitizeAttribute",ue,xe),Ne=xe.attrValue,xe.forceKeepAttr||(Ve(at,ue),!xe.keepAttr))continue;if(!ce&&ot(/\/>/i,Ne)){Ve(at,ue);continue}Z&&(Ne=ut(Ne,D," "),Ne=ut(Ne,B," "),Ne=ut(Ne,H," "));const Dt=Me(ue.nodeName);if(Ct(Dt,We,Ne)){if(p&&(We==="id"||We==="name")&&(Ve(at,ue),Ne=A+Ne),r&&typeof a=="object"&&typeof a.getAttributeType=="function"&&!vt)switch(a.getAttributeType(Dt,We)){case"TrustedHTML":{Ne=r.createHTML(Ne);break}case"TrustedScriptURL":{Ne=r.createScriptURL(Ne);break}}try{vt?ue.setAttributeNS(vt,at,Ne):ue.setAttribute(at,Ne),Ut(t.removed)}catch{}}}ft("afterSanitizeAttributes",ue,null)},Pt=function Le(ue){let ke;const Ne=nt(ue);for(ft("beforeSanitizeShadowDOM",ue,null);ke=Ne.nextNode();)ft("uponSanitizeShadowNode",ke,null),!St(ke)&&(ke.content instanceof U&&Le(ke.content),wt(ke));ft("afterSanitizeShadowDOM",ue,null)};return t.sanitize=function(Le){let ue=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},ke,Ne,We,et;if(Ae=!Le,Ae&&(Le="<!-->"),typeof Le!="string"&&!ct(Le))if(typeof Le.toString=="function"){if(Le=Le.toString(),typeof Le!="string")throw pt("dirty is not a string, aborting")}else throw pt("toString is not a function");if(!t.isSupported)return Le;if(Y||ve(ue),t.removed=[],typeof Le=="string"&&(M=!1),M){if(Le.nodeName){const at=Me(Le.nodeName);if(!re[at]||Se[at])throw pt("root node is forbidden and cannot be sanitized in-place")}}else if(Le instanceof y)ke=tt("<!---->"),Ne=ke.ownerDocument.importNode(Le,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?ke=Ne:ke.appendChild(Ne);else{if(!q&&!Z&&!V&&Le.indexOf("<")===-1)return r&&W?r.createHTML(Le):Le;if(ke=tt(Le),!ke)return q?null:W?b:""}ke&&C&&Qe(ke.firstChild);const rt=nt(M?Le:ke);for(;We=rt.nextNode();)St(We)||(We.content instanceof U&&Pt(We.content),wt(We));if(M)return Le;if(q){if($)for(et=F.call(ke.ownerDocument);ke.firstChild;)et.appendChild(ke.firstChild);else et=ke;return(ie.shadowroot||ie.shadowrootmode)&&(et=R.call(v,et,!0)),et}let xe=V?ke.outerHTML:ke.innerHTML;return V&&re["!doctype"]&&ke.ownerDocument&&ke.ownerDocument.doctype&&ke.ownerDocument.doctype.name&&ot(Qt,ke.ownerDocument.doctype.name)&&(xe="<!DOCTYPE "+ke.ownerDocument.doctype.name+`>
`+xe),Z&&(xe=ut(xe,D," "),xe=ut(xe,B," "),xe=ut(xe,H," ")),r&&W?r.createHTML(xe):xe},t.setConfig=function(Le){ve(Le),Y=!0},t.clearConfig=function(){Ke=null,Y=!1},t.isValidAttribute=function(Le,ue,ke){Ke||ve({});const Ne=Me(Le),We=Me(ue);return Ct(Ne,We,ke)},t.addHook=function(Le,ue){typeof ue=="function"&&(d[Le]=d[Le]||[],$t(d[Le],ue))},t.removeHook=function(Le){if(d[Le])return Ut(d[Le])},t.removeHooks=function(Le){d[Le]&&(d[Le]=[])},t.removeAllHooks=function(){d={}},t}var vi=Gt();define("vs/base/browser/dompurify/dompurify",function(){return vi}),define($e[41],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qQ=t.$pQ=void 0;class v{constructor(w){this.domNode=w,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(w){const y=T(w);this.a!==y&&(this.a=y,this.domNode.style.maxWidth=this.a)}setWidth(w){const y=T(w);this.b!==y&&(this.b=y,this.domNode.style.width=this.b)}setHeight(w){const y=T(w);this.c!==y&&(this.c=y,this.domNode.style.height=this.c)}setTop(w){const y=T(w);this.d!==y&&(this.d=y,this.domNode.style.top=this.d)}setLeft(w){const y=T(w);this.e!==y&&(this.e=y,this.domNode.style.left=this.e)}setBottom(w){const y=T(w);this.f!==y&&(this.f=y,this.domNode.style.bottom=this.f)}setRight(w){const y=T(w);this.g!==y&&(this.g=y,this.domNode.style.right=this.g)}setPaddingTop(w){const y=T(w);this.h!==y&&(this.h=y,this.domNode.style.paddingTop=this.h)}setPaddingLeft(w){const y=T(w);this.i!==y&&(this.i=y,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(w){const y=T(w);this.j!==y&&(this.j=y,this.domNode.style.paddingBottom=this.j)}setPaddingRight(w){const y=T(w);this.k!==y&&(this.k=y,this.domNode.style.paddingRight=this.k)}setFontFamily(w){this.l!==w&&(this.l=w,this.domNode.style.fontFamily=this.l)}setFontWeight(w){this.m!==w&&(this.m=w,this.domNode.style.fontWeight=this.m)}setFontSize(w){const y=T(w);this.n!==y&&(this.n=y,this.domNode.style.fontSize=this.n)}setFontStyle(w){this.o!==w&&(this.o=w,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(w){this.p!==w&&(this.p=w,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(w){this.q!==w&&(this.q=w,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(w){this.r!==w&&(this.r=w,this.domNode.style.textDecoration=this.r)}setLineHeight(w){const y=T(w);this.s!==y&&(this.s=y,this.domNode.style.lineHeight=this.s)}setLetterSpacing(w){const y=T(w);this.t!==y&&(this.t=y,this.domNode.style.letterSpacing=this.t)}setClassName(w){this.u!==w&&(this.u=w,this.domNode.className=this.u)}toggleClassName(w,y){this.domNode.classList.toggle(w,y),this.u=this.domNode.className}setDisplay(w){this.v!==w&&(this.v=w,this.domNode.style.display=this.v)}setPosition(w){this.w!==w&&(this.w=w,this.domNode.style.position=this.w)}setVisibility(w){this.x!==w&&(this.x=w,this.domNode.style.visibility=this.x)}setColor(w){this.y!==w&&(this.y=w,this.domNode.style.color=this.y)}setBackgroundColor(w){this.z!==w&&(this.z=w,this.domNode.style.backgroundColor=this.z)}setLayerHinting(w){this.A!==w&&(this.A=w,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(w){this.C!==w&&(this.C=w,this.domNode.style.boxShadow=w)}setContain(w){this.B!==w&&(this.B=w,this.domNode.style.contain=this.B)}setAttribute(w,y){this.domNode.setAttribute(w,y)}removeAttribute(w){this.domNode.removeAttribute(w)}appendChild(w){this.domNode.appendChild(w.domNode)}removeChild(w){this.domNode.removeChild(w.domNode)}}t.$pQ=v;function T(U){return typeof U=="number"?`${U}px`:U}function i(U){return new v(U)}t.$qQ=i}),define($e[69],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZQ=t.$YQ=t.$XQ=t.ListDragOverEffect=void 0;var v;(function(U){U[U.Copy=0]="Copy",U[U.Move=1]="Move"})(v||(t.ListDragOverEffect=v={})),t.$XQ={reject(){return{accept:!1}},accept(){return{accept:!0}}};class T extends Error{constructor(w,y){super(`ListError [${w}] ${y}`)}}t.$YQ=T;class i{constructor(){this.c=new WeakMap}getHeight(w){return this.c.get(w)??this.d(w)}setDynamicHeight(w,y){y>0&&this.c.set(w,y)}}t.$ZQ=i}),define($e[70],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WQ=void 0;class v{constructor(i){this.a=i}splice(i,U,w){this.a.forEach(y=>y.splice(i,U,w))}}t.$WQ=v}),define($e[42],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vQ=void 0;const v=20;class T{constructor(U,w,y,c,g,f){this.a=Math.round(w),this.b=Math.round(y),this.c=Math.round(U),this.d=c,this.e=g,this.f=f,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new T(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(U){const w=Math.round(U);return this.d!==w?(this.d=w,this.m(),!0):!1}setScrollSize(U){const w=Math.round(U);return this.e!==w?(this.e=w,this.m(),!0):!1}setScrollPosition(U){const w=Math.round(U);return this.f!==w?(this.f=w,this.m(),!0):!1}setScrollbarSize(U){this.a=Math.round(U)}setOppositeScrollbarSize(U){this.b=Math.round(U)}static l(U,w,y,c,g){const f=Math.max(0,y-U),L=Math.max(0,f-2*w),s=c>0&&c>y;if(!s)return{computedAvailableSize:Math.round(f),computedIsNeeded:s,computedSliderSize:Math.round(L),computedSliderRatio:0,computedSliderPosition:0};const a=Math.round(Math.max(v,Math.floor(y*L/c))),e=(L-a)/(c-y),h=g*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:s,computedSliderSize:Math.round(a),computedSliderRatio:e,computedSliderPosition:Math.round(h)}}m(){const U=T.l(this.b,this.c,this.d,this.e,this.f);this.g=U.computedAvailableSize,this.h=U.computedIsNeeded,this.i=U.computedSliderSize,this.j=U.computedSliderRatio,this.k=U.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(U){if(!this.h)return 0;const w=U-this.c-this.i/2;return Math.round(w/this.j)}getDesiredScrollPositionFromOffsetPaged(U){if(!this.h)return 0;const w=U-this.c;let y=this.f;return w<this.k?y-=this.d:y+=this.d,y}getDesiredScrollPositionFromDelta(U){if(!this.h)return 0;const w=this.k+U;return Math.round(w/this.j)}}t.$vQ=T}),define($e[25],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TS=t.$SS=t.$RS=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var v;(function(c){c[c.Hidden=0]="Hidden",c[c.Visible=1]="Visible",c[c.Recurse=2]="Recurse"})(v||(t.TreeVisibility=v={}));var T;(function(c){c[c.Expanded=0]="Expanded",c[c.Collapsed=1]="Collapsed",c[c.PreserveOrExpanded=2]="PreserveOrExpanded",c[c.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(T||(t.ObjectTreeElementCollapseState=T={}));var i;(function(c){c[c.Unknown=0]="Unknown",c[c.Twistie=1]="Twistie",c[c.Element=2]="Element",c[c.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var U;(function(c){c[c.Down=0]="Down",c[c.Up=1]="Up"})(U||(t.TreeDragOverBubble=U={})),t.$RS={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(c=!1){return{accept:!0,bubble:0,autoExpand:c}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(c=!1){return{accept:!0,bubble:0,effect:0,autoExpand:c}}};class w extends Error{constructor(g,f){super(`TreeError [${g}] ${f}`)}}t.$SS=w;class y{constructor(g){this.a=g,this.b=new WeakMap}map(g){let f=this.b.get(g);return f||(f=this.a(g),this.b.set(g,f)),f}}t.$TS=y}),define($e[14],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$window=t.$pO=void 0,t.$pO=window,t.$window=t.$pO}),define($e[71],we([1,0,14]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$MO=t.$LO=void 0;let T=!1,i=null;function U(g){if(!g.parent||g.parent===g)return null;try{const f=g.location,L=g.parent.location;if(f.origin!=="null"&&L.origin!=="null"&&f.origin!==L.origin)return T=!0,null}catch{return T=!0,null}return g.parent}class w{static getSameOriginWindowChain(){if(!i){i=[];let f=v.$window,L;do L=U(f),L?i.push({window:f,iframeElement:f.frameElement||null}):i.push({window:f,iframeElement:null}),f=L;while(f)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),T}static getPositionOfChildWindowRelativeToAncestorWindow(f,L){if(!L||f===L)return{top:0,left:0};let s=0,a=0;const e=this.getSameOriginWindowChain();for(const h of e){if(s+=h.window.scrollY,a+=h.window.scrollX,h.window===L||!h.iframeElement)break;const l=h.iframeElement.getBoundingClientRect();s+=l.top,a+=l.left}return{top:s,left:a}}}t.$LO=w;async function y(g,f){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const L=JSON.stringify({parentOrigin:g,salt:f}),a=new TextEncoder().encode(L),e=await crypto.subtle.digest("sha-256",a);return c(e)}t.$MO=y;function c(g){const L=Array.from(new Uint8Array(g)).map(s=>s.toString(16).padStart(2,"0")).join("");return BigInt(`0x${L}`).toString(32).padStart(52,"0")}}),define($e[72],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=void 0;function v(h,l,m){const n=T(h,l);if(n!==-1)return h[n]}t.$eb=v;function T(h,l,m=h.length-1){for(let n=m;n>=0;n--){const r=h[n];if(l(r))return n}return-1}t.$fb=T;function i(h,l){const m=U(h,l);return m===-1?void 0:h[m]}t.$gb=i;function U(h,l,m=0,n=h.length){let r=m,b=n;for(;r<b;){const u=Math.floor((r+b)/2);l(h[u])?r=u+1:b=u}return r-1}t.$hb=U;function w(h,l){const m=y(h,l);return m===h.length?void 0:h[m]}t.$ib=w;function y(h,l,m=0,n=h.length){let r=m,b=n;for(;r<b;){const u=Math.floor((r+b)/2);l(h[u])?b=u:r=u+1}return r}t.$jb=y;function c(h,l,m=0,n=h.length){const r=y(h,l,m,n);return r===h.length?-1:r}t.$kb=c;class g{static{this.assertInvariants=!1}constructor(l){this.e=l,this.c=0}findLastMonotonous(l){if(g.assertInvariants){if(this.d){for(const n of this.e)if(this.d(n)&&!l(n))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=l}const m=U(this.e,l,this.c);return this.c=m+1,m===-1?void 0:this.e[m]}}t.$lb=g;function f(h,l){if(h.length===0)return;let m=h[0];for(let n=1;n<h.length;n++){const r=h[n];l(r,m)>0&&(m=r)}return m}t.$mb=f;function L(h,l){if(h.length===0)return;let m=h[0];for(let n=1;n<h.length;n++){const r=h[n];l(r,m)>=0&&(m=r)}return m}t.$nb=L;function s(h,l){return f(h,(m,n)=>-l(m,n))}t.$ob=s;function a(h,l){if(h.length===0)return-1;let m=0;for(let n=1;n<h.length;n++){const r=h[n];l(r,h[m])>0&&(m=n)}return m}t.$pb=a;function e(h,l){for(const m of h){const n=l(m);if(n!==void 0)return n}}t.$qb=e}),define($e[73],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$M=t.$L=t.$K=t.$J=void 0;function v(w,y){const c=Object.create(null);for(const g of w){const f=y(g);let L=c[f];L||(L=c[f]=[]),L.push(g)}return c}t.$J=v;function T(w,y){const c=[],g=[];for(const f of w)y.has(f)||c.push(f);for(const f of y)w.has(f)||g.push(f);return{removed:c,added:g}}t.$K=T;function i(w,y){const c=[],g=[];for(const[f,L]of w)y.has(f)||c.push(L);for(const[f,L]of y)w.has(f)||g.push(L);return{removed:c,added:g}}t.$L=i;function U(w,y){const c=new Set;for(const g of y)w.has(g)&&c.add(g);return c}t.$M=U}),define($e[74],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ys=t.$Xs=t.$Ws=t.$Vs=void 0;function v(y,c){const g=Math.pow(10,c);return Math.round(y*g)/g}class T{constructor(c,g,f,L=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,c))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=v(Math.max(Math.min(1,L),0),3)}static equals(c,g){return c.r===g.r&&c.g===g.g&&c.b===g.b&&c.a===g.a}}t.$Vs=T;class i{constructor(c,g,f,L){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=v(Math.max(Math.min(1,g),0),3),this.l=v(Math.max(Math.min(1,f),0),3),this.a=v(Math.max(Math.min(1,L),0),3)}static equals(c,g){return c.h===g.h&&c.s===g.s&&c.l===g.l&&c.a===g.a}static fromRGBA(c){const g=c.r/255,f=c.g/255,L=c.b/255,s=c.a,a=Math.max(g,f,L),e=Math.min(g,f,L);let h=0,l=0;const m=(e+a)/2,n=a-e;if(n>0){switch(l=Math.min(m<=.5?n/(2*m):n/(2-2*m),1),a){case g:h=(f-L)/n+(f<L?6:0);break;case f:h=(L-g)/n+2;break;case L:h=(g-f)/n+4;break}h*=60,h=Math.round(h)}return new i(h,l,m,s)}static i(c,g,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?c+(g-c)*6*f:f<1/2?g:f<2/3?c+(g-c)*(2/3-f)*6:c}static toRGBA(c){const g=c.h/360,{s:f,l:L,a:s}=c;let a,e,h;if(f===0)a=e=h=L;else{const l=L<.5?L*(1+f):L+f-L*f,m=2*L-l;a=i.i(m,l,g+1/3),e=i.i(m,l,g),h=i.i(m,l,g-1/3)}return new T(Math.round(a*255),Math.round(e*255),Math.round(h*255),s)}}t.$Ws=i;class U{constructor(c,g,f,L){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,c),0)|0,this.s=v(Math.max(Math.min(1,g),0),3),this.v=v(Math.max(Math.min(1,f),0),3),this.a=v(Math.max(Math.min(1,L),0),3)}static equals(c,g){return c.h===g.h&&c.s===g.s&&c.v===g.v&&c.a===g.a}static fromRGBA(c){const g=c.r/255,f=c.g/255,L=c.b/255,s=Math.max(g,f,L),a=Math.min(g,f,L),e=s-a,h=s===0?0:e/s;let l;return e===0?l=0:s===g?l=((f-L)/e%6+6)%6:s===f?l=(L-g)/e+2:l=(g-f)/e+4,new U(Math.round(l*60),h,s,c.a)}static toRGBA(c){const{h:g,s:f,v:L,a:s}=c,a=L*f,e=a*(1-Math.abs(g/60%2-1)),h=L-a;let[l,m,n]=[0,0,0];return g<60?(l=a,m=e):g<120?(l=e,m=a):g<180?(m=a,n=e):g<240?(m=e,n=a):g<300?(l=e,n=a):g<=360&&(l=a,n=e),l=Math.round((l+h)*255),m=Math.round((m+h)*255),n=Math.round((n+h)*255),new T(l,m,n,s)}}t.$Xs=U;class w{static fromHex(c){return w.Format.CSS.parseHex(c)||w.red}static equals(c,g){return!c&&!g?!0:!c||!g?!1:c.equals(g)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:U.fromRGBA(this.rgba)}constructor(c){if(c)if(c instanceof T)this.rgba=c;else if(c instanceof i)this.i=c,this.rgba=i.toRGBA(c);else if(c instanceof U)this.j=c,this.rgba=U.toRGBA(c);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(c){return!!c&&T.equals(this.rgba,c.rgba)&&i.equals(this.hsla,c.hsla)&&U.equals(this.hsva,c.hsva)}getRelativeLuminance(){const c=w.k(this.rgba.r),g=w.k(this.rgba.g),f=w.k(this.rgba.b),L=.2126*c+.7152*g+.0722*f;return v(L,4)}static k(c){const g=c/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(c){const g=this.getRelativeLuminance(),f=c.getRelativeLuminance();return g>f?(g+.05)/(f+.05):(f+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(c){const g=this.getRelativeLuminance(),f=c.getRelativeLuminance();return g>f}isDarkerThan(c){const g=this.getRelativeLuminance(),f=c.getRelativeLuminance();return g<f}lighten(c){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*c,this.hsla.a))}darken(c){return new w(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*c,this.hsla.a))}transparent(c){const{r:g,g:f,b:L,a:s}=this.rgba;return new w(new T(g,f,L,s*c))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new w(new T(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(c){const g=c.rgba,f=this.rgba.a,L=g.a,s=f+L*(1-f);if(s<1e-6)return w.transparent;const a=this.rgba.r*f/s+g.r*L*(1-f)/s,e=this.rgba.g*f/s+g.g*L*(1-f)/s,h=this.rgba.b*f/s+g.b*L*(1-f)/s;return new w(new T(a,e,h,s))}makeOpaque(c){if(this.isOpaque()||c.rgba.a!==1)return this;const{r:g,g:f,b:L,a:s}=this.rgba;return new w(new T(c.rgba.r-s*(c.rgba.r-g),c.rgba.g-s*(c.rgba.g-f),c.rgba.b-s*(c.rgba.b-L),1))}flatten(...c){const g=c.reduceRight((f,L)=>w.o(L,f));return w.o(this,g)}static o(c,g){const f=1-c.rgba.a;return new w(new T(f*g.rgba.r+c.rgba.a*c.rgba.r,f*g.rgba.g+c.rgba.a*c.rgba.g,f*g.rgba.b+c.rgba.a*c.rgba.b))}toString(){return this.u||(this.u=w.Format.CSS.format(this)),this.u}static getLighterColor(c,g,f){if(c.isLighterThan(g))return c;f=f||.5;const L=c.getRelativeLuminance(),s=g.getRelativeLuminance();return f=f*(s-L)/s,c.lighten(f)}static getDarkerColor(c,g,f){if(c.isDarkerThan(g))return c;f=f||.5;const L=c.getRelativeLuminance(),s=g.getRelativeLuminance();return f=f*(L-s)/L,c.darken(f)}static{this.white=new w(new T(255,255,255,1))}static{this.black=new w(new T(0,0,0,1))}static{this.red=new w(new T(255,0,0,1))}static{this.blue=new w(new T(0,0,255,1))}static{this.green=new w(new T(0,255,0,1))}static{this.cyan=new w(new T(0,255,255,1))}static{this.lightgrey=new w(new T(211,211,211,1))}static{this.transparent=new w(new T(0,0,0,0))}}t.$Ys=w,function(y){let c;(function(g){let f;(function(L){function s(o){return o.rgba.a===1?`rgb(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b})`:y.Format.CSS.formatRGBA(o)}L.formatRGB=s;function a(o){return`rgba(${o.rgba.r}, ${o.rgba.g}, ${o.rgba.b}, ${+o.rgba.a.toFixed(2)})`}L.formatRGBA=a;function e(o){return o.hsla.a===1?`hsl(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%)`:y.Format.CSS.formatHSLA(o)}L.formatHSL=e;function h(o){return`hsla(${o.hsla.h}, ${(o.hsla.s*100).toFixed(2)}%, ${(o.hsla.l*100).toFixed(2)}%, ${o.hsla.a.toFixed(2)})`}L.formatHSLA=h;function l(o){const F=o.toString(16);return F.length!==2?"0"+F:F}function m(o){return`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}`}L.formatHex=m;function n(o,F=!1){return F&&o.rgba.a===1?y.Format.CSS.formatHex(o):`#${l(o.rgba.r)}${l(o.rgba.g)}${l(o.rgba.b)}${l(Math.round(o.rgba.a*255))}`}L.formatHexA=n;function r(o){return o.isOpaque()?y.Format.CSS.formatHex(o):y.Format.CSS.formatRGBA(o)}L.format=r;function b(o){const F=o.length;if(F===0||o.charCodeAt(0)!==35)return null;if(F===7){const j=16*u(o.charCodeAt(1))+u(o.charCodeAt(2)),R=16*u(o.charCodeAt(3))+u(o.charCodeAt(4)),d=16*u(o.charCodeAt(5))+u(o.charCodeAt(6));return new y(new T(j,R,d,1))}if(F===9){const j=16*u(o.charCodeAt(1))+u(o.charCodeAt(2)),R=16*u(o.charCodeAt(3))+u(o.charCodeAt(4)),d=16*u(o.charCodeAt(5))+u(o.charCodeAt(6)),D=16*u(o.charCodeAt(7))+u(o.charCodeAt(8));return new y(new T(j,R,d,D/255))}if(F===4){const j=u(o.charCodeAt(1)),R=u(o.charCodeAt(2)),d=u(o.charCodeAt(3));return new y(new T(16*j+j,16*R+R,16*d+d))}if(F===5){const j=u(o.charCodeAt(1)),R=u(o.charCodeAt(2)),d=u(o.charCodeAt(3)),D=u(o.charCodeAt(4));return new y(new T(16*j+j,16*R+R,16*d+d,(16*D+D)/255))}return null}L.parseHex=b;function u(o){switch(o){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=g.CSS||(g.CSS={}))})(c=y.Format||(y.Format={}))}(w||(t.$Ys=w={}))}),define($e[26],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kh=t.$jh=t.$ih=void 0;function v(w){return(y,c,g)=>{let f=null,L=null;if(typeof g.value=="function"?(f="value",L=g.value):typeof g.get=="function"&&(f="get",L=g.get),!L)throw new Error("not supported");g[f]=w(L,c)}}function T(w,y,c){let g=null,f=null;if(typeof c.value=="function"?(g="value",f=c.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(g="get",f=c.get),!f)throw new Error("not supported");const L=`$memoize$${y}`;c[g]=function(...s){return this.hasOwnProperty(L)||Object.defineProperty(this,L,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,s)}),this[L]}}t.$ih=T;function i(w,y,c){return v((g,f)=>{const L=`$debounce$${f}`,s=`$debounce$result$${f}`;return function(...a){this[s]||(this[s]=c?c():void 0),clearTimeout(this[L]),y&&(this[s]=y(this[s],...a),a=[this[s]]),this[L]=setTimeout(()=>{g.apply(this,a),this[s]=c?c():void 0},w)}})}t.$jh=i;function U(w,y,c){return v((g,f)=>{const L=`$throttle$timer$${f}`,s=`$throttle$result$${f}`,a=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...h){if(this[s]||(this[s]=c?c():void 0),(this[a]===null||this[a]===void 0)&&(this[a]=-Number.MAX_VALUE),y&&(this[s]=y(this[s],...h)),this[e])return;const l=this[a]+w;l<=Date.now()?(this[a]=Date.now(),g.apply(this,[this[s]]),this[s]=c?c():void 0):(this[e]=!0,this[L]=setTimeout(()=>{this[e]=!1,this[a]=Date.now(),g.apply(this,[this[s]]),this[s]=c?c():void 0},l-Date.now()))}})}t.$kh=U}),define($e[75],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xs=void 0;class v{constructor(i,U,w,y){this.originalStart=i,this.originalLength=U,this.modifiedStart=w,this.modifiedLength=y}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$xs=v}),define($e[6],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.setUnexpectedErrorHandler=t.$W=t.$V=void 0;class v{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?r.isErrorNoTelemetry(o)?new r(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(F=>{F(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}t.$V=v,t.$W=new v;function T(u){t.$W.setUnexpectedErrorHandler(u)}t.setUnexpectedErrorHandler=T;function i(u){if(!u||typeof u!="object")return!1;const o=u;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}t.$Y=i;function U(u){g(u)||t.$W.onUnexpectedError(u)}t.$Z=U;function w(u){g(u)||t.$W.onUnexpectedExternalError(u)}t.$1=w;function y(u){if(u instanceof Error){const{name:o,message:F}=u,j=u.stacktrace||u.stack;return{$isError:!0,name:o,message:F,stack:j,noTelemetry:r.isErrorNoTelemetry(u)}}return u}t.$2=y;const c="Canceled";function g(u){return u instanceof f?!0:u instanceof Error&&u.name===c&&u.message===c}t.$3=g;class f extends Error{constructor(){super(c),this.name=this.message}}t.$4=f;function L(){const u=new Error(c);return u.name=u.message,u}t.$5=L;function s(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}t.$6=s;function a(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}t.$7=a;class e extends TypeError{constructor(o){super(o?`${o} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$8=e;function h(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}t.$9=h;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}t.$0=l;class m extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}t.$$=m;class n extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=n;class r extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof r)return o;const F=new r;return F.message=o.message,F.stack=o.stack,F}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}t.$ab=r;class b extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,b.prototype)}}t.$bb=b}),define($e[11],we([1,0,6,72]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.$6b=t.CompareResult=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.$Fb=t.top=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=t.$rb=void 0;function i(p,A=0){return p[p.length-(1+A)]}t.$rb=i;function U(p){if(p.length===0)throw new Error("Invalid tail call");return[p.slice(0,p.length-1),p[p.length-1]]}t.$sb=U;function w(p,A,E=(M,k)=>M===k){if(p===A)return!0;if(!p||!A||p.length!==A.length)return!1;for(let M=0,k=p.length;M<k;M++)if(!E(p[M],A[M]))return!1;return!0}t.$tb=w;function y(p,A){const E=p.length-1;A<E&&(p[A]=p[E]),p.pop()}t.$ub=y;function c(p,A,E){return g(p.length,M=>E(p[M],A))}t.$vb=c;function g(p,A){let E=0,M=p-1;for(;E<=M;){const k=(E+M)/2|0,I=A(k);if(I<0)E=k+1;else if(I>0)M=k-1;else return k}return-(E+1)}t.$wb=g;function f(p,A,E){if(p=p|0,p>=A.length)throw new TypeError("invalid index");const M=A[Math.floor(A.length*Math.random())],k=[],I=[],S=[];for(const N of A){const z=E(N,M);z<0?k.push(N):z>0?I.push(N):S.push(N)}return p<k.length?f(p,k,E):p<k.length+S.length?S[0]:f(p-(k.length+S.length),I,E)}t.$xb=f;function L(p,A){const E=[];let M;for(const k of p.slice(0).sort(A))!M||A(M[0],k)!==0?(M=[k],E.push(M)):M.push(k);return E}t.$yb=L;function*s(p,A){let E,M;for(const k of p)M!==void 0&&A(M,k)?E.push(k):(E&&(yield E),E=[k]),M=k;E&&(yield E)}t.$zb=s;function a(p,A){for(let E=0;E<=p.length;E++)A(E===0?void 0:p[E-1],E===p.length?void 0:p[E])}t.$Ab=a;function e(p,A){for(let E=0;E<p.length;E++)A(E===0?void 0:p[E-1],p[E],E+1===p.length?void 0:p[E+1])}t.$Bb=e;function h(p,A,E){const M=[];function k(N,z,x){if(z===0&&x.length===0)return;const ee=M[M.length-1];ee&&ee.start+ee.deleteCount===N?(ee.deleteCount+=z,ee.toInsert.push(...x)):M.push({start:N,deleteCount:z,toInsert:x})}let I=0,S=0;for(;;){if(I===p.length){k(I,0,A.slice(S));break}if(S===A.length){k(I,p.length-I,[]);break}const N=p[I],z=A[S],x=E(N,z);x===0?(I+=1,S+=1):x<0?(k(I,1,[]),I+=1):x>0&&(k(I,0,[z]),S+=1)}return M}t.$Cb=h;function l(p,A,E){const M=h(p,A,E),k=[],I=[];for(const S of M)k.push(...p.slice(S.start,S.start+S.deleteCount)),I.push(...S.toInsert);return{removed:k,added:I}}t.$Db=l;function m(p,A,E){if(E===0)return[];const M=p.slice(0,E).sort(A);return r(p,A,M,E,p.length),M}t.top=m;function n(p,A,E,M,k){return E===0?Promise.resolve([]):new Promise((I,S)=>{(async()=>{const N=p.length,z=p.slice(0,E).sort(A);for(let x=E,ee=Math.min(E+M,N);x<N;x=ee,ee=Math.min(ee+M,N)){if(x>E&&await new Promise(se=>setTimeout(se)),k&&k.isCancellationRequested)throw new v.$4;r(p,A,z,x,ee)}return z})().then(I,S)})}t.$Fb=n;function r(p,A,E,M,k){for(const I=E.length;M<k;M++){const S=p[M];if(A(S,E[I-1])<0){E.pop();const N=(0,T.$jb)(E,z=>A(S,z)<0);E.splice(N,0,S)}}}function b(p){return p.filter(A=>!!A)}t.$Gb=b;function u(p){let A=0;for(let E=0;E<p.length;E++)p[E]&&(p[A]=p[E],A+=1);p.length=A}t.$Hb=u;function o(p,A,E){p.splice(E,0,p.splice(A,1)[0])}t.$Ib=o;function F(p){return!Array.isArray(p)||p.length===0}t.$Jb=F;function j(p){return Array.isArray(p)&&p.length>0}t.$Kb=j;function R(p,A=E=>E){const E=new Set;return p.filter(M=>{const k=A(M);return E.has(k)?!1:(E.add(k),!0)})}t.$Lb=R;function d(p){const A=new Set;return E=>{const M=p(E);return A.has(M)?!1:(A.add(M),!0)}}t.$Mb=d;function D(p,A){return p.length>0?p[0]:A}t.$Nb=D;function B(p,A){return p.length>0?p[p.length-1]:A}t.$Ob=B;function H(p,A,E=(M,k)=>M===k){let M=0;for(let k=0,I=Math.min(p.length,A.length);k<I&&E(p[k],A[k]);k++)M++;return M}t.$Pb=H;function X(p){return[].concat(...p)}t.$Qb=X;function P(p,A){let E=typeof A=="number"?p:0;typeof A=="number"?E=p:(E=0,A=p);const M=[];if(E<=A)for(let k=E;k<A;k++)M.push(k);else for(let k=E;k>A;k--)M.push(k);return M}t.$Rb=P;function O(p,A,E){return p.reduce((M,k)=>(M[A(k)]=E?E(k):k,M),Object.create(null))}t.$Sb=O;function Q(p,A){return p.push(A),()=>te(p,A)}t.$Tb=Q;function te(p,A){const E=p.indexOf(A);if(E>-1)return p.splice(E,1),A}t.$Ub=te;function re(p,A,E){const M=p.slice(0,A),k=p.slice(A);return M.concat(E,k)}t.$Vb=re;function fe(p,A){let E;if(typeof A=="number"){let M=A;E=()=>{const k=Math.sin(M++)*179426549;return k-Math.floor(k)}}else E=Math.random;for(let M=p.length-1;M>0;M-=1){const k=Math.floor(E()*(M+1)),I=p[M];p[M]=p[k],p[k]=I}}t.$Wb=fe;function ie(p,A){const E=p.indexOf(A);E>-1&&(p.splice(E,1),p.unshift(A))}t.$Xb=ie;function oe(p,A){const E=p.indexOf(A);E>-1&&(p.splice(E,1),p.push(A))}t.$Yb=oe;function be(p,A){for(const E of A)p.push(E)}t.$Zb=be;function Se(p,A){return Array.isArray(p)?p.map(A):A(p)}t.$1b=Se;function Te(p){return Array.isArray(p)?p:[p]}t.$2b=Te;function Fe(p){return p[Math.floor(Math.random()*p.length)]}t.$3b=Fe;function de(p,A,E){const M=ce(p,A),k=p.length,I=E.length;p.length=k+I;for(let S=k-1;S>=M;S--)p[S+I]=p[S];for(let S=0;S<I;S++)p[S+M]=E[S]}t.$4b=de;function ne(p,A,E,M){const k=ce(p,A);let I=p.splice(k,E);return I===void 0&&(I=[]),de(p,k,M),I}t.$5b=ne;function ce(p,A){return A<0?Math.max(A+p.length,0):Math.min(A,p.length)}var Z;(function(p){function A(I){return I<0}p.isLessThan=A;function E(I){return I<=0}p.isLessThanOrEqual=E;function M(I){return I>0}p.isGreaterThan=M;function k(I){return I===0}p.isNeitherLessOrGreaterThan=k,p.greaterThan=1,p.lessThan=-1,p.neitherLessOrGreaterThan=0})(Z||(t.CompareResult=Z={}));function V(p,A){return(E,M)=>A(p(E),p(M))}t.$6b=V;function Y(...p){return(A,E)=>{for(const M of p){const k=M(A,E);if(!Z.isNeitherLessOrGreaterThan(k))return k}return Z.neitherLessOrGreaterThan}}t.$7b=Y;const C=(p,A)=>p-A;t.$8b=C;const q=(p,A)=>(0,t.$8b)(p?1:0,A?1:0);t.$9b=q;function $(p){return(A,E)=>-p(A,E)}t.$0b=$;class W{constructor(A){this.g=A,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(A){let E=this.c;for(;E<this.g.length&&A(this.g[E]);)E++;const M=E===this.c?null:this.g.slice(this.c,E);return this.c=E,M}takeFromEndWhile(A){let E=this.d;for(;E>=0&&A(this.g[E]);)E--;const M=E===this.d?null:this.g.slice(E+1,this.d+1);return this.d=E,M}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const A=this.g[this.c];return this.c++,A}removeLast(){const A=this.g[this.d];return this.d--,A}takeCount(A){const E=this.g.slice(this.c,this.c+A);return this.c+=A,E}}t.$$b=W;class _{static{this.empty=new _(A=>{})}constructor(A){this.iterate=A}forEach(A){this.iterate(E=>(A(E),!0))}toArray(){const A=[];return this.iterate(E=>(A.push(E),!0)),A}filter(A){return new _(E=>this.iterate(M=>A(M)?E(M):!0))}map(A){return new _(E=>this.iterate(M=>E(A(M))))}some(A){let E=!1;return this.iterate(M=>(E=A(M),!E)),E}findFirst(A){let E;return this.iterate(M=>A(M)?(E=M,!1):!0),E}findLast(A){let E;return this.iterate(M=>(A(M)&&(E=M),!0)),E}findLastMaxBy(A){let E,M=!0;return this.iterate(k=>((M||Z.isGreaterThan(A(k,E)))&&(M=!1,E=k),!0)),E}}t.$_b=_}),define($e[76],we([1,0,6]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=t.$5c=t.$4c=t.$3c=t.ok=void 0;function T(c,g){if(!c)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}t.ok=T;function i(c,g="Unreachable"){throw new Error(g)}t.$3c=i;function U(c){if(!c)throw new v.$bb("Assertion Failed")}t.$4c=U;function w(c){if(!c()){debugger;c(),(0,v.$Z)(new v.$bb("Assertion Failed"))}}t.$5c=w;function y(c,g){let f=0;for(;f<c.length-1;){const L=c[f],s=c[f+1];if(!g(L,s))return!1;f++}return!0}t.$6c=y}),define($e[43],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function v(T){const i=this;let U=!1,w;return function(){return U||(U=!0,w=T.apply(i,arguments)),w}}t.$cb=v}),define($e[77],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AM=t.$zM=void 0;class v{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.$zM=v,t.$AM=new v("id#")}),define($e[27],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var v;(function(T){function i(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}T.is=i;const U=Object.freeze([]);function w(){return U}T.empty=w;function*y(u){yield u}T.single=y;function c(u){return i(u)?u:y(u)}T.wrap=c;function g(u){return u||U}T.from=g;function*f(u){for(let o=u.length-1;o>=0;o--)yield u[o]}T.reverse=f;function L(u){return!u||u[Symbol.iterator]().next().done===!0}T.isEmpty=L;function s(u){return u[Symbol.iterator]().next().value}T.first=s;function a(u,o){for(const F of u)if(o(F))return!0;return!1}T.some=a;function e(u,o){for(const F of u)if(o(F))return F}T.find=e;function*h(u,o){for(const F of u)o(F)&&(yield F)}T.filter=h;function*l(u,o){let F=0;for(const j of u)yield o(j,F++)}T.map=l;function*m(...u){for(const o of u)for(const F of o)yield F}T.concat=m;function n(u,o,F){let j=F;for(const R of u)j=o(j,R);return j}T.reduce=n;function*r(u,o,F=u.length){for(o<0&&(o+=u.length),F<0?F+=u.length:F>u.length&&(F=u.length);o<F;o++)yield u[o]}T.slice=r;function b(u,o=Number.POSITIVE_INFINITY){const F=[];if(o===0)return[F,u];const j=u[Symbol.iterator]();for(let R=0;R<o;R++){const d=j.next();if(d.done)return[F,T.empty()];F.push(d.value)}return[F,{[Symbol.iterator](){return j}}]}T.consume=b})(v||(t.Iterable=v={}))}),define($e[44],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gq=t.KeyMod=t.KeyCodeUtils=t.$Fq=t.$Eq=t.$Dq=t.$Cq=t.$Bq=t.ScanCode=t.KeyCode=void 0;var v;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(v||(t.KeyCode=v={}));var T;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(T||(t.ScanCode=T={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,l){this._keyCodeToStr[h]=l,this._strToKeyCode[l.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const U=new i,w=new i,y=new i;t.$Bq=new Array(230),t.$Cq={};const c=[],g=Object.create(null),f=Object.create(null);t.$Dq={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>g[e]||0,toString:e=>c[e]||"None"},t.$Eq=[],t.$Fq=[];for(let e=0;e<=193;e++)t.$Eq[e]=-1;for(let e=0;e<=132;e++)t.$Fq[e]=-1;(function(){const e="",h=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],l=[],m=[];for(const n of h){const[r,b,u,o,F,j,R,d,D]=n;if(m[b]||(m[b]=!0,c[b]=u,g[u]=b,f[u.toLowerCase()]=b,r&&(t.$Eq[b]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(t.$Fq[o]=b))),!l[o]){if(l[o]=!0,!F)throw new Error(`String representation missing for key code ${o} around scan code ${u}`);U.define(o,F),w.define(o,d||F),y.define(o,D||d||F)}j&&(t.$Bq[j]=o),R&&(t.$Cq[R]=o)}t.$Fq[3]=46})();var L;(function(e){function h(u){return U.keyCodeToStr(u)}e.toString=h;function l(u){return U.strToKeyCode(u)}e.fromString=l;function m(u){return w.keyCodeToStr(u)}e.toUserSettingsUS=m;function n(u){return y.keyCodeToStr(u)}e.toUserSettingsGeneral=n;function r(u){return w.strToKeyCode(u)||y.strToKeyCode(u)}e.fromUserSettings=r;function b(u){if(u>=98&&u<=113)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return U.keyCodeToStr(u)}e.toElectronAccelerator=b})(L||(t.KeyCodeUtils=L={}));var s;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(s||(t.KeyMod=s={}));function a(e,h){const l=(h&65535)<<16>>>0;return(e|l)>>>0}t.$Gq=a}),define($e[78],we([1,0,6]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nq=t.$Mq=t.$Lq=t.$Kq=t.$Jq=t.$Iq=t.$Hq=void 0;var T;(function(L){L[L.CtrlCmd=2048]="CtrlCmd",L[L.Shift=1024]="Shift",L[L.Alt=512]="Alt",L[L.WinCtrl=256]="WinCtrl",L[L.KeyCode=255]="KeyCode"})(T||(T={}));function i(L,s){if(typeof L=="number"){if(L===0)return null;const a=(L&65535)>>>0,e=(L&4294901760)>>>16;return e!==0?new c([U(a,s),U(e,s)]):new c([U(a,s)])}else{const a=[];for(let e=0;e<L.length;e++)a.push(U(L[e],s));return new c(a)}}t.$Hq=i;function U(L,s){const a=!!(L&2048),e=!!(L&256),h=s===2?e:a,l=!!(L&1024),m=!!(L&512),n=s===2?a:e,r=L&255;return new w(h,l,m,n,r)}t.$Iq=U;class w{constructor(s,a,e,h,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.keyCode=l}equals(s){return s instanceof w&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.keyCode===s.keyCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`K${s}${a}${e}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new c([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Jq=w;class y{constructor(s,a,e,h,l){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.scanCode=l}equals(s){return s instanceof y&&this.ctrlKey===s.ctrlKey&&this.shiftKey===s.shiftKey&&this.altKey===s.altKey&&this.metaKey===s.metaKey&&this.scanCode===s.scanCode}getHashCode(){const s=this.ctrlKey?"1":"0",a=this.shiftKey?"1":"0",e=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`S${s}${a}${e}${h}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Kq=y;class c{constructor(s){if(s.length===0)throw(0,v.$6)("chords");this.chords=s}getHashCode(){let s="";for(let a=0,e=this.chords.length;a<e;a++)a!==0&&(s+=";"),s+=this.chords[a].getHashCode();return s}equals(s){if(s===null||this.chords.length!==s.chords.length)return!1;for(let a=0;a<this.chords.length;a++)if(!this.chords[a].equals(s.chords[a]))return!1;return!0}}t.$Lq=c;class g{constructor(s,a,e,h,l,m){this.ctrlKey=s,this.shiftKey=a,this.altKey=e,this.metaKey=h,this.keyLabel=l,this.keyAriaLabel=m}}t.$Mq=g;class f{}t.$Nq=f}),define($e[28],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$U=void 0;class v{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$U=v}),define($e[45],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1c=void 0;class v{static{this.Undefined=new v(void 0)}constructor(U){this.element=U,this.next=v.Undefined,this.prev=v.Undefined}}class T{constructor(){this.a=v.Undefined,this.b=v.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===v.Undefined}clear(){let U=this.a;for(;U!==v.Undefined;){const w=U.next;U.prev=v.Undefined,U.next=v.Undefined,U=w}this.a=v.Undefined,this.b=v.Undefined,this.c=0}unshift(U){return this.d(U,!1)}push(U){return this.d(U,!0)}d(U,w){const y=new v(U);if(this.a===v.Undefined)this.a=y,this.b=y;else if(w){const g=this.b;this.b=y,y.prev=g,g.next=y}else{const g=this.a;this.a=y,y.next=g,g.prev=y}this.c+=1;let c=!1;return()=>{c||(c=!0,this.e(y))}}shift(){if(this.a!==v.Undefined){const U=this.a.element;return this.e(this.a),U}}pop(){if(this.b!==v.Undefined){const U=this.b.element;return this.e(this.b),U}}e(U){if(U.prev!==v.Undefined&&U.next!==v.Undefined){const w=U.prev;w.next=U.next,U.next.prev=w}else U.prev===v.Undefined&&U.next===v.Undefined?(this.a=v.Undefined,this.b=v.Undefined):U.next===v.Undefined?(this.b=this.b.prev,this.b.next=v.Undefined):U.prev===v.Undefined&&(this.a=this.a.next,this.a.prev=v.Undefined);this.c-=1}*[Symbol.iterator](){let U=this.a;for(;U!==v.Undefined;)yield U.element,U=U.next}}t.$1c=T}),define($e[32],we([1,0]),function(le,t){"use strict";var v,T,i;Object.defineProperty(t,"__esModule",{value:!0}),t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.$Bc=t.Touch=t.$Ac=t.$zc=t.$yc=t.$xc=t.$wc=void 0;function U(n,r,b){let u=n.get(r);return u===void 0&&(u=b,n.set(r,u)),u}t.$wc=U;function w(n){const r=[];return n.forEach((b,u)=>{r.push(`${u} => ${b}`)}),`Map(${n.size}) {${r.join(", ")}}`}t.$xc=w;function y(n){const r=[];return n.forEach(b=>{r.push(b)}),`Set(${n.size}) {${r.join(", ")}}`}t.$yc=y;class c{constructor(r,b){this.uri=r,this.value=b}}function g(n){return Array.isArray(n)}class f{static{this.a=r=>r.toString()}constructor(r,b){if(this[v]="ResourceMap",r instanceof f)this.b=new Map(r.b),this.c=b??f.a;else if(g(r)){this.b=new Map,this.c=b??f.a;for(const[u,o]of r)this.set(u,o)}else this.b=new Map,this.c=r??f.a}set(r,b){return this.b.set(this.c(r),new c(r,b)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,b){typeof b<"u"&&(r=r.bind(b));for(const[u,o]of this.b)r(o.value,o.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(v=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}t.$zc=f;class L{constructor(r,b){this[T]="ResourceSet",!r||typeof r=="function"?this.a=new f(r):(this.a=new f(b),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,b){this.a.forEach((u,o)=>r.call(b,o,o,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Ac=L;var s;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(s||(t.Touch=s={}));class a{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,b=0){const u=this.a.get(r);if(u)return b!==0&&this.j(u,b),u.value}set(r,b,u=0){let o=this.a.get(r);if(o)o.value=b,u!==0&&this.j(o,u);else{switch(o={key:r,value:b,next:void 0,previous:void 0},u){case 0:this.h(o);break;case 1:this.g(o);break;case 2:this.h(o);break;default:this.h(o);break}this.a.set(r,o),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const b=this.a.get(r);if(b)return this.a.delete(r),this.i(b),this.d--,b.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,b){const u=this.e;let o=this.b;for(;o;){if(b?r.bind(b)(o.value,o.key,this):r(o.value,o.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const F={value:u.key,done:!1};return u=u.next,F}else return{value:void 0,done:!0}}};return o}values(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const F={value:u.value,done:!1};return u=u.next,F}else return{value:void 0,done:!0}}};return o}entries(){const r=this,b=this.e;let u=this.b;const o={[Symbol.iterator](){return o},next(){if(r.e!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const F={value:[u.key,u.value],done:!1};return u=u.next,F}else return{value:void 0,done:!0}}};return o}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let b=this.b,u=this.size;for(;b&&u>r;)this.a.delete(b.key),b=b.next,u--;this.b=b,this.d=u,b&&(b.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const b=r.next,u=r.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}r.next=void 0,r.previous=void 0,this.e++}j(r,b){if(!this.b||!this.c)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(r===this.b)return;const u=r.next,o=r.previous;r===this.c?(o.next=void 0,this.c=o):(u.previous=o,o.next=u),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(b===2){if(r===this.c)return;const u=r.next,o=r.previous;r===this.b?(u.previous=void 0,this.b=u):(u.previous=o,o.next=u),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((b,u)=>{r.push([u,b])}),r}fromJSON(r){this.clear();for(const[b,u]of r)this.set(b,u)}}t.$Bc=a;class e extends a{constructor(r,b=1){super(),this.k=r,this.l=Math.min(Math.max(0,b),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,b=2){return super.get(r,b)}peek(r){return super.get(r,0)}set(r,b){return super.set(r,b,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.$Cc=e;class h{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let b=this.a.get(r)||0;return b===0?!1:(b--,b===0?this.a.delete(r):this.a.set(r,b),!0)}has(r){return this.a.has(r)}}t.$Dc=h;class l{constructor(r){if(this.a=new Map,this.b=new Map,r)for(const[b,u]of r)this.set(b,u)}clear(){this.a.clear(),this.b.clear()}set(r,b){this.a.set(r,b),this.b.set(b,r)}get(r){return this.a.get(r)}getKey(r){return this.b.get(r)}delete(r){const b=this.a.get(r);return b===void 0?!1:(this.a.delete(r),this.b.delete(b),!0)}forEach(r,b){this.a.forEach((u,o)=>{r.call(b,u,o,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}t.$Ec=l;class m{constructor(){this.a=new Map}add(r,b){let u=this.a.get(r);u||(u=new Set,this.a.set(r,u)),u.add(b)}delete(r,b){const u=this.a.get(r);u&&(u.delete(b),u.size===0&&this.a.delete(r))}forEach(r,b){const u=this.a.get(r);u&&u.forEach(b)}get(r){const b=this.a.get(r);return b||new Set}}t.$Fc=m}),define($e[2],we([1,0,11,73,32,43,27]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=t.$Hc=t.$Gc=void 0;const y=!1;let c=null;class g{constructor(){this.b=new Map}static{this.a=0}c(O){let Q=this.b.get(O);return Q||(Q={parent:null,source:null,isSingleton:!1,value:O,idx:g.a++},this.b.set(O,Q)),Q}trackDisposable(O){const Q=this.c(O);Q.source||(Q.source=new Error().stack)}setParent(O,Q){const te=this.c(O);te.parent=Q}markAsDisposed(O){this.b.delete(O)}markAsSingleton(O){this.c(O).isSingleton=!0}f(O,Q){const te=Q.get(O);if(te)return te;const re=O.parent?this.f(this.c(O.parent),Q):O;return Q.set(O,re),re}getTrackedDisposables(){const O=new Map;return[...this.b.entries()].filter(([,te])=>te.source!==null&&!this.f(te,O).isSingleton).flatMap(([te])=>te)}computeLeakingDisposables(O=10,Q){let te;if(Q)te=Q;else{const be=new Map,Se=[...this.b.values()].filter(Fe=>Fe.source!==null&&!this.f(Fe,be).isSingleton);if(Se.length===0)return;const Te=new Set(Se.map(Fe=>Fe.value));if(te=Se.filter(Fe=>!(Fe.parent&&Te.has(Fe.parent))),te.length===0)throw new Error("There are cyclic diposable chains!")}if(!te)return;function re(be){function Se(Fe,de){for(;Fe.length>0&&de.some(ne=>typeof ne=="string"?ne===Fe[0]:Fe[0].match(ne));)Fe.shift()}const Te=be.source.split(`
`).map(Fe=>Fe.trim().replace("at ","")).filter(Fe=>Fe!=="");return Se(Te,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Te.reverse()}const fe=new i.$Fc;for(const be of te){const Se=re(be);for(let Te=0;Te<=Se.length;Te++)fe.add(Se.slice(0,Te).join(`
`),be)}te.sort((0,v.$6b)(be=>be.idx,v.$8b));let ie="",oe=0;for(const be of te.slice(0,O)){oe++;const Se=re(be),Te=[];for(let Fe=0;Fe<Se.length;Fe++){let de=Se[Fe];de=`(shared with ${fe.get(Se.slice(0,Fe+1).join(`
`)).size}/${te.length} leaks) at ${de}`;const ce=fe.get(Se.slice(0,Fe).join(`
`)),Z=(0,T.$J)([...ce].map(V=>re(V)[Fe]),V=>V);delete Z[Se[Fe]];for(const[V,Y]of Object.entries(Z))Te.unshift(`    - stacktraces of ${Y.length} other leaks continue with ${V}`);Te.unshift(de)}ie+=`


==================== Leaking disposable ${oe}/${te.length}: ${be.value.constructor.name} ====================
${Te.join(`
`)}
============================================================

`}return te.length>O&&(ie+=`


... and ${te.length-O} more leaking disposables

`),{leaks:te,details:ie}}}t.$Gc=g;function f(P){c=P}if(t.$Hc=f,y){const P="__is_disposable_tracked__";f(new class{trackDisposable(O){const Q=new Error("Potentially leaked disposable").stack;setTimeout(()=>{O[P]||console.log(Q)},3e3)}setParent(O,Q){if(O&&O!==o.None)try{O[P]=!0}catch{}}markAsDisposed(O){if(O&&O!==o.None)try{O[P]=!0}catch{}}markAsSingleton(O){}})}function L(P){return c?.trackDisposable(P),P}t.$Ic=L;function s(P){c?.markAsDisposed(P)}t.$Jc=s;function a(P,O){c?.setParent(P,O)}function e(P,O){if(c)for(const Q of P)c.setParent(Q,O)}function h(P){return c?.markAsSingleton(P),P}t.$Kc=h;function l(P){return typeof P.dispose=="function"&&P.dispose.length===0}t.$Lc=l;function m(P){if(w.Iterable.is(P)){const O=[];for(const Q of P)if(Q)try{Q.dispose()}catch(te){O.push(te)}if(O.length===1)throw O[0];if(O.length>1)throw new AggregateError(O,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}t.$Mc=m;function n(P){for(const O of P)l(O)&&O.dispose();return[]}t.$Nc=n;function r(...P){const O=b(()=>m(P));return e(P,O),O}t.$Oc=r;function b(P){const O=L({dispose:(0,U.$cb)(()=>{s(O),P()})});return O}t.$Pc=b;class u{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,L(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{m(this.f)}finally{this.f.clear()}}add(O){if(!O)return O;if(O===this)throw new Error("Cannot register a disposable on itself!");return a(O,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(O),O}delete(O){if(O){if(O===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(O),O.dispose()}}deleteAndLeak(O){O&&this.f.has(O)&&(this.f.delete(O),a(O,null))}}t.$Qc=u;class o{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new u,L(this),a(this.q,this)}dispose(){s(this),this.q.dispose()}B(O){if(O===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(O)}}t.$Rc=o;class F{constructor(){this.b=!1,L(this)}get value(){return this.b?void 0:this.a}set value(O){this.b||O===this.a||(this.a?.dispose(),O&&a(O,this),this.a=O)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const O=this.a;return this.a=void 0,O&&a(O,null),O}}t.$Sc=F;class j{constructor(O){this.b=O,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Tc=j;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,L(this)}set(O){let Q=O;return this.unset=()=>Q=void 0,this.isset=()=>Q!==void 0,this.dispose=()=>{Q&&(Q(),Q=void 0,s(this))},this}}t.$Uc=R;class d{constructor(){this.a=new Map}acquire(O,...Q){let te=this.a.get(O);te||(te={counter:0,object:this.b(O,...Q)},this.a.set(O,te));const{object:re}=te,fe=(0,U.$cb)(()=>{--te.counter===0&&(this.c(O,te.object),this.a.delete(O))});return te.counter++,{object:re,dispose:fe}}}t.$Vc=d;class D{constructor(O){this.a=O}async acquire(O,...Q){const te=this.a.acquire(O,...Q);try{return{object:await te.object,dispose:()=>te.dispose()}}catch(re){throw te.dispose(),re}}}t.$Wc=D;class B{constructor(O){this.object=O}dispose(){}}t.$Xc=B;function H(P){const O=new u;try{P(O)}finally{O.dispose()}}t.$Yc=H;class X{constructor(){this.a=new Map,this.b=!1,L(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{m(this.a.values())}finally{this.a.clear()}}has(O){return this.a.has(O)}get size(){return this.a.size}get(O){return this.a.get(O)}set(O,Q,te=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),te||this.a.get(O)?.dispose(),this.a.set(O,Q)}deleteAndDispose(O){this.a.get(O)?.dispose(),this.a.delete(O)}keys(){return this.a.keys()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$Zc=X}),function(le,t){typeof define=="function"&&define.amd?define($e[79],we([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(le=typeof globalThis<"u"?globalThis:le||self,t(le.marked={}))}(this,function(le){"use strict";function t(A,E){for(var M=0;M<E.length;M++){var k=E[M];k.enumerable=k.enumerable||!1,k.configurable=!0,"value"in k&&(k.writable=!0),Object.defineProperty(A,k.key,k)}}function v(A,E,M){return E&&t(A.prototype,E),M&&t(A,M),Object.defineProperty(A,"prototype",{writable:!1}),A}function T(A,E){if(A){if(typeof A=="string")return i(A,E);var M=Object.prototype.toString.call(A).slice(8,-1);if(M==="Object"&&A.constructor&&(M=A.constructor.name),M==="Map"||M==="Set")return Array.from(A);if(M==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(M))return i(A,E)}}function i(A,E){(E==null||E>A.length)&&(E=A.length);for(var M=0,k=new Array(E);M<E;M++)k[M]=A[M];return k}function U(A,E){var M=typeof Symbol<"u"&&A[Symbol.iterator]||A["@@iterator"];if(M)return(M=M.call(A)).next.bind(M);if(Array.isArray(A)||(M=T(A))||E&&A&&typeof A.length=="number"){M&&(A=M);var k=0;return function(){return k>=A.length?{done:!0}:{done:!1,value:A[k++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function w(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=w();function y(A){le.defaults=A}var c=/[&<>"']/,g=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,L=/[<>"']|&(?!#?\w+;)/g,s={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},a=function(E){return s[E]};function e(A,E){if(E){if(c.test(A))return A.replace(g,a)}else if(f.test(A))return A.replace(L,a);return A}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function l(A){return A.replace(h,function(E,M){return M=M.toLowerCase(),M==="colon"?":":M.charAt(0)==="#"?M.charAt(1)==="x"?String.fromCharCode(parseInt(M.substring(2),16)):String.fromCharCode(+M.substring(1)):""})}var m=/(^|[^\[])\^/g;function n(A,E){A=typeof A=="string"?A:A.source,E=E||"";var M={replace:function(I,S){return S=S.source||S,S=S.replace(m,"$1"),A=A.replace(I,S),M},getRegex:function(){return new RegExp(A,E)}};return M}var r=/[^\w:]/g,b=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(A,E,M){if(A){var k;try{k=decodeURIComponent(l(M)).replace(r,"").toLowerCase()}catch{return null}if(k.indexOf("javascript:")===0||k.indexOf("vbscript:")===0||k.indexOf("data:")===0)return null}E&&!b.test(M)&&(M=d(E,M));try{M=encodeURI(M).replace(/%25/g,"%")}catch{return null}return M}var o={},F=/^[^:]+:\/*[^/]*$/,j=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(A,E){o[" "+A]||(F.test(A)?o[" "+A]=A+"/":o[" "+A]=X(A,"/",!0)),A=o[" "+A];var M=A.indexOf(":")===-1;return E.substring(0,2)==="//"?M?E:A.replace(j,"$1")+E:E.charAt(0)==="/"?M?E:A.replace(R,"$1")+E:A+E}var D={exec:function(){}};function B(A){for(var E=1,M,k;E<arguments.length;E++){M=arguments[E];for(k in M)Object.prototype.hasOwnProperty.call(M,k)&&(A[k]=M[k])}return A}function H(A,E){var M=A.replace(/\|/g,function(S,N,z){for(var x=!1,ee=N;--ee>=0&&z[ee]==="\\";)x=!x;return x?"|":" |"}),k=M.split(/ \|/),I=0;if(k[0].trim()||k.shift(),k.length>0&&!k[k.length-1].trim()&&k.pop(),k.length>E)k.splice(E);else for(;k.length<E;)k.push("");for(;I<k.length;I++)k[I]=k[I].trim().replace(/\\\|/g,"|");return k}function X(A,E,M){var k=A.length;if(k===0)return"";for(var I=0;I<k;){var S=A.charAt(k-I-1);if(S===E&&!M)I++;else if(S!==E&&M)I++;else break}return A.slice(0,k-I)}function P(A,E){if(A.indexOf(E[1])===-1)return-1;for(var M=A.length,k=0,I=0;I<M;I++)if(A[I]==="\\")I++;else if(A[I]===E[0])k++;else if(A[I]===E[1]&&(k--,k<0))return I;return-1}function O(A){A&&A.sanitize&&!A.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function Q(A,E){if(E<1)return"";for(var M="";E>1;)E&1&&(M+=A),E>>=1,A+=A;return M+A}function te(A,E,M,k){var I=E.href,S=E.title?e(E.title):null,N=A[1].replace(/\\([\[\]])/g,"$1");if(A[0].charAt(0)!=="!"){k.state.inLink=!0;var z={type:"link",raw:M,href:I,title:S,text:N,tokens:k.inlineTokens(N)};return k.state.inLink=!1,z}return{type:"image",raw:M,href:I,title:S,text:e(N)}}function re(A,E){var M=A.match(/^(\s+)(?:```)/);if(M===null)return E;var k=M[1];return E.split(`
`).map(function(I){var S=I.match(/^\s+/);if(S===null)return I;var N=S[0];return N.length>=k.length?I.slice(k.length):I}).join(`
`)}var fe=function(){function A(M){this.options=M||le.defaults}var E=A.prototype;return E.space=function(k){var I=this.rules.block.newline.exec(k);if(I&&I[0].length>0)return{type:"space",raw:I[0]}},E.code=function(k){var I=this.rules.block.code.exec(k);if(I){var S=I[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:I[0],codeBlockStyle:"indented",text:this.options.pedantic?S:X(S,`
`)}}},E.fences=function(k){var I=this.rules.block.fences.exec(k);if(I){var S=I[0],N=re(S,I[3]||"");return{type:"code",raw:S,lang:I[2]?I[2].trim():I[2],text:N}}},E.heading=function(k){var I=this.rules.block.heading.exec(k);if(I){var S=I[2].trim();if(/#$/.test(S)){var N=X(S,"#");(this.options.pedantic||!N||/ $/.test(N))&&(S=N.trim())}return{type:"heading",raw:I[0],depth:I[1].length,text:S,tokens:this.lexer.inline(S)}}},E.hr=function(k){var I=this.rules.block.hr.exec(k);if(I)return{type:"hr",raw:I[0]}},E.blockquote=function(k){var I=this.rules.block.blockquote.exec(k);if(I){var S=I[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:I[0],tokens:this.lexer.blockTokens(S,[]),text:S}}},E.list=function(k){var I=this.rules.block.list.exec(k);if(I){var S,N,z,x,ee,se,ge,pe,Pe,Ae,De,Re,Oe=I[1].trim(),_e=Oe.length>1,He={type:"list",raw:"",ordered:_e,start:_e?+Oe.slice(0,-1):"",loose:!1,items:[]};Oe=_e?"\\d{1,9}\\"+Oe.slice(-1):"\\"+Oe,this.options.pedantic&&(Oe=_e?Oe:"[*+-]");for(var Me=new RegExp("^( {0,3}"+Oe+")((?:[	 ][^\\n]*)?(?:\\n|$))");k&&(Re=!1,!(!(I=Me.exec(k))||this.rules.block.hr.test(k)));){if(S=I[0],k=k.substring(S.length),pe=I[2].split(`
`,1)[0],Pe=k.split(`
`,1)[0],this.options.pedantic?(x=2,De=pe.trimLeft()):(x=I[2].search(/[^ ]/),x=x>4?1:x,De=pe.slice(x),x+=I[1].length),se=!1,!pe&&/^ *$/.test(Pe)&&(S+=Pe+`
`,k=k.substring(Pe.length+1),Re=!0),!Re)for(var Ke=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),J=new RegExp("^ {0,"+Math.min(3,x-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),he=new RegExp("^ {0,"+Math.min(3,x-1)+"}(?:```|~~~)"),ve=new RegExp("^ {0,"+Math.min(3,x-1)+"}#");k&&(Ae=k.split(`
`,1)[0],pe=Ae,this.options.pedantic&&(pe=pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(he.test(pe)||ve.test(pe)||Ke.test(pe)||J.test(k)));){if(pe.search(/[^ ]/)>=x||!pe.trim())De+=`
`+pe.slice(x);else if(!se)De+=`
`+pe;else break;!se&&!pe.trim()&&(se=!0),S+=Ae+`
`,k=k.substring(Ae.length+1)}He.loose||(ge?He.loose=!0:/\n *\n *$/.test(S)&&(ge=!0)),this.options.gfm&&(N=/^\[[ xX]\] /.exec(De),N&&(z=N[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:S,task:!!N,checked:z,loose:!1,text:De}),He.raw+=S}He.items[He.items.length-1].raw=S.trimRight(),He.items[He.items.length-1].text=De.trimRight(),He.raw=He.raw.trimRight();var Ee=He.items.length;for(ee=0;ee<Ee;ee++){this.lexer.state.top=!1,He.items[ee].tokens=this.lexer.blockTokens(He.items[ee].text,[]);var Ce=He.items[ee].tokens.filter(function(Ue){return Ue.type==="space"}),Be=Ce.every(function(Ue){for(var Ze=Ue.raw.split(""),Je=0,Qe=U(Ze),Ve;!(Ve=Qe()).done;){var tt=Ve.value;if(tt===`
`&&(Je+=1),Je>1)return!0}return!1});!He.loose&&Ce.length&&Be&&(He.loose=!0,He.items[ee].loose=!0)}return He}},E.html=function(k){var I=this.rules.block.html.exec(k);if(I){var S={type:"html",raw:I[0],pre:!this.options.sanitizer&&(I[1]==="pre"||I[1]==="script"||I[1]==="style"),text:I[0]};if(this.options.sanitize){var N=this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]);S.type="paragraph",S.text=N,S.tokens=this.lexer.inline(N)}return S}},E.def=function(k){var I=this.rules.block.def.exec(k);if(I){I[3]&&(I[3]=I[3].substring(1,I[3].length-1));var S=I[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:S,raw:I[0],href:I[2],title:I[3]}}},E.table=function(k){var I=this.rules.block.table.exec(k);if(I){var S={type:"table",header:H(I[1]).map(function(ge){return{text:ge}}),align:I[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:I[3]&&I[3].trim()?I[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(S.header.length===S.align.length){S.raw=I[0];var N=S.align.length,z,x,ee,se;for(z=0;z<N;z++)/^ *-+: *$/.test(S.align[z])?S.align[z]="right":/^ *:-+: *$/.test(S.align[z])?S.align[z]="center":/^ *:-+ *$/.test(S.align[z])?S.align[z]="left":S.align[z]=null;for(N=S.rows.length,z=0;z<N;z++)S.rows[z]=H(S.rows[z],S.header.length).map(function(ge){return{text:ge}});for(N=S.header.length,x=0;x<N;x++)S.header[x].tokens=this.lexer.inline(S.header[x].text);for(N=S.rows.length,x=0;x<N;x++)for(se=S.rows[x],ee=0;ee<se.length;ee++)se[ee].tokens=this.lexer.inline(se[ee].text);return S}}},E.lheading=function(k){var I=this.rules.block.lheading.exec(k);if(I)return{type:"heading",raw:I[0],depth:I[2].charAt(0)==="="?1:2,text:I[1],tokens:this.lexer.inline(I[1])}},E.paragraph=function(k){var I=this.rules.block.paragraph.exec(k);if(I){var S=I[1].charAt(I[1].length-1)===`
`?I[1].slice(0,-1):I[1];return{type:"paragraph",raw:I[0],text:S,tokens:this.lexer.inline(S)}}},E.text=function(k){var I=this.rules.block.text.exec(k);if(I)return{type:"text",raw:I[0],text:I[0],tokens:this.lexer.inline(I[0])}},E.escape=function(k){var I=this.rules.inline.escape.exec(k);if(I)return{type:"escape",raw:I[0],text:e(I[1])}},E.tag=function(k){var I=this.rules.inline.tag.exec(k);if(I)return!this.lexer.state.inLink&&/^<a /i.test(I[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(I[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(I[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(I[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:I[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(I[0]):e(I[0]):I[0]}},E.link=function(k){var I=this.rules.inline.link.exec(k);if(I){var S=I[2].trim();if(!this.options.pedantic&&/^</.test(S)){if(!/>$/.test(S))return;var N=X(S.slice(0,-1),"\\");if((S.length-N.length)%2===0)return}else{var z=P(I[2],"()");if(z>-1){var x=I[0].indexOf("!")===0?5:4,ee=x+I[1].length+z;I[2]=I[2].substring(0,z),I[0]=I[0].substring(0,ee).trim(),I[3]=""}}var se=I[2],ge="";if(this.options.pedantic){var pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);pe&&(se=pe[1],ge=pe[3])}else ge=I[3]?I[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(S)?se=se.slice(1):se=se.slice(1,-1)),te(I,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:ge&&ge.replace(this.rules.inline._escapes,"$1")},I[0],this.lexer)}},E.reflink=function(k,I){var S;if((S=this.rules.inline.reflink.exec(k))||(S=this.rules.inline.nolink.exec(k))){var N=(S[2]||S[1]).replace(/\s+/g," ");if(N=I[N.toLowerCase()],!N||!N.href){var z=S[0].charAt(0);return{type:"text",raw:z,text:z}}return te(S,N,S[0],this.lexer)}},E.emStrong=function(k,I,S){S===void 0&&(S="");var N=this.rules.inline.emStrong.lDelim.exec(k);if(N&&!(N[3]&&S.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=N[1]||N[2]||"";if(!z||z&&(S===""||this.rules.inline.punctuation.exec(S))){var x=N[0].length-1,ee,se,ge=x,pe=0,Pe=N[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Pe.lastIndex=0,I=I.slice(-1*k.length+x);(N=Pe.exec(I))!=null;)if(ee=N[1]||N[2]||N[3]||N[4]||N[5]||N[6],!!ee){if(se=ee.length,N[3]||N[4]){ge+=se;continue}else if((N[5]||N[6])&&x%3&&!((x+se)%3)){pe+=se;continue}if(ge-=se,!(ge>0)){if(se=Math.min(se,se+ge+pe),Math.min(x,se)%2){var Ae=k.slice(1,x+N.index+se);return{type:"em",raw:k.slice(0,x+N.index+se+1),text:Ae,tokens:this.lexer.inlineTokens(Ae)}}var De=k.slice(2,x+N.index+se-1);return{type:"strong",raw:k.slice(0,x+N.index+se+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},E.codespan=function(k){var I=this.rules.inline.code.exec(k);if(I){var S=I[2].replace(/\n/g," "),N=/[^ ]/.test(S),z=/^ /.test(S)&&/ $/.test(S);return N&&z&&(S=S.substring(1,S.length-1)),S=e(S,!0),{type:"codespan",raw:I[0],text:S}}},E.br=function(k){var I=this.rules.inline.br.exec(k);if(I)return{type:"br",raw:I[0]}},E.del=function(k){var I=this.rules.inline.del.exec(k);if(I)return{type:"del",raw:I[0],text:I[2],tokens:this.lexer.inlineTokens(I[2])}},E.autolink=function(k,I){var S=this.rules.inline.autolink.exec(k);if(S){var N,z;return S[2]==="@"?(N=e(this.options.mangle?I(S[1]):S[1]),z="mailto:"+N):(N=e(S[1]),z=N),{type:"link",raw:S[0],text:N,href:z,tokens:[{type:"text",raw:N,text:N}]}}},E.url=function(k,I){var S;if(S=this.rules.inline.url.exec(k)){var N,z;if(S[2]==="@")N=e(this.options.mangle?I(S[0]):S[0]),z="mailto:"+N;else{var x;do x=S[0],S[0]=this.rules.inline._backpedal.exec(S[0])[0];while(x!==S[0]);N=e(S[0]),S[1]==="www."?z="http://"+N:z=N}return{type:"link",raw:S[0],text:N,href:z,tokens:[{type:"text",raw:N,text:N}]}}},E.inlineText=function(k,I){var S=this.rules.inline.text.exec(k);if(S){var N;return this.lexer.state.inRawBlock?N=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(S[0]):e(S[0]):S[0]:N=e(this.options.smartypants?I(S[0]):S[0]),{type:"text",raw:S[0],text:N}}},A}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=n(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=n(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=n(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=n(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=n(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=n(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=B({},ie),ie.gfm=B({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=n(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=n(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=B({},ie.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:n(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var oe={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};oe._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",oe.punctuation=n(oe.punctuation).replace(/punctuation/g,oe._punctuation).getRegex(),oe.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,oe.escapedEmSt=/\\\*|\\_/g,oe._comment=n(ie._comment).replace("(?:-->|$)","-->").getRegex(),oe.emStrong.lDelim=n(oe.emStrong.lDelim).replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimAst=n(oe.emStrong.rDelimAst,"g").replace(/punct/g,oe._punctuation).getRegex(),oe.emStrong.rDelimUnd=n(oe.emStrong.rDelimUnd,"g").replace(/punct/g,oe._punctuation).getRegex(),oe._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,oe._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,oe._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,oe.autolink=n(oe.autolink).replace("scheme",oe._scheme).replace("email",oe._email).getRegex(),oe._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,oe.tag=n(oe.tag).replace("comment",oe._comment).replace("attribute",oe._attribute).getRegex(),oe._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,oe._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,oe._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,oe.link=n(oe.link).replace("label",oe._label).replace("href",oe._href).replace("title",oe._title).getRegex(),oe.reflink=n(oe.reflink).replace("label",oe._label).replace("ref",ie._label).getRegex(),oe.nolink=n(oe.nolink).replace("ref",ie._label).getRegex(),oe.reflinkSearch=n(oe.reflinkSearch,"g").replace("reflink",oe.reflink).replace("nolink",oe.nolink).getRegex(),oe.normal=B({},oe),oe.pedantic=B({},oe.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",oe._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",oe._label).getRegex()}),oe.gfm=B({},oe.normal,{escape:n(oe.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),oe.gfm.url=n(oe.gfm.url,"i").replace("email",oe.gfm._extended_email).getRegex(),oe.breaks=B({},oe.gfm,{br:n(oe.br).replace("{2,}","*").getRegex(),text:n(oe.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function be(A){return A.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Se(A){var E="",M,k,I=A.length;for(M=0;M<I;M++)k=A.charCodeAt(M),Math.random()>.5&&(k="x"+k.toString(16)),E+="&#"+k+";";return E}var Te=function(){function A(M){this.tokens=[],this.tokens.links=Object.create(null),this.options=M||le.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var k={block:ie.normal,inline:oe.normal};this.options.pedantic?(k.block=ie.pedantic,k.inline=oe.pedantic):this.options.gfm&&(k.block=ie.gfm,this.options.breaks?k.inline=oe.breaks:k.inline=oe.gfm),this.tokenizer.rules=k}A.lex=function(k,I){var S=new A(I);return S.lex(k)},A.lexInline=function(k,I){var S=new A(I);return S.inlineTokens(k)};var E=A.prototype;return E.lex=function(k){k=k.replace(/\r\n|\r/g,`
`),this.blockTokens(k,this.tokens);for(var I;I=this.inlineQueue.shift();)this.inlineTokens(I.src,I.tokens);return this.tokens},E.blockTokens=function(k,I){var S=this;I===void 0&&(I=[]),this.options.pedantic?k=k.replace(/\t/g,"    ").replace(/^ +$/gm,""):k=k.replace(/^( *)(\t+)/gm,function(ge,pe,Pe){return pe+"    ".repeat(Pe.length)});for(var N,z,x,ee;k;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ge){return(N=ge.call({lexer:S},k,I))?(k=k.substring(N.raw.length),I.push(N),!0):!1}))){if(N=this.tokenizer.space(k)){k=k.substring(N.raw.length),N.raw.length===1&&I.length>0?I[I.length-1].raw+=`
`:I.push(N);continue}if(N=this.tokenizer.code(k)){k=k.substring(N.raw.length),z=I[I.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):I.push(N);continue}if(N=this.tokenizer.fences(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.heading(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.hr(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.blockquote(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.list(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.html(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.def(k)){k=k.substring(N.raw.length),z=I[I.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+N.raw,z.text+=`
`+N.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[N.tag]||(this.tokens.links[N.tag]={href:N.href,title:N.title});continue}if(N=this.tokenizer.table(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.lheading(k)){k=k.substring(N.raw.length),I.push(N);continue}if(x=k,this.options.extensions&&this.options.extensions.startBlock&&function(){var ge=1/0,pe=k.slice(1),Pe=void 0;S.options.extensions.startBlock.forEach(function(Ae){Pe=Ae.call({lexer:this},pe),typeof Pe=="number"&&Pe>=0&&(ge=Math.min(ge,Pe))}),ge<1/0&&ge>=0&&(x=k.substring(0,ge+1))}(),this.state.top&&(N=this.tokenizer.paragraph(x))){z=I[I.length-1],ee&&z.type==="paragraph"?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):I.push(N),ee=x.length!==k.length,k=k.substring(N.raw.length);continue}if(N=this.tokenizer.text(k)){k=k.substring(N.raw.length),z=I[I.length-1],z&&z.type==="text"?(z.raw+=`
`+N.raw,z.text+=`
`+N.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):I.push(N);continue}if(k){var se="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,I},E.inline=function(k,I){return I===void 0&&(I=[]),this.inlineQueue.push({src:k,tokens:I}),I},E.inlineTokens=function(k,I){var S=this;I===void 0&&(I=[]);var N,z,x,ee=k,se,ge,pe;if(this.tokens.links){var Pe=Object.keys(this.tokens.links);if(Pe.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(ee))!=null;)Pe.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(ee=ee.slice(0,se.index)+"["+Q("a",se[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(ee))!=null;)ee=ee.slice(0,se.index)+"["+Q("a",se[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(ee))!=null;)ee=ee.slice(0,se.index)+"++"+ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;k;)if(ge||(pe=""),ge=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(N=De.call({lexer:S},k,I))?(k=k.substring(N.raw.length),I.push(N),!0):!1}))){if(N=this.tokenizer.escape(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.tag(k)){k=k.substring(N.raw.length),z=I[I.length-1],z&&N.type==="text"&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):I.push(N);continue}if(N=this.tokenizer.link(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.reflink(k,this.tokens.links)){k=k.substring(N.raw.length),z=I[I.length-1],z&&N.type==="text"&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):I.push(N);continue}if(N=this.tokenizer.emStrong(k,ee,pe)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.codespan(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.br(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.del(k)){k=k.substring(N.raw.length),I.push(N);continue}if(N=this.tokenizer.autolink(k,Se)){k=k.substring(N.raw.length),I.push(N);continue}if(!this.state.inLink&&(N=this.tokenizer.url(k,Se))){k=k.substring(N.raw.length),I.push(N);continue}if(x=k,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Re=k.slice(1),Oe=void 0;S.options.extensions.startInline.forEach(function(_e){Oe=_e.call({lexer:this},Re),typeof Oe=="number"&&Oe>=0&&(De=Math.min(De,Oe))}),De<1/0&&De>=0&&(x=k.substring(0,De+1))}(),N=this.tokenizer.inlineText(x,be)){k=k.substring(N.raw.length),N.raw.slice(-1)!=="_"&&(pe=N.raw.slice(-1)),ge=!0,z=I[I.length-1],z&&z.type==="text"?(z.raw+=N.raw,z.text+=N.text):I.push(N);continue}if(k){var Ae="Infinite loop on byte: "+k.charCodeAt(0);if(this.options.silent){console.error(Ae);break}else throw new Error(Ae)}}return I},v(A,null,[{key:"rules",get:function(){return{block:ie,inline:oe}}}]),A}(),Fe=function(){function A(M){this.options=M||le.defaults}var E=A.prototype;return E.code=function(k,I,S){var N=(I||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(k,N);z!=null&&z!==k&&(S=!0,k=z)}return k=k.replace(/\n$/,"")+`
`,N?'<pre><code class="'+this.options.langPrefix+e(N,!0)+'">'+(S?k:e(k,!0))+`</code></pre>
`:"<pre><code>"+(S?k:e(k,!0))+`</code></pre>
`},E.blockquote=function(k){return`<blockquote>
`+k+`</blockquote>
`},E.html=function(k){return k},E.heading=function(k,I,S,N){if(this.options.headerIds){var z=this.options.headerPrefix+N.slug(S);return"<h"+I+' id="'+z+'">'+k+"</h"+I+`>
`}return"<h"+I+">"+k+"</h"+I+`>
`},E.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},E.list=function(k,I,S){var N=I?"ol":"ul",z=I&&S!==1?' start="'+S+'"':"";return"<"+N+z+`>
`+k+"</"+N+`>
`},E.listitem=function(k){return"<li>"+k+`</li>
`},E.checkbox=function(k){return"<input "+(k?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},E.paragraph=function(k){return"<p>"+k+`</p>
`},E.table=function(k,I){return I&&(I="<tbody>"+I+"</tbody>"),`<table>
<thead>
`+k+`</thead>
`+I+`</table>
`},E.tablerow=function(k){return`<tr>
`+k+`</tr>
`},E.tablecell=function(k,I){var S=I.header?"th":"td",N=I.align?"<"+S+' align="'+I.align+'">':"<"+S+">";return N+k+("</"+S+`>
`)},E.strong=function(k){return"<strong>"+k+"</strong>"},E.em=function(k){return"<em>"+k+"</em>"},E.codespan=function(k){return"<code>"+k+"</code>"},E.br=function(){return this.options.xhtml?"<br/>":"<br>"},E.del=function(k){return"<del>"+k+"</del>"},E.link=function(k,I,S){if(k=u(this.options.sanitize,this.options.baseUrl,k),k===null)return S;var N='<a href="'+e(k)+'"';return I&&(N+=' title="'+I+'"'),N+=">"+S+"</a>",N},E.image=function(k,I,S){if(k=u(this.options.sanitize,this.options.baseUrl,k),k===null)return S;var N='<img src="'+k+'" alt="'+S+'"';return I&&(N+=' title="'+I+'"'),N+=this.options.xhtml?"/>":">",N},E.text=function(k){return k},A}(),de=function(){function A(){}var E=A.prototype;return E.strong=function(k){return k},E.em=function(k){return k},E.codespan=function(k){return k},E.del=function(k){return k},E.html=function(k){return k},E.text=function(k){return k},E.link=function(k,I,S){return""+S},E.image=function(k,I,S){return""+S},E.br=function(){return""},A}(),ne=function(){function A(){this.seen={}}var E=A.prototype;return E.serialize=function(k){return k.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},E.getNextSafeSlug=function(k,I){var S=k,N=0;if(this.seen.hasOwnProperty(S)){N=this.seen[k];do N++,S=k+"-"+N;while(this.seen.hasOwnProperty(S))}return I||(this.seen[k]=N,this.seen[S]=0),S},E.slug=function(k,I){I===void 0&&(I={});var S=this.serialize(k);return this.getNextSafeSlug(S,I.dryrun)},A}(),ce=function(){function A(M){this.options=M||le.defaults,this.options.renderer=this.options.renderer||new Fe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new ne}A.parse=function(k,I){var S=new A(I);return S.parse(k)},A.parseInline=function(k,I){var S=new A(I);return S.parseInline(k)};var E=A.prototype;return E.parse=function(k,I){I===void 0&&(I=!0);var S="",N,z,x,ee,se,ge,pe,Pe,Ae,De,Re,Oe,_e,He,Me,Ke,J,he,ve,Ee=k.length;for(N=0;N<Ee;N++){if(De=k[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(ve=this.options.extensions.renderers[De.type].call({parser:this},De),ve!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){S+=ve||"";continue}switch(De.type){case"space":continue;case"hr":{S+=this.renderer.hr();continue}case"heading":{S+=this.renderer.heading(this.parseInline(De.tokens),De.depth,l(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{S+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(Pe="",pe="",ee=De.header.length,z=0;z<ee;z++)pe+=this.renderer.tablecell(this.parseInline(De.header[z].tokens),{header:!0,align:De.align[z]});for(Pe+=this.renderer.tablerow(pe),Ae="",ee=De.rows.length,z=0;z<ee;z++){for(ge=De.rows[z],pe="",se=ge.length,x=0;x<se;x++)pe+=this.renderer.tablecell(this.parseInline(ge[x].tokens),{header:!1,align:De.align[x]});Ae+=this.renderer.tablerow(pe)}S+=this.renderer.table(Pe,Ae);continue}case"blockquote":{Ae=this.parse(De.tokens),S+=this.renderer.blockquote(Ae);continue}case"list":{for(Re=De.ordered,Oe=De.start,_e=De.loose,ee=De.items.length,Ae="",z=0;z<ee;z++)Me=De.items[z],Ke=Me.checked,J=Me.task,He="",Me.task&&(he=this.renderer.checkbox(Ke),_e?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=he+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=he+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:he}):He+=he),He+=this.parse(Me.tokens,_e),Ae+=this.renderer.listitem(He,J,Ke);S+=this.renderer.list(Ae,Re,Oe);continue}case"html":{S+=this.renderer.html(De.text);continue}case"paragraph":{S+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ae=De.tokens?this.parseInline(De.tokens):De.text;N+1<Ee&&k[N+1].type==="text";)De=k[++N],Ae+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);S+=I?this.renderer.paragraph(Ae):Ae;continue}default:{var Ce='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(Ce);return}else throw new Error(Ce)}}}return S},E.parseInline=function(k,I){I=I||this.renderer;var S="",N,z,x,ee=k.length;for(N=0;N<ee;N++){if(z=k[N],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(x=this.options.extensions.renderers[z.type].call({parser:this},z),x!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){S+=x||"";continue}switch(z.type){case"escape":{S+=I.text(z.text);break}case"html":{S+=I.html(z.text);break}case"link":{S+=I.link(z.href,z.title,this.parseInline(z.tokens,I));break}case"image":{S+=I.image(z.href,z.title,z.text);break}case"strong":{S+=I.strong(this.parseInline(z.tokens,I));break}case"em":{S+=I.em(this.parseInline(z.tokens,I));break}case"codespan":{S+=I.codespan(z.text);break}case"br":{S+=I.br();break}case"del":{S+=I.del(this.parseInline(z.tokens,I));break}case"text":{S+=I.text(z.text);break}default:{var se='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return S},A}();function Z(A,E,M){if(typeof A>"u"||A===null)throw new Error("marked(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");if(typeof E=="function"&&(M=E,E=null),E=B({},Z.defaults,E||{}),O(E),M){var k=E.highlight,I;try{I=Te.lex(A,E)}catch(ee){return M(ee)}var S=function(se){var ge;if(!se)try{E.walkTokens&&Z.walkTokens(I,E.walkTokens),ge=ce.parse(I,E)}catch(pe){se=pe}return E.highlight=k,se?M(se):M(null,ge)};if(!k||k.length<3||(delete E.highlight,!I.length))return S();var N=0;Z.walkTokens(I,function(ee){ee.type==="code"&&(N++,setTimeout(function(){k(ee.text,ee.lang,function(se,ge){if(se)return S(se);ge!=null&&ge!==ee.text&&(ee.text=ge,ee.escaped=!0),N--,N===0&&S()})},0))}),N===0&&S();return}function z(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}try{var x=Te.lex(A,E);if(E.walkTokens){if(E.async)return Promise.all(Z.walkTokens(x,E.walkTokens)).then(function(){return ce.parse(x,E)}).catch(z);Z.walkTokens(x,E.walkTokens)}return ce.parse(x,E)}catch(ee){z(ee)}}Z.options=Z.setOptions=function(A){return B(Z.defaults,A),y(Z.defaults),Z},Z.getDefaults=w,Z.defaults=le.defaults,Z.use=function(){for(var A=arguments.length,E=new Array(A),M=0;M<A;M++)E[M]=arguments[M];var k=B.apply(void 0,[{}].concat(E)),I=Z.defaults.extensions||{renderers:{},childTokens:{}},S;E.forEach(function(N){if(N.extensions&&(S=!0,N.extensions.forEach(function(x){if(!x.name)throw new Error("extension name required");if(x.renderer){var ee=I.renderers?I.renderers[x.name]:null;ee?I.renderers[x.name]=function(){for(var se=arguments.length,ge=new Array(se),pe=0;pe<se;pe++)ge[pe]=arguments[pe];var Pe=x.renderer.apply(this,ge);return Pe===!1&&(Pe=ee.apply(this,ge)),Pe}:I.renderers[x.name]=x.renderer}if(x.tokenizer){if(!x.level||x.level!=="block"&&x.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");I[x.level]?I[x.level].unshift(x.tokenizer):I[x.level]=[x.tokenizer],x.start&&(x.level==="block"?I.startBlock?I.startBlock.push(x.start):I.startBlock=[x.start]:x.level==="inline"&&(I.startInline?I.startInline.push(x.start):I.startInline=[x.start]))}x.childTokens&&(I.childTokens[x.name]=x.childTokens)})),N.renderer&&function(){var x=Z.defaults.renderer||new Fe,ee=function(pe){var Pe=x[pe];x[pe]=function(){for(var Ae=arguments.length,De=new Array(Ae),Re=0;Re<Ae;Re++)De[Re]=arguments[Re];var Oe=N.renderer[pe].apply(x,De);return Oe===!1&&(Oe=Pe.apply(x,De)),Oe}};for(var se in N.renderer)ee(se);k.renderer=x}(),N.tokenizer&&function(){var x=Z.defaults.tokenizer||new fe,ee=function(pe){var Pe=x[pe];x[pe]=function(){for(var Ae=arguments.length,De=new Array(Ae),Re=0;Re<Ae;Re++)De[Re]=arguments[Re];var Oe=N.tokenizer[pe].apply(x,De);return Oe===!1&&(Oe=Pe.apply(x,De)),Oe}};for(var se in N.tokenizer)ee(se);k.tokenizer=x}(),N.walkTokens){var z=Z.defaults.walkTokens;k.walkTokens=function(x){var ee=[];return ee.push(N.walkTokens.call(this,x)),z&&(ee=ee.concat(z.call(this,x))),ee}}S&&(k.extensions=I),Z.setOptions(k)})},Z.walkTokens=function(A,E){for(var M=[],k=function(){var z=S.value;switch(M=M.concat(E.call(Z,z)),z.type){case"table":{for(var x=U(z.header),ee;!(ee=x()).done;){var se=ee.value;M=M.concat(Z.walkTokens(se.tokens,E))}for(var ge=U(z.rows),pe;!(pe=ge()).done;)for(var Pe=pe.value,Ae=U(Pe),De;!(De=Ae()).done;){var Re=De.value;M=M.concat(Z.walkTokens(Re.tokens,E))}break}case"list":{M=M.concat(Z.walkTokens(z.items,E));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[z.type]?Z.defaults.extensions.childTokens[z.type].forEach(function(Oe){M=M.concat(Z.walkTokens(z[Oe],E))}):z.tokens&&(M=M.concat(Z.walkTokens(z.tokens,E)))}},I=U(A),S;!(S=I()).done;)k();return M},Z.parseInline=function(A,E){if(typeof A>"u"||A===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof A!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(A)+", string expected");E=B({},Z.defaults,E||{}),O(E);try{var M=Te.lexInline(A,E);return E.walkTokens&&Z.walkTokens(M,E.walkTokens),ce.parseInline(M,E)}catch(k){if(k.message+=`
Please report this to https://github.com/markedjs/marked.`,E.silent)return"<p>An error occurred:</p><pre>"+e(k.message+"",!0)+"</pre>";throw k}},Z.Parser=ce,Z.parser=ce.parse,Z.Renderer=Fe,Z.TextRenderer=de,Z.Lexer=Te,Z.lexer=Te.lex,Z.Tokenizer=fe,Z.Slugger=ne,Z.parse=Z;var V=Z.options,Y=Z.setOptions,C=Z.use,q=Z.walkTokens,$=Z.parseInline,W=Z,_=ce.parse,p=Te.lex;le.Lexer=Te,le.Parser=ce,le.Renderer=Fe,le.Slugger=ne,le.TextRenderer=de,le.Tokenizer=fe,le.getDefaults=w,le.lexer=p,le.marked=Z,le.options=V,le.parse=W,le.parseInline=$,le.parser=_,le.setOptions=Y,le.use=C,le.walkTokens=q,Object.defineProperty(le,"__esModule",{value:!0})}),define($e[80],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$R=void 0;class v{constructor(i,U=0,w=i.length,y=U-1){this.a=i,this.b=U,this.c=w,this.d=y}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$$R=v}),define($e[81],we([1,0,80]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aS=t.$_R=void 0;class T{constructor(w=[],y=10){this.h(w),this.b=y,this.d()}getHistory(){return this.j}add(w){this.a.delete(w),this.a.add(w),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(w){return this.a.has(w)}clear(){this.h([]),this.d()}d(){this.f();const w=this.j;this.c=new v.$$R(w,0,w.length,w.length)}f(){const w=this.j;w.length>this.b&&this.h(w.slice(w.length-this.b))}g(){const w=this.c.current();return w?this.j.indexOf(w):-1}h(w){this.a=new Set;for(const y of w)this.a.add(y)}get j(){const w=[];return this.a.forEach(y=>w.push(y)),w}}t.$_R=T;class i{get size(){return this.f}constructor(w,y=10){if(this.g=y,w.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:w[0],previous:void 0,next:void 0},this.a=new Set([w[0]]);for(let c=1;c<w.length;c++)this.add(w[c])}add(w){const y={value:w,previous:this.c,next:void 0};for(this.c.next=y,this.c=y,this.d=this.c,this.f++,this.a.has(w)?this.h(w):this.a.add(w);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(w){if(this.c.value===w)return w;const y=this.c.value;return this.a.delete(y),this.c.value=w,this.a.has(w)?this.h(w):this.a.add(w),y}prepend(w){if(this.f===this.g||this.a.has(w))return;const y={value:w,previous:void 0,next:this.b};this.b.previous=y,this.b=y,this.f++,this.a.add(w)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(w){return this.a.has(w)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let w=this.b;for(;w;)yield w.value,w=w.next}h(w){let y=this.b;for(;y!==this.c;)y.value===w&&(y===this.b?(this.b=this.b.next,this.b.previous=void 0):(y.previous.next=y.next,y.next.previous=y.previous),this.f--),y=y.next}}t.$aS=i}),define($e[46],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tl=t.$Sl=t.$Rl=t.rot=t.$Pl=void 0;function v(y,c,g){return Math.min(Math.max(y,c),g)}t.$Pl=v;function T(y,c){return(c+y%c)%c}t.rot=T;class i{constructor(){this.a=0}getNext(){return this.a++}}t.$Rl=i;class U{constructor(){this.a=1,this.b=0}update(c){return this.b=this.b+(c-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Sl=U;class w{constructor(c){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(c),this.c.fill(0,0,c)}update(c){const g=this.c[this.d];return this.c[this.d]=c,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=c,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Tl=w}),define($e[47],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var v;(function(T){function i(c,g){if(c.start>=g.end||g.start>=c.end)return{start:0,end:0};const f=Math.max(c.start,g.start),L=Math.min(c.end,g.end);return L-f<=0?{start:0,end:0}:{start:f,end:L}}T.intersect=i;function U(c){return c.end-c.start<=0}T.isEmpty=U;function w(c,g){return!U(i(c,g))}T.intersects=w;function y(c,g){const f=[],L={start:c.start,end:Math.min(g.start,c.end)},s={start:Math.max(g.end,c.start),end:c.end};return U(L)||f.push(L),U(s)||f.push(s),f}T.relativeComplement=y})(v||(t.Range=v={}))}),define($e[82],we([1,0,47]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4Q=t.$3Q=t.$2Q=t.$1Q=void 0;function T(c,g){const f=[];for(const L of g){if(c.start>=L.range.end)continue;if(c.end<L.range.start)break;const s=v.Range.intersect(c,L.range);v.Range.isEmpty(s)||f.push({range:s,size:L.size})}return f}t.$1Q=T;function i({start:c,end:g},f){return{start:c+f,end:g+f}}t.$2Q=i;function U(c){const g=[];let f=null;for(const L of c){const s=L.range.start,a=L.range.end,e=L.size;if(f&&e===f.size){f.range.end=a;continue}f={range:{start:s,end:a},size:e},g.push(f)}return g}t.$3Q=U;function w(...c){return U(c.reduce((g,f)=>g.concat(f),[]))}class y{get paddingTop(){return this.c}set paddingTop(g){this.b=this.b+g-this.c,this.c=g}constructor(g){this.a=[],this.b=0,this.c=0,this.c=g??0,this.b=this.c}splice(g,f,L=[]){const s=L.length-f,a=T({start:0,end:g},this.a),e=T({start:g+f,end:Number.POSITIVE_INFINITY},this.a).map(l=>({range:i(l.range,s),size:l.size})),h=L.map((l,m)=>({range:{start:g+m,end:g+m+1},size:l.size}));this.a=w(a,h,e),this.b=this.c+this.a.reduce((l,m)=>l+m.size*(m.range.end-m.range.start),0)}get count(){const g=this.a.length;return g?this.a[g-1].range.end:0}get size(){return this.b}indexAt(g){if(g<0)return-1;if(g<this.c)return 0;let f=0,L=this.c;for(const s of this.a){const a=s.range.end-s.range.start,e=L+a*s.size;if(g<e)return f+Math.floor((g-L)/s.size);f+=a,L=e}return f}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let f=0,L=0;for(const s of this.a){const a=s.range.end-s.range.start,e=L+a;if(g<e)return this.c+f+(g-L)*s.size;f+=a*s.size,L=e}return-1}}t.$4Q=y}),define($e[83],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jd=void 0;const v=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(U){return new T(U)}constructor(U){this.c=v&&U===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Jd=T}),define($e[4],we([1,0,6,43,2,45,83]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.Event=void 0;const y=!1,c=!1;var g;(function(X){X.None=()=>i.$Rc.None;function P(I){if(c){const{onDidAddListener:S}=I,N=e.create();let z=0;I.onDidAddListener=()=>{++z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),N.print()),S?.()}}}function O(I,S){return Fe(I,()=>{},0,void 0,!0,void 0,S)}X.defer=O;function Q(I){return(S,N=null,z)=>{let x=!1,ee;return ee=I(se=>{if(!x)return ee?ee.dispose():x=!0,S.call(N,se)},null,z),x&&ee.dispose(),ee}}X.once=Q;function te(I,S,N){return Se((z,x=null,ee)=>I(se=>z.call(x,S(se)),null,ee),N)}X.map=te;function re(I,S,N){return Se((z,x=null,ee)=>I(se=>{S(se),z.call(x,se)},null,ee),N)}X.forEach=re;function fe(I,S,N){return Se((z,x=null,ee)=>I(se=>S(se)&&z.call(x,se),null,ee),N)}X.filter=fe;function ie(I){return I}X.signal=ie;function oe(...I){return(S,N=null,z)=>{const x=(0,i.$Oc)(...I.map(ee=>ee(se=>S.call(N,se))));return Te(x,z)}}X.any=oe;function be(I,S,N,z){let x=N;return te(I,ee=>(x=S(x,ee),x),z)}X.reduce=be;function Se(I,S){let N;const z={onWillAddFirstListener(){N=I(x.fire,x)},onDidRemoveLastListener(){N?.dispose()}};S||P(z);const x=new r(z);return S?.add(x),x.event}function Te(I,S){return S instanceof Array?S.push(I):S&&S.add(I),I}function Fe(I,S,N=100,z=!1,x=!1,ee,se){let ge,pe,Pe,Ae=0,De;const Re={leakWarningThreshold:ee,onWillAddFirstListener(){ge=I(_e=>{Ae++,pe=S(pe,_e),z&&!Pe&&(Oe.fire(pe),pe=void 0),De=()=>{const He=pe;pe=void 0,Pe=void 0,(!z||Ae>1)&&Oe.fire(He),Ae=0},typeof N=="number"?(clearTimeout(Pe),Pe=setTimeout(De,N)):Pe===void 0&&(Pe=0,queueMicrotask(De))})},onWillRemoveListener(){x&&Ae>0&&De?.()},onDidRemoveLastListener(){De=void 0,ge.dispose()}};se||P(Re);const Oe=new r(Re);return se?.add(Oe),Oe.event}X.debounce=Fe;function de(I,S=0,N){return X.debounce(I,(z,x)=>z?(z.push(x),z):[x],S,void 0,!0,void 0,N)}X.accumulate=de;function ne(I,S=(z,x)=>z===x,N){let z=!0,x;return fe(I,ee=>{const se=z||!S(ee,x);return z=!1,x=ee,se},N)}X.latch=ne;function ce(I,S,N){return[X.filter(I,S,N),X.filter(I,z=>!S(z),N)]}X.split=ce;function Z(I,S=!1,N=[],z){let x=N.slice(),ee=I(pe=>{x?x.push(pe):ge.fire(pe)});z&&z.add(ee);const se=()=>{x?.forEach(pe=>ge.fire(pe)),x=null},ge=new r({onWillAddFirstListener(){ee||(ee=I(pe=>ge.fire(pe)),z&&z.add(ee))},onDidAddFirstListener(){x&&(S?setTimeout(se):se())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return z&&z.add(ge),ge.event}X.buffer=Z;function V(I,S){return(z,x,ee)=>{const se=S(new C);return I(function(ge){const pe=se.evaluate(ge);pe!==Y&&z.call(x,pe)},void 0,ee)}}X.chain=V;const Y=Symbol("HaltChainable");class C{constructor(){this.f=[]}map(S){return this.f.push(S),this}forEach(S){return this.f.push(N=>(S(N),N)),this}filter(S){return this.f.push(N=>S(N)?N:Y),this}reduce(S,N){let z=N;return this.f.push(x=>(z=S(z,x),z)),this}latch(S=(N,z)=>N===z){let N=!0,z;return this.f.push(x=>{const ee=N||!S(x,z);return N=!1,z=x,ee?x:Y}),this}evaluate(S){for(const N of this.f)if(S=N(S),S===Y)break;return S}}function q(I,S,N=z=>z){const z=(...ge)=>se.fire(N(...ge)),x=()=>I.on(S,z),ee=()=>I.removeListener(S,z),se=new r({onWillAddFirstListener:x,onDidRemoveLastListener:ee});return se.event}X.fromNodeEventEmitter=q;function $(I,S,N=z=>z){const z=(...ge)=>se.fire(N(...ge)),x=()=>I.addEventListener(S,z),ee=()=>I.removeEventListener(S,z),se=new r({onWillAddFirstListener:x,onDidRemoveLastListener:ee});return se.event}X.fromDOMEventEmitter=$;function W(I){return new Promise(S=>Q(I)(S))}X.toPromise=W;function _(I){const S=new r;return I.then(N=>{S.fire(N)},()=>{S.fire(void 0)}).finally(()=>{S.dispose()}),S.event}X.fromPromise=_;function p(I,S,N){return S(N),I(z=>S(z))}X.runAndSubscribe=p;function A(I,S){let N=null;function z(ee){N?.dispose(),N=new i.$Qc,S(ee,N)}z(void 0);const x=I(ee=>z(ee));return(0,i.$Pc)(()=>{x.dispose(),N?.dispose()})}X.runAndSubscribeWithStore=A;class E{constructor(S,N){this._observable=S,this.f=0,this.g=!1;const z={onWillAddFirstListener:()=>{S.addObserver(this)},onDidRemoveLastListener:()=>{S.removeObserver(this)}};N||P(z),this.emitter=new r(z),N&&N.add(this.emitter)}beginUpdate(S){this.f++}handlePossibleChange(S){}handleChange(S,N){this.g=!0}endUpdate(S){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function M(I,S){return new E(I,S).emitter.event}X.fromObservable=M;function k(I){return S=>{let N=0,z=!1;const x={beginUpdate(){N++},endUpdate(){N--,N===0&&(I.reportChanges(),z&&(z=!1,S()))},handlePossibleChange(){},handleChange(){z=!0}};return I.addObserver(x),I.reportChanges(),{dispose(){I.removeObserver(x)}}}}X.fromObservableLight=k})(g||(t.Event=g={}));class f{static{this.all=new Set}static{this.f=0}constructor(P){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${P}_${f.f++}`,f.all.add(this)}start(P){this.g=new w.$Jd,this.listenerCount=P}stop(){if(this.g){const P=this.g.elapsed();this.durations.push(P),this.elapsedOverall+=P,this.invocationCount+=1,this.g=void 0}}}t.$Ld=f;let L=-1;function s(X){const P=L;return L=X,{dispose(){L=P}}}t.$Md=s;class a{constructor(P,O=Math.random().toString(18).slice(2,5)){this.threshold=P,this.name=O,this.g=0}dispose(){this.f?.clear()}check(P,O){const Q=this.threshold;if(Q<=0||O<Q)return;this.f||(this.f=new Map);const te=this.f.get(P.value)||0;if(this.f.set(P.value,te+1),this.g-=1,this.g<=0){this.g=Q*.5;let re,fe=0;for(const[ie,oe]of this.f)(!re||fe<oe)&&(re=ie,fe=oe);console.warn(`[${this.name}] potential listener LEAK detected, having ${O} listeners already. MOST frequent listener (${fe}):`),console.warn(re)}return()=>{const re=this.f.get(P.value)||0;this.f.set(P.value,re-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(P){this.value=P}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let h=0;class l{constructor(P){this.value=P,this.id=h++}}const m=2,n=(X,P)=>{if(X instanceof l)P(X);else for(let O=0;O<X.length;O++){const Q=X[O];Q&&P(Q)}};class r{constructor(P){this.w=0,this.f=P,this.g=L>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??L):void 0,this.j=this.f?._profName?new f(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(y){const P=this.t;queueMicrotask(()=>{n(P,O=>O.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(P,O,Q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$Rc.None;if(this.m)return i.$Rc.None;O&&(P=P.bind(O));const te=new l(P);let re,fe;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(te.stack=e.create(),re=this.g.check(te.stack,this.w+1)),y&&(te.stack=fe??e.create()),this.t?this.t instanceof l?(this.u??=new u,this.t=[this.t,te]):this.t.push(te):(this.f?.onWillAddFirstListener?.(this),this.t=te,this.f?.onDidAddFirstListener?.(this)),this.w++;const ie=(0,i.$Pc)(()=>{re?.(),this.x(te)});return Q instanceof i.$Qc?Q.add(ie):Array.isArray(Q)&&Q.push(ie),ie},this.q}x(P){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const O=this.t,Q=O.indexOf(P);if(Q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,O[Q]=void 0;const te=this.u.current===this;if(this.w*m<=O.length){let re=0;for(let fe=0;fe<O.length;fe++)O[fe]?O[re++]=O[fe]:te&&(this.u.end--,re<this.u.i&&this.u.i--);O.length=re}}y(P,O){if(!P)return;const Q=this.f?.onListenerError||v.$Z;if(!Q){P.value(O);return}try{P.value(O)}catch(te){Q(te)}}z(P){const O=P.current.t;for(;P.i<P.end;)this.y(O[P.i++],P.value);P.reset()}fire(P){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,P);else{const O=this.u;O.enqueue(this,P,this.t.length),this.z(O)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Nd=r;const b=()=>new u;t.$Od=b;class u{constructor(){this.i=-1,this.end=0}enqueue(P,O,Q){this.i=0,this.end=Q,this.current=P,this.value=O}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class o extends r{async fireAsync(P,O,Q){if(this.t)for(this.h||(this.h=new U.$1c),n(this.t,te=>this.h.push([te.value,P]));this.h.size>0&&!O.isCancellationRequested;){const[te,re]=this.h.shift(),fe=[],ie={...re,token:O,waitUntil:oe=>{if(Object.isFrozen(fe))throw new Error("waitUntil can NOT be called asynchronous");Q&&(oe=Q(oe,te)),fe.push(oe)}};try{te(ie)}catch(oe){(0,v.$Z)(oe);continue}Object.freeze(fe),await Promise.allSettled(fe).then(oe=>{for(const be of oe)be.status==="rejected"&&(0,v.$Z)(be.reason)})}}}t.$Pd=o;class F extends r{get isPaused(){return this.h!==0}constructor(P){super(P),this.h=0,this.s=new U.$1c,this.A=P?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const P=Array.from(this.s);this.s.clear(),super.fire(this.A(P))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(P){this.w&&(this.h!==0?this.s.push(P):super.fire(P))}}t.$Qd=F;class j extends F{constructor(P){super(P),this.k=P.delay??100}fire(P){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(P)}}t.$Rd=j;class R extends r{constructor(P){super(P),this.h=[],this.k=P?.merge}fire(P){this.hasListeners()&&(this.h.push(P),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(O=>super.fire(O)),this.h=[]}))}}t.$Sd=R;class d{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(P){const O={event:P,listener:null};this.h.push(O),this.g&&this.m(O);const Q=()=>{this.g&&this.o(O);const te=this.h.indexOf(O);this.h.splice(te,1)};return(0,i.$Pc)((0,T.$cb)(Q))}j(){this.g=!0,this.h.forEach(P=>this.m(P))}k(){this.g=!1,this.h.forEach(P=>this.o(P))}m(P){P.listener=P.event(O=>this.f.fire(O))}o(P){P.listener&&P.listener.dispose(),P.listener=null}dispose(){this.f.dispose()}}t.$Td=d;class D{constructor(P,O,Q,te){this.f=new i.$Qc;const re=this.f.add(new d),fe=this.f.add(new i.$Zc);function ie(oe){fe.set(oe,re.add(te(oe)))}for(const oe of P)ie(oe);this.f.add(O(oe=>{ie(oe)})),this.f.add(Q(oe=>{fe.deleteAndDispose(oe)})),this.event=re.event}dispose(){this.f.dispose()}}t.$Ud=D;class B{constructor(){this.f=[]}wrapEvent(P){return(O,Q,te)=>P(re=>{const fe=this.f[this.f.length-1];fe?fe.push(()=>O.call(Q,re)):O.call(Q,re)},void 0,te)}bufferEvents(P){const O=[];this.f.push(O);const Q=P();return this.f.pop(),O.forEach(te=>te()),Q}}t.$Vd=B;class H{constructor(){this.f=!1,this.g=g.None,this.h=i.$Rc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(P){this.g=P,this.f&&(this.h.dispose(),this.h=P(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$Wd=H}),define($e[17],we([1,0,14,4,2]),function(le,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JO=t.$IO=t.$HO=t.$GO=t.$FO=t.$EO=t.$DO=t.$CO=t.$BO=t.$AO=t.$zO=t.$yO=t.$xO=t.$wO=t.$vO=t.$uO=t.$tO=t.$sO=void 0;class U{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new T.$Nd,this.onDidChangeFullscreen=this.d.event}static{this.INSTANCE=new U}getZoomLevel(){return this.a}setZoomLevel(u){this.a!==u&&(this.a=u)}getZoomFactor(){return this.b}setZoomFactor(u){this.b=u}setFullscreen(u){this.c!==u&&(this.c=u,this.d.fire())}isFullscreen(){return this.c}}class w extends i.$Rc{constructor(){super(),this.a=this.B(new T.$Nd),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(u){this.c?.removeEventListener("change",this.b),this.c=v.$window.matchMedia(`(resolution: ${v.$window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),u&&this.a.fire()}}class y extends i.$Rc{get value(){return this.b}constructor(){super(),this.a=this.B(new T.$Nd),this.onDidChange=this.a.event,this.b=this.c();const u=this.B(new w);this.B(u.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const u=document.createElement("canvas").getContext("2d"),o=v.$window.devicePixelRatio||1,F=u.webkitBackingStorePixelRatio||u.mozBackingStorePixelRatio||u.msBackingStorePixelRatio||u.oBackingStorePixelRatio||u.backingStorePixelRatio||1;return o/F}}class c{constructor(){this.a=null}b(){return this.a||(this.a=(0,i.$Kc)(new y)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function g(b,u){typeof b=="string"&&(b=v.$window.matchMedia(b)),b.addEventListener("change",u)}t.$sO=g,t.$tO=new c;function f(b){U.INSTANCE.setZoomLevel(b)}t.$uO=f;function L(){return U.INSTANCE.getZoomLevel()}t.$vO=L;function s(){return U.INSTANCE.getZoomFactor()}t.$wO=s;function a(b){U.INSTANCE.setZoomFactor(b)}t.$xO=a;function e(b){U.INSTANCE.setFullscreen(b)}t.$yO=e;function h(){return U.INSTANCE.isFullscreen()}t.$zO=h,t.$AO=U.INSTANCE.onDidChangeFullscreen;const l=navigator.userAgent;t.$BO=l.indexOf("Firefox")>=0,t.$CO=l.indexOf("AppleWebKit")>=0,t.$DO=l.indexOf("Chrome")>=0,t.$EO=!t.$DO&&l.indexOf("Safari")>=0,t.$FO=!t.$DO&&!t.$EO&&t.$CO,t.$GO=l.indexOf("Electron/")>=0,t.$HO=l.indexOf("Android")>=0;let m=!1;if(v.$window.matchMedia){const b=v.$window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),u=v.$window.matchMedia("(display-mode: fullscreen)");m=b.matches,g(b,({matches:o})=>{m&&u.matches||(m=o)})}function n(){return m}t.$IO=n;function r(){return navigator?.windowControlsOverlay?.visible}t.$JO=r}),define($e[22],we([1,0,4]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SQ=void 0;class T{get event(){return this.a.event}constructor(U,w,y){const c=g=>this.a.fire(g);this.a=new v.$Nd({onWillAddFirstListener:()=>U.addEventListener(w,c,y),onDidRemoveLastListener:()=>U.removeEventListener(w,c,y)})}dispose(){this.a.dispose()}}t.$SQ=T}),define($e[29],we([1,0,4]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xd=t.CancellationToken=void 0;const T=Object.freeze(function(y,c){const g=setTimeout(y.bind(c),0);return{dispose(){clearTimeout(g)}}});var i;(function(y){function c(g){return g===y.None||g===y.Cancelled||g instanceof U?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}y.isCancellationToken=c,y.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),y.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(i||(t.CancellationToken=i={}));class U{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new v.$Nd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class w{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new U),this.f}cancel(){this.f?this.f instanceof U&&this.f.cancel():this.f=i.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof U&&this.f.dispose():this.f=i.None}}t.$Xd=w}),define($e[84],we([1,0,29]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ye=t.$xe=t.$we=void 0;class T{constructor(y){this.b=y,this.a=null}get(){if(this.a)return this.a;const y=new v.$Xd,c=this.b(y.token);return this.a={promise:c,dispose:()=>{this.a=null,y.cancel(),y.dispose()}},this.a}}t.$we=T;class i{constructor(y){this.c=y,this.a=void 0,this.b=void 0}get(y){const c=JSON.stringify(y);return this.b!==c&&(this.b=c,this.a=this.c(y)),this.a}}t.$xe=i;class U{get cachedValues(){return this.a}constructor(y){this.b=y,this.a=new Map}get(y){if(this.a.has(y))return this.a.get(y);const c=this.b(y);return this.a.set(y,c),c}}t.$ye=U}),define($e[48],we([1,0,4,2]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yr=t.$Xr=t.$Wr=t.$Vr=t.ScrollbarVisibility=void 0;var i;(function(a){a[a.Auto=1]="Auto",a[a.Hidden=2]="Hidden",a[a.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class U{constructor(e,h,l,m,n,r,b){this.c=e,this._scrollStateBrand=void 0,this.c&&(h=h|0,l=l|0,m=m|0,n=n|0,r=r|0,b=b|0),this.rawScrollLeft=m,this.rawScrollTop=b,h<0&&(h=0),m+h>l&&(m=l-h),m<0&&(m=0),n<0&&(n=0),b+n>r&&(b=r-n),b<0&&(b=0),this.width=h,this.scrollWidth=l,this.scrollLeft=m,this.height=n,this.scrollHeight=r,this.scrollTop=b}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,h){return new U(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,h?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,h?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new U(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,h){const l=this.width!==e.width,m=this.scrollWidth!==e.scrollWidth,n=this.scrollLeft!==e.scrollLeft,r=this.height!==e.height,b=this.scrollHeight!==e.scrollHeight,u=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:h,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:l,scrollWidthChanged:m,scrollLeftChanged:n,heightChanged:r,scrollHeightChanged:b,scrollTopChanged:u}}}t.$Vr=U;class w extends T.$Rc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new v.$Nd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new U(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,h){const l=this.g.withScrollDimensions(e,h);this.n(l,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const h=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(h,!1)}setScrollPositionSmooth(e,h){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const l=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===l.scrollLeft&&this.h.to.scrollTop===l.scrollTop)return;let m;h?m=new f(this.h.from,l,this.h.startTime,this.h.duration):m=this.h.combine(this.g,l,this.c),this.h.dispose(),this.h=m}else{const l=this.g.withScrollPosition(e);this.h=f.start(this.g,l,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),h=this.g.withScrollPosition(e);if(this.n(h,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,h){const l=this.g;l.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(l,h)))}}t.$Wr=w;class y{constructor(e,h,l){this.scrollLeft=e,this.scrollTop=h,this.isDone=l}}t.$Xr=y;function c(a,e){const h=e-a;return function(l){return a+h*s(l)}}function g(a,e,h){return function(l){return l<h?a(l/h):e((l-h)/(1-h))}}class f{constructor(e,h,l,m){this.from=e,this.to=h,this.duration=m,this.startTime=l,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,h,l){if(Math.abs(e-h)>2.5*l){let n,r;return e<h?(n=e+.75*l,r=h-.75*l):(n=e-.75*l,r=h+.75*l),g(c(e,n),c(r,h),.33)}return c(e,h)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const h=(e-this.startTime)/this.duration;if(h<1){const l=this.c(h),m=this.d(h);return new y(l,m,!1)}return new y(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,h,l){return f.start(e,h,l)}static start(e,h,l){l=l+10;const m=Date.now()-10;return new f(e,h,m,l)}}t.$Yr=f;function L(a){return Math.pow(a,3)}function s(a){return 1-L(1-a)}}),define($e[85],we([1,0,6,2]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=void 0;function i(b){const u=b;return u?typeof u.read=="function":!1}t.$Yd=i;function U(b){const u=b;return u?[u.on,u.pause,u.resume,u.destroy].every(o=>typeof o=="function"):!1}t.$Zd=U;function w(b){const u=b;return u?U(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}t.$1d=w;function y(b,u){return new c(b,u)}t.$2d=y;class c{constructor(u,o){this.e=u,this.f=o,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(o=>this.d.push(o))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(o=>o(u))}h(u){this.c.error.length===0?(0,v.$Z)(u):this.c.error.slice(0).forEach(o=>o(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,o){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(o),this.resume();break;case"end":this.c.end.push(o),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(o),this.a.flowing&&this.k();break}}removeListener(u,o){if(this.a.destroyed)return;let F;switch(u){case"data":F=this.c.data;break;case"end":F=this.c.end;break;case"error":F=this.c.error;break}if(F){const j=F.indexOf(o);j>=0&&F.splice(j,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const o=[...this.d];this.d.length=0,o.forEach(F=>F())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(b,u){const o=[];let F;for(;(F=b.read())!==null;)o.push(F);return u(o)}t.$3d=g;function f(b,u,o){const F=[];let j;for(;(j=b.read())!==null&&F.length<o;)F.push(j);return j===null&&F.length>0?u(F):{read:()=>{if(F.length>0)return F.shift();if(typeof j<"u"){const R=j;return j=void 0,R}return b.read()}}}t.$4d=f;function L(b,u){return new Promise((o,F)=>{const j=[];s(b,{onData:R=>{u&&j.push(R)},onError:R=>{u?F(R):o(void 0)},onEnd:()=>{o(u?u(j):void 0)}})})}t.$5d=L;function s(b,u,o){b.on("error",F=>{o?.isCancellationRequested||u.onError(F)}),b.on("end",()=>{o?.isCancellationRequested||u.onEnd()}),b.on("data",F=>{o?.isCancellationRequested||u.onData(F)})}t.$6d=s;function a(b,u){return new Promise((o,F)=>{const j=new T.$Qc,R=[],d=H=>{if(R.push(H),R.length>u)return j.dispose(),b.pause(),o({stream:b,buffer:R,ended:!1})},D=H=>(j.dispose(),F(H)),B=()=>(j.dispose(),o({stream:b,buffer:R,ended:!0}));j.add((0,T.$Pc)(()=>b.removeListener("error",D))),b.on("error",D),j.add((0,T.$Pc)(()=>b.removeListener("end",B))),b.on("end",B),j.add((0,T.$Pc)(()=>b.removeListener("data",d))),b.on("data",d)})}t.$7d=a;function e(b,u){const o=y(u);return o.end(b),o}t.$8d=e;function h(){const b=y(()=>{throw new Error("not supported")});return b.end(),b}t.$9d=h;function l(b){let u=!1;return{read:()=>u?null:(u=!0,b)}}t.$0d=l;function m(b,u,o){const F=y(o);return s(b,{onData:j=>F.write(u.data(j)),onError:j=>F.error(u.error?u.error(j):j),onEnd:()=>F.end()}),F}t.$$d=m;function n(b,u,o){let F=!1;return{read:()=>{const j=u.read();return F?j:(F=!0,j!==null?o([b,j]):b)}}}t.$_d=n;function r(b,u,o){let F=!1;const j=y(o);return s(u,{onData:R=>F?j.write(R):(F=!0,j.write(o([b,R]))),onError:R=>j.error(R),onEnd:()=>{F||(F=!0,j.write(b)),j.end()}}),j}t.$ae=r}),define($e[33],we([1,0,28,85]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=void 0;const i=typeof Buffer<"u",U=new v.$U(()=>new Uint8Array(256));let w,y;class c{static alloc(O){return i?new c(Buffer.allocUnsafe(O)):new c(new Uint8Array(O))}static wrap(O){return i&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new c(O)}static fromString(O,Q){return!(Q?.dontUseNodeBuffer||!1)&&i?new c(Buffer.from(O)):(w||(w=new TextEncoder),new c(w.encode(O)))}static fromByteArray(O){const Q=c.alloc(O.length);for(let te=0,re=O.length;te<re;te++)Q.buffer[te]=O[te];return Q}static concat(O,Q){if(typeof Q>"u"){Q=0;for(let fe=0,ie=O.length;fe<ie;fe++)Q+=O[fe].byteLength}const te=c.alloc(Q);let re=0;for(let fe=0,ie=O.length;fe<ie;fe++){const oe=O[fe];te.set(oe,re),re+=oe.byteLength}return te}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=c.alloc(this.byteLength);return O.set(this),O}toString(){return i?this.buffer.toString():(y||(y=new TextDecoder),y.decode(this.buffer))}slice(O,Q){return new c(this.buffer.subarray(O,Q))}set(O,Q){if(O instanceof c)this.buffer.set(O.buffer,Q);else if(O instanceof Uint8Array)this.buffer.set(O,Q);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),Q);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),Q);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return s(this.buffer,O)}writeUInt32BE(O,Q){a(this.buffer,O,Q)}readUInt32LE(O){return e(this.buffer,O)}writeUInt32LE(O,Q){h(this.buffer,O,Q)}readUInt8(O){return l(this.buffer,O)}writeUInt8(O,Q){m(this.buffer,O,Q)}indexOf(O,Q=0){return g(this.buffer,O instanceof c?O.buffer:O,Q)}}t.$be=c;function g(P,O,Q=0){const te=O.byteLength,re=P.byteLength;if(te===0)return 0;if(te===1)return P.indexOf(O[0]);if(te>re-Q)return-1;const fe=U.value;fe.fill(O.length);for(let Se=0;Se<O.length;Se++)fe[O[Se]]=O.length-Se-1;let ie=Q+O.length-1,oe=ie,be=-1;for(;ie<re;)if(P[ie]===O[oe]){if(oe===0){be=ie;break}ie--,oe--}else ie+=Math.max(O.length-oe,fe[P[ie]]),oe=O.length-1;return be}t.$ce=g;function f(P,O){return P[O+0]<<0>>>0|P[O+1]<<8>>>0}t.$de=f;function L(P,O,Q){P[Q+0]=O&255,O=O>>>8,P[Q+1]=O&255}t.$ee=L;function s(P,O){return P[O]*2**24+P[O+1]*2**16+P[O+2]*2**8+P[O+3]}t.$fe=s;function a(P,O,Q){P[Q+3]=O,O=O>>>8,P[Q+2]=O,O=O>>>8,P[Q+1]=O,O=O>>>8,P[Q]=O}t.$ge=a;function e(P,O){return P[O+0]<<0>>>0|P[O+1]<<8>>>0|P[O+2]<<16>>>0|P[O+3]<<24>>>0}t.$he=e;function h(P,O,Q){P[Q+0]=O&255,O=O>>>8,P[Q+1]=O&255,O=O>>>8,P[Q+2]=O&255,O=O>>>8,P[Q+3]=O&255}t.$ie=h;function l(P,O){return P[O]}t.$je=l;function m(P,O,Q){P[Q]=O}t.$ke=m;function n(P){return T.$3d(P,O=>c.concat(O))}t.$le=n;function r(P){return T.$0d(P)}t.$me=r;function b(P){return T.$5d(P,O=>c.concat(O))}t.$ne=b;async function u(P){return P.ended?c.concat(P.buffer):c.concat([...P.buffer,await b(P.stream)])}t.$oe=u;function o(P){return T.$8d(P,O=>c.concat(O))}t.$pe=o;function F(P){return T.$$d(P,{data:O=>typeof O=="string"?c.fromString(O):c.wrap(O)},O=>c.concat(O))}t.$qe=F;function j(P){return T.$2d(O=>c.concat(O),P)}t.$re=j;function R(P,O){return T.$_d(P,O,Q=>c.concat(Q))}t.$se=R;function d(P,O){return T.$ae(P,O,Q=>c.concat(Q))}t.$te=d;function D(P){let O=0,Q=0,te=0;const re=new Uint8Array(Math.floor(P.length/4*3)),fe=oe=>{switch(Q){case 3:re[te++]=O|oe,Q=0;break;case 2:re[te++]=O|oe>>>2,O=oe<<6,Q=3;break;case 1:re[te++]=O|oe>>>4,O=oe<<4,Q=2;break;default:O=oe<<2,Q=1}};for(let oe=0;oe<P.length;oe++){const be=P.charCodeAt(oe);if(be>=65&&be<=90)fe(be-65);else if(be>=97&&be<=122)fe(be-97+26);else if(be>=48&&be<=57)fe(be-48+52);else if(be===43||be===45)fe(62);else if(be===47||be===95)fe(63);else{if(be===61)break;throw new SyntaxError(`Unexpected base64 character ${P[oe]}`)}}const ie=te;for(;Q>0;)fe(0);return c.wrap(re).slice(0,ie)}t.$ue=D;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",H="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function X({buffer:P},O=!0,Q=!1){const te=Q?H:B;let re="";const fe=P.byteLength%3;let ie=0;for(;ie<P.byteLength-fe;ie+=3){const oe=P[ie+0],be=P[ie+1],Se=P[ie+2];re+=te[oe>>>2],re+=te[(oe<<4|be>>>4)&63],re+=te[(be<<2|Se>>>6)&63],re+=te[Se&63]}if(fe===1){const oe=P[ie+0];re+=te[oe>>>2],re+=te[oe<<4&63],O&&(re+="==")}else if(fe===2){const oe=P[ie+0],be=P[ie+1];re+=te[oe>>>2],re+=te[(oe<<4|be>>>4)&63],re+=te[be<<2&63],O&&(re+="=")}return re}t.$ve=X}),define($e[12],we([1,0,84,28]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xf=t.$wf=t.$vf=t.$uf=t.GraphemeBreakType=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=t.$Je=t.$Ie=t.$He=t.$Ge=t.$Fe=t.$Ee=t.$De=t.$Ce=t.$Be=void 0;function i(J){return!J||typeof J!="string"?!0:J.trim().length===0}t.$Be=i;const U=/{(\d+)}/g;function w(J,...he){return he.length===0?J:J.replace(U,function(ve,Ee){const Ce=parseInt(Ee,10);return isNaN(Ce)||Ce<0||Ce>=he.length?ve:he[Ce]})}t.$Ce=w;const y=/{([^}]+)}/g;function c(J,he){return Object.keys(he).length===0?J:J.replace(y,(ve,Ee)=>he[Ee]??ve)}t.$De=c;function g(J){return J.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}t.$Ee=g;function f(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Fe=f;function L(J,he){let ve=0;const Ee=he.charCodeAt(0);for(let Ce=J.length-1;Ce>=0;Ce--)J.charCodeAt(Ce)===Ee&&ve++;return ve}t.$Ge=L;function s(J,he,ve="\u2026"){return J.length<=he?J:`${J.substr(0,he)}${ve}`}t.$He=s;function a(J,he=" "){const ve=e(J,he);return h(ve,he)}t.$Ie=a;function e(J,he){if(!J||!he)return J;const ve=he.length;if(ve===0||J.length===0)return J;let Ee=0;for(;J.indexOf(he,Ee)===Ee;)Ee=Ee+ve;return J.substring(Ee)}t.$Je=e;function h(J,he){if(!J||!he)return J;const ve=he.length,Ee=J.length;if(ve===0||Ee===0)return J;let Ce=Ee,Be=-1;for(;Be=J.lastIndexOf(he,Ce-1),!(Be===-1||Be+ve!==Ce);){if(Be===0)return"";Ce=Be}return J.substring(0,Ce)}t.$Ke=h;function l(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$Le=l;function m(J){return J.replace(/\*/g,"")}t.$Me=m;function n(J,he,ve={}){if(!J)throw new Error("Cannot create regex from empty string");he||(J=f(J)),ve.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let Ee="";return ve.global&&(Ee+="g"),ve.matchCase||(Ee+="i"),ve.multiline&&(Ee+="m"),ve.unicode&&(Ee+="u"),new RegExp(J,Ee)}t.$Ne=n;function r(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}t.$Oe=r;function b(J){return J.split(/\r\n|\r|\n/)}t.$Pe=b;function u(J){for(let he=0,ve=J.length;he<ve;he++){const Ee=J.charCodeAt(he);if(Ee!==32&&Ee!==9)return he}return-1}t.$Qe=u;function o(J,he=0,ve=J.length){for(let Ee=he;Ee<ve;Ee++){const Ce=J.charCodeAt(Ee);if(Ce!==32&&Ce!==9)return J.substring(he,Ee)}return J.substring(he,ve)}t.$Re=o;function F(J,he=J.length-1){for(let ve=he;ve>=0;ve--){const Ee=J.charCodeAt(ve);if(Ee!==32&&Ee!==9)return ve}return-1}t.$Se=F;function j(J,he,ve){const Ee=[];let Ce=0;for(const Be of J.matchAll(he)){if(Ee.push(J.slice(Ce,Be.index)),Be.index===void 0)throw new Error("match.index should be defined");Ce=Be.index+Be[0].length,Ee.push(ve(Be[0],...Be.slice(1),Be.index,J,Be.groups))}return Ee.push(J.slice(Ce)),Promise.all(Ee).then(Be=>Be.join(""))}t.$Te=j;function R(J,he){return J<he?-1:J>he?1:0}t.$Ue=R;function d(J,he,ve=0,Ee=J.length,Ce=0,Be=he.length){for(;ve<Ee&&Ce<Be;ve++,Ce++){const Je=J.charCodeAt(ve),Qe=he.charCodeAt(Ce);if(Je<Qe)return-1;if(Je>Qe)return 1}const Ue=Ee-ve,Ze=Be-Ce;return Ue<Ze?-1:Ue>Ze?1:0}t.$Ve=d;function D(J,he){return B(J,he,0,J.length,0,he.length)}t.$We=D;function B(J,he,ve=0,Ee=J.length,Ce=0,Be=he.length){for(;ve<Ee&&Ce<Be;ve++,Ce++){let Je=J.charCodeAt(ve),Qe=he.charCodeAt(Ce);if(Je===Qe)continue;if(Je>=128||Qe>=128)return d(J.toLowerCase(),he.toLowerCase(),ve,Ee,Ce,Be);X(Je)&&(Je-=32),X(Qe)&&(Qe-=32);const Ve=Je-Qe;if(Ve!==0)return Ve}const Ue=Ee-ve,Ze=Be-Ce;return Ue<Ze?-1:Ue>Ze?1:0}t.$Xe=B;function H(J){return J>=48&&J<=57}t.$Ye=H;function X(J){return J>=97&&J<=122}t.$Ze=X;function P(J){return J>=65&&J<=90}t.$1e=P;function O(J,he){return J.length===he.length&&B(J,he)===0}t.$2e=O;function Q(J,he){const ve=he.length;return he.length>J.length?!1:B(J,he,0,ve)===0}t.$3e=Q;function te(J,he){const ve=Math.min(J.length,he.length);let Ee;for(Ee=0;Ee<ve;Ee++)if(J.charCodeAt(Ee)!==he.charCodeAt(Ee))return Ee;return ve}t.$4e=te;function re(J,he){const ve=Math.min(J.length,he.length);let Ee;const Ce=J.length-1,Be=he.length-1;for(Ee=0;Ee<ve;Ee++)if(J.charCodeAt(Ce-Ee)!==he.charCodeAt(Be-Ee))return Ee;return ve}t.$5e=re;function fe(J){return 55296<=J&&J<=56319}t.$6e=fe;function ie(J){return 56320<=J&&J<=57343}t.$7e=ie;function oe(J,he){return(J-55296<<10)+(he-56320)+65536}t.$8e=oe;function be(J,he,ve){const Ee=J.charCodeAt(ve);if(fe(Ee)&&ve+1<he){const Ce=J.charCodeAt(ve+1);if(ie(Ce))return oe(Ee,Ce)}return Ee}t.$9e=be;function Se(J,he){const ve=J.charCodeAt(he-1);if(ie(ve)&&he>1){const Ee=J.charCodeAt(he-2);if(fe(Ee))return oe(Ee,ve)}return ve}class Te{get offset(){return this.e}constructor(he,ve=0){this.c=he,this.d=he.length,this.e=ve}setOffset(he){this.e=he}prevCodePoint(){const he=Se(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=be(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}t.$0e=Te;class Fe{get offset(){return this.c.offset}constructor(he,ve=0){this.c=new Te(he,ve)}nextGraphemeLength(){const he=Ae.getInstance(),ve=this.c,Ee=ve.offset;let Ce=he.getGraphemeBreakType(ve.nextCodePoint());for(;!ve.eol();){const Be=ve.offset,Ue=he.getGraphemeBreakType(ve.nextCodePoint());if(pe(Ce,Ue)){ve.setOffset(Be);break}Ce=Ue}return ve.offset-Ee}prevGraphemeLength(){const he=Ae.getInstance(),ve=this.c,Ee=ve.offset;let Ce=he.getGraphemeBreakType(ve.prevCodePoint());for(;ve.offset>0;){const Be=ve.offset,Ue=he.getGraphemeBreakType(ve.prevCodePoint());if(pe(Ue,Ce)){ve.setOffset(Be);break}Ce=Ue}return Ee-ve.offset}eol(){return this.c.eol()}}t.$$e=Fe;function de(J,he){return new Fe(J,he).nextGraphemeLength()}t.$_e=de;function ne(J,he){return new Fe(J,he).prevGraphemeLength()}t.$af=ne;function ce(J,he){he>0&&ie(J.charCodeAt(he))&&he--;const ve=he+de(J,he);return[ve-ne(J,ve),ve]}t.$bf=ce;function Z(J){const he=new Fe(J);let ve=0;for(;!he.eol();)ve++,he.nextGraphemeLength();return ve}t.$cf=Z;let V;function Y(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function C(J){return V||(V=Y()),V.test(J)}t.$df=C;const q=/^[\t\n\r\x20-\x7E]*$/;function $(J){return q.test(J)}t.$ef=$,t.$ff=/[\u2028\u2029]/;function W(J){return t.$ff.test(J)}t.$gf=W;function _(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}t.$hf=_;function p(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}t.$if=p;function A(J,he){if(J.length<he)return J;const ve=/\b/g;let Ee=0;for(;ve.test(J)&&!(J.length-ve.lastIndex<he);)Ee=ve.lastIndex,ve.lastIndex+=1;return J.substring(Ee).replace(/^\s/,"")}t.$jf=A;const E=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,M=/\x1b\].*?\x07/g;function k(J){return J&&(J=J.replace(E,"").replace(M,"")),J}t.$kf=k,t.$lf=String.fromCharCode(65279);function I(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}t.$mf=I;function S(J){return I(J)?J.substr(1):J}t.$nf=S;function N(J,he){if(!J||!he||J.length<he.length)return!1;const ve=he.length,Ee=J.toLowerCase();let Ce=0,Be=-1;for(;Ce<ve;){const Ue=Ee.indexOf(he[Ce],Be+1);if(Ue<0)return!1;Be=Ue,Ce++}return!0}t.$of=N;function z(J,he=!1){return J?(he&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}t.$pf=z;function x(J){return J.charAt(0).toUpperCase()+J.slice(1)}t.$qf=x;function ee(J,he=1){if(he===0)return"";let ve=-1;do ve=J.indexOf(`
`,ve+1),he--;while(he>0&&ve>=0);return ve===-1?J:(J[ve-1]==="\r"&&ve--,J.substr(0,ve))}t.$rf=ee;function se(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}t.$sf=se;function ge(J){return Ae.getInstance().getGraphemeBreakType(J)}t.$tf=ge;function pe(J,he){return J===0?he!==5&&he!==7:J===2&&he===3?!1:J===4||J===2||J===3||he===4||he===2||he===3?!0:!(J===8&&(he===8||he===9||he===11||he===12)||(J===11||J===9)&&(he===9||he===10)||(J===12||J===10)&&he===10||he===5||he===13||he===7||J===1||J===13&&he===14||J===6&&he===6)}var Pe;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=De()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const ve=this.d,Ee=ve.length/3;let Ce=1;for(;Ce<=Ee;)if(he<ve[3*Ce])Ce=2*Ce;else if(he>ve[3*Ce+1])Ce=2*Ce+1;else return ve[3*Ce+2];return 0}}function De(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(J,he){if(J===0)return 0;const ve=Oe(J,he);if(ve!==void 0)return ve;const Ee=new Te(he,J);return Ee.prevCodePoint(),Ee.offset}t.$uf=Re;function Oe(J,he){const ve=new Te(he,J);let Ee=ve.prevCodePoint();for(;_e(Ee)||Ee===65039||Ee===8419;){if(ve.offset===0)return;Ee=ve.prevCodePoint()}if(!p(Ee))return;let Ce=ve.offset;return Ce>0&&ve.prevCodePoint()===8205&&(Ce=ve.offset),Ce}function _e(J){return 127995<=J&&J<=127999}var He;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(He||(He={})),t.$vf="\xA0";class Me{static{this.c=new T.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new v.$xe(he=>{function ve(Ve){const tt=new Map;for(let nt=0;nt<Ve.length;nt+=2)tt.set(Ve[nt],Ve[nt+1]);return tt}function Ee(Ve,tt){const nt=new Map(Ve);for(const[dt,ct]of tt)nt.set(dt,ct);return nt}function Ce(Ve,tt){if(!Ve)return tt;const nt=new Map;for(const[dt,ct]of Ve)tt.has(dt)&&nt.set(dt,ct);return nt}const Be=this.c.value;let Ue=he.filter(Ve=>!Ve.startsWith("_")&&Ve in Be);Ue.length===0&&(Ue=["_default"]);let Ze;for(const Ve of Ue){const tt=ve(Be[Ve]);Ze=Ce(Ze,tt)}const Je=ve(Be._common),Qe=Ee(Je,Ze);return new Me(Qe)})}static getInstance(he){return Me.d.get(Array.from(he))}static{this.e=new T.$U(()=>Object.keys(Me.c.value).filter(he=>!he.startsWith("_")))}static getLocales(){return Me.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$wf=Me;class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(he){return Ke.e().has(he)}static get codePoints(){return Ke.e()}}t.$xf=Ke}),define($e[34],we([1,0,32,12]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sj=t.$Rj=t.$Qj=t.$Pj=t.FuzzyScore=t.$Oj=t.$Nj=t.$Mj=t.$Lj=t.$Kj=t.$Jj=t.$Ij=t.$Hj=t.$Gj=t.$Fj=t.$Ej=t.$Dj=t.or=void 0;function i(...S){return function(N,z){for(let x=0,ee=S.length;x<ee;x++){const se=S[x](N,z);if(se)return se}return null}}t.or=i,t.$Dj=U.bind(void 0,!1),t.$Ej=U.bind(void 0,!0);function U(S,N,z){if(!z||z.length<N.length)return null;let x;return S?x=T.$3e(z,N):x=z.indexOf(N)===0,x?N.length>0?[{start:0,end:N.length}]:[]:null}function w(S,N){const z=N.toLowerCase().indexOf(S.toLowerCase());return z===-1?null:[{start:z,end:z+S.length}]}t.$Fj=w;function y(S,N){return c(S.toLowerCase(),N.toLowerCase(),0,0)}t.$Gj=y;function c(S,N,z,x){if(z===S.length)return[];if(x===N.length)return null;if(S[z]===N[x]){let ee=null;return(ee=c(S,N,z+1,x+1))?m({start:x,end:x+1},ee):null}return c(S,N,z,x+1)}function g(S){return 97<=S&&S<=122}function f(S){return 65<=S&&S<=90}t.$Hj=f;function L(S){return 48<=S&&S<=57}function s(S){return S===32||S===9||S===10||S===13}const a=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(S=>a.add(S.charCodeAt(0)));function e(S){return s(S)||a.has(S)}function h(S,N){return S===N||e(S)&&e(N)}function l(S){return g(S)||f(S)||L(S)}function m(S,N){return N.length===0?N=[S]:S.end===N[0].start?N[0].start=S.start:N.unshift(S),N}function n(S,N){for(let z=N;z<S.length;z++){const x=S.charCodeAt(z);if(f(x)||L(x)||z>0&&!l(S.charCodeAt(z-1)))return z}return S.length}function r(S,N,z,x){if(z===S.length)return[];if(x===N.length)return null;if(S[z]!==N[x].toLowerCase())return null;{let ee=null,se=x+1;for(ee=r(S,N,z+1,x+1);!ee&&(se=n(N,se))<N.length;)ee=r(S,N,z+1,se),se++;return ee===null?null:m({start:x,end:x+1},ee)}}function b(S){let N=0,z=0,x=0,ee=0,se=0;for(let De=0;De<S.length;De++)se=S.charCodeAt(De),f(se)&&N++,g(se)&&z++,l(se)&&x++,L(se)&&ee++;const ge=N/S.length,pe=z/S.length,Pe=x/S.length,Ae=ee/S.length;return{upperPercent:ge,lowerPercent:pe,alphaPercent:Pe,numericPercent:Ae}}function u(S){const{upperPercent:N,lowerPercent:z}=S;return z===0&&N>.6}function o(S){const{upperPercent:N,lowerPercent:z,alphaPercent:x,numericPercent:ee}=S;return z>.2&&N<.8&&x>.6&&ee<.2}function F(S){let N=0,z=0,x=0,ee=0;for(let se=0;se<S.length;se++)x=S.charCodeAt(se),f(x)&&N++,g(x)&&z++,s(x)&&ee++;return(N===0||z===0)&&ee===0?S.length<=30:N<=5}function j(S,N){if(!N||(N=N.trim(),N.length===0)||!F(S)||N.length>60)return null;const z=b(N);if(!o(z)){if(!u(z))return null;N=N.toLowerCase()}let x=null,ee=0;for(S=S.toLowerCase();ee<N.length&&(x=r(S,N,0,ee))===null;)ee=n(N,ee+1);return x}t.$Ij=j;function R(S,N,z=!1){if(!N||N.length===0)return null;let x=null,ee=0;for(S=S.toLowerCase(),N=N.toLowerCase();ee<N.length&&(x=d(S,N,0,ee,z))===null;)ee=D(N,ee+1);return x}t.$Jj=R;function d(S,N,z,x,ee){if(z===S.length)return[];if(x===N.length)return null;if(h(S.charCodeAt(z),N.charCodeAt(x))){let se=null,ge=x+1;if(se=d(S,N,z+1,x+1,ee),!ee)for(;!se&&(ge=D(N,ge))<N.length;)se=d(S,N,z+1,ge,ee),ge++;return se?S.charCodeAt(z)!==N.charCodeAt(x)?se:m({start:x,end:x+1},se):null}else return null}function D(S,N){for(let z=N;z<S.length;z++)if(e(S.charCodeAt(z))||z>0&&e(S.charCodeAt(z-1)))return z;return S.length}const B=i(t.$Ej,j,w),H=i(t.$Ej,j,y),X=new v.$Cc(1e4);function P(S,N,z=!1){if(typeof S!="string"||typeof N!="string")return null;let x=X.get(S);x||(x=new RegExp(T.$Le(S),"i"),X.set(S,x));const ee=x.exec(N);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:z?H(S,N):B(S,N)}t.$Kj=P;function O(S,N){const z=_(S,S.toLowerCase(),0,N,N.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?te(z):null}t.$Lj=O;function Q(S,N,z,x,ee,se){const ge=Math.min(13,S.length);for(;z<ge;z++){const pe=_(S,N,z,x,ee,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(pe)return pe}return[0,se]}t.$Mj=Q;function te(S){if(typeof S>"u")return[];const N=[],z=S[1];for(let x=S.length-1;x>1;x--){const ee=S[x]+z,se=N[N.length-1];se&&se.end===ee?se.end=ee+1:N.push({start:ee,end:ee+1})}return N}t.$Nj=te;const re=128;function fe(){const S=[],N=[];for(let z=0;z<=re;z++)N[z]=0;for(let z=0;z<=re;z++)S.push(N.slice(0));return S}function ie(S){const N=[];for(let z=0;z<=S;z++)N[z]=0;return N}const oe=ie(2*re),be=ie(2*re),Se=fe(),Te=fe(),Fe=fe(),de=!1;function ne(S,N,z,x,ee){function se(pe,Pe,Ae=" "){for(;pe.length<Pe;)pe=Ae+pe;return pe}let ge=` |   |${x.split("").map(pe=>se(pe,3)).join("|")}
`;for(let pe=0;pe<=z;pe++)pe===0?ge+=" |":ge+=`${N[pe-1]}|`,ge+=S[pe].slice(0,ee+1).map(Pe=>se(Pe.toString(),3)).join("|")+`
`;return ge}function ce(S,N,z,x){S=S.substr(N),z=z.substr(x),console.log(ne(Te,S,S.length,z,z.length)),console.log(ne(Fe,S,S.length,z,z.length)),console.log(ne(Se,S,S.length,z,z.length))}function Z(S,N){if(N<0||N>=S.length)return!1;const z=S.codePointAt(N);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$if(z)}}function V(S,N){if(N<0||N>=S.length)return!1;switch(S.charCodeAt(N)){case 32:case 9:return!0;default:return!1}}function Y(S,N,z){return N[S]!==z[S]}function C(S,N,z,x,ee,se,ge=!1){for(;N<z&&ee<se;)S[N]===x[ee]&&(ge&&(oe[N]=ee),N+=1),ee+=1;return N===z}t.$Oj=C;var q;(function(S){S[S.Diag=1]="Diag",S[S.Left=2]="Left",S[S.LeftLeft=3]="LeftLeft"})(q||(q={}));var $;(function(S){S.Default=[-100,0];function N(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}S.isDefault=N})($||(t.FuzzyScore=$={}));class W{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(N,z){this.firstMatchCanBeWeak=N,this.boostFullMatch=z}}t.$Pj=W;function _(S,N,z,x,ee,se,ge=W.default){const pe=S.length>re?re:S.length,Pe=x.length>re?re:x.length;if(z>=pe||se>=Pe||pe-z>Pe-se||!C(N,z,pe,ee,se,Pe,!0))return;p(pe,Pe,z,se,N,ee);let Ae=1,De=1,Re=z,Oe=se;const _e=[!1];for(Ae=1,Re=z;Re<pe;Ae++,Re++){const he=oe[Re],ve=be[Re],Ee=Re+1<pe?be[Re+1]:Pe;for(De=he-se+1,Oe=he;Oe<Ee;De++,Oe++){let Ce=Number.MIN_SAFE_INTEGER,Be=!1;Oe<=ve&&(Ce=A(S,N,Re,z,x,ee,Oe,Pe,se,Se[Ae-1][De-1]===0,_e));let Ue=0;Ce!==Number.MAX_SAFE_INTEGER&&(Be=!0,Ue=Ce+Te[Ae-1][De-1]);const Ze=Oe>he,Je=Ze?Te[Ae][De-1]+(Se[Ae][De-1]>0?-5:0):0,Qe=Oe>he+1&&Se[Ae][De-1]>0,Ve=Qe?Te[Ae][De-2]+(Se[Ae][De-2]>0?-5:0):0;if(Qe&&(!Ze||Ve>=Je)&&(!Be||Ve>=Ue))Te[Ae][De]=Ve,Fe[Ae][De]=3,Se[Ae][De]=0;else if(Ze&&(!Be||Je>=Ue))Te[Ae][De]=Je,Fe[Ae][De]=2,Se[Ae][De]=0;else if(Be)Te[Ae][De]=Ue,Fe[Ae][De]=1,Se[Ae][De]=Se[Ae-1][De-1]+1;else throw new Error("not possible")}}if(de&&ce(S,z,x,se),!_e[0]&&!ge.firstMatchCanBeWeak)return;Ae--,De--;const He=[Te[Ae][De],se];let Me=0,Ke=0;for(;Ae>=1;){let he=De;do{const ve=Fe[Ae][he];if(ve===3)he=he-2;else if(ve===2)he=he-1;else break}while(he>=1);Me>1&&N[z+Ae-1]===ee[se+De-1]&&!Y(he+se-1,x,ee)&&Me+1>Se[Ae][he]&&(he=De),he===De?Me++:Me=1,Ke||(Ke=he),Ae--,De=he-1,He.push(De)}Pe===pe&&ge.boostFullMatch&&(He[0]+=2);const J=Ke-pe;return He[0]-=J,He}t.$Qj=_;function p(S,N,z,x,ee,se){let ge=S-1,pe=N-1;for(;ge>=z&&pe>=x;)ee[ge]===se[pe]&&(be[ge]=pe,ge--),pe--}function A(S,N,z,x,ee,se,ge,pe,Pe,Ae,De){if(N[z]!==se[ge])return Number.MIN_SAFE_INTEGER;let Re=1,Oe=!1;return ge===z-x?Re=S[z]===ee[ge]?7:5:Y(ge,ee,se)&&(ge===0||!Y(ge-1,ee,se))?(Re=S[z]===ee[ge]?7:5,Oe=!0):Z(se,ge)&&(ge===0||!Z(se,ge-1))?Re=5:(Z(se,ge-1)||V(se,ge-1))&&(Re=5,Oe=!0),Re>1&&z===x&&(De[0]=!0),Oe||(Oe=Y(ge,ee,se)||Z(se,ge-1)||V(se,ge-1)),z===x?ge>Pe&&(Re-=Oe?3:5):Ae?Re+=Oe?2:0:Re+=Oe?0:1,ge+1===pe&&(Re-=Oe?3:5),Re}function E(S,N,z,x,ee,se,ge){return k(S,N,z,x,ee,se,!0,ge)}t.$Rj=E;function M(S,N,z,x,ee,se,ge){return k(S,N,z,x,ee,se,!1,ge)}t.$Sj=M;function k(S,N,z,x,ee,se,ge,pe){let Pe=_(S,N,z,x,ee,se,pe);if(Pe&&!ge)return Pe;if(S.length>=3){const Ae=Math.min(7,S.length-1);for(let De=z+1;De<Ae;De++){const Re=I(S,De);if(Re){const Oe=_(Re,Re.toLowerCase(),z,x,ee,se,pe);Oe&&(Oe[0]-=3,(!Pe||Oe[0]>Pe[0])&&(Pe=Oe))}}}return Pe}function I(S,N){if(N+1>=S.length)return;const z=S[N],x=S[N+1];if(z!==x)return S.slice(0,N)+x+z+S.slice(N+2)}}),define($e[49],we([1,0,12]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ki=t.$Ji=t.$Ii=t.$Hi=t.$Gi=t.$Fi=t.$Ei=void 0;function T(m){return i(m,0)}t.$Ei=T;function i(m,n){switch(typeof m){case"object":return m===null?U(349,n):Array.isArray(m)?c(m,n):g(m,n);case"string":return y(m,n);case"boolean":return w(m,n);case"number":return U(m,n);case"undefined":return U(937,n);default:return U(617,n)}}t.$Fi=i;function U(m,n){return(n<<5)-n+m|0}t.$Gi=U;function w(m,n){return U(m?433:863,n)}function y(m,n){n=U(149417,n);for(let r=0,b=m.length;r<b;r++)n=U(m.charCodeAt(r),n);return n}t.$Hi=y;function c(m,n){return n=U(104579,n),m.reduce((r,b)=>i(b,r),n)}function g(m,n){return n=U(181387,n),Object.keys(m).sort().reduce((r,b)=>(r=y(b,r),i(m[b],r)),n)}class f{constructor(){this.g=0}get value(){return this.g}hash(n){return this.g=i(n,this.g),this.g}}t.$Ii=f;var L;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(L||(L={}));function s(m,n,r=32){const b=r-n,u=~((1<<b)-1);return(m<<n|(u&m)>>>b)>>>0}function a(m,n=0,r=m.byteLength,b=0){for(let u=0;u<r;u++)m[n+u]=b}function e(m,n,r="0"){for(;m.length<n;)m=r+m;return m}function h(m,n=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(r=>r.toString(16).padStart(2,"0")).join(""):e((m>>>0).toString(16),n/4)}t.$Ji=h;class l{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(n){const r=n.length;if(r===0)return;const b=this.p;let u=this.r,o=this.u,F,j;for(o!==0?(F=o,j=-1,o=0):(F=n.charCodeAt(0),j=0);;){let R=F;if(v.$6e(F))if(j+1<r){const d=n.charCodeAt(j+1);v.$7e(d)?(j++,R=v.$8e(F,d)):R=65533}else{o=F;break}else v.$7e(F)&&(R=65533);if(u=this.w(b,u,R),j++,j<r)F=n.charCodeAt(j);else break}this.r=u,this.u=o}w(n,r,b){return b<128?n[r++]=b:b<2048?(n[r++]=192|(b&1984)>>>6,n[r++]=128|(b&63)>>>0):b<65536?(n[r++]=224|(b&61440)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0):(n[r++]=240|(b&1835008)>>>18,n[r++]=128|(b&258048)>>>12,n[r++]=128|(b&4032)>>>6,n[r++]=128|(b&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,n[0]=n[64+0],n[1]=n[64+1],n[2]=n[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),h(this.h)+h(this.l)+h(this.m)+h(this.n)+h(this.o)}x(){this.p[this.r++]=128,a(this.p,this.r),this.r>56&&(this.y(),a(this.p));const n=8*this.t;this.q.setUint32(56,Math.floor(n/4294967296),!1),this.q.setUint32(60,n%4294967296,!1),this.y()}y(){const n=l.g,r=this.q;for(let B=0;B<64;B+=4)n.setUint32(B,r.getUint32(B,!1),!1);for(let B=64;B<320;B+=4)n.setUint32(B,s(n.getUint32(B-12,!1)^n.getUint32(B-32,!1)^n.getUint32(B-56,!1)^n.getUint32(B-64,!1),1),!1);let b=this.h,u=this.l,o=this.m,F=this.n,j=this.o,R,d,D;for(let B=0;B<80;B++)B<20?(R=u&o|~u&F,d=1518500249):B<40?(R=u^o^F,d=1859775393):B<60?(R=u&o|u&F|o&F,d=2400959708):(R=u^o^F,d=3395469782),D=s(b,5)+R+j+d+n.getUint32(B*4,!1)&4294967295,j=F,F=o,o=s(u,30),u=b,b=D;this.h=this.h+b&4294967295,this.l=this.l+u&4294967295,this.m=this.m+o&4294967295,this.n=this.n+F&4294967295,this.o=this.o+j&4294967295}}t.$Ki=l}),define($e[86],we([1,0,75,49]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$As=t.$zs=t.$ys=void 0;class i{constructor(s){this.a=s}getElements(){const s=this.a,a=new Int32Array(s.length);for(let e=0,h=s.length;e<h;e++)a[e]=s.charCodeAt(e);return a}}t.$ys=i;function U(L,s,a){return new f(new i(L),new i(s)).ComputeDiff(a).changes}t.$zs=U;class w{static Assert(s,a){if(!s)throw new Error(a)}}class y{static Copy(s,a,e,h,l){for(let m=0;m<l;m++)e[h+m]=s[a+m]}static Copy2(s,a,e,h,l){for(let m=0;m<l;m++)e[h+m]=s[a+m]}}var c;(function(L){L[L.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(c||(c={}));class g{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new v.$xs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.d++}AddModifiedElement(s,a){this.b=Math.min(this.b,s),this.c=Math.min(this.c,a),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(s,a,e=null){this.a=e,this.b=s,this.c=a;const[h,l,m]=f.o(s),[n,r,b]=f.o(a);this.d=m&&b,this.e=h,this.f=l,this.g=n,this.h=r,this.k=[],this.m=[]}static n(s){return s.length>0&&typeof s[0]=="string"}static o(s){const a=s.getElements();if(f.n(a)){const e=new Int32Array(a.length);for(let h=0,l=a.length;h<l;h++)e[h]=(0,T.$Hi)(a[h],0);return[a,e,!0]}return a instanceof Int32Array?[[],a,!1]:[[],new Int32Array(a),!1]}p(s,a){return this.f[s]!==this.h[a]?!1:this.d?this.e[s]===this.g[a]:!0}q(s,a){if(!this.p(s,a))return!1;const e=f.r(this.b,s),h=f.r(this.c,a);return e===h}static r(s,a){return typeof s.getStrictElement=="function"?s.getStrictElement(a):null}s(s,a){return this.f[s]!==this.f[a]?!1:this.d?this.e[s]===this.e[a]:!0}u(s,a){return this.h[s]!==this.h[a]?!1:this.d?this.g[s]===this.g[a]:!0}ComputeDiff(s){return this.v(0,this.f.length-1,0,this.h.length-1,s)}v(s,a,e,h,l){const m=[!1];let n=this.w(s,a,e,h,m);return l&&(n=this.z(n)),{quitEarly:m[0],changes:n}}w(s,a,e,h,l){for(l[0]=!1;s<=a&&e<=h&&this.p(s,e);)s++,e++;for(;a>=s&&h>=e&&this.p(a,h);)a--,h--;if(s>a||e>h){let o;return e<=h?(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),o=[new v.$xs(s,0,e,h-e+1)]):s<=a?(w.Assert(e===h+1,"modifiedStart should only be one more than modifiedEnd"),o=[new v.$xs(s,a-s+1,e,0)]):(w.Assert(s===a+1,"originalStart should only be one more than originalEnd"),w.Assert(e===h+1,"modifiedStart should only be one more than modifiedEnd"),o=[]),o}const m=[0],n=[0],r=this.y(s,a,e,h,m,n,l),b=m[0],u=n[0];if(r!==null)return r;if(!l[0]){const o=this.w(s,b,e,u,l);let F=[];return l[0]?F=[new v.$xs(b+1,a-(b+1)+1,u+1,h-(u+1)+1)]:F=this.w(b+1,a,u+1,h,l),this.H(o,F)}return[new v.$xs(s,a-s+1,e,h-e+1)]}x(s,a,e,h,l,m,n,r,b,u,o,F,j,R,d,D,B,H){let X=null,P=null,O=new g,Q=a,te=e,re=j[0]-D[0]-h,fe=-1073741824,ie=this.k.length-1;do{const oe=re+s;oe===Q||oe<te&&b[oe-1]<b[oe+1]?(o=b[oe+1],R=o-re-h,o<fe&&O.MarkNextChange(),fe=o,O.AddModifiedElement(o+1,R),re=oe+1-s):(o=b[oe-1]+1,R=o-re-h,o<fe&&O.MarkNextChange(),fe=o-1,O.AddOriginalElement(o,R+1),re=oe-1-s),ie>=0&&(b=this.k[ie],s=b[0],Q=1,te=b.length-1)}while(--ie>=-1);if(X=O.getReverseChanges(),H[0]){let oe=j[0]+1,be=D[0]+1;if(X!==null&&X.length>0){const Se=X[X.length-1];oe=Math.max(oe,Se.getOriginalEnd()),be=Math.max(be,Se.getModifiedEnd())}P=[new v.$xs(oe,F-oe+1,be,d-be+1)]}else{O=new g,Q=m,te=n,re=j[0]-D[0]-r,fe=1073741824,ie=B?this.m.length-1:this.m.length-2;do{const oe=re+l;oe===Q||oe<te&&u[oe-1]>=u[oe+1]?(o=u[oe+1]-1,R=o-re-r,o>fe&&O.MarkNextChange(),fe=o+1,O.AddOriginalElement(o+1,R+1),re=oe+1-l):(o=u[oe-1],R=o-re-r,o>fe&&O.MarkNextChange(),fe=o,O.AddModifiedElement(o+1,R+1),re=oe-1-l),ie>=0&&(u=this.m[ie],l=u[0],Q=1,te=u.length-1)}while(--ie>=-1);P=O.getChanges()}return this.H(X,P)}y(s,a,e,h,l,m,n){let r=0,b=0,u=0,o=0,F=0,j=0;s--,e--,l[0]=0,m[0]=0,this.k=[],this.m=[];const R=a-s+(h-e),d=R+1,D=new Int32Array(d),B=new Int32Array(d),H=h-e,X=a-s,P=s-e,O=a-h,te=(X-H)%2===0;D[H]=s,B[X]=a,n[0]=!1;for(let re=1;re<=R/2+1;re++){let fe=0,ie=0;u=this.J(H-re,re,H,d),o=this.J(H+re,re,H,d);for(let be=u;be<=o;be+=2){be===u||be<o&&D[be-1]<D[be+1]?r=D[be+1]:r=D[be-1]+1,b=r-(be-H)-P;const Se=r;for(;r<a&&b<h&&this.p(r+1,b+1);)r++,b++;if(D[be]=r,r+b>fe+ie&&(fe=r,ie=b),!te&&Math.abs(be-X)<=re-1&&r>=B[be])return l[0]=r,m[0]=b,Se<=B[be]&&1447>0&&re<=1447+1?this.x(H,u,o,P,X,F,j,O,D,B,r,a,l,b,h,m,te,n):null}const oe=(fe-s+(ie-e)-re)/2;if(this.a!==null&&!this.a(fe,oe))return n[0]=!0,l[0]=fe,m[0]=ie,oe>0&&1447>0&&re<=1447+1?this.x(H,u,o,P,X,F,j,O,D,B,r,a,l,b,h,m,te,n):(s++,e++,[new v.$xs(s,a-s+1,e,h-e+1)]);F=this.J(X-re,re,X,d),j=this.J(X+re,re,X,d);for(let be=F;be<=j;be+=2){be===F||be<j&&B[be-1]>=B[be+1]?r=B[be+1]-1:r=B[be-1],b=r-(be-X)-O;const Se=r;for(;r>s&&b>e&&this.p(r,b);)r--,b--;if(B[be]=r,te&&Math.abs(be-H)<=re&&r<=D[be])return l[0]=r,m[0]=b,Se>=D[be]&&1447>0&&re<=1447+1?this.x(H,u,o,P,X,F,j,O,D,B,r,a,l,b,h,m,te,n):null}if(re<=1447){let be=new Int32Array(o-u+2);be[0]=H-u+1,y.Copy2(D,u,be,1,o-u+1),this.k.push(be),be=new Int32Array(j-F+2),be[0]=X-F+1,y.Copy2(B,F,be,1,j-F+1),this.m.push(be)}}return this.x(H,u,o,P,X,F,j,O,D,B,r,a,l,b,h,m,te,n)}z(s){for(let a=0;a<s.length;a++){const e=s[a],h=a<s.length-1?s[a+1].originalStart:this.f.length,l=a<s.length-1?s[a+1].modifiedStart:this.h.length,m=e.originalLength>0,n=e.modifiedLength>0;for(;e.originalStart+e.originalLength<h&&e.modifiedStart+e.modifiedLength<l&&(!m||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!n||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const b=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!b)break;e.originalStart++,e.modifiedStart++}const r=[null];if(a<s.length-1&&this.I(s[a],s[a+1],r)){s[a]=r[0],s.splice(a+1,1),a--;continue}}for(let a=s.length-1;a>=0;a--){const e=s[a];let h=0,l=0;if(a>0){const o=s[a-1];h=o.originalStart+o.originalLength,l=o.modifiedStart+o.modifiedLength}const m=e.originalLength>0,n=e.modifiedLength>0;let r=0,b=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let o=1;;o++){const F=e.originalStart-o,j=e.modifiedStart-o;if(F<h||j<l||m&&!this.s(F,F+e.originalLength)||n&&!this.u(j,j+e.modifiedLength))break;const d=(F===h&&j===l?5:0)+this.G(F,e.originalLength,j,e.modifiedLength);d>b&&(b=d,r=o)}e.originalStart-=r,e.modifiedStart-=r;const u=[null];if(a>0&&this.I(s[a-1],s[a],u)){s[a-1]=u[0],s.splice(a,1),a++;continue}}if(this.d)for(let a=1,e=s.length;a<e;a++){const h=s[a-1],l=s[a],m=l.originalStart-h.originalStart-h.originalLength,n=h.originalStart,r=l.originalStart+l.originalLength,b=r-n,u=h.modifiedStart,o=l.modifiedStart+l.modifiedLength,F=o-u;if(m<5&&b<20&&F<20){const j=this.A(n,b,u,F,m);if(j){const[R,d]=j;(R!==h.originalStart+h.originalLength||d!==h.modifiedStart+h.modifiedLength)&&(h.originalLength=R-h.originalStart,h.modifiedLength=d-h.modifiedStart,l.originalStart=R+m,l.modifiedStart=d+m,l.originalLength=r-l.originalStart,l.modifiedLength=o-l.modifiedStart)}}}return s}A(s,a,e,h,l){if(a<l||h<l)return null;const m=s+a-l+1,n=e+h-l+1;let r=0,b=0,u=0;for(let o=s;o<m;o++)for(let F=e;F<n;F++){const j=this.B(o,F,l);j>0&&j>r&&(r=j,b=o,u=F)}return r>0?[b,u]:null}B(s,a,e){let h=0;for(let l=0;l<e;l++){if(!this.p(s+l,a+l))return 0;h+=this.e[s+l].length}return h}C(s){return s<=0||s>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[s])}D(s,a){if(this.C(s)||this.C(s-1))return!0;if(a>0){const e=s+a;if(this.C(e-1)||this.C(e))return!0}return!1}E(s){return s<=0||s>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[s])}F(s,a){if(this.E(s)||this.E(s-1))return!0;if(a>0){const e=s+a;if(this.E(e-1)||this.E(e))return!0}return!1}G(s,a,e,h){const l=this.D(s,a)?1:0,m=this.F(e,h)?1:0;return l+m}H(s,a){const e=[];if(s.length===0||a.length===0)return a.length>0?a:s;if(this.I(s[s.length-1],a[0],e)){const h=new Array(s.length+a.length-1);return y.Copy(s,0,h,0,s.length-1),h[s.length-1]=e[0],y.Copy(a,1,h,s.length,a.length-1),h}else{const h=new Array(s.length+a.length);return y.Copy(s,0,h,0,s.length),y.Copy(a,0,h,s.length,a.length),h}}I(s,a,e){if(w.Assert(s.originalStart<=a.originalStart,"Left change is not less than or equal to right change"),w.Assert(s.modifiedStart<=a.modifiedStart,"Left change is not less than or equal to right change"),s.originalStart+s.originalLength>=a.originalStart||s.modifiedStart+s.modifiedLength>=a.modifiedStart){const h=s.originalStart;let l=s.originalLength;const m=s.modifiedStart;let n=s.modifiedLength;return s.originalStart+s.originalLength>=a.originalStart&&(l=a.originalStart+a.originalLength-s.originalStart),s.modifiedStart+s.modifiedLength>=a.modifiedStart&&(n=a.modifiedStart+a.modifiedLength-s.modifiedStart),e[0]=new v.$xs(h,l,m,n),!0}else return e[0]=null,!1}J(s,a,e,h){if(s>=0&&s<h)return s;const l=e,m=h-e-1,n=a%2===0;if(s<0){const r=l%2===0;return n===r?0:1}else{const r=m%2===0;return n===r?h-1:h-2}}}t.$As=f}),define($e[50],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0,t.$Kd=Symbol("MicrotaskDelay")}),define($e[87],we([1,0,11,12]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Wh=t.$Vh=t.$Uh=t.$Th=t.$Sh=void 0;class i{constructor(){this.b="",this.c=0}reset(a){return this.b=a,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(a){const e=a.charCodeAt(0),h=this.b.charCodeAt(this.c);return e-h}value(){return this.b[this.c]}}t.$Sh=i;class U{constructor(a=!0){this.e=a}reset(a){return this.b=a,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let a=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(a)this.c++;else break;else a=!1;return this}cmp(a){return this.e?(0,T.$Ve)(a,this.b,0,a.length,this.c,this.d):(0,T.$Xe)(a,this.b,0,a.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$Th=U;class w{constructor(a=!0,e=!0){this.f=a,this.g=e}reset(a){this.d=0,this.e=0,this.b=a,this.c=a.length;for(let e=a.length-1;e>=0;e--,this.c--){const h=this.b.charCodeAt(e);if(!(h===47||this.f&&h===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let a=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(a)this.d++;else break;else a=!1}return this}cmp(a){return this.g?(0,T.$Ve)(a,this.b,0,a.length,this.d,this.e):(0,T.$Xe)(a,this.b,0,a.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$Uh=w;var y;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(y||(y={}));class c{constructor(a,e){this.f=a,this.g=e,this.d=[],this.e=0}reset(a){return this.c=a,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new w(!1,!this.f(a)),this.b.reset(a.path),this.b.value()&&this.d.push(3)),this.g(a)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(a){if(this.d[this.e]===1)return(0,T.$We)(a,this.c.scheme);if(this.d[this.e]===2)return(0,T.$We)(a,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(a);if(this.d[this.e]===4)return(0,T.$Ue)(a,this.c.query);if(this.d[this.e]===5)return(0,T.$Ue)(a,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Vh=c;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const a=this.right;return this.right=a.left,a.left=this,this.updateHeight(),a.updateHeight(),a}rotateRight(){const a=this.left;return this.left=a.right,a.right=this,this.updateHeight(),a.updateHeight(),a}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var f;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(f||(f={}));class L{static forUris(a=()=>!1,e=()=>!1){return new L(new c(a,e))}static forPaths(a=!1){return new L(new w(void 0,!a))}static forStrings(){return new L(new i)}static forConfigKeys(){return new L(new U)}constructor(a){this.b=a}clear(){this.c=void 0}fill(a,e){if(e){const h=e.slice(0);(0,v.$Wb)(h);for(const l of h)this.set(l,a)}else{const h=a.slice(0);(0,v.$Wb)(h);for(const l of h)this.set(l[0],l[1])}}set(a,e){const h=this.b.reset(a);let l;this.c||(this.c=new g,this.c.segment=h.value());const m=[];for(l=this.c;;){const r=h.cmp(l.segment);if(r>0)l.left||(l.left=new g,l.left.segment=h.value()),m.push([-1,l]),l=l.left;else if(r<0)l.right||(l.right=new g,l.right.segment=h.value()),m.push([1,l]),l=l.right;else if(h.hasNext())h.next(),l.mid||(l.mid=new g,l.mid.segment=h.value()),m.push([0,l]),l=l.mid;else break}const n=l.value;l.value=e,l.key=a;for(let r=m.length-1;r>=0;r--){const b=m[r][1];b.updateHeight();const u=b.balanceFactor();if(u<-1||u>1){const o=m[r][0],F=m[r+1][0];if(o===1&&F===1)m[r][1]=b.rotateLeft();else if(o===-1&&F===-1)m[r][1]=b.rotateRight();else if(o===1&&F===-1)b.right=m[r+1][1]=m[r+1][1].rotateRight(),m[r][1]=b.rotateLeft();else if(o===-1&&F===1)b.left=m[r+1][1]=m[r+1][1].rotateLeft(),m[r][1]=b.rotateRight();else throw new Error;if(r>0)switch(m[r-1][0]){case-1:m[r-1][1].left=m[r][1];break;case 1:m[r-1][1].right=m[r][1];break;case 0:m[r-1][1].mid=m[r][1];break}else this.c=m[0][1]}}return n}get(a){return this.d(a)?.value}d(a){const e=this.b.reset(a);let h=this.c;for(;h;){const l=e.cmp(h.segment);if(l>0)h=h.left;else if(l<0)h=h.right;else if(e.hasNext())e.next(),h=h.mid;else break}return h}has(a){const e=this.d(a);return!(e?.value===void 0&&e?.mid===void 0)}delete(a){return this.e(a,!1)}deleteSuperstr(a){return this.e(a,!0)}e(a,e){const h=this.b.reset(a),l=[];let m=this.c;for(;m;){const n=h.cmp(m.segment);if(n>0)l.push([-1,m]),m=m.left;else if(n<0)l.push([1,m]),m=m.right;else if(h.hasNext())h.next(),l.push([0,m]),m=m.mid;else break}if(m){if(e?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const n=this.f(m.right);if(n.key){const{key:r,value:b,segment:u}=n;this.e(n.key,!1),m.key=r,m.value=b,m.segment=u}}else{const n=m.left??m.right;if(l.length>0){const[r,b]=l[l.length-1];switch(r){case-1:b.left=n;break;case 0:b.mid=n;break;case 1:b.right=n;break}}else this.c=n}for(let n=l.length-1;n>=0;n--){const r=l[n][1];r.updateHeight();const b=r.balanceFactor();if(b>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),l[n][1]=r.rotateLeft()):b<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),l[n][1]=r.rotateRight()),n>0)switch(l[n-1][0]){case-1:l[n-1][1].left=l[n][1];break;case 1:l[n-1][1].right=l[n][1];break;case 0:l[n-1][1].mid=l[n][1];break}else this.c=l[0][1]}}}f(a){for(;a.left;)a=a.left;return a}findSubstr(a){const e=this.b.reset(a);let h=this.c,l;for(;h;){const m=e.cmp(h.segment);if(m>0)h=h.left;else if(m<0)h=h.right;else if(e.hasNext())e.next(),l=h.value||l,h=h.mid;else break}return h&&h.value||l}findSuperstr(a){return this.g(a,!1)}g(a,e){const h=this.b.reset(a);let l=this.c;for(;l;){const m=h.cmp(l.segment);if(m>0)l=l.left;else if(m<0)l=l.right;else if(h.hasNext())h.next(),l=l.mid;else return l.mid?this.h(l.mid):e?l.value:void 0}}hasElementOrSubtree(a){return this.g(a,!0)!==void 0}forEach(a){for(const[e,h]of this)a(h,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(a){const e=[];return this.j(a,e),e[Symbol.iterator]()}j(a,e){a&&(a.left&&this.j(a.left,e),a.value&&e.push([a.key,a.value]),a.mid&&this.j(a.mid,e),a.right&&this.j(a.right,e))}_isBalanced(){const a=e=>{if(!e)return!0;const h=e.balanceFactor();return h<-1||h>1?!1:a(e.left)&&a(e.right)};return a(this.c)}}t.$Wh=L}),define($e[7],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=void 0;function v(u){return typeof u=="string"}t.$yf=v;function T(u){return Array.isArray(u)&&u.every(o=>v(o))}t.$zf=T;function i(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}t.$Af=i;function U(u){const o=Object.getPrototypeOf(Uint8Array);return typeof u=="object"&&u instanceof o}t.$Bf=U;function w(u){return typeof u=="number"&&!isNaN(u)}t.$Cf=w;function y(u){return!!u&&typeof u[Symbol.iterator]=="function"}t.$Df=y;function c(u){return u===!0||u===!1}t.$Ef=c;function g(u){return typeof u>"u"}t.$Ff=g;function f(u){return!L(u)}t.$Gf=f;function L(u){return g(u)||u===null}t.$Hf=L;function s(u,o){if(!u)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.$If=s;function a(u){if(L(u))throw new Error("Assertion Failed: argument is undefined or null");return u}t.$Jf=a;function e(...u){const o=[];for(let F=0;F<u.length;F++){const j=u[F];if(L(j))throw new Error(`Assertion Failed: argument at index ${F} is undefined or null`);o.push(j)}return o}t.$Kf=e;const h=Object.prototype.hasOwnProperty;function l(u){if(!i(u))return!1;for(const o in u)if(h.call(u,o))return!1;return!0}t.$Lf=l;function m(u){return typeof u=="function"}t.$Mf=m;function n(...u){return u.length>0&&u.every(m)}t.$Nf=n;function r(u,o){const F=Math.min(u.length,o.length);for(let j=0;j<F;j++)b(u[j],o[j])}t.$Of=r;function b(u,o){if(v(o)){if(typeof u!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(m(o)){try{if(u instanceof o)return}catch{}if(!L(u)&&u.constructor===o||o.length===1&&o.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$Pf=b}),define($e[18],we([1,0,7]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Vj=t.$Uj=t.$Tj=void 0;const T=Object.create(null);function i(y,c){if((0,v.$yf)(c)){const g=T[c];if(g===void 0)throw new Error(`${y} references an unknown codicon: ${c}`);c=g}return T[y]=c,{id:y}}function U(){return T}t.$Tj=U;function w(){return Object.values(t.$Vj)}t.$Uj=w,t.$Vj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),gitPullRequestLabel:i("git-pull-request-label",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),gitPullRequestMilestone:i("git-pull-request-milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),gitPullRequestReviewer:i("git-pull-request-reviewer",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),gitPullRequestAssignee:i("git-pull-request-assignee",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),mic:i("mic",60434),thumbsDownFilled:i("thumbsdown-filled",60435),thumbsUpFilled:i("thumbsup-filled",60436),coffee:i("coffee",60437),snake:i("snake",60438),game:i("game",60439),vr:i("vr",60440),chip:i("chip",60441),piano:i("piano",60442),music:i("music",60443),micFilled:i("mic-filled",60444),gitFetch:i("git-fetch",60445),copilot:i("copilot",60446),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define($e[51],we([1,0,7]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gn=t.$fn=t.$en=t.$dn=t.$cn=t.$bn=t.$an=t.$_m=t.$$m=t.$0m=t.$9m=t.$8m=void 0;function T(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const n=Array.isArray(m)?[]:{};return Object.entries(m).forEach(([r,b])=>{n[r]=b&&typeof b=="object"?T(b):b}),n}t.$8m=T;function i(m){if(!m||typeof m!="object")return m;const n=[m];for(;n.length>0;){const r=n.shift();Object.freeze(r);for(const b in r)if(U.call(r,b)){const u=r[b];typeof u=="object"&&!Object.isFrozen(u)&&!(0,v.$Bf)(u)&&n.push(u)}}return m}t.$9m=i;const U=Object.prototype.hasOwnProperty;function w(m,n){return y(m,n,new Set)}t.$0m=w;function y(m,n,r){if((0,v.$Hf)(m))return m;const b=n(m);if(typeof b<"u")return b;if(Array.isArray(m)){const u=[];for(const o of m)u.push(y(o,n,r));return u}if((0,v.$Af)(m)){if(r.has(m))throw new Error("Cannot clone recursive data-structure");r.add(m);const u={};for(const o in m)U.call(m,o)&&(u[o]=y(m[o],n,r));return r.delete(m),u}return m}function c(m,n,r=!0){return(0,v.$Af)(m)?((0,v.$Af)(n)&&Object.keys(n).forEach(b=>{b in m?r&&((0,v.$Af)(m[b])&&(0,v.$Af)(n[b])?c(m[b],n[b],r):m[b]=n[b]):m[b]=n[b]}),m):n}t.$$m=c;function g(m,n){if(m===n)return!0;if(m==null||n===null||n===void 0||typeof m!=typeof n||typeof m!="object"||Array.isArray(m)!==Array.isArray(n))return!1;let r,b;if(Array.isArray(m)){if(m.length!==n.length)return!1;for(r=0;r<m.length;r++)if(!g(m[r],n[r]))return!1}else{const u=[];for(b in m)u.push(b);u.sort();const o=[];for(b in n)o.push(b);if(o.sort(),!g(u,o))return!1;for(r=0;r<u.length;r++)if(!g(m[u[r]],n[u[r]]))return!1}return!0}t.$_m=g;function f(m){const n=new Set;return JSON.stringify(m,(r,b)=>{if((0,v.$Af)(b)||Array.isArray(b)){if(n.has(b))return"[Circular]";n.add(b)}return b})}t.$an=f;function L(m,n){const r=Object.create(null);return!m||!n||Object.keys(n).forEach(u=>{const o=m[u],F=n[u];g(o,F)||(r[u]=F)}),r}t.$bn=L;function s(m,n){const r=n.toLowerCase(),b=Object.keys(m).find(u=>u.toLowerCase()===r);return b?m[b]:m[n]}t.$cn=s;function a(m,n){const r=Object.create(null);for(const[b,u]of Object.entries(m))n(b,u)&&(r[b]=u);return r}t.$dn=a;function e(m){let n=[];for(;Object.prototype!==m;)n=n.concat(Object.getOwnPropertyNames(m)),m=Object.getPrototypeOf(m);return n}t.$en=e;function h(m){const n=[];for(const r of e(m))typeof m[r]=="function"&&n.push(r);return n}t.$fn=h;function l(m,n){const r=u=>function(){const o=Array.prototype.slice.call(arguments,0);return n(u,o)},b={};for(const u of m)b[u]=r(u);return b}t.$gn=l}),define($e[19],we([1,0,18]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$Wj=t.ThemeColor=void 0;var T;(function(w){function y(c){return c&&typeof c=="object"&&typeof c.id=="string"}w.isThemeColor=y})(T||(t.ThemeColor=T={}));function i(w){return{id:w}}t.$Wj=i;var U;(function(w){w.iconNameSegment="[A-Za-z0-9]+",w.iconNameExpression="[A-Za-z0-9-]+",w.iconModifierExpression="~[A-Za-z]+",w.iconNameCharacter="[A-Za-z0-9~-]";const y=new RegExp(`^(${w.iconNameExpression})(${w.iconModifierExpression})?$`);function c(n){const r=y.exec(n.id);if(!r)return c(v.$Vj.error);const[,b,u]=r,o=["codicon","codicon-"+b];return u&&o.push("codicon-modifier-"+u.substring(1)),o}w.asClassNameArray=c;function g(n){return c(n).join(" ")}w.asClassName=g;function f(n){return"."+c(n).join(".")}w.asCSSSelector=f;function L(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}w.isThemeIcon=L;const s=new RegExp(`^\\$\\((${w.iconNameExpression}(?:${w.iconModifierExpression})?)\\)$`);function a(n){const r=s.exec(n);if(!r)return;const[,b]=r;return{id:b}}w.fromString=a;function e(n){return{id:n}}w.fromId=e;function h(n,r){let b=n.id;const u=b.lastIndexOf("~");return u!==-1&&(b=b.substring(0,u)),r&&(b=`${b}~${r}`),{id:b}}w.modify=h;function l(n){const r=n.id.lastIndexOf("~");if(r!==-1)return n.id.substring(r+1)}w.getModifier=l;function m(n,r){return n.id===r.id&&n.color?.id===r.color?.id}w.isEqual=m})(U||(t.ThemeIcon=U={}))}),define($e[35],we([1,0,34,12,19]),function(le,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=void 0;const U="$(",w=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(`(\\\\)?${w.source}`,"g");function c(m){return m.replace(y,(n,r)=>r?n:`\\${n}`)}t.$Xj=c;const g=new RegExp(`\\\\${w.source}`,"g");function f(m){return m.replace(g,n=>`\\${n}`)}t.$Yj=f;const L=new RegExp(`(\\s)?(\\\\)?${w.source}(\\s)?`,"g");function s(m){return m.indexOf(U)===-1?m:m.replace(L,(n,r,b,u)=>b?n:r||u||"")}t.$Zj=s;function a(m){return m?m.replace(/\$\((.*?)\)/g,(n,r)=>` ${r} `).trim():""}t.$1j=a;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function h(m){e.lastIndex=0;let n="";const r=[];let b=0;for(;;){const u=e.lastIndex,o=e.exec(m),F=m.substring(u,o?.index);if(F.length>0){n+=F;for(let j=0;j<F.length;j++)r.push(b)}if(!o)break;b+=o[0].length}return{text:n,iconOffsets:r}}t.$2j=h;function l(m,n,r=!1){const{text:b,iconOffsets:u}=n;if(!u||u.length===0)return(0,v.$Kj)(m,b,r);const o=(0,T.$Je)(b," "),F=b.length-o.length,j=(0,v.$Kj)(m,o,r);if(j)for(const R of j){const d=u[R.start+F]+F;R.start+=d,R.end+=d}return j}t.$3j=l}),define($e[88],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IT=t.$HT=void 0,t.$HT="vscode:contextmenu",t.$IT="vscode:onCloseContextMenu"}),define($e[89],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PT=void 0;class v{constructor(i,U){this.a=i,this.onMessage=U}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$PT=v}),define($e[52],we([8]),{}),define($e[90],we([8]),{}),define($e[91],we([8]),{}),define($e[92],we([8]),{}),define($e[93],we([1,0,91,92]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define($e[94],we([8]),{}),define($e[95],we([8]),{}),define($e[96],we([8]),{}),define($e[97],we([8]),{}),define($e[98],we([8]),{}),define($e[99],we([8]),{}),define($e[100],we([8]),{}),define($e[101],we([8]),{}),define($e[102],we([8]),{}),define($e[103],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define($e[104],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/findinput/findInput",t)}),define($e[105],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define($e[106],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define($e[107],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/inputbox/inputBox",t)}),define($e[108],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define($e[109],we([13,10]),function(le,t){return le.create("vs/base/browser/ui/tree/abstractTree",t)}),define($e[110],we([13,10]),function(le,t){return le.create("vs/base/common/actions",t)}),define($e[36],we([1,0,4,2,110]),function(le,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ai=t.$zi=t.$yi=t.$xi=t.$wi=t.$vi=void 0;class U extends T.$Rc{constructor(s,a="",e="",h=!0,l){super(),this.h=this.B(new v.$Nd),this.onDidChange=this.h.event,this.w=!0,this.j=s,this.m=a,this.u=e,this.w=h,this.C=l}get id(){return this.j}get label(){return this.m}set label(s){this.D(s)}D(s){this.m!==s&&(this.m=s,this.h.fire({label:s}))}get tooltip(){return this.n||""}set tooltip(s){this.F(s)}F(s){this.n!==s&&(this.n=s,this.h.fire({tooltip:s}))}get class(){return this.u}set class(s){this.G(s)}G(s){this.u!==s&&(this.u=s,this.h.fire({class:s}))}get enabled(){return this.w}set enabled(s){this.H(s)}H(s){this.w!==s&&(this.w=s,this.h.fire({enabled:s}))}get checked(){return this.z}set checked(s){this.I(s)}I(s){this.z!==s&&(this.z=s,this.h.fire({checked:s}))}async run(s,a){this.C&&await this.C(s)}}t.$vi=U;class w extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new v.$Nd),this.onWillRun=this.f.event,this.m=this.B(new v.$Nd),this.onDidRun=this.m.event}async run(s,a){if(!s.enabled)return;this.f.fire({action:s});let e;try{await this.u(s,a)}catch(h){e=h}this.m.fire({action:s,error:e})}async u(s,a){await s.run(a)}}t.$wi=w;class y{constructor(){this.id=y.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...s){let a=[];for(const e of s)e.length&&(a.length?a=[...a,new y,...e]:a=e);return a}static{this.ID="vs.actions.separator"}async run(){}}t.$xi=y;class c{get actions(){return this.a}constructor(s,a,e,h){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=s,this.label=a,this.class=h,this.a=e}async run(){}}t.$yi=c;class g extends U{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,i.localize(0,null),void 0,!1)}}t.$zi=g;function f(L){return{id:L.id,label:L.label,class:void 0,enabled:L.enabled??!0,checked:L.checked??!1,run:async(...s)=>L.run(...s),tooltip:L.label}}t.$Ai=f}),define($e[111],we([13,10]),function(le,t){return le.create("vs/base/common/platform",t)}),define($e[5],we([1,0,111]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$h=t.$g=void 0,t.$g="en";let T=!1,i=!1,U=!1,w=!1,y=!1,c=!1,g=!1,f=!1,L=!1,s=!1,a,e=t.$g,h=t.$g,l,m;t.$h=typeof self=="object"?self:typeof global=="object"?global:{};let n;typeof t.$h.vscode<"u"&&typeof t.$h.vscode.process<"u"?n=t.$h.vscode.process:typeof process<"u"&&(n=process);const r=typeof n?.versions?.electron=="string",b=r&&n?.type==="renderer";if(typeof navigator=="object"&&!b)m=navigator.userAgent,T=m.indexOf("Windows")>=0,i=m.indexOf("Macintosh")>=0,f=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=m.indexOf("Linux")>=0,s=m?.indexOf("Mobi")>=0,c=!0,a=v.getConfiguredDefaultLocale(v.localize(0,null))||t.$g,e=a,h=navigator.language;else if(typeof n=="object"){T=n.platform==="win32",i=n.platform==="darwin",U=n.platform==="linux",w=U&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,g=r,L=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,a=t.$g,e=t.$g;const H=n.env.VSCODE_NLS_CONFIG;if(H)try{const X=JSON.parse(H),P=X.availableLanguages["*"];a=X.locale,h=X.osLocale,e=P||t.$g,l=X._translationsConfigFile}catch{}y=!0}else console.error("Unable to resolve platform.");var u;(function(H){H[H.Web=0]="Web",H[H.Mac=1]="Mac",H[H.Linux=2]="Linux",H[H.Windows=3]="Windows"})(u||(t.Platform=u={}));function o(H){switch(H){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$i=o;let F=0;i?F=1:T?F=3:U&&(F=2),t.$j=T,t.$k=i,t.$l=U,t.$m=w,t.$n=y,t.$o=g,t.$p=c,t.$q=c&&typeof t.$h.importScripts=="function",t.$r=f,t.$s=s,t.$t=L,t.$u=F,t.$v=m,t.$w=e;var j;(function(H){function X(){return t.$w}H.value=X;function P(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}H.isDefaultVariant=P;function O(){return t.$w==="en"}H.isDefault=O})(j||(t.Language=j={})),t.$x=a,t.$y=h,t.$z=l,t.$A=typeof t.$h.postMessage=="function"&&!t.$h.importScripts,t.$B=(()=>{if(t.$A){const H=[];t.$h.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let O=0,Q=H.length;O<Q;O++){const te=H[O];if(te.id===P.data.vscodeScheduleAsyncWork){H.splice(O,1),te.callback();return}}});let X=0;return P=>{const O=++X;H.push({id:O,callback:P}),t.$h.postMessage({vscodeScheduleAsyncWork:O},"*")}}return H=>setTimeout(H)})();var R;(function(H){H[H.Windows=1]="Windows",H[H.Macintosh=2]="Macintosh",H[H.Linux=3]="Linux"})(R||(t.OperatingSystem=R={})),t.OS=i||f?2:T?1:3;let d=!0,D=!1;function B(){if(!D){D=!0;const H=new Uint8Array(2);H[0]=1,H[1]=2,d=new Uint16Array(H.buffer)[0]===(2<<8)+1}return d}t.$D=B,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0)}),define($e[112],we([1,0,17,14,5]),function(le,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KO=t.KeyboardSupport=void 0;var U;(function(w){w[w.Always=0]="Always",w[w.FullScreen=1]="FullScreen",w[w.None=2]="None"})(U||(t.KeyboardSupport=U={})),t.$KO={clipboard:{writeText:i.$n||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.$n||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.$n||v.$IO()?0:navigator.keyboard||v.$EO?1:2)(),touch:"ontouchstart"in T.$pO||navigator.maxTouchPoints>0,pointerEvents:T.$pO.PointerEvent&&("ontouchstart"in T.$pO||navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define($e[15],we([1,0,17,44,78,5]),function(le,t,v,T,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SO=t.$RO=t.$QO=void 0;function w(e){if(e.charCode){const l=String.fromCharCode(e.charCode).toUpperCase();return T.KeyCodeUtils.fromString(l)}const h=e.keyCode;if(h===3)return 7;if(v.$BO)switch(h){case 59:return 85;case 60:if(U.$l)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(U.$k)return 57;break}else if(v.$CO){if(U.$k&&h===93)return 57;if(!U.$k&&h===92)return 57}return T.$Bq[h]||0}const y=U.$k?256:2048,c=512,g=1024,f=U.$k?2048:256;function L(e){const h=[];return e.ctrlKey&&h.push("ctrl"),e.shiftKey&&h.push("shift"),e.altKey&&h.push("alt"),e.metaKey&&h.push("meta"),`modifiers: [${h.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$QO=L;function s(e){const h=[];return e.ctrlKey&&h.push("ctrl"),e.shiftKey&&h.push("shift"),e.altKey&&h.push("alt"),e.metaKey&&h.push("meta"),`modifiers: [${h.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${T.KeyCodeUtils.toString(e.keyCode)}')`}t.$RO=s;class a{constructor(h){this._standardKeyboardEventBrand=!0;const l=h;this.browserEvent=l,this.target=l.target,this.ctrlKey=l.ctrlKey,this.shiftKey=l.shiftKey,this.altKey=l.altKey,this.metaKey=l.metaKey,this.altGraphKey=l.getModifierState("AltGraph"),this.keyCode=w(l),this.code=l.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(h){return this.a===h}c(){let h=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(h=this.keyCode);let l=0;return this.ctrlKey&&(l|=y),this.altKey&&(l|=c),this.shiftKey&&(l|=g),this.metaKey&&(l|=f),l|=h,l}d(){let h=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(h=this.keyCode),new i.$Jq(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,h)}}t.$SO=a}),define($e[20],we([1,0,17,71,14,5]),function(le,t,v,T,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$PO=t.$OO=t.$NO=void 0;class w{constructor(f){this.timestamp=Date.now(),this.browserEvent=f,this.leftButton=f.button===0,this.middleButton=f.button===1,this.rightButton=f.button===2,this.buttons=f.buttons,this.target=f.target,this.detail=f.detail||1,f.type==="dblclick"&&(this.detail=2),this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,typeof f.pageX=="number"?(this.posx=f.pageX,this.posy=f.pageY):(this.posx=f.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=f.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const L=T.$LO.getPositionOfChildWindowRelativeToAncestorWindow(i.$window,f.view);this.posx-=L.left,this.posy-=L.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$NO=w;class y extends w{constructor(f){super(f),this.dataTransfer=f.dataTransfer}}t.$OO=y;class c{constructor(f,L=0,s=0){if(this.browserEvent=f||null,this.target=f?f.target||f.targetNode||f.srcElement:null,this.deltaY=s,this.deltaX=L,f){const a=f,e=f;if(typeof a.wheelDeltaY<"u")this.deltaY=a.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(f.type==="wheel"){const h=f;h.deltaMode===h.DOM_DELTA_LINE?v.$BO&&!U.$k?this.deltaY=-f.deltaY/3:this.deltaY=-f.deltaY:this.deltaY=-f.deltaY/40}if(typeof a.wheelDeltaX<"u")v.$EO&&U.$j?this.deltaX=-(a.wheelDeltaX/120):this.deltaX=a.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-f.detail/3;else if(f.type==="wheel"){const h=f;h.deltaMode===h.DOM_DELTA_LINE?v.$BO&&!U.$k?this.deltaX=-f.deltaX/3:this.deltaX=-f.deltaX:this.deltaX=-f.deltaX/40}this.deltaY===0&&this.deltaX===0&&f.wheelDelta&&(this.deltaY=f.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$PO=c}),define($e[113],we([1,0,5]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dc=t.$cc=t.env=t.cwd=void 0;let T;if(typeof v.$h.vscode<"u"&&typeof v.$h.vscode.process<"u"){const i=v.$h.vscode.process;T={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return v.$j?"win32":v.$k?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=T.cwd,t.env=T.env,t.$cc=T.platform,t.$dc=T.arch}),define($e[23],we([1,0,113]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sc=t.sep=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=void 0;const T=65,i=97,U=90,w=122,y=46,c=47,g=92,f=58,L=63;class s extends Error{constructor(F,j,R){let d;typeof j=="string"&&j.indexOf("not ")===0?(d="must not be",j=j.replace(/^not /,"")):d="must be";const D=F.indexOf(".")!==-1?"property":"argument";let B=`The "${F}" ${D} ${d} of type ${j}`;B+=`. Received type ${typeof R}`,super(B),this.code="ERR_INVALID_ARG_TYPE"}}function a(o,F){if(o===null||typeof o!="object")throw new s(F,"Object",o)}function e(o,F){if(typeof o!="string")throw new s(F,"string",o)}const h=v.$cc==="win32";function l(o){return o===c||o===g}function m(o){return o===c}function n(o){return o>=T&&o<=U||o>=i&&o<=w}function r(o,F,j,R){let d="",D=0,B=-1,H=0,X=0;for(let P=0;P<=o.length;++P){if(P<o.length)X=o.charCodeAt(P);else{if(R(X))break;X=c}if(R(X)){if(!(B===P-1||H===1))if(H===2){if(d.length<2||D!==2||d.charCodeAt(d.length-1)!==y||d.charCodeAt(d.length-2)!==y){if(d.length>2){const O=d.lastIndexOf(j);O===-1?(d="",D=0):(d=d.slice(0,O),D=d.length-1-d.lastIndexOf(j)),B=P,H=0;continue}else if(d.length!==0){d="",D=0,B=P,H=0;continue}}F&&(d+=d.length>0?`${j}..`:"..",D=2)}else d.length>0?d+=`${j}${o.slice(B+1,P)}`:d=o.slice(B+1,P),D=P-B-1;B=P,H=0}else X===y&&H!==-1?++H:H=-1}return d}function b(o,F){a(F,"pathObject");const j=F.dir||F.root,R=F.base||`${F.name||""}${F.ext||""}`;return j?j===F.root?`${j}${R}`:`${j}${o}${R}`:R}t.$ec={resolve(...o){let F="",j="",R=!1;for(let d=o.length-1;d>=-1;d--){let D;if(d>=0){if(D=o[d],e(D,"path"),D.length===0)continue}else F.length===0?D=v.cwd():(D=v.env[`=${F}`]||v.cwd(),(D===void 0||D.slice(0,2).toLowerCase()!==F.toLowerCase()&&D.charCodeAt(2)===g)&&(D=`${F}\\`));const B=D.length;let H=0,X="",P=!1;const O=D.charCodeAt(0);if(B===1)l(O)&&(H=1,P=!0);else if(l(O))if(P=!0,l(D.charCodeAt(1))){let Q=2,te=Q;for(;Q<B&&!l(D.charCodeAt(Q));)Q++;if(Q<B&&Q!==te){const re=D.slice(te,Q);for(te=Q;Q<B&&l(D.charCodeAt(Q));)Q++;if(Q<B&&Q!==te){for(te=Q;Q<B&&!l(D.charCodeAt(Q));)Q++;(Q===B||Q!==te)&&(X=`\\\\${re}\\${D.slice(te,Q)}`,H=Q)}}}else H=1;else n(O)&&D.charCodeAt(1)===f&&(X=D.slice(0,2),H=2,B>2&&l(D.charCodeAt(2))&&(P=!0,H=3));if(X.length>0)if(F.length>0){if(X.toLowerCase()!==F.toLowerCase())continue}else F=X;if(R){if(F.length>0)break}else if(j=`${D.slice(H)}\\${j}`,R=P,P&&F.length>0)break}return j=r(j,!R,"\\",l),R?`${F}\\${j}`:`${F}${j}`||"."},normalize(o){e(o,"path");const F=o.length;if(F===0)return".";let j=0,R,d=!1;const D=o.charCodeAt(0);if(F===1)return m(D)?"\\":o;if(l(D))if(d=!0,l(o.charCodeAt(1))){let H=2,X=H;for(;H<F&&!l(o.charCodeAt(H));)H++;if(H<F&&H!==X){const P=o.slice(X,H);for(X=H;H<F&&l(o.charCodeAt(H));)H++;if(H<F&&H!==X){for(X=H;H<F&&!l(o.charCodeAt(H));)H++;if(H===F)return`\\\\${P}\\${o.slice(X)}\\`;H!==X&&(R=`\\\\${P}\\${o.slice(X,H)}`,j=H)}}}else j=1;else n(D)&&o.charCodeAt(1)===f&&(R=o.slice(0,2),j=2,F>2&&l(o.charCodeAt(2))&&(d=!0,j=3));let B=j<F?r(o.slice(j),!d,"\\",l):"";return B.length===0&&!d&&(B="."),B.length>0&&l(o.charCodeAt(F-1))&&(B+="\\"),R===void 0?d?`\\${B}`:B:d?`${R}\\${B}`:`${R}${B}`},isAbsolute(o){e(o,"path");const F=o.length;if(F===0)return!1;const j=o.charCodeAt(0);return l(j)||F>2&&n(j)&&o.charCodeAt(1)===f&&l(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let F,j;for(let D=0;D<o.length;++D){const B=o[D];e(B,"path"),B.length>0&&(F===void 0?F=j=B:F+=`\\${B}`)}if(F===void 0)return".";let R=!0,d=0;if(typeof j=="string"&&l(j.charCodeAt(0))){++d;const D=j.length;D>1&&l(j.charCodeAt(1))&&(++d,D>2&&(l(j.charCodeAt(2))?++d:R=!1))}if(R){for(;d<F.length&&l(F.charCodeAt(d));)d++;d>=2&&(F=`\\${F.slice(d)}`)}return t.$ec.normalize(F)},relative(o,F){if(e(o,"from"),e(F,"to"),o===F)return"";const j=t.$ec.resolve(o),R=t.$ec.resolve(F);if(j===R||(o=j.toLowerCase(),F=R.toLowerCase(),o===F))return"";let d=0;for(;d<o.length&&o.charCodeAt(d)===g;)d++;let D=o.length;for(;D-1>d&&o.charCodeAt(D-1)===g;)D--;const B=D-d;let H=0;for(;H<F.length&&F.charCodeAt(H)===g;)H++;let X=F.length;for(;X-1>H&&F.charCodeAt(X-1)===g;)X--;const P=X-H,O=B<P?B:P;let Q=-1,te=0;for(;te<O;te++){const fe=o.charCodeAt(d+te);if(fe!==F.charCodeAt(H+te))break;fe===g&&(Q=te)}if(te!==O){if(Q===-1)return R}else{if(P>O){if(F.charCodeAt(H+te)===g)return R.slice(H+te+1);if(te===2)return R.slice(H+te)}B>O&&(o.charCodeAt(d+te)===g?Q=te:te===2&&(Q=3)),Q===-1&&(Q=0)}let re="";for(te=d+Q+1;te<=D;++te)(te===D||o.charCodeAt(te)===g)&&(re+=re.length===0?"..":"\\..");return H+=Q,re.length>0?`${re}${R.slice(H,X)}`:(R.charCodeAt(H)===g&&++H,R.slice(H,X))},toNamespacedPath(o){if(typeof o!="string"||o.length===0)return o;const F=t.$ec.resolve(o);if(F.length<=2)return o;if(F.charCodeAt(0)===g){if(F.charCodeAt(1)===g){const j=F.charCodeAt(2);if(j!==L&&j!==y)return`\\\\?\\UNC\\${F.slice(2)}`}}else if(n(F.charCodeAt(0))&&F.charCodeAt(1)===f&&F.charCodeAt(2)===g)return`\\\\?\\${F}`;return o},dirname(o){e(o,"path");const F=o.length;if(F===0)return".";let j=-1,R=0;const d=o.charCodeAt(0);if(F===1)return l(d)?o:".";if(l(d)){if(j=R=1,l(o.charCodeAt(1))){let H=2,X=H;for(;H<F&&!l(o.charCodeAt(H));)H++;if(H<F&&H!==X){for(X=H;H<F&&l(o.charCodeAt(H));)H++;if(H<F&&H!==X){for(X=H;H<F&&!l(o.charCodeAt(H));)H++;if(H===F)return o;H!==X&&(j=R=H+1)}}}}else n(d)&&o.charCodeAt(1)===f&&(j=F>2&&l(o.charCodeAt(2))?3:2,R=j);let D=-1,B=!0;for(let H=F-1;H>=R;--H)if(l(o.charCodeAt(H))){if(!B){D=H;break}}else B=!1;if(D===-1){if(j===-1)return".";D=j}return o.slice(0,D)},basename(o,F){F!==void 0&&e(F,"ext"),e(o,"path");let j=0,R=-1,d=!0,D;if(o.length>=2&&n(o.charCodeAt(0))&&o.charCodeAt(1)===f&&(j=2),F!==void 0&&F.length>0&&F.length<=o.length){if(F===o)return"";let B=F.length-1,H=-1;for(D=o.length-1;D>=j;--D){const X=o.charCodeAt(D);if(l(X)){if(!d){j=D+1;break}}else H===-1&&(d=!1,H=D+1),B>=0&&(X===F.charCodeAt(B)?--B===-1&&(R=D):(B=-1,R=H))}return j===R?R=H:R===-1&&(R=o.length),o.slice(j,R)}for(D=o.length-1;D>=j;--D)if(l(o.charCodeAt(D))){if(!d){j=D+1;break}}else R===-1&&(d=!1,R=D+1);return R===-1?"":o.slice(j,R)},extname(o){e(o,"path");let F=0,j=-1,R=0,d=-1,D=!0,B=0;o.length>=2&&o.charCodeAt(1)===f&&n(o.charCodeAt(0))&&(F=R=2);for(let H=o.length-1;H>=F;--H){const X=o.charCodeAt(H);if(l(X)){if(!D){R=H+1;break}continue}d===-1&&(D=!1,d=H+1),X===y?j===-1?j=H:B!==1&&(B=1):j!==-1&&(B=-1)}return j===-1||d===-1||B===0||B===1&&j===d-1&&j===R+1?"":o.slice(j,d)},format:b.bind(null,"\\"),parse(o){e(o,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return F;const j=o.length;let R=0,d=o.charCodeAt(0);if(j===1)return l(d)?(F.root=F.dir=o,F):(F.base=F.name=o,F);if(l(d)){if(R=1,l(o.charCodeAt(1))){let Q=2,te=Q;for(;Q<j&&!l(o.charCodeAt(Q));)Q++;if(Q<j&&Q!==te){for(te=Q;Q<j&&l(o.charCodeAt(Q));)Q++;if(Q<j&&Q!==te){for(te=Q;Q<j&&!l(o.charCodeAt(Q));)Q++;Q===j?R=Q:Q!==te&&(R=Q+1)}}}}else if(n(d)&&o.charCodeAt(1)===f){if(j<=2)return F.root=F.dir=o,F;if(R=2,l(o.charCodeAt(2))){if(j===3)return F.root=F.dir=o,F;R=3}}R>0&&(F.root=o.slice(0,R));let D=-1,B=R,H=-1,X=!0,P=o.length-1,O=0;for(;P>=R;--P){if(d=o.charCodeAt(P),l(d)){if(!X){B=P+1;break}continue}H===-1&&(X=!1,H=P+1),d===y?D===-1?D=P:O!==1&&(O=1):D!==-1&&(O=-1)}return H!==-1&&(D===-1||O===0||O===1&&D===H-1&&D===B+1?F.base=F.name=o.slice(B,H):(F.name=o.slice(B,D),F.base=o.slice(B,H),F.ext=o.slice(D,H))),B>0&&B!==R?F.dir=o.slice(0,B-1):F.dir=F.root,F},sep:"\\",delimiter:";",win32:null,posix:null};const u=(()=>{if(h){const o=/\\/g;return()=>{const F=v.cwd().replace(o,"/");return F.slice(F.indexOf("/"))}}return()=>v.cwd()})();t.$fc={resolve(...o){let F="",j=!1;for(let R=o.length-1;R>=-1&&!j;R--){const d=R>=0?o[R]:u();e(d,"path"),d.length!==0&&(F=`${d}/${F}`,j=d.charCodeAt(0)===c)}return F=r(F,!j,"/",m),j?`/${F}`:F.length>0?F:"."},normalize(o){if(e(o,"path"),o.length===0)return".";const F=o.charCodeAt(0)===c,j=o.charCodeAt(o.length-1)===c;return o=r(o,!F,"/",m),o.length===0?F?"/":j?"./":".":(j&&(o+="/"),F?`/${o}`:o)},isAbsolute(o){return e(o,"path"),o.length>0&&o.charCodeAt(0)===c},join(...o){if(o.length===0)return".";let F;for(let j=0;j<o.length;++j){const R=o[j];e(R,"path"),R.length>0&&(F===void 0?F=R:F+=`/${R}`)}return F===void 0?".":t.$fc.normalize(F)},relative(o,F){if(e(o,"from"),e(F,"to"),o===F||(o=t.$fc.resolve(o),F=t.$fc.resolve(F),o===F))return"";const j=1,R=o.length,d=R-j,D=1,B=F.length-D,H=d<B?d:B;let X=-1,P=0;for(;P<H;P++){const Q=o.charCodeAt(j+P);if(Q!==F.charCodeAt(D+P))break;Q===c&&(X=P)}if(P===H)if(B>H){if(F.charCodeAt(D+P)===c)return F.slice(D+P+1);if(P===0)return F.slice(D+P)}else d>H&&(o.charCodeAt(j+P)===c?X=P:P===0&&(X=0));let O="";for(P=j+X+1;P<=R;++P)(P===R||o.charCodeAt(P)===c)&&(O+=O.length===0?"..":"/..");return`${O}${F.slice(D+X)}`},toNamespacedPath(o){return o},dirname(o){if(e(o,"path"),o.length===0)return".";const F=o.charCodeAt(0)===c;let j=-1,R=!0;for(let d=o.length-1;d>=1;--d)if(o.charCodeAt(d)===c){if(!R){j=d;break}}else R=!1;return j===-1?F?"/":".":F&&j===1?"//":o.slice(0,j)},basename(o,F){F!==void 0&&e(F,"ext"),e(o,"path");let j=0,R=-1,d=!0,D;if(F!==void 0&&F.length>0&&F.length<=o.length){if(F===o)return"";let B=F.length-1,H=-1;for(D=o.length-1;D>=0;--D){const X=o.charCodeAt(D);if(X===c){if(!d){j=D+1;break}}else H===-1&&(d=!1,H=D+1),B>=0&&(X===F.charCodeAt(B)?--B===-1&&(R=D):(B=-1,R=H))}return j===R?R=H:R===-1&&(R=o.length),o.slice(j,R)}for(D=o.length-1;D>=0;--D)if(o.charCodeAt(D)===c){if(!d){j=D+1;break}}else R===-1&&(d=!1,R=D+1);return R===-1?"":o.slice(j,R)},extname(o){e(o,"path");let F=-1,j=0,R=-1,d=!0,D=0;for(let B=o.length-1;B>=0;--B){const H=o.charCodeAt(B);if(H===c){if(!d){j=B+1;break}continue}R===-1&&(d=!1,R=B+1),H===y?F===-1?F=B:D!==1&&(D=1):F!==-1&&(D=-1)}return F===-1||R===-1||D===0||D===1&&F===R-1&&F===j+1?"":o.slice(F,R)},format:b.bind(null,"/"),parse(o){e(o,"path");const F={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return F;const j=o.charCodeAt(0)===c;let R;j?(F.root="/",R=1):R=0;let d=-1,D=0,B=-1,H=!0,X=o.length-1,P=0;for(;X>=R;--X){const O=o.charCodeAt(X);if(O===c){if(!H){D=X+1;break}continue}B===-1&&(H=!1,B=X+1),O===y?d===-1?d=X:P!==1&&(P=1):d!==-1&&(P=-1)}if(B!==-1){const O=D===0&&j?1:D;d===-1||P===0||P===1&&d===B-1&&d===D+1?F.base=F.name=o.slice(O,B):(F.name=o.slice(O,d),F.base=o.slice(O,B),F.ext=o.slice(d,B))}return D>0?F.dir=o.slice(0,D-1):j&&(F.dir="/"),F},sep:"/",delimiter:":",win32:null,posix:null},t.$fc.win32=t.$ec.win32=t.$ec,t.$fc.posix=t.$ec.posix=t.$fc,t.$gc=h?t.$ec.normalize:t.$fc.normalize,t.$hc=h?t.$ec.isAbsolute:t.$fc.isAbsolute,t.$ic=h?t.$ec.join:t.$fc.join,t.$jc=h?t.$ec.resolve:t.$fc.resolve,t.$kc=h?t.$ec.relative:t.$fc.relative,t.$lc=h?t.$ec.dirname:t.$fc.dirname,t.$mc=h?t.$ec.basename:t.$fc.basename,t.$nc=h?t.$ec.extname:t.$fc.extname,t.$oc=h?t.$ec.format:t.$fc.format,t.$pc=h?t.$ec.parse:t.$fc.parse,t.$qc=h?t.$ec.toNamespacedPath:t.$fc.toNamespacedPath,t.sep=h?t.$ec.sep:t.$fc.sep,t.$sc=h?t.$ec.delimiter:t.$fc.delimiter}),define($e[114],we([1,0,23,5,12,7]),function(le,t,v,T,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=void 0;function w(D){return D===47||D===92}t.$Qf=w;function y(D){return D.replace(/[\\/]/g,v.$fc.sep)}t.$Rf=y;function c(D){return D.indexOf("/")===-1&&(D=y(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}t.$Sf=c;function g(D,B=v.$fc.sep){if(!D)return"";const H=D.length,X=D.charCodeAt(0);if(w(X)){if(w(D.charCodeAt(1))&&!w(D.charCodeAt(2))){let O=3;const Q=O;for(;O<H&&!w(D.charCodeAt(O));O++);if(Q!==O&&!w(D.charCodeAt(O+1))){for(O+=1;O<H;O++)if(w(D.charCodeAt(O)))return D.slice(0,O+1).replace(/[\\/]/g,B)}}return B}else if(m(X)&&D.charCodeAt(1)===58)return w(D.charCodeAt(2))?D.slice(0,2)+B:D.slice(0,2);let P=D.indexOf("://");if(P!==-1){for(P+=3;P<H;P++)if(w(D.charCodeAt(P)))return D.slice(0,P+1)}return""}t.$Tf=g;function f(D){if(!T.$j||!D||D.length<5)return!1;let B=D.charCodeAt(0);if(B!==92||(B=D.charCodeAt(1),B!==92))return!1;let H=2;const X=H;for(;H<D.length&&(B=D.charCodeAt(H),B!==92);H++);return!(X===H||(B=D.charCodeAt(H+1),isNaN(B)||B===92))}t.$Uf=f;const L=/[\\/:\*\?"<>\|]/g,s=/[\\/]/g,a=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(D,B=T.$j){const H=B?L:s;return!(!D||D.length===0||/^\s+$/.test(D)||(H.lastIndex=0,H.test(D))||B&&a.test(D)||D==="."||D===".."||B&&D[D.length-1]==="."||B&&D.length!==D.trim().length||D.length>255)}t.$Vf=e;function h(D,B,H){const X=D===B;return!H||X?X:!D||!B?!1:(0,i.$2e)(D,B)}t.$Wf=h;function l(D,B,H,X=v.sep){if(D===B)return!0;if(!D||!B||B.length>D.length)return!1;if(H){if(!(0,i.$3e)(D,B))return!1;if(B.length===D.length)return!0;let O=B.length;return B.charAt(B.length-1)===X&&O--,D.charAt(O)===X}return B.charAt(B.length-1)!==X&&(B+=X),D.indexOf(B)===0}t.$Xf=l;function m(D){return D>=65&&D<=90||D>=97&&D<=122}t.$Yf=m;function n(D,B){return T.$j&&D.endsWith(":")&&(D+=v.sep),(0,v.$hc)(D)||(D=(0,v.$ic)(B,D)),D=(0,v.$gc)(D),T.$j?(D=(0,i.$Ke)(D,v.sep),D.endsWith(":")&&(D+=v.sep)):(D=(0,i.$Ke)(D,v.sep),D||(D=v.sep)),D}t.$Zf=n;function r(D){const B=(0,v.$gc)(D);return T.$j?D.length>3?!1:b(B)&&(D.length===2||B.charCodeAt(2)===92):B===v.$fc.sep}t.$1f=r;function b(D,B=T.$j){return B?m(D.charCodeAt(0))&&D.charCodeAt(1)===58:!1}t.$2f=b;function u(D,B=T.$j){return b(D,B)?D[0]:void 0}t.$3f=u;function o(D,B,H){return B.length>D.length?-1:D===B?0:(H&&(D=D.toLowerCase(),B=B.toLowerCase()),D.indexOf(B))}t.$4f=o;function F(D){const B=D.split(":");let H,X,P;for(const O of B){const Q=Number(O);(0,U.$Cf)(Q)?X===void 0?X=Q:P===void 0&&(P=Q):H=H?[H,O].join(":"):O}if(!H)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:H,line:X!==void 0?X:void 0,column:P!==void 0?P:X!==void 0?1:void 0}}t.$5f=F;const j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function d(D,B,H=8){let X="";for(let O=0;O<H;O++){let Q;O===0&&T.$j&&!B&&(H===3||H===4)?Q=R:Q=j,X+=Q.charAt(Math.floor(Math.random()*Q.length))}let P;return B?P=`${B}-${X}`:P=X,D?(0,v.$ic)(D,P):P}t.$6f=d}),define($e[115],we([1,0,23]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ur=t.$Tr=t.$Sr=t.$Rr=t.$Qr=void 0,t.$Qr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function U(f){const L=(0,v.$nc)(f),s=T[L.toLowerCase()];return s!==void 0?s:w(f)}t.$Rr=U;function w(f){const L=(0,v.$nc)(f);return i[L.toLowerCase()]}t.$Sr=w;function y(f){for(const L in i)if(i[L]===f)return L}t.$Tr=y;const c=/^(.+)\/(.+?)(;.+)?$/;function g(f,L){const s=c.exec(f);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${s[3]??""}`:L?void 0:f}t.$Ur=g}),define($e[16],we([1,0,23,5]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vc=t.$uc=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,U=/^\//,w=/^\/\//;function y(R,d){if(!R.scheme&&d)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!i.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!U.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(w.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function c(R,d){return!R&&!d?"file":R}function g(R,d){switch(R){case"https":case"http":case"file":d?d[0]!==L&&(d=L+d):d=L;break}return d}const f="",L="/",s=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class a{static isUri(d){return d instanceof a?!0:d?typeof d.authority=="string"&&typeof d.fragment=="string"&&typeof d.path=="string"&&typeof d.query=="string"&&typeof d.scheme=="string"&&typeof d.fsPath=="string"&&typeof d.with=="function"&&typeof d.toString=="function":!1}constructor(d,D,B,H,X,P=!1){typeof d=="object"?(this.scheme=d.scheme||f,this.authority=d.authority||f,this.path=d.path||f,this.query=d.query||f,this.fragment=d.fragment||f):(this.scheme=c(d,P),this.authority=D||f,this.path=g(this.scheme,B||f),this.query=H||f,this.fragment=X||f,y(this,P))}get fsPath(){return b(this,!1)}with(d){if(!d)return this;let{scheme:D,authority:B,path:H,query:X,fragment:P}=d;return D===void 0?D=this.scheme:D===null&&(D=f),B===void 0?B=this.authority:B===null&&(B=f),H===void 0?H=this.path:H===null&&(H=f),X===void 0?X=this.query:X===null&&(X=f),P===void 0?P=this.fragment:P===null&&(P=f),D===this.scheme&&B===this.authority&&H===this.path&&X===this.query&&P===this.fragment?this:new l(D,B,H,X,P)}static parse(d,D=!1){const B=s.exec(d);return B?new l(B[2]||f,j(B[4]||f),j(B[5]||f),j(B[7]||f),j(B[9]||f),D):new l(f,f,f,f,f)}static file(d){let D=f;if(T.$j&&(d=d.replace(/\\/g,L)),d[0]===L&&d[1]===L){const B=d.indexOf(L,2);B===-1?(D=d.substring(2),d=L):(D=d.substring(2,B),d=d.substring(B)||L)}return new l("file",D,d,f,f)}static from(d,D){return new l(d.scheme,d.authority,d.path,d.query,d.fragment,D)}static joinPath(d,...D){if(!d.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let B;return T.$j&&d.scheme==="file"?B=a.file(v.$ec.join(b(d,!0),...D)).path:B=v.$fc.join(d.path,...D),d.with({path:B})}toString(d=!1){return u(this,d)}toJSON(){return this}static revive(d){if(d){if(d instanceof a)return d;{const D=new l(d);return D._formatted=d.external??null,D._fsPath=d._sep===h?d.fsPath??null:null,D}}else return d}}t.URI=a;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$uc=e;const h=T.$j?1:void 0;class l extends a{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(d=!1){return d?u(this,!0):(this._formatted||(this._formatted=u(this,!1)),this._formatted)}toJSON(){const d={$mid:1};return this._fsPath&&(d.fsPath=this._fsPath,d._sep=h),this._formatted&&(d.external=this._formatted),this.path&&(d.path=this.path),this.scheme&&(d.scheme=this.scheme),this.authority&&(d.authority=this.authority),this.query&&(d.query=this.query),this.fragment&&(d.fragment=this.fragment),d}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function n(R,d,D){let B,H=-1;for(let X=0;X<R.length;X++){const P=R.charCodeAt(X);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||d&&P===47||D&&P===91||D&&P===93||D&&P===58)H!==-1&&(B+=encodeURIComponent(R.substring(H,X)),H=-1),B!==void 0&&(B+=R.charAt(X));else{B===void 0&&(B=R.substr(0,X));const O=m[P];O!==void 0?(H!==-1&&(B+=encodeURIComponent(R.substring(H,X)),H=-1),B+=O):H===-1&&(H=X)}}return H!==-1&&(B+=encodeURIComponent(R.substring(H))),B!==void 0?B:R}function r(R){let d;for(let D=0;D<R.length;D++){const B=R.charCodeAt(D);B===35||B===63?(d===void 0&&(d=R.substr(0,D)),d+=m[B]):d!==void 0&&(d+=R[D])}return d!==void 0?d:R}function b(R,d){let D;return R.authority&&R.path.length>1&&R.scheme==="file"?D=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?d?D=R.path.substr(1):D=R.path[1].toLowerCase()+R.path.substr(2):D=R.path,T.$j&&(D=D.replace(/\//g,"\\")),D}t.$vc=b;function u(R,d){const D=d?r:n;let B="",{scheme:H,authority:X,path:P,query:O,fragment:Q}=R;if(H&&(B+=H,B+=":"),(X||H==="file")&&(B+=L,B+=L),X){let te=X.indexOf("@");if(te!==-1){const re=X.substr(0,te);X=X.substr(te+1),te=re.lastIndexOf(":"),te===-1?B+=D(re,!1,!1):(B+=D(re.substr(0,te),!1,!1),B+=":",B+=D(re.substr(te+1),!1,!0)),B+="@"}X=X.toLowerCase(),te=X.lastIndexOf(":"),te===-1?B+=D(X,!1,!0):(B+=D(X.substr(0,te),!1,!0),B+=X.substr(te))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const te=P.charCodeAt(1);te>=65&&te<=90&&(P=`/${String.fromCharCode(te+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const te=P.charCodeAt(0);te>=65&&te<=90&&(P=`${String.fromCharCode(te+32)}:${P.substr(2)}`)}B+=D(P,!0,!1)}return O&&(B+="?",B+=D(O,!1,!1)),Q&&(B+="#",B+=d?Q:n(Q,!1,!1)),B}function o(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+o(R.substr(3)):R}}const F=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function j(R){return R.match(F)?R.replace(F,d=>o(d)):R}}),define($e[53],we([1,0,33,16]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nh=t.$mh=t.$lh=void 0;function i(c){return JSON.stringify(c,w)}t.$lh=i;function U(c){let g=JSON.parse(c);return g=y(g),g}t.$mh=U;function w(c,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function y(c,g=0){if(!c||g>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return T.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 17:return new Date(c.source)}if(c instanceof v.$be||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let f=0;f<c.length;++f)c[f]=y(c[f],g+1);else for(const f in c)Object.hasOwnProperty.call(c,f)&&(c[f]=y(c[f],g+1))}return c}t.$nh=y}),define($e[30],we([1,0,6,5,16]),function(le,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.Schemas=void 0;var U;(function(g){g.inMemory="inmemory",g.vscode="vscode",g.internal="private",g.walkThrough="walkThrough",g.walkThroughSnippet="walkThroughSnippet",g.http="http",g.https="https",g.file="file",g.mailto="mailto",g.untitled="untitled",g.data="data",g.command="command",g.vscodeRemote="vscode-remote",g.vscodeRemoteResource="vscode-remote-resource",g.vscodeManagedRemoteResource="vscode-managed-remote-resource",g.vscodeUserData="vscode-userdata",g.vscodeCustomEditor="vscode-custom-editor",g.vscodeNotebookCell="vscode-notebook-cell",g.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",g.vscodeNotebookCellOutput="vscode-notebook-cell-output",g.vscodeInteractiveInput="vscode-interactive-input",g.vscodeSettings="vscode-settings",g.vscodeWorkspaceTrust="vscode-workspace-trust",g.vscodeTerminal="vscode-terminal",g.vscodeChatSesssion="vscode-chat-editor",g.webviewPanel="webview-panel",g.vscodeWebview="vscode-webview",g.extension="extension",g.vscodeFileResource="vscode-file",g.tmp="tmp",g.vsls="vsls",g.vscodeSourceControl="vscode-scm"})(U||(t.Schemas=U={})),t.$7f="vscode-tkn",t.$8f="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${U.vscodeRemoteResource}`}setPreferredWebSchema(f){this.d=f}setDelegate(f){this.e=f}setServerRootPath(f){this.f=`${f}/${U.vscodeRemoteResource}`}set(f,L,s){this.a[f]=L,this.b[f]=s}setConnectionToken(f,L){this.c[f]=L}getPreferredWebSchema(){return this.d}rewrite(f){if(this.e)try{return this.e(f)}catch(l){return v.$Z(l),f}const L=f.authority;let s=this.a[L];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const a=this.b[L],e=this.c[L];let h=`path=${encodeURIComponent(f.path)}`;return typeof e=="string"&&(h+=`&${t.$8f}=${encodeURIComponent(e)}`),i.URI.from({scheme:T.$p?this.d:U.vscodeRemoteResource,authority:`${s}:${a}`,path:this.f,query:h})}}t.$9f=new w,t.$0f="vs/../../extensions",t.$$f="vs/../../node_modules",t.$_f="vs/../../node_modules.asar",t.$ag="vs/../../node_modules.asar.unpacked",t.$bg="vscode-app";class y{static{this.a=t.$bg}asBrowserUri(f){const L=this.b(f,le);return this.uriToBrowserUri(L)}uriToBrowserUri(f){return f.scheme===U.vscodeRemote?t.$9f.rewrite(f):f.scheme===U.file&&(T.$n||T.$q&&T.$h.origin===`${U.vscodeFileResource}://${y.a}`)?f.with({scheme:U.vscodeFileResource,authority:f.authority||y.a,query:null,fragment:null}):f}asFileUri(f){const L=this.b(f,le);return this.uriToFileUri(L)}uriToFileUri(f){return f.scheme===U.vscodeFileResource?f.with({scheme:U.file,authority:f.authority!==y.a?f.authority:null,query:null,fragment:null}):f}b(f,L){return i.URI.isUri(f)?f:i.URI.parse(L.toUrl(f))}}t.$cg=new y;var c;(function(g){const f=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);g.CoopAndCoep=Object.freeze(f.get("3"));const L="vscode-coi";function s(e){let h;typeof e=="string"?h=new URL(e).searchParams:e instanceof URL?h=e.searchParams:i.URI.isUri(e)&&(h=new URL(e.toString(!0)).searchParams);const l=h?.get(L);if(l)return f.get(l)}g.getHeadersFromQuery=s;function a(e,h,l){if(!globalThis.crossOriginIsolated)return;const m=h&&l?"3":l?"2":"1";e instanceof URLSearchParams?e.set(L,m):e[L]=m}g.addSearchParam=a})(c||(t.COI=c={}))}),define($e[37],we([1,0,114,30,23,5,12,16]),function(le,t,v,T,i,U,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fg=t.DataUri=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=t.$vg=t.$ug=t.$tg=t.$sg=t.$rg=t.$qg=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=void 0;function c(a){return(0,y.$vc)(a,!0)}t.$jg=c;class g{constructor(e){this.a=e}compare(e,h,l=!1){return e===h?0:(0,w.$Ue)(this.getComparisonKey(e,l),this.getComparisonKey(h,l))}isEqual(e,h,l=!1){return e===h?!0:!e||!h?!1:this.getComparisonKey(e,l)===this.getComparisonKey(h,l)}getComparisonKey(e,h=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,h,l=!1){if(e.scheme===h.scheme){if(e.scheme===T.Schemas.file)return v.$Xf(c(e),c(h),this.a(e))&&e.query===h.query&&(l||e.fragment===h.fragment);if((0,t.$Ag)(e.authority,h.authority))return v.$Xf(e.path,h.path,this.a(e),"/")&&e.query===h.query&&(l||e.fragment===h.fragment)}return!1}joinPath(e,...h){return y.URI.joinPath(e,...h)}basenameOrAuthority(e){return(0,t.$sg)(e)||e.authority}basename(e){return i.$fc.basename(e.path)}extname(e){return i.$fc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let h;return e.scheme===T.Schemas.file?h=y.URI.file(i.$lc(c(e))).path:(h=i.$fc.dirname(e.path),e.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),h="/")),e.with({path:h})}normalizePath(e){if(!e.path.length)return e;let h;return e.scheme===T.Schemas.file?h=y.URI.file(i.$gc(c(e))).path:h=i.$fc.normalize(e.path),e.with({path:h})}relativePath(e,h){if(e.scheme!==h.scheme||!(0,t.$Ag)(e.authority,h.authority))return;if(e.scheme===T.Schemas.file){const n=i.$kc(c(e),c(h));return U.$j?v.$Rf(n):n}let l=e.path||"/";const m=h.path||"/";if(this.a(e)){let n=0;for(const r=Math.min(l.length,m.length);n<r&&!(l.charCodeAt(n)!==m.charCodeAt(n)&&l.charAt(n).toLowerCase()!==m.charAt(n).toLowerCase());n++);l=m.substr(0,n)+l.substr(n)}return i.$fc.relative(l,m)}resolvePath(e,h){if(e.scheme===T.Schemas.file){const l=y.URI.file(i.$jc(c(e),h));return e.with({authority:l.authority,path:l.path})}return h=v.$Sf(h),e.with({path:i.$fc.resolve(e.path,h)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,h){return e===h||e!==void 0&&h!==void 0&&(0,w.$2e)(e,h)}hasTrailingPathSeparator(e,h=i.sep){if(e.scheme===T.Schemas.file){const l=c(e);return l.length>v.$Tf(l).length&&l[l.length-1]===h}else{const l=e.path;return l.length>1&&l.charCodeAt(l.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,h=i.sep){return(0,t.$Bg)(e,h)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,h=i.sep){let l=!1;if(e.scheme===T.Schemas.file){const m=c(e);l=m!==void 0&&m.length===v.$Tf(m).length&&m[m.length-1]===h}else{h="/";const m=e.path;l=m.length===1&&m.charCodeAt(m.length-1)===47}return!l&&!(0,t.$Bg)(e,h)?e.with({path:e.path+"/"}):e}}t.$kg=g,t.$lg=new g(()=>!1),t.$mg=new g(a=>a.scheme===T.Schemas.file?!U.$l:!0),t.$ng=new g(a=>!0),t.$og=t.$lg.isEqual.bind(t.$lg),t.$pg=t.$lg.isEqualOrParent.bind(t.$lg),t.$qg=t.$lg.getComparisonKey.bind(t.$lg),t.$rg=t.$lg.basenameOrAuthority.bind(t.$lg),t.$sg=t.$lg.basename.bind(t.$lg),t.$tg=t.$lg.extname.bind(t.$lg),t.$ug=t.$lg.dirname.bind(t.$lg),t.$vg=t.$lg.joinPath.bind(t.$lg),t.$wg=t.$lg.normalizePath.bind(t.$lg),t.$xg=t.$lg.relativePath.bind(t.$lg),t.$yg=t.$lg.resolvePath.bind(t.$lg),t.$zg=t.$lg.isAbsolutePath.bind(t.$lg),t.$Ag=t.$lg.isEqualAuthority.bind(t.$lg),t.$Bg=t.$lg.hasTrailingPathSeparator.bind(t.$lg),t.$Cg=t.$lg.removeTrailingPathSeparator.bind(t.$lg),t.$Dg=t.$lg.addTrailingPathSeparator.bind(t.$lg);function f(a,e){const h=[];for(let l=0;l<a.length;l++){const m=e(a[l]);a.some((n,r)=>r===l?!1:(0,t.$pg)(m,e(n)))||h.push(a[l])}return h}t.$Eg=f;var L;(function(a){a.META_DATA_LABEL="label",a.META_DATA_DESCRIPTION="description",a.META_DATA_SIZE="size",a.META_DATA_MIME="mime";function e(h){const l=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(r=>{const[b,u]=r.split(":");b&&u&&l.set(b,u)});const n=h.path.substring(0,h.path.indexOf(";"));return n&&l.set(a.META_DATA_MIME,n),l}a.parseMetaData=e})(L||(t.DataUri=L={}));function s(a,e,h){if(e){let l=a.path;return l&&l[0]!==i.$fc.sep&&(l=i.$fc.sep+l),a.with({scheme:h,authority:e,path:l})}return a.with({scheme:h})}t.$Fg=s}),define($e[9],we([1,0,29,6,4,2,37,5,50]),function(le,t,v,T,i,U,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hh=t.$gh=t.$fh=t.$eh=t.Promises=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=t.$Sg=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=void 0;function g(_){return!!_&&typeof _.then=="function"}t.$Gg=g;function f(_){const p=new v.$Xd,A=_(p.token),E=new Promise((M,k)=>{const I=p.token.onCancellationRequested(()=>{I.dispose(),p.dispose(),k(new T.$4)});Promise.resolve(A).then(S=>{I.dispose(),p.dispose(),M(S)},S=>{I.dispose(),p.dispose(),k(S)})});return new class{cancel(){p.cancel()}then(M,k){return E.then(M,k)}catch(M){return this.then(void 0,M)}finally(M){return E.finally(M)}}}t.$Hg=f;function L(_,p,A){return new Promise((E,M)=>{const k=p.onCancellationRequested(()=>{k.dispose(),E(A)});_.then(E,M).finally(()=>k.dispose())})}t.$Ig=L;function s(_,p){return new Promise((A,E)=>{const M=p.onCancellationRequested(()=>{M.dispose(),E(new T.$4)});_.then(A,E).finally(()=>M.dispose())})}t.$Jg=s;async function a(_){let p=-1;const A=_.map((E,M)=>E.then(k=>(p=M,k)));try{return await Promise.race(A)}finally{_.forEach((E,M)=>{M!==p&&E.cancel()})}}t.$Kg=a;function e(_,p,A){let E;const M=setTimeout(()=>{E?.(void 0),A?.()},p);return Promise.race([_.finally(()=>clearTimeout(M)),new Promise(k=>E=k)])}t.$Lg=e;function h(_){return new Promise((p,A)=>{const E=_();g(E)?E.then(p,A):p(E)})}t.$Mg=h;class l{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(p){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=p,!this.b){const A=()=>{if(this.b=null,this.f)return;const E=this.queue(this.d);return this.d=null,E};this.b=new Promise(E=>{this.a.then(A,A).then(E)})}return new Promise((A,E)=>{this.b.then(A,E)})}return this.a=p(),new Promise((A,E)=>{this.a.then(M=>{this.a=null,A(M)},M=>{this.a=null,E(M)})})}dispose(){this.f=!0}}t.$Ng=l;class m{constructor(){this.a=Promise.resolve(null)}queue(p){return this.a=this.a.then(()=>p(),()=>p())}}t.$Og=m;class n{constructor(){this.a=new Map}queue(p,A){const M=(this.a.get(p)??Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.a.get(p)===M&&this.a.delete(p)});return this.a.set(p,M),M}}t.$Pg=n;const r=(_,p)=>{let A=!0;const E=setTimeout(()=>{A=!1,p()},_);return{isTriggered:()=>A,dispose:()=>{clearTimeout(E),A=!1}}},b=_=>{let p=!0;return queueMicrotask(()=>{p&&(p=!1,_())}),{isTriggered:()=>p,dispose:()=>{p=!1}}};class u{constructor(p){this.defaultDelay=p,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(p,A=this.defaultDelay){this.g=p,this.h(),this.b||(this.b=new Promise((M,k)=>{this.d=M,this.f=k}).then(()=>{if(this.b=null,this.d=null,this.g){const M=this.g;return this.g=null,M()}}));const E=()=>{this.a=null,this.d?.(null)};return this.a=A===c.$Kd?b(E):r(A,E),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$Qg=u;class o{constructor(p){this.a=new u(p),this.b=new l}trigger(p,A){return this.a.trigger(()=>this.b.queue(p),A)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$Rg=o;class F{constructor(){this.a=!1,this.b=new Promise((p,A)=>{this.d=p})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$Sg=F;class j extends F{constructor(p){super(),this.f=setTimeout(()=>this.open(),p)}open(){clearTimeout(this.f),super.open()}}t.$Tg=j;function R(_,p){return p?new Promise((A,E)=>{const M=setTimeout(()=>{k.dispose(),A()},_),k=p.onCancellationRequested(()=>{clearTimeout(M),k.dispose(),E(new T.$4)})}):f(A=>R(_,A))}t.$Ug=R;function d(_,p=0,A){const E=setTimeout(()=>{_(),A&&M.dispose()},p),M=(0,U.$Pc)(()=>{clearTimeout(E),A?.deleteAndLeak(M)});return A?.add(M),M}t.$Vg=d;function D(_,p,A){let E=0;const M=setInterval(()=>{E++,(E>=A||_())&&k.dispose()},p),k=(0,U.$Pc)(()=>{clearInterval(M)});return k}t.$Wg=D;function B(_){const p=[];let A=0;const E=_.length;function M(){return A<E?_[A++]():null}function k(I){I!=null&&p.push(I);const S=M();return S?S.then(k):Promise.resolve(p)}return Promise.resolve(null).then(k)}t.$Xg=B;function H(_,p=E=>!!E,A=null){let E=0;const M=_.length,k=()=>{if(E>=M)return Promise.resolve(A);const I=_[E++];return Promise.resolve(I()).then(N=>p(N)?Promise.resolve(N):k())};return k()}t.$Yg=H;function X(_,p=E=>!!E,A=null){if(_.length===0)return Promise.resolve(A);let E=_.length;const M=()=>{E=-1;for(const k of _)k.cancel?.()};return new Promise((k,I)=>{for(const S of _)S.then(N=>{--E>=0&&p(N)?(M(),k(N)):E===0&&k(A)}).catch(N=>{--E>=0&&(M(),I(N))})})}t.$Zg=X;class P{constructor(p){this.a=0,this.d=p,this.f=[],this.b=0,this.g=new i.$Nd}get onDrained(){return this.g.event}get size(){return this.a}queue(p){return this.a++,new Promise((A,E)=>{this.f.push({factory:p,c:A,e:E}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const p=this.f.shift();this.b++;const A=p.factory();A.then(p.c,p.e),A.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.$1g=P;class O extends P{constructor(){super(1)}}t.$2g=O;class Q{constructor(){this.a=new de,this.b=0}queue(p){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,p())):this.a.run(this.b++,p())}}t.$3g=Q;class te{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const p=new Z;return this.b.add(p),p.p}g(){for(const[,p]of this.a)if(p.size>0)return!1;return!0}queueFor(p,A=w.$lg){const E=A.getComparisonKey(p);let M=this.a.get(E);if(!M){M=new O;const k=this.f++,I=i.Event.once(M.onDrained)(()=>{M?.dispose(),this.a.delete(E),this.h(),this.d?.deleteAndDispose(k),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new U.$Zc),this.d.set(k,I),this.a.set(E,M)}return M}h(){this.g()&&this.j()}j(){for(const p of this.b)p.complete();this.b.clear()}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$4g=te;class re{constructor(p,A){this.a=-1,typeof p=="function"&&typeof A=="number"&&this.setIfNotSet(p,A)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(p,A){this.cancel(),this.a=setTimeout(()=>{this.a=-1,p()},A)}setIfNotSet(p,A){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,p()},A))}}t.$5g=re;class fe{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(p,A){this.cancel(),this.a=setInterval(()=>{p()},A)}}t.$6g=fe;class ie{constructor(p,A){this.b=-1,this.a=p,this.d=A,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(p=this.d){this.cancel(),this.b=setTimeout(this.f,p)}get delay(){return this.d}set delay(p){this.d=p}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$7g=ie;class oe{constructor(p,A){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.a=p,this.b=A,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(p=this.b){p%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${p}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(p/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$8g=oe;class be extends ie{constructor(p,A){super(p,A),this.j=[]}work(p){this.j.push(p),this.isScheduled()||this.schedule()}h(){const p=this.j;this.j=[],this.a?.(p)}dispose(){this.j=[],super.dispose()}}t.$9g=be;class Se extends U.$Rc{constructor(p,A){super(),this.g=p,this.h=A,this.a=[],this.b=this.B(new U.$Sc),this.f=!1}get pending(){return this.a.length}work(p){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+p.length>this.g.maxBufferedWork)return!1}else if(this.pending+p.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const A of p)this.a.push(A);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ie(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$0g=Se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.$$g=_=>{(0,y.$B)(()=>{if(p)return;const A=Date.now()+15;_(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let p=!1;return{dispose(){p||(p=!0)}}}:t.$$g=(_,p)=>{const A=requestIdleCallback(_,typeof p=="number"?{timeout:p}:void 0);let E=!1;return{dispose(){E||(E=!0,cancelIdleCallback(A))}}}}();class Te{constructor(p){this.d=!1,this.a=()=>{try{this.f=p()}catch(A){this.g=A}finally{this.d=!0}},this.b=(0,t.$$g)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.$_g=Te;async function Fe(_,p,A){let E;for(let M=0;M<A;M++)try{return await _()}catch(k){E=k,await R(p)}throw E}t.$ah=Fe;class de{isRunning(p){return typeof p=="number"?this.a?.taskId===p:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(p,A,E){return this.a={taskId:p,cancel:()=>E?.(),promise:A},A.then(()=>this.d(p),()=>this.d(p)),A}d(p){this.a&&p===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const p=this.b;this.b=void 0,p.run().then(p.promiseResolve,p.promiseReject)}}queue(p){if(this.b)this.b.run=p;else{let A,E;const M=new Promise((k,I)=>{A=k,E=I});this.b={run:p,promise:M,promiseResolve:A,promiseReject:E}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$bh=de;class ne{constructor(p,A=()=>Date.now()){this.d=p,this.f=A,this.a=0,this.b=0}increment(){const p=this.f();return p-this.a>this.d&&(this.a=p,this.b=0),this.b++,this.b}}t.$ch=ne;var ce;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(ce||(ce={}));class Z{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((p,A)=>{this.a=p,this.b=A})}complete(p){return new Promise(A=>{this.a(p),this.d={outcome:0,value:p},A()})}error(p){return new Promise(A=>{this.b(p),this.d={outcome:1,value:p},A()})}cancel(){return this.error(new T.$4)}}t.$dh=Z;var V;(function(_){async function p(E){let M;const k=await Promise.all(E.map(I=>I.then(S=>S,S=>{M||(M=S)})));if(typeof M<"u")throw M;return k}_.settled=p;function A(E){return new Promise(async(M,k)=>{try{await E(M,k)}catch(I){k(I)}})}_.withAsyncBody=A})(V||(t.Promises=V={}));var Y;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(Y||(Y={}));class C{static fromArray(p){return new C(A=>{A.emitMany(p)})}static fromPromise(p){return new C(async A=>{A.emitMany(await p)})}static fromPromises(p){return new C(async A=>{await Promise.all(p.map(async E=>A.emitOne(await E)))})}static merge(p){return new C(async A=>{await Promise.all(p.map(async E=>{for await(const M of E)A.emitOne(M)}))})}static{this.EMPTY=C.fromArray([])}constructor(p){this.a=0,this.b=[],this.d=null,this.f=new i.$Nd,queueMicrotask(async()=>{const A={emitOne:E=>this.g(E),emitMany:E=>this.h(E),reject:E=>this.k(E)};try{await Promise.resolve(p(A)),this.j()}catch(E){this.k(E)}finally{A.emitOne=void 0,A.emitMany=void 0,A.reject=void 0}})}[Symbol.asyncIterator](){let p=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(p<this.b.length)return{done:!1,value:this.b[p++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(p,A){return new C(async E=>{for await(const M of p)E.emitOne(A(M))})}map(p){return C.map(this,p)}static filter(p,A){return new C(async E=>{for await(const M of p)A(M)&&E.emitOne(M)})}filter(p){return C.filter(this,p)}static coalesce(p){return C.filter(p,A=>!!A)}coalesce(){return C.coalesce(this)}static async toPromise(p){const A=[];for await(const E of p)A.push(E);return A}toPromise(){return C.toPromise(this)}g(p){this.a===0&&(this.b.push(p),this.f.fire())}h(p){this.a===0&&(this.b=this.b.concat(p),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(p){this.a===0&&(this.a=2,this.d=p,this.f.fire())}}t.$eh=C;class q extends C{constructor(p,A){super(A),this.l=p}cancel(){this.l.cancel()}}t.$fh=q;function $(_){const p=new v.$Xd,A=_(p.token);return new q(p,async E=>{const M=p.token.onCancellationRequested(()=>{M.dispose(),p.dispose(),E.reject(new T.$4)});try{for await(const k of A){if(p.token.isCancellationRequested)return;E.emitOne(k)}M.dispose(),p.dispose()}catch(k){M.dispose(),p.dispose(),E.reject(k)}})}t.$gh=$;class W{constructor(){this.a=new Z,this.b=new C(E=>{if(p){E.reject(p);return}return A&&E.emitMany(A),this.d=M=>E.reject(M),this.f=M=>E.emitOne(M),this.a.p});let p,A;this.f=E=>{A||(A=[]),A.push(E)},this.d=E=>{p||(p=E)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(p){this.d(p),this.a.complete()}emitOne(p){this.f(p)}}t.$hh=W}),define($e[3],we([1,0,17,112,15,20,9,6,4,116,2,30,5,16,49,14]),function(le,t,v,T,i,U,w,y,c,g,f,L,s,a,e,h){"use strict";var l;Object.defineProperty(t,"__esModule",{value:!0}),t.$kQ=t.$jQ=t.h=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.DetectedFullscreenMode=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.$XP=t.$WP=t.$VP=t.$=t.Namespace=t.$TP=t.$SP=t.$RP=t.$QP=t.$PP=t.$OP=t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=t.$vP=t.$uP=t.$tP=t.$sP=t.$rP=t.$qP=t.$pP=t.$oP=t.$nP=t.$mP=t.$lP=t.$kP=t.$jP=t.$iP=t.$hP=t.$gP=t.$fP=t.$eP=t.$dP=t.$cP=t.$bP=t.$aP=t.$_O=t.$$O=t.$0O=t.$9O=t.$8O=t.$7O=t.$6O=t.$5O=t.$4O=t.$3O=t.$2O=t.$1O=t.$ZO=t.$YO=t.$XO=t.$WO=t.$VO=t.$UO=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.getWindowId=t.getWindowsCount=t.getWindows=t.registerWindow=void 0,l=function(){const K=new Map;typeof h.$pO.vscodeWindowId!="number"&&Object.defineProperty(h.$pO,"vscodeWindowId",{get:()=>1}),K.set(h.$pO.vscodeWindowId,{window:h.$pO,disposables:new f.$Qc});const G=new c.$Nd,ae=new c.$Nd,me=new c.$Nd;return{onDidRegisterWindow:G.event,onWillUnregisterWindow:me.event,onDidUnregisterWindow:ae.event,registerWindow(ye){if(K.has(ye.vscodeWindowId))return f.$Rc.None;const Ie=new f.$Qc,je={window:ye,disposables:Ie.add(new f.$Qc)};return K.set(ye.vscodeWindowId,je),Ie.add((0,f.$Pc)(()=>{K.delete(ye.vscodeWindowId),ae.fire(ye)})),Ie.add(r(ye,t.$KP.BEFORE_UNLOAD,()=>{me.fire(ye)})),G.fire(je),Ie},getWindows(){return K.values()},getWindowsCount(){return K.size},getWindowId(ye){return ye.vscodeWindowId}}}(),t.registerWindow=l.registerWindow,t.getWindows=l.getWindows,t.getWindowsCount=l.getWindowsCount,t.getWindowId=l.getWindowId,t.onDidRegisterWindow=l.onDidRegisterWindow,t.onWillUnregisterWindow=l.onWillUnregisterWindow,t.onDidUnregisterWindow=l.onDidUnregisterWindow;function m(K){for(;K.firstChild;)K.firstChild.remove()}t.$UO=m;class n{constructor(G,ae,me,ye){this.f=G,this.g=ae,this.d=me,this.j=ye||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function r(K,G,ae,me){return new n(K,G,ae,me)}t.$VO=r;function b(K){return function(G){return K(new U.$NO(G))}}function u(K){return function(G){return K(new i.$SO(G))}}const o=function(G,ae,me,ye){let Ie=me;return ae==="click"||ae==="mousedown"?Ie=b(me):(ae==="keydown"||ae==="keypress"||ae==="keyup")&&(Ie=u(me)),r(G,ae,Ie,ye)};t.$WO=o;const F=function(G,ae,me){const ye=b(ae);return R(G,ye,me)};t.$XO=F;const j=function(G,ae,me){const ye=b(ae);return D(G,ye,me)};t.$YO=j;function R(K,G,ae){return r(K,s.$r&&T.$KO.pointerEvents?t.$KP.POINTER_DOWN:t.$KP.MOUSE_DOWN,G,ae)}t.$ZO=R;function d(K,G,ae){return r(K,s.$r&&T.$KO.pointerEvents?t.$KP.POINTER_MOVE:t.$KP.MOUSE_MOVE,G,ae)}t.$1O=d;function D(K,G,ae){return r(K,s.$r&&T.$KO.pointerEvents?t.$KP.POINTER_UP:t.$KP.MOUSE_UP,G,ae)}t.$2O=D;class B{constructor(G,ae=0){this.d=G,this.priority=ae,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(G){(0,y.$Z)(G)}}static sort(G,ae){return ae.priority-G.priority}}(function(){const K=new Map,G=new Map,ae=new Map,me=new Map,ye=Ie=>{ae.set(Ie,!1);const je=K.get(Ie)??[];for(G.set(Ie,je),K.set(Ie,[]),me.set(Ie,!0);je.length>0;)je.sort(B.sort),je.shift().execute();me.set(Ie,!1)};t.$4O=(Ie,je,Ge=0)=>{const Xe=(0,t.getWindowId)(je),qe=new B(Ie,Ge);let st=K.get(Xe);return st||(st=[],K.set(Xe,st)),st.push(qe),ae.get(Xe)||(ae.set(Xe,!0),je.requestAnimationFrame(()=>ye(Xe))),qe},t.$3O=(Ie,je,Ge)=>{const Xe=(0,t.getWindowId)(je);if(me.get(Xe)){const qe=new B(Ie,Ge);let st=G.get(Xe);return st||(st=[],G.set(Xe,st)),st.push(qe),qe}else return(0,t.$4O)(Ie,je,Ge)}})();function H(K,G){return(0,t.$4O)(K,G,1e4)}t.$5O=H;function X(K,G){return(0,t.$4O)(K,G,-1e4)}t.$6O=X;const P=8,O=function(K,G){return G};class Q extends f.$Rc{constructor(G,ae,me,ye=O,Ie=P){super();let je=null,Ge=0;const Xe=this.B(new w.$5g),qe=()=>{Ge=new Date().getTime(),me(je),je=null};this.B(r(G,ae,st=>{je=ye(je,st);const Nt=new Date().getTime()-Ge;Nt>=Ie?(Xe.cancel(),qe()):Xe.setIfNotSet(qe,Ie-Nt)}))}}function te(K,G,ae,me,ye){return new Q(K,G,ae,me,ye)}t.$7O=te;function re(K){return K.ownerDocument.defaultView.getComputedStyle(K,null)}t.$8O=re;function fe(K){const G=K.ownerDocument,ae=G.defaultView?.window;if(K!==G.body)return new oe(K.clientWidth,K.clientHeight);if(s.$r&&ae?.visualViewport)return new oe(ae.visualViewport.width,ae.visualViewport.height);if(ae?.innerWidth&&ae.innerHeight)return new oe(ae.innerWidth,ae.innerHeight);if(G.body&&G.body.clientWidth&&G.body.clientHeight)return new oe(G.body.clientWidth,G.body.clientHeight);if(G.documentElement&&G.documentElement.clientWidth&&G.documentElement.clientHeight)return new oe(G.documentElement.clientWidth,G.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.$9O=fe;class ie{static d(G,ae){return parseFloat(ae)||0}static f(G,ae,me){const ye=re(G),Ie=ye?ye.getPropertyValue(ae):"0";return ie.d(G,Ie)}static getBorderLeftWidth(G){return ie.f(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return ie.f(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return ie.f(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return ie.f(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return ie.f(G,"padding-left","paddingLeft")}static getPaddingRight(G){return ie.f(G,"padding-right","paddingRight")}static getPaddingTop(G){return ie.f(G,"padding-top","paddingTop")}static getPaddingBottom(G){return ie.f(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return ie.f(G,"margin-left","marginLeft")}static getMarginTop(G){return ie.f(G,"margin-top","marginTop")}static getMarginRight(G){return ie.f(G,"margin-right","marginRight")}static getMarginBottom(G){return ie.f(G,"margin-bottom","marginBottom")}}class oe{static{this.None=new oe(0,0)}constructor(G,ae){this.width=G,this.height=ae}with(G=this.width,ae=this.height){return G!==this.width||ae!==this.height?new oe(G,ae):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof oe?G:new oe(G.width,G.height)}static equals(G,ae){return G===ae?!0:!G||!ae?!1:G.width===ae.width&&G.height===ae.height}}t.$0O=oe;function be(K){let G=K.offsetParent,ae=K.offsetTop,me=K.offsetLeft;for(;(K=K.parentNode)!==null&&K!==K.ownerDocument.body&&K!==K.ownerDocument.documentElement;){ae-=K.scrollTop;const ye=k(K)?null:re(K);ye&&(me-=ye.direction!=="rtl"?K.scrollLeft:-K.scrollLeft),K===G&&(me+=ie.getBorderLeftWidth(K),ae+=ie.getBorderTopWidth(K),ae+=K.offsetTop,me+=K.offsetLeft,G=K.offsetParent)}return{left:me,top:ae}}t.$$O=be;function Se(K,G,ae){typeof G=="number"&&(K.style.width=`${G}px`),typeof ae=="number"&&(K.style.height=`${ae}px`)}t.$_O=Se;function Te(K,G,ae,me,ye,Ie="absolute"){typeof G=="number"&&(K.style.top=`${G}px`),typeof ae=="number"&&(K.style.right=`${ae}px`),typeof me=="number"&&(K.style.bottom=`${me}px`),typeof ye=="number"&&(K.style.left=`${ye}px`),K.style.position=Ie}t.$aP=Te;function Fe(K){const G=K.getBoundingClientRect();return{left:G.left+(K.ownerDocument.defaultView?.scrollX??0),top:G.top+(K.ownerDocument.defaultView?.scrollY??0),width:G.width,height:G.height}}t.$bP=Fe;function de(K){let G=K,ae=1;do{const me=re(G).zoom;me!=null&&me!=="1"&&(ae*=me),G=G.parentElement}while(G!==null&&G!==G.ownerDocument.documentElement);return ae}t.$cP=de;function ne(K){const G=ie.getMarginLeft(K)+ie.getMarginRight(K);return K.offsetWidth+G}t.$dP=ne;function ce(K){const G=ie.getBorderLeftWidth(K)+ie.getBorderRightWidth(K),ae=ie.getPaddingLeft(K)+ie.getPaddingRight(K);return K.offsetWidth-G-ae}t.$eP=ce;function Z(K){const G=ie.getMarginLeft(K)+ie.getMarginRight(K);return K.scrollWidth+G}t.$fP=Z;function V(K){const G=ie.getBorderTopWidth(K)+ie.getBorderBottomWidth(K),ae=ie.getPaddingTop(K)+ie.getPaddingBottom(K);return K.offsetHeight-G-ae}t.$gP=V;function Y(K){const G=ie.getMarginTop(K)+ie.getMarginBottom(K);return K.offsetHeight+G}t.$hP=Y;function C(K,G){if(K===null)return 0;const ae=be(K),me=be(G);return ae.left-me.left}function q(K,G){const ae=G.map(ye=>Math.max(Z(ye),ne(ye))+C(ye,K)||0);return Math.max(...ae)}t.$iP=q;function $(K,G){return!!G?.contains(K)}t.$jP=$;const W="parentFlowToElementId";function _(K,G){K.dataset[W]=G.id}t.$kP=_;function p(K){const G=K.dataset[W];return typeof G=="string"?K.ownerDocument.getElementById(G):null}function A(K,G){let ae=K;for(;ae;){if(ae===G)return!0;if(ae instanceof HTMLElement){const me=p(ae);if(me){ae=me;continue}}ae=ae.parentNode}return!1}t.$lP=A;function E(K,G,ae){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K.classList.contains(G))return K;if(ae){if(typeof ae=="string"){if(K.classList.contains(ae))return null}else if(K===ae)return null}K=K.parentNode}return null}t.$mP=E;function M(K,G,ae){return!!E(K,G,ae)}t.$nP=M;function k(K){return K&&!!K.host&&!!K.mode}t.$oP=k;function I(K){return!!S(K)}t.$pP=I;function S(K){for(;K.parentNode;){if(K===K.ownerDocument?.body)return null;K=K.parentNode}return k(K)?K:null}t.$qP=S;function N(){let K=se().activeElement;for(;K?.shadowRoot;)K=K.shadowRoot.activeElement;return K}t.$rP=N;function z(K){return K.ownerDocument.activeElement===K}t.$sP=z;function x(K){return $(K.ownerDocument.activeElement,K)}t.$tP=x;function ee(K){return K.ownerDocument===se()}t.$uP=ee;function se(){return(0,t.getWindowsCount)()<=1?document:Array.from((0,t.getWindows)()).map(({window:G})=>G.document).find(G=>G.hasFocus())??document}t.$vP=se;function ge(){return se().defaultView?.window??h.$pO}t.$wP=ge;function pe(K){const G=K;if(G?.ownerDocument?.defaultView)return G.ownerDocument.defaultView.window;const ae=K;return ae?.view?ae.view.window:h.$pO}t.$xP=pe;function Pe(K){const G=pe(K);G!==ge()&&G.focus()}t.$yP=Pe;const Ae=new Map;function De(K){return Ae.has(K)}t.$zP=De;function Re(K=document.head,G,ae){const me=document.createElement("style");if(me.type="text/css",me.media="screen",G?.(me),K.appendChild(me),ae&&ae.add((0,f.$Pc)(()=>K.removeChild(me))),K===document.head){const ye=new Set;Ae.set(me,ye);for(const{window:Ie,disposables:je}of(0,t.getWindows)()){if(Ie===h.$pO)continue;const Ge=je.add(_e(me,ye,Ie));ae?.add(Ge)}}return me}t.$AP=Re;function Oe(K){const G=new f.$Qc;for(const[ae,me]of Ae)G.add(_e(ae,me,K));return G}t.$BP=Oe;function _e(K,G,ae){const me=new f.$Qc,ye=K.cloneNode(!0);ae.document.head.appendChild(ye),me.add((0,f.$Pc)(()=>ae.document.head.removeChild(ye)));for(const Ie of J(K))ye.sheet?.insertRule(Ie.cssText,ye.sheet?.cssRules.length);return me.add(t.$CP.observe(K,me,{childList:!0})(()=>{ye.textContent=K.textContent})),G.add(ye),me.add((0,f.$Pc)(()=>G.delete(ye))),me}t.$CP=new class{constructor(){this.mutationObservers=new Map}observe(K,G,ae){let me=this.mutationObservers.get(K);me||(me=new Map,this.mutationObservers.set(K,me));const ye=(0,e.$Ei)(ae);let Ie=me.get(ye);if(Ie)Ie.users+=1;else{const je=new c.$Nd,Ge=new MutationObserver(qe=>je.fire(qe));Ge.observe(K,ae);const Xe=Ie={users:1,observer:Ge,onDidMutate:je.event};G.add((0,f.$Pc)(()=>{Xe.users-=1,Xe.users===0&&(je.dispose(),Ge.disconnect(),me?.delete(ye),me?.size===0&&this.mutationObservers.delete(K))})),me.set(ye,Ie)}return Ie.onDidMutate}};function He(K=document.head){const G=document.createElement("meta");return K.appendChild(G),G}t.$DP=He;let Me=null;function Ke(){return Me||(Me=Re()),Me}function J(K){return K?.sheet?.rules?K.sheet.rules:K?.sheet?.cssRules?K.sheet.cssRules:[]}function he(K,G,ae=Ke()){if(!(!ae||!G)){ae.sheet?.insertRule(`${K} {${G}}`,0);for(const me of Ae.get(ae)??[])he(K,G,me)}}t.$EP=he;function ve(K,G=Ke()){if(!G)return;const ae=J(G),me=[];for(let ye=0;ye<ae.length;ye++){const Ie=ae[ye];Ee(Ie)&&Ie.selectorText.indexOf(K)!==-1&&me.push(ye)}for(let ye=me.length-1;ye>=0;ye--)G.sheet?.deleteRule(me[ye]);for(const ye of Ae.get(G)??[])ve(K,ye)}t.$FP=ve;function Ee(K){return typeof K.selectorText=="string"}function Ce(K){return K instanceof MouseEvent||K instanceof pe(K).MouseEvent}t.$GP=Ce;function Be(K){return K instanceof KeyboardEvent||K instanceof pe(K).KeyboardEvent}t.$HP=Be;function Ue(K){return K instanceof PointerEvent||K instanceof pe(K).PointerEvent}t.$IP=Ue;function Ze(K){return K instanceof DragEvent||K instanceof pe(K).DragEvent}t.$JP=Ze,t.$KP={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:v.$CO?"webkitAnimationStart":"animationstart",ANIMATION_END:v.$CO?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:v.$CO?"webkitAnimationIteration":"animationiteration"};function Je(K){const G=K;return!!(G&&typeof G.preventDefault=="function"&&typeof G.stopPropagation=="function")}t.$LP=Je,t.$MP={stop:(K,G)=>(K.preventDefault(),G&&K.stopPropagation(),K)};function Qe(K){const G=[];for(let ae=0;K&&K.nodeType===K.ELEMENT_NODE;ae++)G[ae]=K.scrollTop,K=K.parentNode;return G}t.$NP=Qe;function Ve(K,G){for(let ae=0;K&&K.nodeType===K.ELEMENT_NODE;ae++)K.scrollTop!==G[ae]&&(K.scrollTop=G[ae]),K=K.parentNode}t.$OP=Ve;class tt extends f.$Rc{static m(G){if(G instanceof HTMLElement){const ae=S(G),me=ae?ae.activeElement:G.ownerDocument.activeElement;return $(me,G)}else{const ae=G;return $(ae.document.activeElement,ae.document)}}constructor(G){super(),this.f=this.B(new c.$Nd),this.onDidFocus=this.f.event,this.g=this.B(new c.$Nd),this.onDidBlur=this.g.event;let ae=tt.m(G),me=!1;const ye=()=>{me=!1,ae||(ae=!0,this.f.fire())},Ie=()=>{ae&&(me=!0,(G instanceof HTMLElement?pe(G):G).setTimeout(()=>{me&&(me=!1,ae=!1,this.g.fire())},0))};this.j=()=>{tt.m(G)!==ae&&(ae?Ie():ye())},this.B(r(G,t.$KP.FOCUS,ye,!0)),this.B(r(G,t.$KP.BLUR,Ie,!0)),G instanceof HTMLElement&&(this.B(r(G,t.$KP.FOCUS_IN,()=>this.j())),this.B(r(G,t.$KP.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function nt(K){return new tt(K)}t.$PP=nt;function dt(K,G){return K.after(G),G}t.$QP=dt;function ct(K,...G){if(K.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.$RP=ct;function ft(K,G){return K.insertBefore(G,K.firstChild),G}t.$SP=ft;function St(K,...G){K.innerText="",ct(K,...G)}t.$TP=St;const Ct=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var gt;(function(K){K.HTML="http://www.w3.org/1999/xhtml",K.SVG="http://www.w3.org/2000/svg"})(gt||(t.Namespace=gt={}));function wt(K,G,ae,...me){const ye=Ct.exec(G);if(!ye)throw new Error("Bad use of emmet");const Ie=ye[1]||"div";let je;return K!==gt.HTML?je=document.createElementNS(K,Ie):je=document.createElement(Ie),ye[3]&&(je.id=ye[3]),ye[4]&&(je.className=ye[4].replace(/\./g," ").trim()),ae&&Object.entries(ae).forEach(([Ge,Xe])=>{typeof Xe>"u"||(/^on\w+$/.test(Ge)?je[Ge]=Xe:Ge==="selected"?Xe&&je.setAttribute(Ge,"true"):je.setAttribute(Ge,Xe))}),je.append(...me),je}function Pt(K,G,...ae){return wt(gt.HTML,K,G,...ae)}t.$=Pt,Pt.SVG=function(K,G,...ae){return wt(gt.SVG,K,G,...ae)};function Le(K,G){const ae=[];return K.forEach((me,ye)=>{ye>0&&(G instanceof Node?ae.push(G.cloneNode()):ae.push(document.createTextNode(G))),ae.push(me)}),ae}t.$VP=Le;function ue(K,...G){K?ke(...G):Ne(...G)}t.$WP=ue;function ke(...K){for(const G of K)G.style.display="",G.removeAttribute("aria-hidden")}t.$XP=ke;function Ne(...K){for(const G of K)G.style.display="none",G.setAttribute("aria-hidden","true")}t.$YP=Ne;function We(K,G){for(;K&&K.nodeType===K.ELEMENT_NODE;){if(K instanceof HTMLElement&&K.hasAttribute(G))return K;K=K.parentNode}return null}function et(K){!K||!K.hasAttribute("tabIndex")||(K.ownerDocument.activeElement===K&&We(K.parentElement,"tabIndex")?.focus(),K.removeAttribute("tabindex"))}t.$ZP=et;function rt(K){return G=>{G.preventDefault(),G.stopPropagation(),K(G)}}t.$1P=rt;function xe(K){return new Promise(G=>{if(K.document.readyState==="complete"||K.document&&K.document.body!==null)G(void 0);else{const me=()=>{K.window.removeEventListener("DOMContentLoaded",me,!1),G()};K.window.addEventListener("DOMContentLoaded",me,!1)}})}t.$2P=xe;function at(K,G){const ae=K.devicePixelRatio*G;return Math.max(1,Math.floor(ae))/K.devicePixelRatio}t.$3P=at;function vt(K){h.$window.open(K,"_blank","noopener")}t.$4P=vt;const Dt=780,Bt=640;function yi(K){const G=Math.floor(h.$window.screenLeft+h.$window.innerWidth/2-Dt/2),ae=Math.floor(h.$window.screenTop+h.$window.innerHeight/2-Bt/2);h.$window.open(K,"_blank",`width=${Dt},height=${Bt},top=${ae},left=${G}`)}t.$5P=yi;function Ei(K,G=!0){const ae=h.$window.open();return ae?(G&&(ae.opener=null),ae.location.href=K,!0):!1}t.$6P=Ei;function Ai(K,G){const ae=()=>{K(),me=(0,t.$4O)(ae,G)};let me=(0,t.$4O)(ae,G);return(0,f.$Pc)(()=>me.dispose())}t.$7P=Ai,L.$9f.setPreferredWebSchema(/^https:/.test(h.$pO.location.href)?"https":"http");function ki(K){return K?`url('${L.$cg.uriToBrowserUri(K).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$8P=ki;function Si(K){return`'${K.replace(/'/g,"%27")}'`}t.$9P=Si;function Xt(K,G){if(K!==void 0){const ae=K.match(/^\s*var\((.+)\)$/);if(ae){const me=ae[1].split(",",2);return me.length===2&&(G=Xt(me[1].trim(),G)),`var(${me[0]}, ${G})`}return K}return G}t.$0P=Xt;function Ci(K,G){let ae;if(a.URI.isUri(K))ae=K.toString(!0);else{const ye=new Blob([K]);ae=URL.createObjectURL(ye),setTimeout(()=>URL.revokeObjectURL(ae))}const me=document.createElement("a");document.body.appendChild(me),me.download=G,me.href=ae,me.click(),setTimeout(()=>document.body.removeChild(me))}t.$$P=Ci;function Pi(){return new Promise(K=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,c.Event.once(c.Event.fromDOMEventEmitter(G,"input"))(()=>{K(G.files??void 0)}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.$_P=Pi;var yt;(function(K){K[K.DOCUMENT=1]="DOCUMENT",K[K.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function Ni(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:h.$window.innerHeight===screen.height?{mode:yt.BROWSER,guess:!1}:(s.$k||s.$l)&&h.$window.outerHeight===screen.height&&h.$window.outerWidth===screen.width?{mode:yt.BROWSER,guess:!0}:null}t.$aQ=Ni;function Yt(K,G=!1){const ae=document.createElement("a");return g.addHook("afterSanitizeAttributes",me=>{for(const ye of["href","src"])if(me.hasAttribute(ye)){const Ie=me.getAttribute(ye);if(ye==="href"&&Ie.startsWith("#"))continue;if(ae.href=Ie,!K.includes(ae.protocol.replace(/:$/,""))){if(G&&ye==="src"&&ae.href.startsWith("data:"))continue;me.removeAttribute(ye)}}}),(0,f.$Pc)(()=>{g.removeHook("afterSanitizeAttributes")})}t.$bQ=Yt;const Fi=[L.Schemas.http,L.Schemas.https,L.Schemas.command];t.$cQ=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Oi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Ti(K,G){const ae=Yt(Fi);try{const me=g.sanitize(G,Oi);K.innerHTML=me}finally{ae.dispose()}}t.$dQ=Ti;function Li(K){const G=new Uint16Array(K.length);for(let ye=0;ye<G.length;ye++)G[ye]=K.charCodeAt(ye);let ae="";const me=new Uint8Array(G.buffer);for(let ye=0;ye<me.length;ye++)ae+=String.fromCharCode(me[ye]);return ae}function Ri(K){return btoa(Li(K))}t.$eQ=Ri;class bt extends c.$Nd{constructor(){super(),this.o=new f.$Qc,this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(c.Event.runAndSubscribe(t.onDidRegisterWindow,({window:G,disposables:ae})=>this.B(G,ae),{window:h.$pO,disposables:this.o}))}B(G,ae){ae.add(r(G,"keydown",me=>{if(me.defaultPrevented)return;const ye=new i.$SO(me);if(!(ye.keyCode===6&&me.repeat)){if(me.altKey&&!this.s.altKey)this.s.lastKeyPressed="alt";else if(me.ctrlKey&&!this.s.ctrlKey)this.s.lastKeyPressed="ctrl";else if(me.metaKey&&!this.s.metaKey)this.s.lastKeyPressed="meta";else if(me.shiftKey&&!this.s.shiftKey)this.s.lastKeyPressed="shift";else if(ye.keyCode!==6)this.s.lastKeyPressed=void 0;else return;this.s.altKey=me.altKey,this.s.ctrlKey=me.ctrlKey,this.s.metaKey=me.metaKey,this.s.shiftKey=me.shiftKey,this.s.lastKeyPressed&&(this.s.event=me,this.fire(this.s))}},!0)),ae.add(r(G,"keyup",me=>{me.defaultPrevented||(!me.altKey&&this.s.altKey?this.s.lastKeyReleased="alt":!me.ctrlKey&&this.s.ctrlKey?this.s.lastKeyReleased="ctrl":!me.metaKey&&this.s.metaKey?this.s.lastKeyReleased="meta":!me.shiftKey&&this.s.shiftKey?this.s.lastKeyReleased="shift":this.s.lastKeyReleased=void 0,this.s.lastKeyPressed!==this.s.lastKeyReleased&&(this.s.lastKeyPressed=void 0),this.s.altKey=me.altKey,this.s.ctrlKey=me.ctrlKey,this.s.metaKey=me.metaKey,this.s.shiftKey=me.shiftKey,this.s.lastKeyReleased&&(this.s.event=me,this.fire(this.s)))},!0)),ae.add(r(G.document.body,"mousedown",()=>{this.s.lastKeyPressed=void 0},!0)),ae.add(r(G.document.body,"mouseup",()=>{this.s.lastKeyPressed=void 0},!0)),ae.add(r(G.document.body,"mousemove",me=>{me.buttons&&(this.s.lastKeyPressed=void 0)},!0)),ae.add(r(G,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.s}get isModifierPressed(){return this.s.altKey||this.s.ctrlKey||this.s.metaKey||this.s.shiftKey}resetKeyStatus(){this.C(),this.fire(this.s)}C(){this.s={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return bt.A||(bt.A=new bt),bt.A}dispose(){super.dispose(),this.o.dispose()}}t.$fQ=bt;function Ii(K){const G=document.cookie.match("(^|[^;]+)\\s*"+K+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.$gQ=Ii;class Mi extends f.$Rc{constructor(G,ae){super(),this.j=G,this.m=ae,this.f=0,this.g=0,this.n()}n(){this.B(r(this.j,t.$KP.DRAG_ENTER,G=>{this.f++,this.g=G.timeStamp,this.m.onDragEnter(G)})),this.B(r(this.j,t.$KP.DRAG_OVER,G=>{G.preventDefault(),this.m.onDragOver?.(G,G.timeStamp-this.g)})),this.B(r(this.j,t.$KP.DRAG_LEAVE,G=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave(G))})),this.B(r(this.j,t.$KP.DRAG_END,G=>{this.f=0,this.g=0,this.m.onDragEnd(G)})),this.B(r(this.j,t.$KP.DROP,G=>{this.f=0,this.g=0,this.m.onDrop(G)}))}}t.$hQ=Mi;const Bi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function ji(K,...G){let ae,me;Array.isArray(G[0])?(ae={},me=G[0]):(ae=G[0]||{},me=G[1]);const ye=Bi.exec(K);if(!ye||!ye.groups)throw new Error("Bad use of h");const Ie=ye.groups.tag||"div",je=document.createElement(Ie);ye.groups.id&&(je.id=ye.groups.id);const Ge=[];if(ye.groups.class)for(const qe of ye.groups.class.split("."))qe!==""&&Ge.push(qe);if(ae.className!==void 0)for(const qe of ae.className.split("."))qe!==""&&Ge.push(qe);Ge.length>0&&(je.className=Ge.join(" "));const Xe={};if(ye.groups.name&&(Xe[ye.groups.name]=je),me)for(const qe of me)qe instanceof HTMLElement?je.appendChild(qe):typeof qe=="string"?je.append(qe):"root"in qe&&(Object.assign(Xe,qe),je.appendChild(qe.root));for(const[qe,st]of Object.entries(ae))if(qe!=="className")if(qe==="style")for(const[Nt,jt]of Object.entries(st))je.style.setProperty(Zt(Nt),typeof jt=="number"?jt+"px":""+jt);else qe==="tabIndex"?je.tabIndex=st:je.setAttribute(Zt(qe),st.toString());return Xe.root=je,Xe}t.h=ji;function Zt(K){return K.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function Jt(K,G){for(const{name:ae,value:me}of K.attributes)G.setAttribute(ae,me)}t.$jQ=Jt;function zi(K,G,ae){const me=K.getAttribute(ae);me?G.setAttribute(ae,me):G.removeAttribute(ae)}function Hi(K,G,ae){Jt(K,G);const me=new f.$Qc;return me.add(t.$CP.observe(K,me,{attributes:!0,attributeFilter:ae})(ye=>{for(const Ie of ye)Ie.type==="attributes"&&Ie.attributeName&&zi(K,G,Ie.attributeName)})),me}t.$kQ=Hi}),define($e[54],we([1,0,3,2,115]),function(le,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nQ=t.$mQ=t.$lQ=void 0;class U extends T.$Rc{constructor(c,g){super(),this.B((0,v.$VO)(c,"dragover",f=>{f.preventDefault(),this.a||(this.a=setTimeout(()=>{g(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this.B((0,v.$VO)(c,f,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$lQ=U,t.$mQ={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.$Qr.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function w(y,c,g,f,L){const s=document.createElement("div");if(s.className=g,s.textContent=c,L&&(s.style.color=L),f&&(s.style.background=f),y.dataTransfer){const a=(0,v.$xP)(y).document;a.body.appendChild(s),y.dataTransfer.setDragImage(s,-10,-10),setTimeout(()=>a.body.removeChild(s),0)}}t.$nQ=w}),define($e[55],we([1,0,3]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RQ=t.$QQ=t.$PQ=void 0;function T(s,a={}){const e=U(a);return e.textContent=s,e}t.$PQ=T;function i(s,a={}){const e=U(a);return c(e,g(s,!!a.renderCodeSegments),a.actionHandler,a.renderCodeSegments),e}t.$QQ=i;function U(s){const a=s.inline?"span":"div",e=document.createElement(a);return s.className&&(e.className=s.className),e}t.$RQ=U;class w{constructor(a){this.b=a,this.c=0}eos(){return this.c>=this.b.length}next(){const a=this.peek();return this.advance(),a}peek(){return this.b[this.c]}advance(){this.c++}}var y;(function(s){s[s.Invalid=0]="Invalid",s[s.Root=1]="Root",s[s.Text=2]="Text",s[s.Bold=3]="Bold",s[s.Italics=4]="Italics",s[s.Action=5]="Action",s[s.ActionClose=6]="ActionClose",s[s.Code=7]="Code",s[s.NewLine=8]="NewLine"})(y||(y={}));function c(s,a,e,h){let l;if(a.type===2)l=document.createTextNode(a.content||"");else if(a.type===3)l=document.createElement("b");else if(a.type===4)l=document.createElement("i");else if(a.type===7&&h)l=document.createElement("code");else if(a.type===5&&e){const m=document.createElement("a");e.disposables.add(v.$WO(m,"click",n=>{e.callback(String(a.index),n)})),l=m}else a.type===8?l=document.createElement("br"):a.type===1&&(l=s);l&&s!==l&&s.appendChild(l),l&&Array.isArray(a.children)&&a.children.forEach(m=>{c(l,m,e,h)})}function g(s,a){const e={type:1,children:[]};let h=0,l=e;const m=[],n=new w(s);for(;!n.eos();){let r=n.next();const b=r==="\\"&&L(n.peek(),a)!==0;if(b&&(r=n.next()),!b&&f(r,a)&&r===n.peek()){n.advance(),l.type===2&&(l=m.pop());const u=L(r,a);if(l.type===u||l.type===5&&u===6)l=m.pop();else{const o={type:u,children:[]};u===5&&(o.index=h,h++),l.children.push(o),m.push(l),l=o}}else if(r===`
`)l.type===2&&(l=m.pop()),l.children.push({type:8});else if(l.type!==2){const u={type:2,content:r};l.children.push(u),m.push(l),l=u}else l.content+=r}return l.type===2&&(l=m.pop()),m.length,e}function f(s,a){return L(s,a)!==0}function L(s,a){switch(s){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return a?7:0;default:return 0}}}),define($e[56],we([1,0,3,2]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rQ=void 0;class i{constructor(){this.a=new T.$Qc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(w,y){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const c=this.c;this.c=null,w&&c&&c(y)}isMonitoring(){return!!this.b}startMonitoring(w,y,c,g,f){this.isMonitoring()&&this.stopMonitoring(!1),this.b=g,this.c=f;let L=w;try{w.setPointerCapture(y),this.a.add((0,T.$Pc)(()=>{try{w.releasePointerCapture(y)}catch{}}))}catch{L=v.$xP(w)}this.a.add(v.$VO(L,v.$KP.POINTER_MOVE,s=>{if(s.buttons!==c){this.stopMonitoring(!0);return}s.preventDefault(),this.b(s)})),this.a.add(v.$VO(L,v.$KP.POINTER_UP,s=>this.stopMonitoring(!0)))}}t.$rQ=i});var Ye=this&&this.__decorate||function(le,t,v,T){var i=arguments.length,U=i<3?t:T===null?T=Object.getOwnPropertyDescriptor(t,v):T,w;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")U=Reflect.decorate(le,t,v,T);else for(var y=le.length-1;y>=0;y--)(w=le[y])&&(U=(i<3?w(U):i>3?w(t,v,U):w(t,v))||U);return i>3&&U&&Object.defineProperty(t,v,U),U};define($e[24],we([1,0,3,14,11,26,4,2,45]),function(le,t,v,T,i,U,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oQ=t.EventType=void 0;var g;(function(L){L.Tap="-monaco-gesturetap",L.Change="-monaco-gesturechange",L.Start="-monaco-gesturestart",L.End="-monaco-gesturesend",L.Contextmenu="-monaco-gesturecontextmenu"})(g||(t.EventType=g={}));class f extends y.$Rc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new c.$1c,this.h=new c.$1c,this.m={},this.j=null,this.n=0,this.B(w.Event.runAndSubscribe(v.onDidRegisterWindow,({window:s,disposables:a})=>{a.add(v.$VO(s.document,"touchstart",e=>this.s(e),{passive:!1})),a.add(v.$VO(s.document,"touchend",e=>this.u(s,e))),a.add(v.$VO(s.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:T.$pO,disposables:this.q}))}static addTarget(s){if(!f.isTouchDevice())return y.$Rc.None;f.b||(f.b=(0,y.$Kc)(new f));const a=f.b.g.push(s);return(0,y.$Pc)(a)}static ignoreTarget(s){if(!f.isTouchDevice())return y.$Rc.None;f.b||(f.b=(0,y.$Kc)(new f));const a=f.b.h.push(s);return(0,y.$Pc)(a)}static isTouchDevice(){return"ontouchstart"in T.$pO||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(s){const a=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,h=s.targetTouches.length;e<h;e++){const l=s.targetTouches.item(e);this.m[l.identifier]={id:l.identifier,initialTarget:l.target,initialTimeStamp:a,initialPageX:l.pageX,initialPageY:l.pageY,rollingTimestamps:[a],rollingPageX:[l.pageX],rollingPageY:[l.pageY]};const m=this.w(g.Start,l.target);m.pageX=l.pageX,m.pageY=l.pageY,this.z(m)}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}u(s,a){const e=Date.now(),h=Object.keys(this.m).length;for(let l=0,m=a.changedTouches.length;l<m;l++){const n=a.changedTouches.item(l);if(!this.m.hasOwnProperty(String(n.identifier))){console.warn("move of an UNKNOWN touch",n);continue}const r=this.m[n.identifier],b=Date.now()-r.initialTimeStamp;if(b<f.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(g.Tap,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(b>=f.c&&Math.abs(r.initialPageX-i.$rb(r.rollingPageX))<30&&Math.abs(r.initialPageY-i.$rb(r.rollingPageY))<30){const u=this.w(g.Contextmenu,r.initialTarget);u.pageX=i.$rb(r.rollingPageX),u.pageY=i.$rb(r.rollingPageY),this.z(u)}else if(h===1){const u=i.$rb(r.rollingPageX),o=i.$rb(r.rollingPageY),F=i.$rb(r.rollingTimestamps)-r.rollingTimestamps[0],j=u-r.rollingPageX[0],R=o-r.rollingPageY[0],d=[...this.g].filter(D=>r.initialTarget instanceof Node&&D.contains(r.initialTarget));this.C(s,d,e,Math.abs(j)/F,j>0?1:-1,u,Math.abs(R)/F,R>0?1:-1,o)}this.z(this.w(g.End,r.initialTarget)),delete this.m[n.identifier]}this.f&&(a.preventDefault(),a.stopPropagation(),this.f=!1)}w(s,a){const e=document.createEvent("CustomEvent");return e.initEvent(s,!1,!0),e.initialTarget=a,e.tapCount=0,e}z(s){if(s.type===g.Tap){const a=new Date().getTime();let e=0;a-this.n>f.r?e=1:e=2,this.n=a,s.tapCount=e}else(s.type===g.Change||s.type===g.Contextmenu)&&(this.n=0);if(s.initialTarget instanceof Node){for(const a of this.h)if(a.contains(s.initialTarget))return;for(const a of this.g)a.contains(s.initialTarget)&&(a.dispatchEvent(s),this.f=!0)}}C(s,a,e,h,l,m,n,r,b){this.j=v.$4O(()=>{const u=Date.now(),o=u-e;let F=0,j=0,R=!0;h+=f.a*o,n+=f.a*o,h>0&&(R=!1,F=l*h*o),n>0&&(R=!1,j=r*n*o);const d=this.w(g.Change);d.translationX=F,d.translationY=j,a.forEach(D=>D.dispatchEvent(d)),R||this.C(s,a,u,h,l,m+F,n,r,b+j)},s)}D(s){const a=Date.now();for(let e=0,h=s.changedTouches.length;e<h;e++){const l=s.changedTouches.item(e);if(!this.m.hasOwnProperty(String(l.identifier))){console.warn("end of an UNKNOWN touch",l);continue}const m=this.m[l.identifier],n=this.w(g.Change,m.initialTarget);n.translationX=l.pageX-i.$rb(m.rollingPageX),n.translationY=l.pageY-i.$rb(m.rollingPageY),n.pageX=l.pageX,n.pageY=l.pageY,this.z(n),m.rollingPageX.length>3&&(m.rollingPageX.shift(),m.rollingPageY.shift(),m.rollingTimestamps.shift()),m.rollingPageX.push(l.pageX),m.rollingPageY.push(l.pageY),m.rollingTimestamps.push(a)}this.f&&(s.preventDefault(),s.stopPropagation(),this.f=!1)}}t.$oQ=f,Ye([U.$ih],f,"isTouchDevice",null)}),define($e[57],we([1,0,3,90]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$VQ=t.$UQ=t.$TQ=void 0;const T=2e4;let i,U,w,y,c;function g(a){i=document.createElement("div"),i.className="monaco-aria-container";const e=()=>{const l=document.createElement("div");return l.className="monaco-alert",l.setAttribute("role","alert"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};U=e(),w=e();const h=()=>{const l=document.createElement("div");return l.className="monaco-status",l.setAttribute("aria-live","polite"),l.setAttribute("aria-atomic","true"),i.appendChild(l),l};y=h(),c=h(),a.appendChild(i)}t.$TQ=g;function f(a){i&&(U.textContent!==a?(v.$UO(w),s(U,a)):(v.$UO(U),s(w,a)))}t.$UQ=f;function L(a){i&&(y.textContent!==a?(v.$UO(c),s(y,a)):(v.$UO(y),s(c,a)))}t.$VQ=L;function s(a,e){v.$UO(a),e.length>T&&(e=e.substr(0,T)),a.textContent=e,a.style.visibility="hidden",a.style.visibility="visible"}}),define($e[117],we([1,0,3,19]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iR=t.$hR=void 0;const i=new RegExp(`(\\\\)?\\$\\((${T.ThemeIcon.iconNameExpression}(?:${T.ThemeIcon.iconModifierExpression})?)\\)`,"g");function U(y){const c=new Array;let g,f=0,L=0;for(;(g=i.exec(y))!==null;){L=g.index||0,f<L&&c.push(y.substring(f,L)),f=(g.index||0)+g[0].length;const[,s,a]=g;c.push(s?`$(${a})`:w({id:a}))}return f<y.length&&c.push(y.substring(f)),c}t.$hR=U;function w(y){const c=v.$("span");return c.classList.add(...T.ThemeIcon.asClassNameArray(y)),c}t.$iR=w}),define($e[118],we([1,0,3]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5Q=void 0;function T(U){try{U.parentElement?.removeChild(U)}catch{}}class i{constructor(w){this.d=w,this.a=new Map,this.b=new Set,this.c=!1}alloc(w){let y=this.h(w).pop(),c=!1;if(y)c=this.b.has(y.domNode),c&&this.b.delete(y.domNode);else{const g=(0,v.$)(".monaco-list-row"),L=this.i(w).renderTemplate(g);y={domNode:g,templateId:w,templateData:L}}return{row:y,isReusingConnectedDomNode:c}}release(w){w&&this.f(w)}transact(w){if(this.c)throw new Error("Already in transaction");this.c=!0;try{w()}finally{for(const y of this.b)this.g(y);this.b.clear(),this.c=!1}}f(w){const{domNode:y,templateId:c}=w;y&&(this.c?this.b.add(y):this.g(y)),this.h(c).push(w)}g(w){w.classList.remove("scrolling"),T(w)}h(w){let y=this.a.get(w);return y||(y=[],this.a.set(w,y)),y}dispose(){this.a.forEach((w,y)=>{for(const c of w)this.i(y).disposeTemplate(c.templateData),c.templateData=null}),this.a.clear(),this.b.clear()}i(w){const y=this.d.get(w);if(!y)throw new Error(`No renderer found for ${w}`);return y}}t.$5Q=i}),define($e[119],we([1,0,9,2]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wQ=void 0;class i extends T.$Rc{constructor(w,y,c){super(),this.a=w,this.b=y,this.c=c,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new v.$5g)}setVisibility(w){this.a!==w&&(this.a=w,this.s())}setShouldBeVisible(w){this.g=w,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const w=this.r();this.h!==w&&(this.h=w,this.ensureVisibility())}setIsNeeded(w){this.j!==w&&(this.j=w,this.ensureVisibility())}setDomNode(w){this.f=w,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(w){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(w?" fade":"")))}}t.$wQ=i}),define($e[120],we([1,0,3,24,11,4,2,5]),function(le,t,v,T,i,U,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pR=void 0;class c extends w.$Rc{constructor(f,L,s,a){super(),this.f=0,this.b=a||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new U.$Nd),this.h=s,this.j(),this.setOptions(f,L)}j(){this.B(T.$oQ.addTarget(this.a)),[T.EventType.Tap].forEach(f=>{this.B(v.$VO(this.a,f,L=>{this.a.focus()}))}),this.B(v.$WO(this.a,"click",f=>{v.$MP.stop(f,!0)})),this.B(v.$WO(this.a,"change",f=>{this.a.title=f.target.value,this.g.fire({index:f.target.selectedIndex,selected:f.target.value})})),this.B(v.$WO(this.a,"keydown",f=>{let L=!1;y.$k?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(L=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(L=!0),L&&f.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(f,L){(!this.c||!i.$tb(this.c,f))&&(this.c=f,this.a.options.length=0,this.c.forEach((s,a)=>{this.a.add(this.m(s.text,a,s.isDisabled))})),L!==void 0&&this.select(L)}select(f){this.c.length===0?this.f=0:f>=0&&f<this.c.length?this.f=f:f>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(f){this.b.ariaLabel=f,this.a.setAttribute("aria-label",f)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(f){this.a.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(f){this.h=f,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(f,L,s){const a=document.createElement("option");return a.value=f,a.text=f,a.disabled=!!s,a}}t.$pR=c}),define($e[58],we([1,0,25,11,9,50,86,4,27]),function(le,t,v,T,i,U,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WS=t.$VS=t.$US=void 0;function g(a){return typeof a=="object"&&"visibility"in a&&"data"in a}t.$US=g;function f(a){switch(a){case!0:return 1;case!1:return 0;default:return a}}t.$VS=f;function L(a){return typeof a.collapsible=="boolean"}class s{constructor(e,h,l,m={}){this.o=e,this.p=h,this.rootRef=[],this.d=new y.$Vd,this.f=new y.$Nd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new y.$Nd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new y.$Nd,this.onDidSplice=this.l.event,this.m=new i.$Qg(U.$Kd),this.h=typeof m.collapseByDefault>"u"?!1:m.collapseByDefault,this.j=m.filter,this.k=typeof m.autoExpandSingleChildren>"u"?!1:m.autoExpandSingleChildren,this.c={parent:void 0,element:l,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,h,l=c.Iterable.empty(),m={}){if(e.length===0)throw new v.$SS(this.o,"Invalid tree location");m.diffIdentityProvider?this.q(m.diffIdentityProvider,e,h,l,m):this.s(e,h,l,m)}q(e,h,l,m=c.Iterable.empty(),n,r=n.diffDepth??0){const{parentNode:b}=this.G(h);if(!b.lastDiffIds)return this.s(h,l,m,n);const u=[...m],o=h[h.length-1],F=new w.$As({getElements:()=>b.lastDiffIds},{getElements:()=>[...b.children.slice(0,o),...u,...b.children.slice(o+l)].map(B=>e.getId(B.element).toString())}).ComputeDiff(!1);if(F.quitEarly)return b.lastDiffIds=void 0,this.s(h,l,u,n);const j=h.slice(0,-1),R=(B,H,X)=>{if(r>0)for(let P=0;P<X;P++)B--,H--,this.q(e,[...j,B,0],Number.MAX_SAFE_INTEGER,u[H].children,n,r-1)};let d=Math.min(b.children.length,o+l),D=u.length;for(const B of F.changes.sort((H,X)=>X.originalStart-H.originalStart))R(d,D,d-(B.originalStart+B.originalLength)),d=B.originalStart,D=B.modifiedStart-o,this.s([...j,d],B.originalLength,c.Iterable.slice(u,D,D+B.modifiedLength),n);R(d,D,d)}s(e,h,l=c.Iterable.empty(),{onDidCreateNode:m,onDidDeleteNode:n,diffIdentityProvider:r}){const{parentNode:b,listIndex:u,revealed:o,visible:F}=this.G(e),j=[],R=c.Iterable.map(l,fe=>this.w(fe,b,b.visible?1:0,o,j,m)),d=e[e.length-1],D=b.children.length>0;let B=0;for(let fe=d;fe>=0&&fe<b.children.length;fe--){const ie=b.children[fe];if(ie.visible){B=ie.visibleChildIndex;break}}const H=[];let X=0,P=0;for(const fe of R)H.push(fe),P+=fe.renderNodeCount,fe.visible&&(fe.visibleChildIndex=B+X++);const O=(0,T.$5b)(b.children,d,h,H);r?b.lastDiffIds?(0,T.$5b)(b.lastDiffIds,d,h,H.map(fe=>r.getId(fe.element).toString())):b.lastDiffIds=b.children.map(fe=>r.getId(fe.element).toString()):b.lastDiffIds=void 0;let Q=0;for(const fe of O)fe.visible&&Q++;if(Q!==0)for(let fe=d+H.length;fe<b.children.length;fe++){const ie=b.children[fe];ie.visible&&(ie.visibleChildIndex-=Q)}if(b.visibleChildrenCount+=X-Q,o&&F){const fe=O.reduce((ie,oe)=>ie+(oe.visible?oe.renderNodeCount:0),0);this.B(b,P-fe),this.p.splice(u,fe,j)}if(O.length>0&&n){const fe=ie=>{n(ie),ie.children.forEach(fe)};O.forEach(fe)}this.l.fire({insertedNodes:H,deletedNodes:O});const te=b.children.length>0;D!==te&&this.setCollapsible(e.slice(0,-1),te);let re=b;for(;re;){if(re.visibility===2){this.m.trigger(()=>this.refilter());break}re=re.parent}}rerender(e){if(e.length===0)throw new v.$SS(this.o,"Invalid tree location");const{node:h,listIndex:l,revealed:m}=this.F(e);h.visible&&m&&this.p.splice(l,1,[h])}updateElementHeight(e,h){if(e.length===0)throw new v.$SS(this.o,"Invalid tree location");const{listIndex:l}=this.F(e);this.p.updateElementHeight(l,h)}has(e){return this.D(e)}getListIndex(e){const{listIndex:h,visible:l,revealed:m}=this.F(e);return l&&m?h:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,h){const l=this.E(e);typeof h>"u"&&(h=!l.collapsible);const m={collapsible:h};return this.d.bufferEvents(()=>this.t(e,m))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,h,l){const m=this.E(e);typeof h>"u"&&(h=!m.collapsed);const n={collapsed:h,recursive:l||!1};return this.d.bufferEvents(()=>this.t(e,n))}t(e,h){const{node:l,listIndex:m,revealed:n}=this.F(e),r=this.u(l,m,n,h);if(l!==this.c&&this.k&&r&&!L(h)&&l.collapsible&&!l.collapsed&&!h.recursive){let b=-1;for(let u=0;u<l.children.length;u++)if(l.children[u].visible)if(b>-1){b=-1;break}else b=u;b>-1&&this.t([...e,b],h)}return r}u(e,h,l,m){const n=this.v(e,m,!1);if(!l||!e.visible||!n)return n;const r=e.renderNodeCount,b=this.x(e),u=r-(h===-1?0:1);return this.p.splice(h+1,u,b.slice(1)),n}v(e,h,l){let m;if(e===this.c?m=!1:(L(h)?(m=e.collapsible!==h.collapsible,e.collapsible=h.collapsible):e.collapsible?(m=e.collapsed!==h.collapsed,e.collapsed=h.collapsed):m=!1,m&&this.f.fire({node:e,deep:l})),!L(h)&&h.recursive)for(const n of e.children)m=this.v(n,h,!0)||m;return m}expandTo(e){this.d.bufferEvents(()=>{let h=this.E(e);for(;h.parent;)h=h.parent,e=e.slice(0,e.length-1),h.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,h=this.z(this.c);this.p.splice(0,e,h),this.m.cancel()}w(e,h,l,m,n,r){const b={parent:h,element:e.element,children:[],depth:h.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},u=this.C(b,l);b.visibility=u,m&&n.push(b);const o=e.children||c.Iterable.empty(),F=m&&u!==0&&!b.collapsed;let j=0,R=1;for(const d of o){const D=this.w(d,b,u,F,n,r);b.children.push(D),R+=D.renderNodeCount,D.visible&&(D.visibleChildIndex=j++)}return b.collapsible=b.collapsible||b.children.length>0,b.visibleChildrenCount=j,b.visible=u===2?j>0:u===1,b.visible?b.collapsed||(b.renderNodeCount=R):(b.renderNodeCount=0,m&&n.pop()),r?.(b),b}x(e){const h=e.renderNodeCount,l=[];return this.y(e,l),this.B(e.parent,l.length-h),l}y(e,h){if(e.visible===!1)return 0;if(h.push(e),e.renderNodeCount=1,!e.collapsed)for(const l of e.children)e.renderNodeCount+=this.y(l,h);return this.g.fire(e),e.renderNodeCount}z(e){const h=e.renderNodeCount,l=[];return this.A(e,e.visible?1:0,l),this.B(e.parent,l.length-h),l}A(e,h,l,m=!0){let n;if(e!==this.c){if(n=this.C(e,h),n===0)return e.visible=!1,e.renderNodeCount=0,!1;m&&l.push(e)}const r=l.length;e.renderNodeCount=e===this.c?0:1;let b=!1;if(!e.collapsed||n!==0){let u=0;for(const o of e.children)b=this.A(o,n,l,m&&!e.collapsed)||b,o.visible&&(o.visibleChildIndex=u++);e.visibleChildrenCount=u}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=n===2?b:n===1,e.visibility=n),e.visible?e.collapsed||(e.renderNodeCount+=l.length-r):(e.renderNodeCount=0,m&&l.pop()),this.g.fire(e),e.visible}B(e,h){if(h!==0)for(;e;)e.renderNodeCount+=h,this.g.fire(e),e=e.parent}C(e,h){const l=this.j?this.j.filter(e.element,h):1;return typeof l=="boolean"?(e.filterData=void 0,l?1:0):g(l)?(e.filterData=l.data,f(l.visibility)):(e.filterData=void 0,f(l))}D(e,h=this.c){if(!e||e.length===0)return!0;const[l,...m]=e;return l<0||l>h.children.length?!1:this.D(m,h.children[l])}E(e,h=this.c){if(!e||e.length===0)return h;const[l,...m]=e;if(l<0||l>h.children.length)throw new v.$SS(this.o,"Invalid tree location");return this.E(m,h.children[l])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:h,listIndex:l,revealed:m,visible:n}=this.G(e),r=e[e.length-1];if(r<0||r>h.children.length)throw new v.$SS(this.o,"Invalid tree location");const b=h.children[r];return{node:b,listIndex:l,revealed:m,visible:n&&b.visible}}G(e,h=this.c,l=0,m=!0,n=!0){const[r,...b]=e;if(r<0||r>h.children.length)throw new v.$SS(this.o,"Invalid tree location");for(let u=0;u<r;u++)l+=h.children[u].renderNodeCount;return m=m&&!h.collapsed,n=n&&h.visible,b.length===0?{parentNode:h,listIndex:l,revealed:m,visible:n}:this.G(b,h.children[r],l+1,m,n)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const h=[];let l=e;for(;l.parent;)h.push(l.parent.children.indexOf(l)),l=l.parent;return h.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,T.$sb)(e)[0]}getFirstElementChild(e){const h=this.E(e);if(h.children.length!==0)return h.children[0].element}getLastElementAncestor(e=[]){const h=this.E(e);if(h.children.length!==0)return this.H(h)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$WS=s}),define($e[121],we([1,0,58,25,27]),function(le,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3S=void 0;class U{get size(){return this.d.size}constructor(y,c,g={}){this.k=y,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new v.$WS(y,c,null,g),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,g.sorter&&(this.j={compare(f,L){return g.sorter.compare(f.element,L.element)}}),this.h=g.identityProvider}setChildren(y,c=i.Iterable.empty(),g={}){const f=this.o(y);this.l(f,this.m(c),g)}l(y,c=i.Iterable.empty(),g){const f=new Set,L=new Set,s=e=>{if(e.element===null)return;const h=e;if(f.add(h.element),this.d.set(h.element,h),this.h){const l=this.h.getId(h.element).toString();L.add(l),this.f.set(l,h)}g.onDidCreateNode?.(h)},a=e=>{if(e.element===null)return;const h=e;if(f.has(h.element)||this.d.delete(h.element),this.h){const l=this.h.getId(h.element).toString();L.has(l)||this.f.delete(l)}g.onDidDeleteNode?.(h)};this.c.splice([...y,0],Number.MAX_VALUE,c,{...g,onDidCreateNode:s,onDidDeleteNode:a})}m(y=i.Iterable.empty()){return this.j&&(y=[...y].sort(this.j.compare.bind(this.j))),i.Iterable.map(y,c=>{let g=this.d.get(c.element);if(!g&&this.h){const s=this.h.getId(c.element).toString();g=this.f.get(s)}if(!g){let s;return typeof c.collapsed>"u"?s=void 0:c.collapsed===T.ObjectTreeElementCollapseState.Collapsed||c.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed?s=!0:c.collapsed===T.ObjectTreeElementCollapseState.Expanded||c.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?s=!1:s=!!c.collapsed,{...c,children:this.m(c.children),collapsed:s}}const f=typeof c.collapsible=="boolean"?c.collapsible:g.collapsible;let L;return typeof c.collapsed>"u"||c.collapsed===T.ObjectTreeElementCollapseState.PreserveOrCollapsed||c.collapsed===T.ObjectTreeElementCollapseState.PreserveOrExpanded?L=g.collapsed:c.collapsed===T.ObjectTreeElementCollapseState.Collapsed?L=!0:c.collapsed===T.ObjectTreeElementCollapseState.Expanded?L=!1:L=!!c.collapsed,{...c,collapsible:f,collapsed:L,children:this.m(c.children)}})}rerender(y){const c=this.o(y);this.c.rerender(c)}updateElementHeight(y,c){const g=this.o(y);this.c.updateElementHeight(g,c)}resort(y=null,c=!0){if(!this.j)return;const g=this.o(y),f=this.c.getNode(g);this.l(g,this.n(f,c),{})}n(y,c,g=!0){let f=[...y.children];return(c||g)&&(f=f.sort(this.j.compare.bind(this.j))),i.Iterable.map(f,L=>({element:L.element,collapsible:L.collapsible,collapsed:L.collapsed,children:this.n(L,c,!1)}))}getFirstElementChild(y=null){const c=this.o(y);return this.c.getFirstElementChild(c)}getLastElementAncestor(y=null){const c=this.o(y);return this.c.getLastElementAncestor(c)}has(y){return this.d.has(y)}getListIndex(y){const c=this.o(y);return this.c.getListIndex(c)}getListRenderCount(y){const c=this.o(y);return this.c.getListRenderCount(c)}isCollapsible(y){const c=this.o(y);return this.c.isCollapsible(c)}setCollapsible(y,c){const g=this.o(y);return this.c.setCollapsible(g,c)}isCollapsed(y){const c=this.o(y);return this.c.isCollapsed(c)}setCollapsed(y,c,g){const f=this.o(y);return this.c.setCollapsed(f,c,g)}expandTo(y){const c=this.o(y);this.c.expandTo(c)}refilter(){this.c.refilter()}getNode(y=null){if(y===null)return this.c.getNode(this.c.rootRef);const c=this.d.get(y);if(!c)throw new T.$SS(this.k,`Tree element not found: ${y}`);return c}getNodeLocation(y){return y.element}getParentNodeLocation(y){if(y===null)throw new T.$SS(this.k,"Invalid getParentNodeLocation call");const c=this.d.get(y);if(!c)throw new T.$SS(this.k,`Tree element not found: ${y}`);const g=this.c.getNodeLocation(c),f=this.c.getParentNodeLocation(g);return this.c.getNode(f).element}o(y){if(y===null)return[];const c=this.d.get(y);if(!c)throw new T.$SS(this.k,`Tree element not found: ${y}`);return this.c.getNodeLocation(c)}}t.$3S=U}),define($e[21],we([1,0,3,15,20,24,2]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sQ=void 0;class y extends w.$Rc{f(g,f){this.B(v.$VO(g,v.$KP.CLICK,L=>f(new i.$NO(L))))}j(g,f){this.B(v.$VO(g,v.$KP.MOUSE_DOWN,L=>f(new i.$NO(L))))}m(g,f){this.B(v.$VO(g,v.$KP.MOUSE_OVER,L=>f(new i.$NO(L))))}u(g,f){this.B(v.$VO(g,v.$KP.MOUSE_LEAVE,L=>f(new i.$NO(L))))}z(g,f){this.B(v.$VO(g,v.$KP.KEY_DOWN,L=>f(new T.$SO(L))))}C(g,f){this.B(v.$VO(g,v.$KP.KEY_UP,L=>f(new T.$SO(L))))}D(g,f){this.B(v.$VO(g,v.$KP.INPUT,f))}F(g,f){this.B(v.$VO(g,v.$KP.BLUR,f))}G(g,f){this.B(v.$VO(g,v.$KP.FOCUS,f))}H(g,f){this.B(v.$VO(g,v.$KP.CHANGE,f))}I(g){return U.$oQ.ignoreTarget(g)}}t.$sQ=y}),define($e[38],we([1,0,56,21,9,19,3]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uQ=t.$tQ=void 0,t.$tQ=11;class y extends T.$sQ{constructor(g){super(),this.a=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top<"u"&&(this.bgDomNode.style.top="0px"),typeof g.left<"u"&&(this.bgDomNode.style.left="0px"),typeof g.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof g.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(g.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$tQ+"px",this.domNode.style.height=t.$tQ+"px",typeof g.top<"u"&&(this.domNode.style.top=g.top+"px"),typeof g.left<"u"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom<"u"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right<"u"&&(this.domNode.style.right=g.right+"px"),this.g=this.B(new v.$rQ),this.B(w.$WO(this.bgDomNode,w.$KP.POINTER_DOWN,f=>this.h(f))),this.B(w.$WO(this.domNode,w.$KP.POINTER_DOWN,f=>this.h(f))),this.b=this.B(new i.$6g),this.c=this.B(new i.$5g)}h(g){if(!g.target||!(g.target instanceof Element))return;const f=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(f,200),this.g.startMonitoring(g.target,g.pointerId,g.buttons,L=>{},()=>{this.b.cancel(),this.c.cancel()}),g.preventDefault()}}t.$uQ=y}),define($e[59],we([1,0,3,41,56,38,119,21,5]),function(le,t,v,T,i,U,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xQ=void 0;const g=140;class f extends y.$sQ{constructor(s){super(),this.g=s.lazyRender,this.a=s.host,this.b=s.scrollable,this.c=s.scrollByPage,this.h=s.scrollbarState,this.n=this.B(new w.$wQ(s.visibility,"visible scrollbar "+s.extraScrollbarClassName,"invisible scrollbar "+s.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new i.$rQ),this.s=!0,this.domNode=(0,T.$qQ)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(v.$VO(this.domNode.domNode,v.$KP.POINTER_DOWN,a=>this.M(a)))}t(s){const a=this.B(new U.$uQ(s));this.domNode.domNode.appendChild(a.bgDomNode),this.domNode.domNode.appendChild(a.domNode)}w(s,a,e,h){this.slider=(0,T.$qQ)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(s),this.slider.setLeft(a),typeof e=="number"&&this.slider.setWidth(e),typeof h=="number"&&this.slider.setHeight(h),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(v.$VO(this.slider.domNode,v.$KP.POINTER_DOWN,l=>{l.button===0&&(l.preventDefault(),this.O(l))})),this.f(this.slider.domNode,l=>{l.leftButton&&l.stopPropagation()})}y(s){return this.h.setVisibleSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(s){return this.h.setScrollSize(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(s){return this.h.setScrollPosition(s)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(s){s.target===this.domNode.domNode&&this.N(s)}delegatePointerDown(s){const a=this.domNode.domNode.getClientRects()[0].top,e=a+this.h.getSliderPosition(),h=a+this.h.getSliderPosition()+this.h.getSliderSize(),l=this.U(s);e<=l&&l<=h?s.button===0&&(s.preventDefault(),this.O(s)):this.N(s)}N(s){let a,e;if(s.target===this.domNode.domNode&&typeof s.offsetX=="number"&&typeof s.offsetY=="number")a=s.offsetX,e=s.offsetY;else{const l=v.$bP(this.domNode.domNode);a=s.pageX-l.left,e=s.pageY-l.top}const h=this.S(a,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(h):this.h.getDesiredScrollPositionFromOffset(h)),s.button===0&&(s.preventDefault(),this.O(s))}O(s){if(!s.target||!(s.target instanceof Element))return;const a=this.U(s),e=this.W(s),h=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(s.target,s.pointerId,s.buttons,l=>{const m=this.W(l),n=Math.abs(m-e);if(c.$j&&n>g){this.P(h.getScrollPosition());return}const b=this.U(l)-a;this.P(h.getDesiredScrollPositionFromDelta(b))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(s){const a={};this.writeScrollPosition(a,s),this.b.setScrollPositionNow(a)}updateScrollbarSize(s){this.X(s),this.h.setScrollbarSize(s),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$xQ=f}),define($e[122],we([1,0,20,59,38,42,18]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yQ=void 0;class y extends T.$xQ{constructor(g,f,L){const s=g.getScrollDimensions(),a=g.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:L,scrollbarState:new U.$vQ(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,s.width,s.scrollWidth,a.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:f.scrollByPage}),f.horizontalHasArrows){const e=(f.arrowSize-i.$tQ)/2,h=(f.horizontalScrollbarSize-i.$tQ)/2;this.t({className:"scra",icon:w.$Vj.scrollbarButtonLeft,top:h,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$PO(null,1,0))}),this.t({className:"scra",icon:w.$Vj.scrollbarButtonRight,top:h,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new v.$PO(null,-1,0))})}this.w(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}R(g,f){this.slider.setWidth(g),this.slider.setLeft(f)}Q(g,f){this.domNode.setWidth(g),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this.s=this.J(g.scrollWidth)||this.s,this.s=this.L(g.scrollLeft)||this.s,this.s=this.y(g.width)||this.s,this.s}S(g,f){return g}U(g){return g.pageX}W(g){return g.pageY}X(g){this.slider.setHeight(g)}writeScrollPosition(g,f){g.scrollLeft=f}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.n.setVisibility(g.horizontal),this.c=g.scrollByPage}}t.$yQ=y}),define($e[123],we([1,0,20,59,38,42,18]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zQ=void 0;class y extends T.$xQ{constructor(g,f,L){const s=g.getScrollDimensions(),a=g.getCurrentScrollPosition();if(super({lazyRender:f.lazyRender,host:L,scrollbarState:new U.$vQ(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,s.height,s.scrollHeight,a.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:f.scrollByPage}),f.verticalHasArrows){const e=(f.arrowSize-i.$tQ)/2,h=(f.verticalScrollbarSize-i.$tQ)/2;this.t({className:"scra",icon:w.$Vj.scrollbarButtonUp,top:e,left:h,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$PO(null,0,1))}),this.t({className:"scra",icon:w.$Vj.scrollbarButtonDown,top:void 0,left:h,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this.a.onMouseWheel(new v.$PO(null,0,-1))})}this.w(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}R(g,f){this.slider.setHeight(g),this.slider.setTop(f)}Q(g,f){this.domNode.setWidth(f),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this.s=this.J(g.scrollHeight)||this.s,this.s=this.L(g.scrollTop)||this.s,this.s=this.y(g.height)||this.s,this.s}S(g,f){return f}U(g){return g.pageY}W(g){return g.pageX}X(g){this.slider.setWidth(g)}writeScrollPosition(g,f){g.scrollTop=f}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(g.vertical),this.c=g.scrollByPage}}t.$zQ=y}),define($e[60],we([1,0,17,3,41,20,122,123,21,9,4,2,5,48,97]),function(le,t,v,T,i,U,w,y,c,g,f,L,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EQ=t.$DQ=t.$CQ=t.$BQ=t.$AQ=void 0;const e=500,h=50,l=!0;class m{constructor(R,d,D){this.timestamp=R,this.deltaX=d,this.deltaY=D,this.score=0}}class n{static{this.INSTANCE=new n}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,d=0,D=1,B=this.d;do{const H=B===this.c?R:Math.pow(2,-D);if(R-=H,d+=this.b[B].score*H,B===this.c)break;B=(this.a+B-1)%this.a,D++}while(!0);return d<=.5}acceptStandardWheelEvent(R){const d=T.$xP(R.browserEvent).devicePixelRatio/(0,v.$wO)();s.$j||s.$l?this.accept(Date.now(),R.deltaX/d,R.deltaY/d):this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,d,D){const B=new m(R,d,D);B.score=this.f(B),this.c===-1&&this.d===-1?(this.b[0]=B,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=B)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let d=.5;const D=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(d+=.25),Math.min(Math.max(d,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$AQ=n;class r extends c.$sQ{get options(){return this.a}constructor(R,d,D){super(),this.O=this.B(new f.$Nd),this.onScroll=this.O.event,this.P=this.B(new f.$Nd),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=F(d),this.b=D,this.B(this.b.onScroll(H=>{this.P.fire(H),this.S(H),this.O.fire(H)}));const B={onMouseWheel:H=>this.R(H),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new y.$zQ(this.b,this.a,B)),this.g=this.B(new w.$yQ(this.b,this.a,B)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,i.$qQ)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,i.$qQ)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,i.$qQ)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,H=>this.Z(H)),this.u(this.t,H=>this.Y(H)),this.L=this.B(new g.$5g),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,L.$Mc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,s.$k&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new U.$PO(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,L.$Mc)(this.w),R)){const D=B=>{this.R(new U.$PO(B))};this.w.push(T.$VO(this.t,T.$KP.MOUSE_WHEEL,D,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const d=n.INSTANCE;l&&d.acceptStandardWheelEvent(R);let D=!1;if(R.deltaY||R.deltaX){let H=R.deltaY*this.a.mouseWheelScrollSensitivity,X=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&X+H===0?X=H=0:Math.abs(H)>=Math.abs(X)?X=0:H=0),this.a.flipAxes&&([H,X]=[X,H]);const P=!s.$k&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||P)&&!X&&(X=H,H=0),R.browserEvent&&R.browserEvent.altKey&&(X=X*this.a.fastScrollSensitivity,H=H*this.a.fastScrollSensitivity);const O=this.b.getFutureScrollPosition();let Q={};if(H){const te=h*H,re=O.scrollTop-(te<0?Math.floor(te):Math.ceil(te));this.c.writeScrollPosition(Q,re)}if(X){const te=h*X,re=O.scrollLeft-(te<0?Math.floor(te):Math.ceil(te));this.g.writeScrollPosition(Q,re)}Q=this.b.validateScrollPosition(Q),(O.scrollLeft!==Q.scrollLeft||O.scrollTop!==Q.scrollTop)&&(l&&this.a.mouseWheelSmoothScroll&&d.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(Q):this.b.setScrollPositionNow(Q),D=!0)}let B=D;!B&&this.a.alwaysConsumeMouseWheel&&(B=!0),!B&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(B=!0),B&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),d=R.scrollTop>0,D=R.scrollLeft>0,B=D?" left":"",H=d?" top":"",X=D||d?" top-left-corner":"";this.n.setClassName(`shadow${B}`),this.r.setClassName(`shadow${H}`),this.s.setClassName(`shadow${X}${H}${B}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$BQ=r;class b extends r{constructor(R,d){d=d||{},d.mouseWheelSmoothScroll=!1;const D=new a.$Wr({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>T.$4O(B,T.$xP(R))});super(R,d,D),this.B(D)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$CQ=b;class u extends r{constructor(R,d,D){super(R,d,D)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$DQ=u;class o extends r{constructor(R,d){d=d||{},d.mouseWheelSmoothScroll=!1;const D=new a.$Wr({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:B=>T.$4O(B,T.$xP(R))});super(R,d,D),this.B(D),this.cb=R,this.B(this.onScroll(B=>{B.scrollTopChanged&&(this.cb.scrollTop=B.scrollTop),B.scrollLeftChanged&&(this.cb.scrollLeft=B.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$EQ=o;function F(j){const R={lazyRender:typeof j.lazyRender<"u"?j.lazyRender:!1,className:typeof j.className<"u"?j.className:"",useShadows:typeof j.useShadows<"u"?j.useShadows:!0,handleMouseWheel:typeof j.handleMouseWheel<"u"?j.handleMouseWheel:!0,flipAxes:typeof j.flipAxes<"u"?j.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof j.consumeMouseWheelIfScrollbarIsNeeded<"u"?j.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof j.alwaysConsumeMouseWheel<"u"?j.alwaysConsumeMouseWheel:!1,scrollYToX:typeof j.scrollYToX<"u"?j.scrollYToX:!1,mouseWheelScrollSensitivity:typeof j.mouseWheelScrollSensitivity<"u"?j.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof j.fastScrollSensitivity<"u"?j.fastScrollSensitivity:5,scrollPredominantAxis:typeof j.scrollPredominantAxis<"u"?j.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof j.mouseWheelSmoothScroll<"u"?j.mouseWheelSmoothScroll:!0,arrowSize:typeof j.arrowSize<"u"?j.arrowSize:11,listenOnDomNode:typeof j.listenOnDomNode<"u"?j.listenOnDomNode:null,horizontal:typeof j.horizontal<"u"?j.horizontal:1,horizontalScrollbarSize:typeof j.horizontalScrollbarSize<"u"?j.horizontalScrollbarSize:10,horizontalSliderSize:typeof j.horizontalSliderSize<"u"?j.horizontalSliderSize:0,horizontalHasArrows:typeof j.horizontalHasArrows<"u"?j.horizontalHasArrows:!1,vertical:typeof j.vertical<"u"?j.vertical:1,verticalScrollbarSize:typeof j.verticalScrollbarSize<"u"?j.verticalScrollbarSize:10,verticalHasArrows:typeof j.verticalHasArrows<"u"?j.verticalHasArrows:!1,verticalSliderSize:typeof j.verticalSliderSize<"u"?j.verticalSliderSize:0,scrollByPage:typeof j.scrollByPage<"u"?j.scrollByPage:!1};return R.horizontalSliderSize=typeof j.horizontalSliderSize<"u"?j.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof j.verticalSliderSize<"u"?j.verticalSliderSize:R.verticalScrollbarSize,s.$k&&(R.className+=" mac"),R}}),define($e[61],we([1,0,54,3,22,24,60,11,9,26,4,2,47,48,82,118,6]),function(le,t,v,T,i,U,w,y,c,g,f,L,s,a,e,h,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9Q=t.$8Q=t.$7Q=t.$6Q=void 0;const m={CurrentDragAndDropData:void 0},n={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(R){return[R]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class r{get context(){return this.d}set context(d){this.d=d}constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.$6Q=r;class b{constructor(d){this.elements=d}update(){}getData(){return this.elements}}t.$7Q=b;class u{constructor(){this.types=[],this.files=[]}update(d){if(d.types&&this.types.splice(0,this.types.length,...d.types),d.files){this.files.splice(0,this.files.length);for(let D=0;D<d.files.length;D++){const B=d.files.item(D);B&&(B.size||B.type)&&this.files.push(B)}}}getData(){return{types:this.types,files:this.files}}}t.$8Q=u;function o(R,d){return Array.isArray(R)&&Array.isArray(d)?(0,y.$tb)(R,d):R===d}class F{constructor(d){d?.getSetSize?this.getSetSize=d.getSetSize.bind(d):this.getSetSize=(D,B,H)=>H,d?.getPosInSet?this.getPosInSet=d.getPosInSet.bind(d):this.getPosInSet=(D,B)=>B+1,d?.getRole?this.getRole=d.getRole.bind(d):this.getRole=D=>"listitem",d?.isChecked?this.isChecked=d.isChecked.bind(d):this.isChecked=D=>{}}}class j{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get P(){return this.O}set P(d){if(d!==this.O){if(d&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.O=d,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.O){for(const D of this.d)this.Y(D);this.V(),this.q.setScrollDimensions({width:(0,T.$eP)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(d,D,B,H=n){if(this.Q=D,this.domId=`list_id_${++j.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new c.$Qg(50),this.v=!1,this.x=L.$Rc.None,this.y=0,this.G=!1,this.J=L.$Rc.None,this.K=L.$Rc.None,this.L=new L.$Qc,this.M=new f.$Nd,this.N=new f.$Nd,this.onDidChangeContentHeight=f.Event.latch(this.M.event,void 0,this.L),this.onDidChangeContentWidth=f.Event.latch(this.N.event,void 0,this.L),this.O=!1,H.horizontalScrolling&&H.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.$4Q(H.paddingTop??0);for(const P of B)this.j.set(P.templateId,P);this.h=this.L.add(new h.$5Q(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof H.mouseSupport=="boolean"?H.mouseSupport:!0),this.O=H.horizontalScrolling??n.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.O),this.C=typeof H.paddingBottom>"u"?0:H.paddingBottom,this.D=new F(H.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(H.transformOptimization??n.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(U.$oQ.addTarget(this.o)),this.p=this.L.add(new a.$Wr({forceIntegerValues:!0,smoothScrollDuration:H.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:P=>(0,T.$4O)(P,(0,T.$xP)(this.domNode))})),this.q=this.L.add(new w.$DQ(this.o,{alwaysConsumeMouseWheel:H.alwaysConsumeMouseWheel??n.alwaysConsumeMouseWheel,horizontal:1,vertical:H.verticalScrollMode??n.verticalScrollMode,useShadows:H.useShadows??n.useShadows,mouseWheelScrollSensitivity:H.mouseWheelScrollSensitivity,fastScrollSensitivity:H.fastScrollSensitivity,scrollByPage:H.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),d.appendChild(this.domNode),this.q.onScroll(this.gb,this,this.L),this.L.add((0,T.$VO)(this.o,U.EventType.Change,P=>this.hb(P))),this.L.add((0,T.$VO)(this.q.getDomNode(),"scroll",P=>P.target.scrollTop=0)),this.L.add((0,T.$VO)(this.domNode,"dragover",P=>this.jb(this.fb(P)))),this.L.add((0,T.$VO)(this.domNode,"drop",P=>this.lb(this.fb(P)))),this.L.add((0,T.$VO)(this.domNode,"dragleave",P=>this.kb(this.fb(P)))),this.L.add((0,T.$VO)(this.domNode,"dragend",P=>this.mb(P))),this.z=H.setRowLineHeight??n.setRowLineHeight,this.A=H.setRowHeight??n.setRowHeight,this.B=H.supportDynamicHeights??n.supportDynamicHeights,this.F=H.dnd??this.L.add(n.dnd),this.layout(H.initialSize?.height,H.initialSize?.width)}updateOptions(d){d.paddingBottom!==void 0&&(this.C=d.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),d.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(d.smoothScrolling?125:0),d.horizontalScrolling!==void 0&&(this.P=d.horizontalScrolling);let D;if(d.scrollByPage!==void 0&&(D={...D??{},scrollByPage:d.scrollByPage}),d.mouseWheelScrollSensitivity!==void 0&&(D={...D??{},mouseWheelScrollSensitivity:d.mouseWheelScrollSensitivity}),d.fastScrollSensitivity!==void 0&&(D={...D??{},fastScrollSensitivity:d.fastScrollSensitivity}),D&&this.q.updateOptions(D),d.paddingTop!==void 0&&d.paddingTop!==this.g.paddingTop){const B=this.sb(this.k,this.m),H=d.paddingTop-this.g.paddingTop;this.g.paddingTop=d.paddingTop,this.W(B,Math.max(0,this.k+H),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(d){this.q.delegateScrollFromMouseWheelEvent(d)}delegateVerticalScrollbarPointerDown(d){this.q.delegateVerticalScrollbarPointerDown(d)}updateElementHeight(d,D,B){if(d<0||d>=this.d.length)return;const H=this.d[d].size;if(typeof D>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[d].lastDynamicHeightWidth=void 0,D=H+this.ub(d)}if(H===D)return;const X=this.sb(this.k,this.m);let P=0;d<X.start||B!==null&&B>d&&B<X.end?P=D-H:P=0,this.g.splice(d,1,[{size:D}]),this.d[d].size=D,this.W(X,Math.max(0,this.k+P),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.S(),this.B&&this.tb(this.k,this.m)}splice(d,D,B=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.R(d,D,B)}finally{this.v=!1,this.M.fire(this.contentHeight)}}R(d,D,B=[]){const H=this.sb(this.k,this.m),X={start:d,end:d+D},P=s.Range.intersect(H,X),O=new Map;for(let V=P.end-1;V>=P.start;V--){const Y=this.d[V];if(Y.dragStartDisposable.dispose(),Y.checkedDisposable.dispose(),Y.row){let C=O.get(Y.templateId);C||(C=[],O.set(Y.templateId,C));const q=this.j.get(Y.templateId);q&&q.disposeElement&&q.disposeElement(Y.element,V,Y.row.templateData,Y.size),C.push(Y.row)}Y.row=null}const Q={start:d+D,end:this.d.length},te=s.Range.intersect(Q,H),re=s.Range.relativeComplement(Q,H),fe=B.map(V=>({id:String(this.f++),element:V,templateId:this.Q.getTemplateId(V),size:this.Q.getHeight(V),width:void 0,hasDynamicHeight:!!this.Q.hasDynamicHeight&&this.Q.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:L.$Rc.None,checkedDisposable:L.$Rc.None}));let ie;d===0&&D>=this.d.length?(this.g=new e.$4Q(this.g.paddingTop),this.g.splice(0,0,fe),ie=this.d,this.d=fe):(this.g.splice(d,D,fe),ie=this.d.splice(d,D,...fe));const oe=B.length-D,be=this.sb(this.k,this.m),Se=(0,e.$2Q)(te,oe),Te=s.Range.intersect(be,Se);for(let V=Te.start;V<Te.end;V++)this.Z(this.d[V],V);const Fe=s.Range.relativeComplement(Se,be);for(const V of Fe)for(let Y=V.start;Y<V.end;Y++)this.ab(Y);const de=re.map(V=>(0,e.$2Q)(V,oe)),ce=[{start:d,end:d+B.length},...de].map(V=>s.Range.intersect(be,V)),Z=this.vb(ce);for(const V of ce)for(let Y=V.start;Y<V.end;Y++){const C=this.d[Y],$=O.get(C.templateId)?.pop();this.X(Y,Z,$)}for(const V of O.values())for(const Y of V)this.h.release(Y);return this.S(),this.B&&this.tb(this.scrollTop,this.renderHeight),ie.map(V=>V.element)}S(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,T.$4O)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.V(),this.t=null},(0,T.$xP)(this.domNode)))}U(){if(!this.P){this.u.cancel();return}this.u.trigger(()=>this.V())}V(){if(!this.P)return;let d=0;for(const D of this.d)typeof D.width<"u"&&(d=Math.max(d,D.width));this.E=d,this.q.setScrollDimensions({scrollWidth:d===0?0:d+10}),this.N.fire(this.E)}updateWidth(d){if(!this.P||typeof this.E>"u")return;const D=this.d[d];this.Y(D),typeof D.width<"u"&&D.width>this.E&&(this.E=D.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.N.fire(this.E))}rerender(){if(this.B){for(const d of this.d)d.lastDynamicHeightWidth=void 0;this.tb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const d=this.sb(this.k,this.m),D=this.g.positionAt(d.start),B=this.g.positionAt(d.start+1);return B!==-1&&(B-D)/2+D<this.scrollTop?d.start+1:d.start}get lastVisibleIndex(){return this.sb(this.k,this.m).end-1}element(d){return this.d[d].element}indexOf(d){return this.d.findIndex(D=>D.element===d)}domElement(d){const D=this.d[d].row;return D&&D.domNode}elementHeight(d){return this.d[d].size}elementTop(d){return this.g.positionAt(d)}indexAt(d){return this.g.indexAt(d)}indexAfter(d){return this.g.indexAfter(d)}layout(d,D){const B={height:typeof d=="number"?d:(0,T.$gP)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,B.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(B),typeof D<"u"&&(this.n=D,this.B&&this.tb(this.scrollTop,this.renderHeight)),this.P&&this.q.setScrollDimensions({width:typeof D=="number"?D:(0,T.$eP)(this.domNode)})}W(d,D,B,H,X,P=!1){const O=this.sb(D,B),Q=s.Range.relativeComplement(O,d),te=s.Range.relativeComplement(d,O),re=this.vb(Q);if(P){const fe=s.Range.intersect(d,O);for(let ie=fe.start;ie<fe.end;ie++)this.Z(this.d[ie],ie)}this.h.transact(()=>{for(const fe of te)for(let ie=fe.start;ie<fe.end;ie++)this.ab(ie);for(const fe of Q)for(let ie=fe.start;ie<fe.end;ie++)this.X(ie,re)}),H!==void 0&&(this.o.style.left=`-${H}px`),this.o.style.top=`-${D}px`,this.P&&X!==void 0&&(this.o.style.width=`${Math.max(X,this.n)}px`),this.k=D,this.m=B}X(d,D,B){const H=this.d[d];let X=!1;if(!H.row)if(B)H.row=B;else{const re=this.h.alloc(H.templateId);H.row=re.row,X=re.isReusingConnectedDomNode}const P=this.D.getRole(H.element)||"listitem";H.row.domNode.setAttribute("role",P);const O=this.D.isChecked(H.element);if(typeof O=="boolean")H.row.domNode.setAttribute("aria-checked",String(!!O));else if(O){const re=fe=>H.row.domNode.setAttribute("aria-checked",String(!!fe));re(O.value),H.checkedDisposable=O.onDidChange(re)}(X||!H.row.domNode.parentElement)&&(D?this.o.insertBefore(H.row.domNode,D):this.o.appendChild(H.row.domNode)),this.Z(H,d);const Q=this.j.get(H.templateId);if(!Q)throw new Error(`No renderer found for template id ${H.templateId}`);Q?.renderElement(H.element,d,H.row.templateData,H.size);const te=this.F.getDragURI(H.element);H.dragStartDisposable.dispose(),H.row.domNode.draggable=!!te,te&&(H.dragStartDisposable=(0,T.$VO)(H.row.domNode,"dragstart",re=>this.ib(H.element,te,re))),this.P&&(this.Y(H),this.U())}Y(d){if(!d.row||!d.row.domNode)return;d.row.domNode.style.width="fit-content",d.width=(0,T.$eP)(d.row.domNode);const D=(0,T.$xP)(d.row.domNode).getComputedStyle(d.row.domNode);D.paddingLeft&&(d.width+=parseFloat(D.paddingLeft)),D.paddingRight&&(d.width+=parseFloat(D.paddingRight)),d.row.domNode.style.width=""}Z(d,D){d.row.domNode.style.top=`${this.elementTop(D)}px`,this.A&&(d.row.domNode.style.height=`${d.size}px`),this.z&&(d.row.domNode.style.lineHeight=`${d.size}px`),d.row.domNode.setAttribute("data-index",`${D}`),d.row.domNode.setAttribute("data-last-element",D===this.length-1?"true":"false"),d.row.domNode.setAttribute("data-parity",D%2===0?"even":"odd"),d.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(d.element,D,this.length))),d.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(d.element,D))),d.row.domNode.setAttribute("id",this.getElementDomId(D)),d.row.domNode.classList.toggle("drop-target",d.dropTarget)}ab(d){const D=this.d[d];if(D.dragStartDisposable.dispose(),D.checkedDisposable.dispose(),D.row){const B=this.j.get(D.templateId);B&&B.disposeElement&&B.disposeElement(D.element,d,D.row.templateData,D.size),this.h.release(D.row),D.row=null}this.P&&this.U()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(d,D){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:d,reuseAnimation:D})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(d){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:d})}get scrollTop(){return this.getScrollTop()}set scrollTop(d){this.setScrollTop(d)}get scrollHeight(){return this.s+(this.P?10:0)+this.C}get onMouseClick(){return f.Event.map(this.L.add(new i.$SQ(this.domNode,"click")).event,d=>this.bb(d),this.L)}get onMouseDblClick(){return f.Event.map(this.L.add(new i.$SQ(this.domNode,"dblclick")).event,d=>this.bb(d),this.L)}get onMouseMiddleClick(){return f.Event.filter(f.Event.map(this.L.add(new i.$SQ(this.domNode,"auxclick")).event,d=>this.bb(d),this.L),d=>d.browserEvent.button===1,this.L)}get onMouseUp(){return f.Event.map(this.L.add(new i.$SQ(this.domNode,"mouseup")).event,d=>this.bb(d),this.L)}get onMouseDown(){return f.Event.map(this.L.add(new i.$SQ(this.domNode,"mousedown")).event,d=>this.bb(d),this.L)}get onMouseOver(){return f.Event.map(this.L.add(new i.$SQ(this.domNode,"mouseover")).event,d=>this.bb(d),this.L)}get onMouseMove(){return f.Event.map(this.L.add(new i.$SQ(this.domNode,"mousemove")).event,d=>this.bb(d),this.L)}get onMouseOut(){return f.Event.map(this.L.add(new i.$SQ(this.domNode,"mouseout")).event,d=>this.bb(d),this.L)}get onContextMenu(){return f.Event.any(f.Event.map(this.L.add(new i.$SQ(this.domNode,"contextmenu")).event,d=>this.bb(d),this.L),f.Event.map(this.L.add(new i.$SQ(this.domNode,U.EventType.Contextmenu)).event,d=>this.eb(d),this.L))}get onTouchStart(){return f.Event.map(this.L.add(new i.$SQ(this.domNode,"touchstart")).event,d=>this.db(d),this.L)}get onTap(){return f.Event.map(this.L.add(new i.$SQ(this.o,U.EventType.Tap)).event,d=>this.eb(d),this.L)}bb(d){const D=this.rb(d.target||null),B=typeof D>"u"?void 0:this.d[D],H=B&&B.element;return{browserEvent:d,index:D,element:H}}db(d){const D=this.rb(d.target||null),B=typeof D>"u"?void 0:this.d[D],H=B&&B.element;return{browserEvent:d,index:D,element:H}}eb(d){const D=this.rb(d.initialTarget||null),B=typeof D>"u"?void 0:this.d[D],H=B&&B.element;return{browserEvent:d,index:D,element:H}}fb(d){const D=this.rb(d.target||null),B=typeof D>"u"?void 0:this.d[D],H=B&&B.element;return{browserEvent:d,index:D,element:H}}gb(d){try{const D=this.sb(this.k,this.m);this.W(D,d.scrollTop,d.height,d.scrollLeft,d.scrollWidth),this.B&&this.tb(d.scrollTop,d.height,d.inSmoothScrolling)}catch(D){throw console.error("Got bad scroll event:",d),D}}hb(d){d.preventDefault(),d.stopPropagation(),this.scrollTop-=d.translationY}ib(d,D,B){if(!B.dataTransfer)return;const H=this.F.getDragElements(d);if(B.dataTransfer.effectAllowed="copyMove",B.dataTransfer.setData(v.$mQ.TEXT,D),B.dataTransfer.setDragImage){let X;this.F.getDragLabel&&(X=this.F.getDragLabel(H,B)),typeof X>"u"&&(X=String(H.length));const P=(0,T.$)(".monaco-drag-image");P.textContent=X;const Q=(te=>{for(;te&&!te.classList.contains("monaco-workbench");)te=te.parentElement;return te||this.domNode.ownerDocument})(this.domNode);Q.appendChild(P),B.dataTransfer.setDragImage(P,-10,-10),setTimeout(()=>Q.removeChild(P),0)}this.domNode.classList.add("dragging"),this.H=new r(H),m.CurrentDragAndDropData=new b(H),this.F.onDragStart?.(this.H,B)}jb(d){if(d.browserEvent.preventDefault(),this.K.dispose(),m.CurrentDragAndDropData&&m.CurrentDragAndDropData.getData()==="vscode-ui"||(this.ob(d.browserEvent),!d.browserEvent.dataTransfer))return!1;if(!this.H)if(m.CurrentDragAndDropData)this.H=m.CurrentDragAndDropData;else{if(!d.browserEvent.dataTransfer.types)return!1;this.H=new u}const D=this.F.onDragOver(this.H,d.element,d.index,d.browserEvent);if(this.G=typeof D=="boolean"?D:D.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;d.browserEvent.dataTransfer.dropEffect=typeof D!="boolean"&&D.effect===0?"copy":"move";let B;if(typeof D!="boolean"&&D.feedback?B=D.feedback:typeof d.index>"u"?B=[-1]:B=[d.index],B=(0,y.$Lb)(B).filter(H=>H>=-1&&H<this.length).sort((H,X)=>H-X),B=B[0]===-1?[-1]:B,o(this.I,B))return!0;if(this.I=B,this.J.dispose(),B[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,L.$Pc)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const H of B){const X=this.d[H];X.dropTarget=!0,X.row?.domNode.classList.add("drop-target")}this.J=(0,L.$Pc)(()=>{for(const H of B){const X=this.d[H];X.dropTarget=!1,X.row?.domNode.classList.remove("drop-target")}})}return!0}kb(d){this.K.dispose(),this.K=(0,c.$Vg)(()=>this.nb(),100,this.L),this.H&&this.F.onDragLeave?.(this.H,d.element,d.index,d.browserEvent)}lb(d){if(!this.G)return;const D=this.H;this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,!(!D||!d.browserEvent.dataTransfer)&&(d.browserEvent.preventDefault(),D.update(d.browserEvent.dataTransfer),this.F.drop(D,d.element,d.index,d.browserEvent))}mb(d){this.G=!1,this.qb(),this.nb(),this.domNode.classList.remove("dragging"),this.H=void 0,m.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(d)}nb(){this.I=void 0,this.J.dispose(),this.J=L.$Rc.None}ob(d){if(!this.w){const D=(0,T.$$O)(this.domNode).top;this.w=(0,T.$7P)(this.pb.bind(this,D),(0,T.$xP)(this.domNode))}this.x.dispose(),this.x=(0,c.$Vg)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.L),this.y=d.pageY}pb(d){if(this.y===void 0)return;const D=this.y-d,B=this.renderHeight-35;D<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(D-35))):D>B&&(this.scrollTop+=Math.min(14,Math.floor(.3*(D-B))))}qb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}rb(d){const D=this.q.getDomNode();let B=d;for(;B instanceof HTMLElement&&B!==this.o&&D.contains(B);){const H=B.getAttribute("data-index");if(H){const X=Number(H);if(!isNaN(X))return X}B=B.parentElement}}sb(d,D){return{start:this.g.indexAt(d),end:this.g.indexAfter(d+D-1)}}tb(d,D,B){const H=this.sb(d,D);let X,P;d===this.elementTop(H.start)?(X=H.start,P=0):H.end-H.start>1&&(X=H.start+1,P=this.elementTop(X)-d);let O=0;for(;;){const Q=this.sb(d,D);let te=!1;for(let re=Q.start;re<Q.end;re++){const fe=this.ub(re);fe!==0&&this.g.splice(re,1,[this.d[re]]),O+=fe,te=te||fe!==0}if(!te){O!==0&&this.S();const re=s.Range.relativeComplement(H,Q);for(const ie of re)for(let oe=ie.start;oe<ie.end;oe++)this.d[oe].row&&this.ab(oe);const fe=s.Range.relativeComplement(Q,H);for(const ie of fe)for(let oe=ie.start;oe<ie.end;oe++){const be=oe+1,Se=be<this.d.length?this.d[be].row:null,Te=Se?Se.domNode:null;this.X(oe,Te)}for(let ie=Q.start;ie<Q.end;ie++)this.d[ie].row&&this.Z(this.d[ie],ie);if(typeof X=="number"){const ie=this.p.getFutureScrollPosition().scrollTop-d,oe=this.elementTop(X)-P+ie;this.setScrollTop(oe,B)}this.M.fire(this.contentHeight);return}}}ub(d){const D=this.d[d];if(this.Q.getDynamicHeight){const P=this.Q.getDynamicHeight(D.element);if(P!==null){const O=D.size;return D.size=P,D.lastDynamicHeightWidth=this.n,P-O}}if(!D.hasDynamicHeight||D.lastDynamicHeightWidth===this.n||this.Q.hasDynamicHeight&&!this.Q.hasDynamicHeight(D.element))return 0;const B=D.size;if(D.row)return D.row.domNode.style.height="",D.size=D.row.domNode.offsetHeight,D.lastDynamicHeightWidth=this.n,D.size-B;const{row:H}=this.h.alloc(D.templateId);H.domNode.style.height="",this.o.appendChild(H.domNode);const X=this.j.get(D.templateId);if(!X)throw new l.$bb("Missing renderer for templateId: "+D.templateId);return X.renderElement(D.element,d,H.templateData,void 0),D.size=H.domNode.offsetHeight,X.disposeElement?.(D.element,d,H.templateData,void 0),this.Q.setDynamicHeight?.(D.element,D.size),D.lastDynamicHeightWidth=this.n,this.o.removeChild(H.domNode),this.h.release(H),D.size-B}vb(d){const D=d[d.length-1];if(!D)return null;const B=this.d[D.end];return!B||!B.row?null:B.row.domNode}getElementDomId(d){return`${this.domId}_${d}`}dispose(){for(const d of this.d)if(d.dragStartDisposable.dispose(),d.checkedDisposable.dispose(),d.row){const D=this.j.get(d.row.templateId);D&&(D.disposeElement?.(d.element,-1,d.row.templateData,void 0),D.disposeTemplate(d.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.L.dispose()}}t.$9Q=j,Ye([g.$ih],j.prototype,"onMouseClick",null),Ye([g.$ih],j.prototype,"onMouseDblClick",null),Ye([g.$ih],j.prototype,"onMouseMiddleClick",null),Ye([g.$ih],j.prototype,"onMouseUp",null),Ye([g.$ih],j.prototype,"onMouseDown",null),Ye([g.$ih],j.prototype,"onMouseOver",null),Ye([g.$ih],j.prototype,"onMouseMove",null),Ye([g.$ih],j.prototype,"onMouseOut",null),Ye([g.$ih],j.prototype,"onContextMenu",null),Ye([g.$ih],j.prototype,"onTouchStart",null),Ye([g.$ih],j.prototype,"onTap",null)}),define($e[39],we([1,0,3,22,15,24,57,70,11,9,74,26,4,34,2,46,5,7,69,61,20,96]),function(le,t,v,T,i,U,w,y,c,g,f,L,s,a,e,h,l,m,n,r,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gR=t.$fR=t.$eR=t.$dR=t.$cR=t.$bR=t.$aR=t.TypeNavigationMode=t.$_Q=t.$$Q=t.$0Q=void 0;class u{constructor(C){this.d=C,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(C){return C}renderElement(C,q,$){const W=this.c.findIndex(_=>_.templateData===$);if(W>=0){const _=this.c[W];this.d.unrender($),_.index=q}else{const _={index:q,templateData:$};this.c.push(_)}this.d.renderIndex(q,$)}splice(C,q,$){const W=[];for(const _ of this.c)_.index<C?W.push(_):_.index>=C+q&&W.push({index:_.index+$-q,templateData:_.templateData});this.c=W}renderIndexes(C){for(const{index:q,templateData:$}of this.c)C.indexOf(q)>-1&&this.d.renderIndex(q,$)}disposeTemplate(C){const q=this.c.findIndex($=>$.templateData===C);q<0||this.c.splice(q,1)}}class o{get name(){return this.h}get renderer(){return new u(this)}constructor(C){this.h=C,this.c=0,this.d=[],this.f=[],this.g=new s.$Nd,this.onChange=this.g.event}splice(C,q,$){q=Math.max(0,Math.min(q,this.c-C));const W=$.length-q,_=C+q,p=[];let A=0;for(;A<this.f.length&&this.f[A]<C;)p.push(this.f[A++]);for(let M=0;M<$.length;M++)$[M]&&p.push(M+C);for(;A<this.f.length&&this.f[A]>=_;)p.push(this.f[A++]+W);const E=this.c+W;if(this.f.length>0&&p.length===0&&E>0){const M=this.f.find(k=>k>=C)??E-1;p.push(Math.min(M,E-1))}this.renderer.splice(C,q,$.length),this.k(p,p),this.c=E}renderIndex(C,q){q.classList.toggle(this.h,this.contains(C))}unrender(C){C.classList.remove(this.h)}set(C,q){return this.k(C,[...C].sort(de),q)}k(C,q,$){const W=this.d,_=this.f;this.d=C,this.f=q;const p=Te(_,C);return this.renderer.renderIndexes(p),this.g.fire({indexes:C,browserEvent:$}),W}get(){return this.d}contains(C){return(0,c.$vb)(this.f,C,de)>=0}dispose(){(0,e.$Mc)(this.g)}}Ye([L.$ih],o.prototype,"renderer",null);class F extends o{constructor(C){super("selected"),this.l=C}renderIndex(C,q){super.renderIndex(C,q),this.l&&(this.contains(C)?q.setAttribute("aria-selected","true"):q.setAttribute("aria-selected","false"))}}class j{constructor(C,q,$){this.c=C,this.d=q,this.f=$}splice(C,q,$){if(!this.f)return this.c.splice(C,q,new Array($.length).fill(!1));const W=this.c.get().map(A=>this.f.getId(this.d.element(A)).toString());if(W.length===0)return this.c.splice(C,q,new Array($.length).fill(!1));const _=new Set(W),p=$.map(A=>_.has(this.f.getId(A).toString()));this.c.splice(C,q,p)}}function R(Y){return Y.tagName==="INPUT"||Y.tagName==="TEXTAREA"}t.$0Q=R;function d(Y){return Y.classList.contains("monaco-editor")?!0:Y.classList.contains("monaco-list")||!Y.parentElement?!1:d(Y.parentElement)}t.$$Q=d;function D(Y){return Y.tagName==="A"&&Y.classList.contains("monaco-button")||Y.tagName==="DIV"&&Y.classList.contains("monaco-button-dropdown")?!0:Y.classList.contains("monaco-list")||!Y.parentElement?!1:D(Y.parentElement)}t.$_Q=D;class B{get g(){return s.Event.chain(this.c.add(new T.$SQ(this.k.domNode,"keydown")).event,C=>C.filter(q=>!R(q.target)).map(q=>new i.$SO(q)))}constructor(C,q,$){this.h=C,this.k=q,this.c=new e.$Qc,this.d=new e.$Qc,this.f=$.multipleSelectionSupport,this.c.add(this.g(W=>{switch(W.keyCode){case 3:return this.l(W);case 16:return this.o(W);case 18:return this.p(W);case 11:return this.q(W);case 12:return this.s(W);case 9:return this.u(W);case 31:this.f&&(l.$k?W.metaKey:W.ctrlKey)&&this.t(W)}}))}updateOptions(C){C.multipleSelectionSupport!==void 0&&(this.f=C.multipleSelectionSupport)}l(C){C.preventDefault(),C.stopPropagation(),this.h.setSelection(this.h.getFocus(),C.browserEvent)}o(C){C.preventDefault(),C.stopPropagation(),this.h.focusPrevious(1,!1,C.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}p(C){C.preventDefault(),C.stopPropagation(),this.h.focusNext(1,!1,C.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}q(C){C.preventDefault(),C.stopPropagation(),this.h.focusPreviousPage(C.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}s(C){C.preventDefault(),C.stopPropagation(),this.h.focusNextPage(C.browserEvent);const q=this.h.getFocus()[0];this.h.setAnchor(q),this.h.reveal(q),this.k.domNode.focus()}t(C){C.preventDefault(),C.stopPropagation(),this.h.setSelection((0,c.$Rb)(this.h.length),C.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(C){this.h.getSelection().length&&(C.preventDefault(),C.stopPropagation(),this.h.setSelection([],C.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ye([L.$ih],B.prototype,"g",null);var H;(function(Y){Y[Y.Automatic=0]="Automatic",Y[Y.Trigger=1]="Trigger"})(H||(t.TypeNavigationMode=H={}));var X;(function(Y){Y[Y.Idle=0]="Idle",Y[Y.Typing=1]="Typing"})(X||(X={})),t.$aR=new class{mightProducePrintableCharacter(Y){return Y.ctrlKey||Y.metaKey||Y.altKey?!1:Y.keyCode>=31&&Y.keyCode<=56||Y.keyCode>=21&&Y.keyCode<=30||Y.keyCode>=98&&Y.keyCode<=107||Y.keyCode>=85&&Y.keyCode<=95}};class P{constructor(C,q,$,W,_){this.o=C,this.p=q,this.q=$,this.s=W,this.t=_,this.c=!1,this.d=X.Idle,this.f=H.Automatic,this.g=!1,this.h=-1,this.k=new e.$Qc,this.l=new e.$Qc,this.updateOptions(C.options)}updateOptions(C){C.typeNavigationEnabled??!0?this.u():this.v(),this.f=C.typeNavigationMode??H.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let C=!1;const q=s.Event.chain(this.k.add(new T.$SQ(this.p.domNode,"keydown")).event,_=>_.filter(p=>!R(p.target)).filter(()=>this.f===H.Automatic||this.g).map(p=>new i.$SO(p)).filter(p=>C||this.s(p)).filter(p=>this.t.mightProducePrintableCharacter(p)).forEach(p=>v.$MP.stop(p,!0)).map(p=>p.browserEvent.key)),$=s.Event.debounce(q,()=>null,800,void 0,void 0,void 0,this.k);s.Event.reduce(s.Event.any(q,$),(_,p)=>p===null?null:(_||"")+p,void 0,this.k)(this.x,this,this.k),$(this.w,this,this.k),q(()=>C=!0,void 0,this.k),$(()=>C=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const C=this.o.getFocus();if(C.length>0&&C[0]===this.h){const q=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(C[0]));q&&(0,w.$UQ)(q)}this.h=-1}x(C){if(!C){this.d=X.Idle,this.g=!1;return}const q=this.o.getFocus(),$=q.length>0?q[0]:0,W=this.d===X.Idle?1:0;this.d=X.Typing;for(let _=0;_<this.o.length;_++){const p=($+_+W)%this.o.length,A=this.q.getKeyboardNavigationLabel(this.p.element(p)),E=A&&A.toString();if(this.o.options.typeNavigationEnabled){if(typeof E<"u"){if((0,a.$Ej)(C,E)){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}const M=(0,a.$Lj)(C,E);if(M&&M[0].end-M[0].start>1&&M.length===1){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}}}else if(typeof E>"u"||(0,a.$Ej)(C,E)){this.h=$,this.o.setFocus([p]),this.o.reveal(p);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class O{constructor(C,q){this.d=C,this.f=q,this.c=new e.$Qc;const $=s.Event.chain(this.c.add(new T.$SQ(q.domNode,"keydown")).event,_=>_.filter(p=>!R(p.target)).map(p=>new i.$SO(p)));s.Event.chain($,_=>_.filter(p=>p.keyCode===2&&!p.ctrlKey&&!p.metaKey&&!p.shiftKey&&!p.altKey))(this.g,this,this.c)}g(C){if(C.target!==this.f.domNode)return;const q=this.d.getFocus();if(q.length===0)return;const $=this.f.domElement(q[0]);if(!$)return;const W=$.querySelector("[tabIndex]");if(!W||!(W instanceof HTMLElement)||W.tabIndex===-1)return;const _=(0,v.$xP)(W).getComputedStyle(W);_.visibility==="hidden"||_.display==="none"||(C.preventDefault(),C.stopPropagation(),W.focus())}dispose(){this.c.dispose()}}function Q(Y){return l.$k?Y.browserEvent.metaKey:Y.browserEvent.ctrlKey}t.$bR=Q;function te(Y){return Y.browserEvent.shiftKey}t.$cR=te;function re(Y){return(0,v.$GP)(Y)&&Y.button===2}const fe={isSelectionSingleChangeEvent:Q,isSelectionRangeChangeEvent:te};class ie{constructor(C){this.k=C,this.f=new e.$Qc,this.g=new s.$Nd,this.onPointer=this.g.event,C.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||fe),this.d=typeof C.options.mouseSupport>"u"||!!C.options.mouseSupport,this.d&&(C.onMouseDown(this.s,this,this.f),C.onContextMenu(this.t,this,this.f),C.onMouseDblClick(this.v,this,this.f),C.onTouchStart(this.s,this,this.f),this.f.add(U.$oQ.addTarget(C.getHTMLElement()))),s.Event.any(C.onMouseClick,C.onMouseMiddleClick,C.onTap)(this.u,this,this.f)}updateOptions(C){C.multipleSelectionSupport!==void 0&&(this.c=void 0,C.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||fe))}o(C){return this.c?this.c.isSelectionSingleChangeEvent(C):!1}p(C){return this.c?this.c.isSelectionRangeChangeEvent(C):!1}q(C){return this.o(C)||this.p(C)}s(C){d(C.browserEvent.target)||(0,v.$rP)()!==C.browserEvent.target&&this.k.domFocus()}t(C){if(R(C.browserEvent.target)||d(C.browserEvent.target))return;const q=typeof C.index>"u"?[]:[C.index];this.k.setFocus(q,C.browserEvent)}u(C){if(!this.d||R(C.browserEvent.target)||d(C.browserEvent.target)||C.browserEvent.isHandledByList)return;C.browserEvent.isHandledByList=!0;const q=C.index;if(typeof q>"u"){this.k.setFocus([],C.browserEvent),this.k.setSelection([],C.browserEvent),this.k.setAnchor(void 0);return}if(this.q(C))return this.w(C);this.k.setFocus([q],C.browserEvent),this.k.setAnchor(q),re(C.browserEvent)||this.k.setSelection([q],C.browserEvent),this.g.fire(C)}v(C){if(R(C.browserEvent.target)||d(C.browserEvent.target)||this.q(C)||C.browserEvent.isHandledByList)return;C.browserEvent.isHandledByList=!0;const q=this.k.getFocus();this.k.setSelection(q,C.browserEvent)}w(C){const q=C.index;let $=this.k.getAnchor();if(this.p(C)){typeof $>"u"&&($=this.k.getFocus()[0]??q,this.k.setAnchor($));const W=Math.min($,q),_=Math.max($,q),p=(0,c.$Rb)(W,_+1),A=this.k.getSelection(),E=Se(Te(A,[$]),$);if(E.length===0)return;const M=Te(p,Fe(A,E));this.k.setSelection(M,C.browserEvent),this.k.setFocus([q],C.browserEvent)}else if(this.o(C)){const W=this.k.getSelection(),_=W.filter(p=>p!==q);this.k.setFocus([q]),this.k.setAnchor(q),W.length===_.length?this.k.setSelection([..._,q],C.browserEvent):this.k.setSelection(_,C.browserEvent)}}dispose(){this.f.dispose()}}t.$dR=ie;class oe{constructor(C,q){this.c=C,this.d=q}style(C){const q=this.d&&`.${this.d}`,$=[];C.listBackground&&$.push(`.monaco-list${q} .monaco-list-rows { background: ${C.listBackground}; }`),C.listFocusBackground&&($.push(`.monaco-list${q}:focus .monaco-list-row.focused { background-color: ${C.listFocusBackground}; }`),$.push(`.monaco-list${q}:focus .monaco-list-row.focused:hover { background-color: ${C.listFocusBackground}; }`)),C.listFocusForeground&&$.push(`.monaco-list${q}:focus .monaco-list-row.focused { color: ${C.listFocusForeground}; }`),C.listActiveSelectionBackground&&($.push(`.monaco-list${q}:focus .monaco-list-row.selected { background-color: ${C.listActiveSelectionBackground}; }`),$.push(`.monaco-list${q}:focus .monaco-list-row.selected:hover { background-color: ${C.listActiveSelectionBackground}; }`)),C.listActiveSelectionForeground&&$.push(`.monaco-list${q}:focus .monaco-list-row.selected { color: ${C.listActiveSelectionForeground}; }`),C.listActiveSelectionIconForeground&&$.push(`.monaco-list${q}:focus .monaco-list-row.selected .codicon { color: ${C.listActiveSelectionIconForeground}; }`),C.listFocusAndSelectionBackground&&$.push(`
				.monaco-drag-image,
				.monaco-list${q}:focus .monaco-list-row.selected.focused { background-color: ${C.listFocusAndSelectionBackground}; }
			`),C.listFocusAndSelectionForeground&&$.push(`
				.monaco-drag-image,
				.monaco-list${q}:focus .monaco-list-row.selected.focused { color: ${C.listFocusAndSelectionForeground}; }
			`),C.listInactiveFocusForeground&&($.push(`.monaco-list${q} .monaco-list-row.focused { color:  ${C.listInactiveFocusForeground}; }`),$.push(`.monaco-list${q} .monaco-list-row.focused:hover { color:  ${C.listInactiveFocusForeground}; }`)),C.listInactiveSelectionIconForeground&&$.push(`.monaco-list${q} .monaco-list-row.focused .codicon { color:  ${C.listInactiveSelectionIconForeground}; }`),C.listInactiveFocusBackground&&($.push(`.monaco-list${q} .monaco-list-row.focused { background-color:  ${C.listInactiveFocusBackground}; }`),$.push(`.monaco-list${q} .monaco-list-row.focused:hover { background-color:  ${C.listInactiveFocusBackground}; }`)),C.listInactiveSelectionBackground&&($.push(`.monaco-list${q} .monaco-list-row.selected { background-color:  ${C.listInactiveSelectionBackground}; }`),$.push(`.monaco-list${q} .monaco-list-row.selected:hover { background-color:  ${C.listInactiveSelectionBackground}; }`)),C.listInactiveSelectionForeground&&$.push(`.monaco-list${q} .monaco-list-row.selected { color: ${C.listInactiveSelectionForeground}; }`),C.listHoverBackground&&$.push(`.monaco-list${q}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${C.listHoverBackground}; }`),C.listHoverForeground&&$.push(`.monaco-list${q}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${C.listHoverForeground}; }`);const W=(0,v.$0P)(C.listFocusAndSelectionOutline,(0,v.$0P)(C.listSelectionOutline,C.listFocusOutline??""));W&&$.push(`.monaco-list${q}:focus .monaco-list-row.focused.selected { outline: 1px solid ${W}; outline-offset: -1px;}`),C.listFocusOutline&&$.push(`
				.monaco-drag-image,
				.monaco-list${q}:focus .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${q}.last-focused .monaco-list-row.focused { outline: 1px solid ${C.listFocusOutline}; outline-offset: -1px; }
			`);const _=(0,v.$0P)(C.listSelectionOutline,C.listInactiveFocusOutline??"");_&&$.push(`.monaco-list${q} .monaco-list-row.focused.selected { outline: 1px dotted ${_}; outline-offset: -1px; }`),C.listSelectionOutline&&$.push(`.monaco-list${q} .monaco-list-row.selected { outline: 1px dotted ${C.listSelectionOutline}; outline-offset: -1px; }`),C.listInactiveFocusOutline&&$.push(`.monaco-list${q} .monaco-list-row.focused { outline: 1px dotted ${C.listInactiveFocusOutline}; outline-offset: -1px; }`),C.listHoverOutline&&$.push(`.monaco-list${q} .monaco-list-row:hover { outline: 1px dashed ${C.listHoverOutline}; outline-offset: -1px; }`),C.listDropBackground&&$.push(`
				.monaco-list${q}.drop-target,
				.monaco-list${q} .monaco-list-rows.drop-target,
				.monaco-list${q} .monaco-list-row.drop-target { background-color: ${C.listDropBackground} !important; color: inherit !important; }
			`),C.tableColumnsBorder&&$.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${C.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),C.tableOddRowsBackgroundColor&&$.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${C.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=$.join(`
`)}}t.$eR=oe,t.$fR={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:f.$Ys.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:f.$Ys.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:f.$Ys.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const be={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function Se(Y,C){const q=Y.indexOf(C);if(q===-1)return[];const $=[];let W=q-1;for(;W>=0&&Y[W]===C-(q-W);)$.push(Y[W--]);for($.reverse(),W=q;W<Y.length&&Y[W]===C+(W-q);)$.push(Y[W++]);return $}function Te(Y,C){const q=[];let $=0,W=0;for(;$<Y.length||W<C.length;)if($>=Y.length)q.push(C[W++]);else if(W>=C.length)q.push(Y[$++]);else if(Y[$]===C[W]){q.push(Y[$]),$++,W++;continue}else Y[$]<C[W]?q.push(Y[$++]):q.push(C[W++]);return q}function Fe(Y,C){const q=[];let $=0,W=0;for(;$<Y.length||W<C.length;)if($>=Y.length)q.push(C[W++]);else if(W>=C.length)q.push(Y[$++]);else if(Y[$]===C[W]){$++,W++;continue}else Y[$]<C[W]?q.push(Y[$++]):W++;return q}const de=(Y,C)=>Y-C;class ne{constructor(C,q){this.c=C,this.d=q}get templateId(){return this.c}renderTemplate(C){return this.d.map(q=>q.renderTemplate(C))}renderElement(C,q,$,W){let _=0;for(const p of this.d)p.renderElement(C,q,$[_++],W)}disposeElement(C,q,$,W){let _=0;for(const p of this.d)p.disposeElement?.(C,q,$[_],W),_+=1}disposeTemplate(C){let q=0;for(const $ of this.d)$.disposeTemplate(C[q++])}}class ce{constructor(C){this.c=C,this.templateId="a18n"}renderTemplate(C){return C}renderElement(C,q,$){const W=this.c.getAriaLabel(C);W?$.setAttribute("aria-label",W):$.removeAttribute("aria-label");const _=this.c.getAriaLevel&&this.c.getAriaLevel(C);typeof _=="number"?$.setAttribute("aria-level",`${_}`):$.removeAttribute("aria-level")}disposeTemplate(C){}}class Z{constructor(C,q){this.c=C,this.d=q}getDragElements(C){const q=this.c.getSelectedElements();return q.indexOf(C)>-1?q:[C]}getDragURI(C){return this.d.getDragURI(C)}getDragLabel(C,q){if(this.d.getDragLabel)return this.d.getDragLabel(C,q)}onDragStart(C,q){this.d.onDragStart?.(C,q)}onDragOver(C,q,$,W){return this.d.onDragOver(C,q,$,W)}onDragLeave(C,q,$,W){this.d.onDragLeave?.(C,q,$,W)}onDragEnd(C){this.d.onDragEnd?.(C)}drop(C,q,$,W){this.d.drop(C,q,$,W)}dispose(){this.d.dispose()}}class V{get onDidChangeFocus(){return s.Event.map(this.g.wrapEvent(this.c.onChange),C=>this.G(C),this.y)}get onDidChangeSelection(){return s.Event.map(this.g.wrapEvent(this.d.onChange),C=>this.G(C),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let C=!1;const q=s.Event.chain(this.y.add(new T.$SQ(this.k.domNode,"keydown")).event,_=>_.map(p=>new i.$SO(p)).filter(p=>C=p.keyCode===58||p.shiftKey&&p.keyCode===68).map(p=>v.$MP.stop(p,!0)).filter(()=>!1)),$=s.Event.chain(this.y.add(new T.$SQ(this.k.domNode,"keyup")).event,_=>_.forEach(()=>C=!1).map(p=>new i.$SO(p)).filter(p=>p.keyCode===58||p.shiftKey&&p.keyCode===68).map(p=>v.$MP.stop(p,!0)).map(({browserEvent:p})=>{const A=this.getFocus(),E=A.length?A[0]:void 0,M=typeof E<"u"?this.k.element(E):void 0,k=typeof E<"u"?this.k.domElement(E):this.k.domNode;return{index:E,element:M,anchor:k,browserEvent:p}})),W=s.Event.chain(this.k.onContextMenu,_=>_.filter(p=>!C).map(({element:p,index:A,browserEvent:E})=>({element:p,index:A,anchor:new b.$NO(E),browserEvent:E})));return s.Event.any(q,$,W)}get onKeyDown(){return this.y.add(new T.$SQ(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new T.$SQ(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new T.$SQ(this.k.domNode,"keypress")).event}get onDidFocus(){return s.Event.signal(this.y.add(new T.$SQ(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return s.Event.signal(this.y.add(new T.$SQ(this.k.domNode,"blur",!0)).event)}constructor(C,q,$,W,_=be){this.A=C,this.B=_,this.c=new o("focused"),this.f=new o("anchor"),this.g=new s.$Vd,this.x="",this.y=new e.$Qc,this.z=new s.$Nd,this.onDidDispose=this.z.event;const p=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new F(p!=="listbox");const A=[this.c.renderer,this.d.renderer];this.u=_.accessibilityProvider,this.u&&(A.push(new ce(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),W=W.map(M=>new ne(M.templateId,[...A,M]));const E={..._,dnd:_.dnd&&new Z(this,_.dnd)};if(this.k=this.C(q,$,W,E),this.k.domNode.setAttribute("role",p),_.styleController)this.q=_.styleController(this.k.domId);else{const M=(0,v.$AP)(this.k.domNode);this.q=new oe(M,this.k.domId)}if(this.o=new y.$WQ([new j(this.c,this.k,_.identityProvider),new j(this.d,this.k,_.identityProvider),new j(this.f,this.k,_.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new O(this,this.k)),(typeof _.keyboardSupport!="boolean"||_.keyboardSupport)&&(this.v=new B(this,this.k,_),this.y.add(this.v)),_.keyboardNavigationLabelProvider){const M=_.keyboardNavigationDelegate||t.$aR;this.t=new P(this,this.k,_.keyboardNavigationLabelProvider,_.keyboardNavigationEventFilter??(()=>!0),M),this.y.add(this.t)}this.w=this.D(_),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(C,q,$,W){return new r.$9Q(C,q,$,W)}D(C){return new ie(this)}updateOptions(C={}){this.B={...this.B,...C},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(C),this.v?.updateOptions(C),this.k.updateOptions(C)}get options(){return this.B}splice(C,q,$=[]){if(C<0||C>this.k.length)throw new n.$YQ(this.A,`Invalid start index: ${C}`);if(q<0)throw new n.$YQ(this.A,`Invalid delete count: ${q}`);q===0&&$.length===0||this.g.bufferEvents(()=>this.o.splice(C,q,$))}updateWidth(C){this.k.updateWidth(C)}updateElementHeight(C,q){this.k.updateElementHeight(C,q,null)}rerender(){this.k.rerender()}element(C){return this.k.element(C)}indexOf(C){return this.k.indexOf(C)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(C){this.k.setScrollTop(C)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(C){this.k.setScrollLeft(C)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(C){this.x=C,this.k.domNode.setAttribute("aria-label",C)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(C,q){this.k.layout(C,q)}triggerTypeNavigation(){this.t?.trigger()}setSelection(C,q){for(const $ of C)if($<0||$>=this.length)throw new n.$YQ(this.A,`Invalid index ${$}`);this.d.set(C,q)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(C=>this.k.element(C))}setAnchor(C){if(typeof C>"u"){this.f.set([]);return}if(C<0||C>=this.length)throw new n.$YQ(this.A,`Invalid index ${C}`);this.f.set([C])}getAnchor(){return(0,c.$Nb)(this.f.get(),void 0)}getAnchorElement(){const C=this.getAnchor();return typeof C>"u"?void 0:this.element(C)}setFocus(C,q){for(const $ of C)if($<0||$>=this.length)throw new n.$YQ(this.A,`Invalid index ${$}`);this.c.set(C,q)}focusNext(C=1,q=!1,$,W){if(this.length===0)return;const _=this.c.get(),p=this.E(_.length>0?_[0]+C:0,q,W);p>-1&&this.setFocus([p],$)}focusPrevious(C=1,q=!1,$,W){if(this.length===0)return;const _=this.c.get(),p=this.F(_.length>0?_[0]-C:0,q,W);p>-1&&this.setFocus([p],$)}async focusNextPage(C,q){let $=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);$=$===0?0:$-1;const W=this.getFocus()[0];if(W!==$&&(W===void 0||$>W)){const _=this.F($,!1,q);_>-1&&W!==_?this.setFocus([_],C):this.setFocus([$],C)}else{const _=this.k.getScrollTop();let p=_+this.k.renderHeight;$>W&&(p-=this.k.elementHeight($)),this.k.setScrollTop(p),this.k.getScrollTop()!==_&&(this.setFocus([]),await(0,g.$Ug)(0),await this.focusNextPage(C,q))}}async focusPreviousPage(C,q){let $;const W=this.k.getScrollTop();W===0?$=this.k.indexAt(W):$=this.k.indexAfter(W-1);const _=this.getFocus()[0];if(_!==$&&(_===void 0||_>=$)){const p=this.E($,!1,q);p>-1&&_!==p?this.setFocus([p],C):this.setFocus([$],C)}else{const p=W;this.k.setScrollTop(W-this.k.renderHeight),this.k.getScrollTop()!==p&&(this.setFocus([]),await(0,g.$Ug)(0),await this.focusPreviousPage(C,q))}}focusLast(C,q){if(this.length===0)return;const $=this.F(this.length-1,!1,q);$>-1&&this.setFocus([$],C)}focusFirst(C,q){this.focusNth(0,C,q)}focusNth(C,q,$){if(this.length===0)return;const W=this.E(C,!1,$);W>-1&&this.setFocus([W],q)}E(C,q=!1,$){for(let W=0;W<this.length;W++){if(C>=this.length&&!q)return-1;if(C=C%this.length,!$||$(this.element(C)))return C;C++}return-1}F(C,q=!1,$){for(let W=0;W<this.length;W++){if(C<0&&!q)return-1;if(C=(this.length+C%this.length)%this.length,!$||$(this.element(C)))return C;C--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(C=>this.k.element(C))}reveal(C,q){if(C<0||C>=this.length)throw new n.$YQ(this.A,`Invalid index ${C}`);const $=this.k.getScrollTop(),W=this.k.elementTop(C),_=this.k.elementHeight(C);if((0,m.$Cf)(q)){const p=_-this.k.renderHeight;this.k.setScrollTop(p*(0,h.$Pl)(q,0,1)+W)}else{const p=W+_,A=$+this.k.renderHeight;W<$&&p>=A||(W<$||p>=A&&_>=this.k.renderHeight?this.k.setScrollTop(W):p>=A&&this.k.setScrollTop(p-this.k.renderHeight))}}getRelativeTop(C){if(C<0||C>=this.length)throw new n.$YQ(this.A,`Invalid index ${C}`);const q=this.k.getScrollTop(),$=this.k.elementTop(C),W=this.k.elementHeight(C);if($<q||$+W>q+this.k.renderHeight)return null;const _=W-this.k.renderHeight;return Math.abs((q-$)/_)}isDOMFocused(){return(0,v.$sP)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getElementID(C){return this.k.getElementDomId(C)}style(C){this.q.style(C)}G({indexes:C,browserEvent:q}){return{indexes:C,elements:C.map($=>this.k.element($)),browserEvent:q}}H(){const C=this.c.get();this.k.domNode.classList.toggle("element-focused",C.length>0),this.I()}I(){const C=this.c.get();if(C.length>0){let q;this.u?.getActiveDescendantId&&(q=this.u.getActiveDescendantId(this.k.element(C[0]))),this.k.domNode.setAttribute("aria-activedescendant",q||this.k.getElementDomId(C[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const C=this.d.get();this.k.domNode.classList.toggle("selection-none",C.length===0),this.k.domNode.classList.toggle("selection-single",C.length===1),this.k.domNode.classList.toggle("selection-multiple",C.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$gR=V,Ye([L.$ih],V.prototype,"onDidChangeFocus",null),Ye([L.$ih],V.prototype,"onDidChangeSelection",null),Ye([L.$ih],V.prototype,"onContextMenu",null),Ye([L.$ih],V.prototype,"onKeyDown",null),Ye([L.$ih],V.prototype,"onKeyUp",null),Ye([L.$ih],V.prototype,"onKeyPress",null),Ye([L.$ih],V.prototype,"onDidFocus",null),Ye([L.$ih],V.prototype,"onDidBlur",null)}),define($e[62],we([1,0,6,35,37,12,16]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$j=t.$0j=t.$9j=t.$8j=t.$7j=t.$6j=t.$5j=t.$4j=t.MarkdownStringTextNewlineStyle=void 0;var y;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(y||(t.MarkdownStringTextNewlineStyle=y={}));class c{constructor(m="",n=!1){if(this.value=m,typeof this.value!="string")throw(0,v.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(m,n=0){return this.value+=s(this.supportThemeIcons?(0,T.$Xj)(m):m).replace(/([ \t]+)/g,(r,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(m){return this.value+=m,this}appendCodeblock(m,n){return this.value+="\n```",this.value+=m,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(m,n,r){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(m),")"),r&&(this.value+=` "${this.c(this.c(r,'"'),")")}"`),this.value+=")",this}c(m,n){const r=new RegExp((0,U.$Fe)(n),"g");return m.replace(r,(b,u)=>m.charAt(u-1)!=="\\"?`\\${b}`:b)}}t.$4j=c;function g(l){return f(l)?!l.value:Array.isArray(l)?l.every(g):!0}t.$5j=g;function f(l){return l instanceof c?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}t.$6j=f;function L(l,m){return l===m?!0:!l||!m?!1:l.value===m.value&&l.isTrusted===m.isTrusted&&l.supportThemeIcons===m.supportThemeIcons&&l.supportHtml===m.supportHtml&&(l.baseUri===m.baseUri||!!l.baseUri&&!!m.baseUri&&(0,i.$og)(w.URI.from(l.baseUri),w.URI.from(m.baseUri)))}t.$7j=L;function s(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$8j=s;function a(l){return l.replace(/"/g,"&quot;")}t.$9j=a;function e(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$0j=e;function h(l){const m=[],n=l.split("|").map(b=>b.trim());l=n[0];const r=n[1];if(r){const b=/height=(\d+)/.exec(r),u=/width=(\d+)/.exec(r),o=b?b[1]:"",F=u?u[1]:"",j=isFinite(parseInt(F)),R=isFinite(parseInt(o));j&&m.push(`width="${F}"`),R&&m.push(`height="${o}"`)}return{href:l,dimensions:m}}t.$$j=h}),define($e[124],we([1,0,3,116,22,55,15,20,117,6,4,62,35,77,28,2,79,53,30,51,37,12,16]),function(le,t,v,T,i,U,w,y,c,g,f,L,s,a,e,h,l,m,n,r,b,u,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nR=t.$mR=t.$lR=t.$kR=t.$jR=void 0;const F=Object.freeze({image:(Z,V,Y)=>{let C=[],q=[];return Z&&({href:Z,dimensions:C}=(0,L.$$j)(Z),q.push(`src="${(0,L.$9j)(Z)}"`)),Y&&q.push(`alt="${(0,L.$9j)(Y)}"`),V&&q.push(`title="${(0,L.$9j)(V)}"`),C.length&&(q=q.concat(C)),"<img "+q.join(" ")+">"},paragraph:Z=>`<p>${Z}</p>`,link:(Z,V,Y)=>typeof Z!="string"?"":(Z===Y&&(Y=(0,L.$0j)(Y)),V=typeof V=="string"?(0,L.$9j)((0,L.$0j)(V)):"",Z=(0,L.$0j)(Z),Z=Z.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${Z}" title="${V||Z}">${Y}</a>`)});function j(Z,V={},Y={}){const C=new h.$Qc;let q=!1;const $=(0,U.$RQ)(V),W=function(N){let z;try{z=(0,m.$mh)(decodeURIComponent(N))}catch{}return z?(z=(0,r.$0m)(z,x=>{if(Z.uris&&Z.uris[x])return o.URI.revive(Z.uris[x])}),encodeURIComponent(JSON.stringify(z))):N},_=function(N,z){const x=Z.uris&&Z.uris[N];let ee=o.URI.revive(x);return z?N.startsWith(n.Schemas.data+":")?N:(ee||(ee=o.URI.parse(N)),n.$cg.uriToBrowserUri(ee).toString(!0)):!ee||o.URI.parse(N).toString()===ee.toString()?N:(ee.query&&(ee=ee.with({query:W(ee.query)})),ee.toString())},p=new l.marked.Renderer;p.image=F.image,p.link=F.link,p.paragraph=F.paragraph;const A=[],E=[];if(V.codeBlockRendererSync?p.code=(N,z)=>{const x=a.$AM.nextId(),ee=V.codeBlockRendererSync(R(z),N);return E.push([x,ee]),`<div class="code" data-code="${x}">${(0,u.$Ee)(N)}</div>`}:V.codeBlockRenderer&&(p.code=(N,z)=>{const x=a.$AM.nextId(),ee=V.codeBlockRenderer(R(z),N);return A.push(ee.then(se=>[x,se])),`<div class="code" data-code="${x}">${(0,u.$Ee)(N)}</div>`}),V.actionHandler){const N=function(ee){let se=ee.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let ge=se.dataset.href;ge&&(Z.baseUri&&(ge=d(o.URI.from(Z.baseUri),ge)),V.actionHandler.callback(ge,ee))}catch(ge){(0,g.$Z)(ge)}finally{ee.preventDefault()}},z=V.actionHandler.disposables.add(new i.$SQ($,"click")),x=V.actionHandler.disposables.add(new i.$SQ($,"auxclick"));V.actionHandler.disposables.add(f.Event.any(z.event,x.event)(ee=>{const se=new y.$NO(ee);!se.leftButton&&!se.middleButton||N(se)})),V.actionHandler.disposables.add(v.$VO($,"keydown",ee=>{const se=new w.$SO(ee);!se.equals(10)&&!se.equals(3)||N(se)}))}Z.supportHtml||(Y.sanitizer=N=>(Z.isTrusted?N.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?N:"",Y.sanitize=!0,Y.silent=!0),Y.renderer=p;let M=Z.value??"";M.length>1e5&&(M=`${M.substr(0,1e5)}\u2026`),Z.supportThemeIcons&&(M=(0,s.$Yj)(M));let k;if(V.fillInIncompleteTokens){const N={...l.marked.defaults,...Y},z=l.marked.lexer(M,N),x=re(z);k=l.marked.parser(x,N)}else k=l.marked.parse(M,Y);Z.supportThemeIcons&&(k=(0,c.$hR)(k).map(z=>typeof z=="string"?z:z.outerHTML).join(""));const S=new DOMParser().parseFromString(D(Z,k),"text/html");if(S.body.querySelectorAll("img").forEach(N=>{const z=N.getAttribute("src");if(z){let x=z;try{Z.baseUri&&(x=d(o.URI.from(Z.baseUri),x))}catch{}N.src=_(x,!0)}}),S.body.querySelectorAll("a").forEach(N=>{const z=N.getAttribute("href");if(N.setAttribute("href",""),!z||/^data:|javascript:/i.test(z)||/^command:/i.test(z)&&!Z.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(z))N.replaceWith(...N.childNodes);else{let x=_(z,!1);Z.baseUri&&(x=d(o.URI.from(Z.baseUri),z)),N.dataset.href=x}}),$.innerHTML=D(Z,S.body.innerHTML),A.length>0)Promise.all(A).then(N=>{if(q)return;const z=new Map(N),x=$.querySelectorAll("div[data-code]");for(const ee of x){const se=z.get(ee.dataset.code??"");se&&v.$TP(ee,se)}V.asyncRenderCallback?.()});else if(E.length>0){const N=new Map(E),z=$.querySelectorAll("div[data-code]");for(const x of z){const ee=N.get(x.dataset.code??"");ee&&v.$TP(x,ee)}}if(V.asyncRenderCallback)for(const N of $.getElementsByTagName("img")){const z=C.add(v.$VO(N,"load",()=>{z.dispose(),V.asyncRenderCallback()}))}return{element:$,dispose:()=>{q=!0,C.dispose()}}}t.$jR=j;function R(Z){if(!Z)return"";const V=Z.split(/[\s+|:|,|\{|\?]/,1);return V.length?V[0]:Z}function d(Z,V){return/^\w[\w\d+.-]*:/.test(V)?V:Z.path.endsWith("/")?(0,b.$yg)(Z,V).toString():(0,b.$yg)((0,b.$ug)(Z),V).toString()}function D(Z,V){const{config:Y,allowedSchemes:C}=B(Z);T.addHook("uponSanitizeAttribute",($,W)=>{if(W.attrName==="style"||W.attrName==="class"){if($.tagName==="SPAN"){if(W.attrName==="style"){W.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(W.attrValue);return}else if(W.attrName==="class"){W.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(W.attrValue);return}}W.keepAttr=!1;return}});const q=v.$bQ(C);try{return T.sanitize(V,{...Y,RETURN_TRUSTED_TYPE:!0})}finally{T.removeHook("uponSanitizeAttribute"),q.dispose()}}t.$kR=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function B(Z){const V=[n.Schemas.http,n.Schemas.https,n.Schemas.mailto,n.Schemas.data,n.Schemas.file,n.Schemas.vscodeFileResource,n.Schemas.vscodeRemote,n.Schemas.vscodeRemoteResource];return Z.isTrusted&&V.push(n.Schemas.command),{config:{ALLOWED_TAGS:[...v.$cQ],ALLOWED_ATTR:t.$kR,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:V}}function H(Z){return typeof Z=="string"?Z:X(Z)}t.$lR=H;function X(Z){let V=Z.value??"";V.length>1e5&&(V=`${V.substr(0,1e5)}\u2026`);const Y=l.marked.parse(V,{renderer:O.value}).replace(/&(#\d+|[a-zA-Z]+);/g,C=>P.get(C)??C);return D({isTrusted:!1},Y).toString()}t.$mR=X;const P=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),O=new e.$U(()=>{const Z=new l.marked.Renderer;return Z.code=V=>V,Z.blockquote=V=>V,Z.html=V=>"",Z.heading=(V,Y,C)=>V+`
`,Z.hr=()=>"",Z.list=(V,Y)=>V,Z.listitem=V=>V+`
`,Z.paragraph=V=>V+`
`,Z.table=(V,Y)=>V+Y+`
`,Z.tablerow=V=>V,Z.tablecell=(V,Y)=>V+" ",Z.strong=V=>V,Z.em=V=>V,Z.codespan=V=>V,Z.br=()=>`
`,Z.del=V=>V,Z.image=(V,Y,C)=>"",Z.text=V=>V,Z.link=(V,Y,C)=>C,Z});function Q(Z){let V="";return Z.forEach(Y=>{V+=Y.raw}),V}function te(Z){for(const V of Z.tokens)if(V.type==="text"){const Y=V.raw.split(`
`),C=Y[Y.length-1];if(C.includes("`"))return ie(Z);if(C.includes("**"))return Fe(Z);if(C.match(/\*\w/))return oe(Z);if(C.match(/(^|\s)__\w/))return de(Z);if(C.match(/(^|\s)_\w/))return be(Z);if(C.match(/(^|\s)\[.*\]\(\w*/))return Se(Z);if(C.match(/(^|\s)\[\w/))return Te(Z)}}function re(Z){let V,Y;for(V=0;V<Z.length;V++){const C=Z[V];if(C.type==="paragraph"&&C.raw.match(/(\n|^)```/)){Y=fe(Z.slice(V));break}if(C.type==="paragraph"&&C.raw.match(/(\n|^)\|/)){Y=ce(Z.slice(V));break}if(V===Z.length-1&&C.type==="paragraph"){const q=te(C);if(q){Y=[q];break}}}if(Y){const C=[...Z.slice(0,V),...Y];return C.links=Z.links,C}return Z}t.$nR=re;function fe(Z){const V=Q(Z);return l.marked.lexer(V+"\n```")}function ie(Z){return ne(Z,"`")}function oe(Z){return ne(Z,"*")}function be(Z){return ne(Z,"_")}function Se(Z){return ne(Z,")")}function Te(Z){return ne(Z,"](about:blank)")}function Fe(Z){return ne(Z,"**")}function de(Z){return ne(Z,"__")}function ne(Z,V){const Y=Q(Array.isArray(Z)?Z:[Z]);return l.marked.lexer(Y+V)[0]}function ce(Z){const V=Q(Z),Y=V.split(`
`);let C,q=!1;for(let $=0;$<Y.length;$++){const W=Y[$].trim();if(typeof C>"u"&&W.match(/^\s*\|/)){const _=W.match(/(\|[^\|]+)(?=\||$)/g);_&&(C=_.length)}else if(typeof C=="number")if(W.match(/^\s*\|/)){if($!==Y.length-1)return;q=!0}else return}if(typeof C=="number"&&C>0){const $=q?Y.slice(0,-1).join(`
`):V,W=!!$.match(/\|\s*$/),_=$+(W?"":"|")+`
|${" --- |".repeat(C)}`;return l.marked.lexer(_)}}}),define($e[125],we([1,0,3,9,29,62,35,2,7,106]),function(le,t,v,T,i,U,w,y,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JQ=t.$IQ=void 0;function f(a,e){(0,c.$yf)(e)?a.title=(0,w.$Zj)(e):e?.markdownNotSupportedFallback?a.title=e.markdownNotSupportedFallback:a.removeAttribute("title")}t.$IQ=f;class L{constructor(e,h,l){this.c=e,this.d=h,this.f=l}async update(e,h,l){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let m;if(e===void 0||(0,c.$yf)(e)||e instanceof HTMLElement)m=e;else if(!(0,c.$Mf)(e.markdown))m=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,g.localize)(0,null),h),this.b=new i.$Xd;const n=this.b.token;if(m=await e.markdown(n),m===void 0&&(m=e.markdownNotSupportedFallback),this.isDisposed||n.isCancellationRequested)return}this.g(m,h,l)}g(e,h,l){const m=this.a;if(this.h(e)){const n={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!m,...l};this.a=this.c.showHover(n,h)}m?.dispose()}h(e){return e?(0,U.$6j)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function s(a,e,h,l){let m,n;const r=(j,R)=>{const d=n!==void 0;j&&(n?.dispose(),n=void 0),R&&(m?.dispose(),m=void 0),d&&a.onDidHideHover?.()},b=(j,R,d)=>new T.$5g(async()=>{(!n||n.isDisposed)&&(n=new L(a,d||e,j>0),await n.update(h,R,l))},j),u=()=>{if(m)return;const j=new y.$Qc,R=B=>r(!1,B.fromElement===e);j.add(v.$VO(e,v.$KP.MOUSE_LEAVE,R,!0));const d=()=>r(!0,!0);j.add(v.$VO(e,v.$KP.MOUSE_DOWN,d,!0));const D={targetElements:[e],dispose:()=>{}};if(a.placement===void 0||a.placement==="mouse"){const B=H=>{D.x=H.x+10,H.target instanceof HTMLElement&&H.target.classList.contains("action-label")&&r(!0,!0)};j.add(v.$VO(e,v.$KP.MOUSE_MOVE,B,!0))}j.add(b(a.delay,!1,D)),m=j},o=v.$VO(e,v.$KP.MOUSE_OVER,u,!0);return{show:j=>{r(!1,!0),b(0,j)},hide:()=>{r(!0,!0)},update:async(j,R)=>{h=j,await n?.update(h,void 0,R)},dispose:()=>{o.dispose(),r(!0,!0)}}}t.$JQ=s}),define($e[126],we([1,0,3,22,15,124,39,11,4,44,2,5,108,99]),function(le,t,v,T,i,U,w,y,c,g,f,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oR=void 0;const a=v.$,e="selectOption.entry.template";class h{get templateId(){return e}renderTemplate(n){const r=Object.create(null);return r.root=n,r.text=v.$RP(n,a(".option-text")),r.detail=v.$RP(n,a(".option-detail")),r.decoratorRight=v.$RP(n,a(".option-decorator-right")),r}renderElement(n,r,b){const u=b,o=n.text,F=n.detail,j=n.decoratorRight,R=n.isDisabled;u.text.textContent=o,u.detail.textContent=F||"",u.decoratorRight.innerText=j||"",R?u.root.classList.add("option-disabled"):u.root.classList.remove("option-disabled")}disposeTemplate(n){}}class l extends f.$Rc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(n,r,b,u,o){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=u,this.g=o||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=l.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new c.$Nd,this.B(this.r),this.O(),this.N(b),this.n=r||0,n&&this.setOptions(n,r),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(n){this.u=n,this.w=v.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=v.$RP(this.w,a(".select-box-details-pane"));const r=v.$RP(this.w,a(".select-box-dropdown-container-width-control")),b=v.$RP(r,a(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",v.$RP(b,this.D),this.G=0,this.y=v.$AP(this.w),this.w.setAttribute("draggable","true"),this.B(v.$VO(this.w,v.$KP.DRAG_START,u=>{v.$MP.stop(u,!0)}))}O(){this.B(v.$WO(this.h,"change",r=>{this.n=r.target.selectedIndex,this.r.fire({index:r.target.selectedIndex,selected:r.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(v.$VO(this.h,v.$KP.CLICK,r=>{v.$MP.stop(r),this.f?this.X(!0):this.W()})),this.B(v.$VO(this.h,v.$KP.MOUSE_DOWN,r=>{v.$MP.stop(r)}));let n;this.B(v.$VO(this.h,"touchstart",r=>{n=this.f})),this.B(v.$VO(this.h,"touchend",r=>{v.$MP.stop(r),n?this.X(!0):this.W()})),this.B(v.$VO(this.h,v.$KP.KEY_DOWN,r=>{const b=new i.$SO(r);let u=!1;L.$k?(b.keyCode===18||b.keyCode===16||b.keyCode===10||b.keyCode===3)&&(u=!0):(b.keyCode===18&&b.altKey||b.keyCode===16&&b.altKey||b.keyCode===10||b.keyCode===3)&&(u=!0),u&&(this.W(),v.$MP.stop(r,!0))}))}get onDidSelect(){return this.r.event}setOptions(n,r){y.$tb(this.m,n)||(this.m=n,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((b,u)=>{this.h.add(this.U(b.text,u,b.isDisabled)),typeof b.description=="string"&&(this.H=!0)})),r!==void 0&&(this.select(r),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(n){n>=0&&n<this.m.length?this.n=n:n>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(n){this.g.ariaLabel=n,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(n){this.h.tabIndex=n?0:-1}render(n){this.j=n,n.classList.add("select-container"),n.appendChild(this.h),this.R()}Q(){const n=[];this.s.listFocusBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(n.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),n.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&n.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),n.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=n.join(`
`)}R(){const n=this.s.selectBackground??"",r=this.s.selectForeground??"",b=this.s.selectBorder??"";this.h.style.backgroundColor=n,this.h.style.color=r,this.h.style.borderColor=b}S(){const n=this.s.selectBackground??"",r=v.$0P(this.s.selectListBackground,n);this.C.style.backgroundColor=r,this.I.style.backgroundColor=r;const b=this.s.focusBorder??"";this.w.style.outlineColor=b,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(n,r,b){const u=document.createElement("option");return u.value=n,u.text=n,u.disabled=!!b,u}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:n=>this.Y(n),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(n){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),n&&this.h.focus(),this.u.hideContextView())}Y(n,r){return n.appendChild(this.w),this.ab(r),{dispose:()=>{try{n.removeChild(this.w)}catch{}}}}Z(){let n=0;return this.m.forEach((r,b)=>{this.hb(b),this.I.offsetHeight>n&&(n=this.I.offsetHeight)}),n}ab(n){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const r=v.$xP(this.h),b=v.$bP(this.h),u=getComputedStyle(this.h),o=parseFloat(u.getPropertyValue("--dropdown-padding-top"))+parseFloat(u.getPropertyValue("--dropdown-padding-bottom")),F=r.innerHeight-b.top-b.height-(this.g.minBottomMargin||0),j=b.top-l.b,R=this.h.offsetWidth,d=this.bb(this.D),D=Math.max(d,Math.round(R)).toString()+"px";this.w.style.width=D,this.z.getHTMLElement().style.height="",this.z.layout();let B=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const H=this.H?this.L:0,X=B+o+H,P=Math.floor((F-o-H)/this.getHeight()),O=Math.floor((j-o-H)/this.getHeight());if(n)return b.top+b.height>r.innerHeight-22||b.top<l.b||P<1&&O<1?!1:(P<l.c&&O>P&&this.m.length>P?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(b.top+b.height>r.innerHeight-22||b.top<l.b||this.G===0&&P<1||this.G===1&&O<1)return this.X(!0),!1;if(this.G===0){if(this.f&&P+O<1)return this.X(!0),!1;X>F&&(B=P*this.getHeight())}else X>j&&(B=O*this.getHeight());return this.z.layout(B),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=B+o+"px",this.w.style.height=""):this.w.style.height=B+o+"px",this.hb(this.n),this.w.style.width=D,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(n){let r=0;if(n){let b=0,u=0;this.m.forEach((o,F)=>{const j=o.detail?o.detail.length:0,R=o.decoratorRight?o.decoratorRight.length:0,d=o.text.length+j+R;d>u&&(b=F,u=d)}),n.textContent=this.m[b].text+(this.m[b].decoratorRight?this.m[b].decoratorRight+" ":""),r=v.$dP(n)}return r}cb(n){if(this.z)return;this.C=v.$RP(n,a(".select-box-dropdown-list-container")),this.t=new h,this.z=new w.$gR("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:u=>{let o=u.text;return u.detail&&(o+=`. ${u.detail}`),u.decoratorRight&&(o+=`. ${u.decoratorRight}`),u.description&&(o+=`. ${u.description}`),o},getWidgetAriaLabel:()=>(0,s.localize)(0,null),getRole:()=>L.$k?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const r=this.B(new T.$SQ(this.C,"keydown")),b=c.Event.chain(r.event,u=>u.filter(()=>this.z.length>0).map(o=>new i.$SO(o)));this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===3))(this.jb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===2))(this.jb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===9))(this.ib,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===16))(this.lb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===18))(this.kb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===12))(this.nb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===11))(this.mb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===14))(this.ob,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode===13))(this.pb,this)),this.B(c.Event.chain(b,u=>u.filter(o=>o.keyCode>=21&&o.keyCode<=56||o.keyCode>=85&&o.keyCode<=113))(this.qb,this)),this.B(v.$VO(this.z.getHTMLElement(),v.$KP.POINTER_UP,u=>this.db(u))),this.B(this.z.onMouseOver(u=>typeof u.index<"u"&&this.z.setFocus([u.index]))),this.B(this.z.onDidChangeFocus(u=>this.gb(u))),this.B(v.$VO(this.w,v.$KP.FOCUS_OUT,u=>{!this.f||v.$jP(u.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(n){if(!this.z.length)return;v.$MP.stop(n);const r=n.target;if(!r||r.classList.contains("slider"))return;const b=r.closest(".monaco-list-row");if(!b)return;const u=Number(b.getAttribute("data-index")),o=b.classList.contains("option-disabled");u>=0&&u<this.m.length&&!o&&(this.n=u,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(n,r){const b=o=>{for(let F=0;F<o.childNodes.length;F++){const j=o.childNodes.item(F);(j.tagName&&j.tagName.toLowerCase())==="img"?o.removeChild(j):b(j)}},u=(0,U.$jR)({value:n,supportThemeIcons:!0},{actionHandler:r});return u.element.classList.add("select-box-description-markdown"),b(u.element),u.element}gb(n){!this.f||!this.H||this.hb(n.indexes[0])}hb(n){this.I.innerText="";const r=this.m[n],b=r?.description??"",u=r?.descriptionIsMarkdown??!1;if(b){if(u){const o=r.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(b,o))}else this.I.innerText=b;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(n){v.$MP.stop(n),this.select(this.F),this.X(!0)}jb(n){v.$MP.stop(n),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(n){if(this.n<this.m.length-1){v.$MP.stop(n,!0);const r=this.m[this.n+1].isDisabled;if(r&&this.m.length>this.n+2)this.n+=2;else{if(r)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(n){this.n>0&&(v.$MP.stop(n,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(n){v.$MP.stop(n),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(n){v.$MP.stop(n),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(n){v.$MP.stop(n),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(n){v.$MP.stop(n),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(n){const r=g.KeyCodeUtils.toString(n.keyCode);let b=-1;for(let u=0;u<this.m.length-1;u++)if(b=(u+this.n+1)%this.m.length,this.m[b].text.charAt(0).toUpperCase()===r&&!this.m[b].isDisabled){this.select(b),this.z.setFocus([b]),this.z.reveal(this.z.getFocus()[0]),v.$MP.stop(n);break}}dispose(){this.X(!1),super.dispose()}}t.$oR=l}),define($e[127],we([1,0,39,126,120,21,5,98]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rR=t.$qR=void 0,t.$qR={...v.$fR,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class y extends U.$sQ{constructor(g,f,L,s,a){super(),w.$k&&!a?.useCustomDrawn?this.a=new i.$pR(g,f,s,a):this.a=new T.$oR(g,f,L,s,a),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(g,f){this.a.setOptions(g,f)}select(g){this.a.select(g)}setAriaLabel(g){this.a.setAriaLabel(g)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(g){this.a.setFocusable(g)}render(g){this.a.render(g)}}t.$rR=y}),define($e[63],we([1,0,17,54,3,24,125,127,36,2,5,7,103,52]),function(le,t,v,T,i,U,w,y,c,g,f,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yR=t.$xR=t.$wR=void 0;class a extends g.$Rc{get action(){return this._action}constructor(m,n,r={}){super(),this.m=r,this._context=m||this,this._action=n,n instanceof c.$vi&&this.B(n.onDidChange(b=>{this.element&&this.t(b)}))}t(m){m.enabled!==void 0&&this.u(),m.checked!==void 0&&this.G(),m.class!==void 0&&this.F(),m.label!==void 0&&(this.w(),this.C()),m.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new c.$wi)),this.j}set actionRunner(m){this.j=m}isEnabled(){return this._action.enabled}setActionContext(m){this._context=m}render(m){const n=this.element=m;this.B(U.$oQ.addTarget(m));const r=this.m&&this.m.draggable;r&&(m.draggable=!0,v.$BO&&this.B((0,i.$VO)(m,i.$KP.DRAG_START,b=>b.dataTransfer?.setData(T.$mQ.TEXT,this._action.label)))),this.B((0,i.$VO)(n,U.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,i.$VO)(n,i.$KP.MOUSE_DOWN,b=>{r||i.$MP.stop(b,!0),this._action.enabled&&b.button===0&&n.classList.add("active")})),f.$k&&this.B((0,i.$VO)(n,i.$KP.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,i.$VO)(n,i.$KP.CLICK,b=>{i.$MP.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,i.$VO)(n,i.$KP.DBLCLICK,b=>{i.$MP.stop(b,!0)})),[i.$KP.MOUSE_UP,i.$KP.MOUSE_OUT].forEach(b=>{this.B((0,i.$VO)(n,b,u=>{i.$MP.stop(u),n.classList.remove("active")}))})}onClick(m,n=!1){i.$MP.stop(m,!0);const r=L.$Hf(this._context)?this.m?.useEventAsContext?m:{preserveFocus:n}:this._context;this.actionRunner.run(this._action,r)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(m){this.element&&(this.element.tabIndex=m?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const m=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(m):(this.f=(0,w.$JQ)(this.m.hoverDelegate,this.element,m),this.q.add(this.f))):this.element.title=m}D(){if(this.element){const m=this.z()??"";this.element.setAttribute("aria-label",m)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$wR=a;class e extends a{constructor(m,n,r){super(m,n,r),this.m=r,this.m.icon=r.icon!==void 0?r.icon:!1,this.m.label=r.label!==void 0?r.label:!0,this.J=""}render(m){super.render(m),L.$If(this.element);const n=document.createElement("a");if(n.classList.add("action-label"),n.setAttribute("role",this.L()),this.H=n,this.element.appendChild(n),this.m.label&&this.m.keybinding){const r=document.createElement("span");r.classList.add("keybinding"),r.textContent=this.m.keybinding,this.element.appendChild(r)}this.F(),this.w(),this.C(),this.u(),this.G()}L(){return this._action.id===c.$xi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.H&&(this.H.tabIndex=0,this.H.focus())}isFocused(){return!!this.H&&this.H?.tabIndex===0}blur(){this.H&&(this.H.tabIndex=-1)}setFocusable(m){this.H&&(this.H.tabIndex=m?0:-1)}w(){this.m.label&&this.H&&(this.H.textContent=this.action.label)}z(){let m=null;return this.action.tooltip?m=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(m=this.action.label,this.m.keybinding&&(m=s.localize(0,null,m,this.m.keybinding))),m??void 0}F(){this.J&&this.H&&this.H.classList.remove(...this.J.split(" ")),this.m.icon?(this.J=this.action.class,this.H&&(this.H.classList.add("codicon"),this.J&&this.H.classList.add(...this.J.split(" "))),this.u()):this.H?.classList.remove("codicon")}u(){this.action.enabled?(this.H&&(this.H.removeAttribute("aria-disabled"),this.H.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.H&&(this.H.setAttribute("aria-disabled","true"),this.H.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.H){const m=this.z()??"";this.H.setAttribute("aria-label",m)}}G(){this.H&&(this.action.checked!==void 0?(this.H.classList.toggle("checked",this.action.checked),this.H.setAttribute("aria-checked",this.action.checked?"true":"false"),this.H.setAttribute("role","checkbox")):(this.H.classList.remove("checked"),this.H.setAttribute("aria-checked",""),this.H.setAttribute("role",this.L())))}}t.$xR=e;class h extends a{constructor(m,n,r,b,u,o,F){super(m,n),this.b=new y.$rR(r,b,u,o,F),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(m,n){this.b.setOptions(m,n)}select(m){this.b.select(m)}g(){this.B(this.b.onDidSelect(m=>this.n(m.selected,m.index)))}n(m,n){this.actionRunner.run(this._action,this.r(m,n))}r(m,n){return m}setFocusable(m){this.b.setFocusable(m)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(m){this.b.render(m)}}t.$yR=h}),define($e[64],we([1,0,3,15,63,36,4,2,7,52]),function(le,t,v,T,i,U,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LQ=t.$KQ=t.ActionsOrientation=void 0;var g;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(g||(t.ActionsOrientation=g={}));class f extends y.$Rc{constructor(a,e={}){super(),this.g=this.B(new y.$Qc),this.r=this.B(new y.$Zc),this.w=!1,this.y=!0,this.C=this.B(new w.$Nd),this.onDidBlur=this.C.event,this.D=this.B(new w.$Nd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new w.$Nd),this.onDidRun=this.G.event,this.H=this.B(new w.$Nd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new U.$wi,this.g.add(this.f)),this.g.add(this.f.onDidRun(m=>this.G.fire(m))),this.g.add(this.f.onWillRun(m=>this.H.fire(m))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let h,l;switch(this.m){case 0:h=[15],l=[17];break;case 1:h=[16],l=[18],this.domNode.className+=" vertical";break}this.B(v.$VO(this.domNode,v.$KP.KEY_DOWN,m=>{const n=new T.$SO(m);let r=!0;const b=typeof this.t=="number"?this.viewItems[this.t]:void 0;h&&(n.equals(h[0])||n.equals(h[1]))?r=this.P():l&&(n.equals(l[0])||n.equals(l[1]))?r=this.O():n.equals(9)&&this.F?this.D.fire():n.equals(14)?r=this.M():n.equals(13)?r=this.N():n.equals(2)&&b instanceof i.$wR&&b.trapsArrowNavigation?r=this.O():this.J(n)?this.n.keyDown?this.R(n):this.w=!0:r=!1,r&&(n.preventDefault(),n.stopPropagation())})),this.B(v.$VO(this.domNode,v.$KP.KEY_UP,m=>{const n=new T.$SO(m);this.J(n)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(n)),n.preventDefault(),n.stopPropagation()):(n.equals(2)||n.equals(1026))&&this.L()})),this.u=this.B(v.$PP(this.domNode)),this.B(this.u.onDidBlur(()=>{(v.$rP()===this.domNode||!v.$jP(v.$rP(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),a.appendChild(this.domNode)}I(){this.length()>=2?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(a){a?this.z.setAttribute("aria-label",a):this.z.removeAttribute("aria-label")}setFocusable(a){if(this.y=a,this.y){const e=this.viewItems.find(h=>h instanceof i.$wR&&h.isEnabled());e instanceof i.$wR&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.$wR&&e.setFocusable(!1)})}J(a){let e=!1;return this.n.keys.forEach(h=>{e=e||a.equals(h)}),e}L(){for(let a=0;a<this.z.children.length;a++){const e=this.z.children[a];if(v.$jP(v.$rP(),e)){this.t=a,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(a){this.j=a,this.viewItems.forEach(e=>e.setActionContext(a))}get actionRunner(){return this.f}set actionRunner(a){this.f=a,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=a)}getContainer(){return this.domNode}hasAction(a){return this.viewItems.findIndex(e=>e.action.id===a.id)!==-1}getAction(a){if(typeof a=="number")return this.viewItems[a]?.action;if(a instanceof HTMLElement){for(;a.parentElement!==this.z;){if(!a.parentElement)return;a=a.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===a)return this.viewItems[e].action}}push(a,e={}){const h=Array.isArray(a)?a:[a];let l=c.$Cf(e.index)?e.index:null;h.forEach(m=>{const n=document.createElement("li");n.className="action-item",n.setAttribute("role","presentation");let r;const b={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(r=this.b.actionViewItemProvider(m,b)),r||(r=new i.$xR(this.context,m,b)),this.b.allowContextMenu||this.r.set(r,v.$VO(n,v.$KP.CONTEXT_MENU,u=>{v.$MP.stop(u,!0)})),r.actionRunner=this.f,r.setActionContext(this.context),r.render(n),this.y&&r instanceof i.$wR&&this.viewItems.length===0&&r.setFocusable(!0),l===null||l<0||l>=this.z.children.length?(this.z.appendChild(n),this.viewItems.push(r)):(this.z.insertBefore(n,this.z.children[l]),this.viewItems.splice(l,0,r),l++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientWidth}return 0}getHeight(a){if(a>=0&&a<this.z.children.length){const e=this.z.children.item(a);if(e)return e.clientHeight}return 0}pull(a){a>=0&&a<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[a]),this.r.deleteAndDispose(this.viewItems[a]),(0,y.$Mc)(this.viewItems.splice(a,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,y.$Mc)(this.viewItems),this.r.clearAndDisposeAll(),v.$UO(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(a){let e=!1,h;if(a===void 0?e=!0:typeof a=="number"?h=a:typeof a=="boolean"&&(e=a),e&&typeof this.t>"u"){const l=this.viewItems.findIndex(m=>m.isEnabled());this.t=l===-1?void 0:l,this.Q(void 0,void 0,!0)}else h!==void 0&&(this.t=h),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(a){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let h;do{if(!a&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,h=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===U.$xi.ID));return this.Q(),!0}P(a){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let h;do{if(this.t=this.t-1,this.t<0){if(!a&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}h=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!h.isEnabled()||h.action.id===U.$xi.ID));return this.Q(!0),!0}Q(a,e,h=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const l=this.t!==void 0?this.viewItems[this.t]:void 0;if(l){let m=!0;c.$Mf(l.focus)||(m=!1),this.b.focusOnlyEnabledItems&&c.$Mf(l.isEnabled)&&!l.isEnabled()&&(m=!1),l.action.id===U.$xi.ID&&(m=!1),m&&l.showHover?.(),m?(h||this.s!==this.t)&&(l.focus(a),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0)}}R(a){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof i.$wR){const h=e._context===null||e._context===void 0?a:e._context;this.run(e._action,h)}}async run(a,e){await this.f.run(a,e)}dispose(){this.j=void 0,this.viewItems=(0,y.$Mc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$KQ=f;function L(s){if(!s.length)return s;let a=-1;for(let h=0;h<s.length;h++)if(s[h].id!==U.$xi.ID){a=h;break}if(a===-1)return[];s=s.slice(a);for(let h=s.length-1;h>=0&&s[h].id===U.$xi.ID;h--)s.splice(h,1);let e=!1;for(let h=s.length-1;h>=0;h--){const l=s[h].id===U.$xi.ID;l&&!e?s.splice(h,1):l?l&&(e=!1):e=!0}return s}t.$LQ=L}),define($e[65],we([1,0,3,22,55,64,57,60,21,4,81,51,107,95]),function(le,t,v,T,i,U,w,y,c,g,f,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dS=t.$cS=t.$bS=t.MessageType=void 0;const a=v.$;var e;(function(m){m[m.INFO=1]="INFO",m[m.WARNING=2]="WARNING",m[m.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$bS={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class h extends c.$sQ{constructor(n,r,b){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new g.$Nd),this.onDidChange=this.O.event,this.P=this.B(new g.$Nd),this.onDidHeightChange=this.P.event,this.a=r,this.g=b,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=v.$RP(n,a(".monaco-inputbox.idle"));const u=this.g.flexibleHeight?"textarea":"input",o=v.$RP(this.element,a(".ibwrapper"));if(this.b=v.$RP(o,a(u+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=v.$RP(o,a("div.mirror")),this.y.innerText="\xA0",this.N=new y.$CQ(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),v.$RP(n,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const F=this.B(new T.$SQ(n.ownerDocument,"selectionchange")),j=g.Event.filter(F.event,()=>n.ownerDocument.getSelection()?.anchorNode===o);this.B(j(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new U.$KQ(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(n){this.n=n,this.b.setAttribute("placeholder",n)}setTooltip(n){this.r=n,this.b.title=n}setAriaLabel(n){this.s=n,n?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(n){this.b.value!==n&&(this.b.value=n,this.Y())}get step(){return this.b.step}set step(n){this.b.step=n}get height(){return typeof this.J=="number"?this.J:v.$hP(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return v.$sP(this.b)}select(n=null){this.b.select(),n&&(this.b.setSelectionRange(n.start,n.end),n.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(n){n?this.enable():this.disable()}get width(){return v.$dP(this.b)}set width(n){if(this.g.flexibleHeight&&this.g.flexibleWidth){let r=0;if(this.y){const b=parseFloat(this.y.style.paddingLeft||"")||0,u=parseFloat(this.y.style.paddingRight||"")||0;r=b+u}this.b.style.width=n-r+"px"}else this.b.style.width=n+"px";this.y&&(this.y.style.width=n+"px")}set paddingRight(n){this.b.style.width=`calc(100% - ${n}px)`,this.y&&(this.y.style.paddingRight=n+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const n=this.L,r=this.J,b=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:n,height:r}),this.N.setScrollPosition({scrollTop:b})}showMessage(n,r){if(this.w==="open"&&(0,L.$_m)(this.h,n))return;this.h=n,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(n.type));const b=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${v.$0P(b.border,"transparent")}`,this.h.content&&(this.hasFocus()||r)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let n=null;return this.t&&(n=this.t(this.value),n?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(n)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),n?.type}stylesForType(n){const r=this.g.inputBoxStyles;switch(n){case 1:return{border:r.inputValidationInfoBorder,background:r.inputValidationInfoBackground,foreground:r.inputValidationInfoForeground};case 2:return{border:r.inputValidationWarningBorder,background:r.inputValidationWarningBackground,foreground:r.inputValidationWarningForeground};default:return{border:r.inputValidationErrorBorder,background:r.inputValidationErrorBackground,foreground:r.inputValidationErrorForeground}}}U(n){switch(n){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let n;const r=()=>n.style.width=v.$dP(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:u=>{if(!this.h)return null;n=v.$RP(u,a(".monaco-inputbox-container")),r();const o={inline:!0,className:"monaco-inputbox-message"},F=this.h.formatContent?(0,i.$QQ)(this.h.content,o):(0,i.$PQ)(this.h.content,o);F.classList.add(this.U(this.h.type));const j=this.stylesForType(this.h.type);return F.style.backgroundColor=j.background??"",F.style.color=j.foreground??"",F.style.border=j.border?`1px solid ${j.border}`:"",v.$RP(n,F),null},onHide:()=>{this.w="closed"},layout:r});let b;this.h.type===3?b=s.localize(0,null,this.h.content):this.h.type===2?b=s.localize(1,null,this.h.content):b=s.localize(2,null,this.h.content),w.$UQ(b),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const n=this.value,b=n.charCodeAt(n.length-1)===10?" ":"";(n+b).replace(/\u000c/g,"")?this.y.textContent=n+b:this.y.innerText="\xA0",this.layout()}ab(){const n=this.g.inputBoxStyles,r=n.inputBackground??"",b=n.inputForeground??"",u=n.inputBorder??"";this.element.style.backgroundColor=r,this.element.style.color=b,this.b.style.backgroundColor="inherit",this.b.style.color=b,this.element.style.border=`1px solid ${v.$0P(u,"transparent")}`}layout(){if(!this.y)return;const n=this.L;this.L=v.$hP(this.y),n!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(n){const r=this.inputElement,b=r.selectionStart,u=r.selectionEnd,o=r.value;b!==null&&u!==null&&(this.value=o.substr(0,b)+n+o.substr(u),r.setSelectionRange(b+1,b+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$cS=h;class l extends h{constructor(n,r,b){const u=s.localize(3,null,"\u21C5"),o=s.localize(4,null,"\u21C5");super(n,r,b),this.db=this.B(new g.$Nd),this.onDidFocus=this.db.event,this.eb=this.B(new g.$Nd),this.onDidBlur=this.eb.event,this.bb=new f.$_R(b.history,100);const F=()=>{if(b.showHistoryHint&&b.showHistoryHint()&&!this.n.endsWith(u)&&!this.n.endsWith(o)&&this.bb.getHistory().length){const j=this.n.endsWith(")")?u:o,R=this.n+j;b.showPlaceholderOnFocus&&!v.$sP(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((j,R)=>{j.forEach(d=>{d.target.textContent||F()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>F()),this.F(this.b,()=>{const j=R=>{if(this.n.endsWith(R)){const d=this.n.slice(0,this.n.length-R.length);return b.showPlaceholderOnFocus?this.n=d:this.setPlaceHolder(d),!0}else return!1};j(o)||j(u)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(n){this.value&&(n||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(n){const r=this.getHistory();this.clearHistory(),n.forEach(b=>{this.bb.add(b)}),r.forEach(b=>{this.bb.add(b)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let n=this.jb();n&&(n=n===this.value?this.jb():n),this.value=n??"",w.$VQ(this.value?this.value:s.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let n=this.ib();n&&(n=n===this.value?this.ib():n),n&&(this.value=n,w.$VQ(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(n){super.setPlaceHolder(n),this.setTooltip(n)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let n=this.bb.current();return n||(n=this.bb.last(),this.bb.next()),n}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$dS=l}),define($e[66],we([1,0,63,21,18,19,4,3,100]),function(le,t,v,T,i,U,w,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vR=t.$uR=t.$tR=t.$sR=void 0,t.$sR={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class c extends v.$wR{constructor(s,a,e){super(s,a,e),this.a=this.B(new g({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:e.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:e.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:e.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(s){this.element=s,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(s){this.a.domNode.tabIndex=s?0:-1}}t.$tR=c;class g extends T.$sQ{constructor(s){super(),this.a=this.B(new w.$Nd),this.onChange=this.a.event,this.b=this.B(new w.$Nd),this.onKeyDown=this.b.event,this.c=s,this.s=this.c.isChecked;const a=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,a.push(...U.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&a.push(...this.c.actionClassName.split(" ")),this.s&&a.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...a),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,e=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),e.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this.s,this.a.fire(!0),e.preventDefault(),e.stopPropagation();return}this.b.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(s){this.s=s,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(s){this.g&&this.domNode.classList.remove(...U.ThemeIcon.asClassNameArray(this.g)),this.g=s,this.g&&this.domNode.classList.add(...U.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(s){this.domNode.title=s,this.domNode.setAttribute("aria-label",s)}}t.$uR=g;class f extends T.$sQ{constructor(s,a,e){super(),this.c=s,this.g=a,this.a=new g({title:this.c,isChecked:this.g,icon:i.$Vj.check,actionClassName:"monaco-checkbox",...t.$sR}),this.domNode=this.a.domNode,this.b=e,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(s){this.a.checked=s,this.h()}focus(){this.domNode.focus()}hasFocus(){return(0,y.$sP)(this.domNode)}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.$vR=f}),define($e[128],we([1,0,66,18,105]),function(le,t,v,T,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qS=t.$pS=t.$oS=void 0;const U=i.localize(0,null),w=i.localize(1,null),y=i.localize(2,null);class c extends v.$uR{constructor(s){super({icon:T.$Vj.caseSensitive,title:U+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$oS=c;class g extends v.$uR{constructor(s){super({icon:T.$Vj.wholeWord,title:w+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$pS=g;class f extends v.$uR{constructor(s){super({icon:T.$Vj.regex,title:y+s.appendTitle,isChecked:s.isChecked,inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$qS=f}),define($e[129],we([1,0,3,128,65,21,4,104,2,94]),function(le,t,v,T,i,U,w,y,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rS=void 0;const g=y.localize(0,null);class f extends U.$sQ{static{this.OPTION_CHANGE="optionChange"}constructor(s,a,e){super(),this.n=!0,this.s=!1,this.w=this.B(new c.$Sc),this.N=[],this.O=this.B(new w.$Nd),this.onDidOptionChange=this.O.event,this.P=this.B(new w.$Nd),this.onKeyDown=this.P.event,this.Q=this.B(new w.$Nd),this.onMouseDown=this.Q.event,this.R=this.B(new w.$Nd),this.onInput=this.R.event,this.S=this.B(new w.$Nd),this.onKeyUp=this.S.event,this.U=this.B(new w.$Nd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new w.$Nd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||g,this.h=!!e.showCommonFindToggles;const h=e.appendCaseSensitiveLabel||"",l=e.appendWholeWordsLabel||"",m=e.appendRegexLabel||"",n=e.history||[],r=!!e.flexibleHeight,b=!!e.flexibleWidth,u=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.$dS(this.domNode,a,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:n,showHistoryHint:e.showHistoryHint,flexibleHeight:r,flexibleWidth:b,flexibleMaxHeight:u,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new T.$qS({appendTitle:m,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(F=>{this.W.fire(F)})),this.L=this.B(new T.$pS({appendTitle:l,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new T.$oS({appendTitle:h,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(F=>{this.O.fire(F),!F&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(F=>{this.U.fire(F)}));const o=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,F=>{if(F.equals(15)||F.equals(17)||F.equals(9)){const j=o.indexOf(this.domNode.ownerDocument.activeElement);if(j>=0){let R=-1;F.equals(17)?R=(j+1)%o.length:F.equals(15)&&(j===0?R=o.length-1:R=j-1),F.equals(9)?(o[j].blur(),this.inputBox.focus()):R>=0&&o[R].focus(),v.$MP.stop(F,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),s?.appendChild(this.domNode),this.B(v.$VO(this.inputBox.inputElement,"compositionstart",o=>{this.s=!0})),this.B(v.$VO(this.inputBox.inputElement,"compositionend",o=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,o=>this.P.fire(o)),this.C(this.inputBox.inputElement,o=>this.S.fire(o)),this.D(this.inputBox.inputElement,o=>this.R.fire()),this.j(this.inputBox.inputElement,o=>this.Q.fire(o))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(s){this.inputBox.layout(),this.X(s.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const s of this.N)s.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const s of this.N)s.disable()}setFocusInputOnOptionClick(s){this.n=s}setEnabled(s){s?this.enable():this.disable()}setAdditionalToggles(s){for(const a of this.N)a.domNode.remove();this.N=[],this.w.value=new c.$Qc;for(const a of s??[])this.w.value.add(a),this.y.appendChild(a.domNode),this.w.value.add(a.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(a);this.N.length>0&&(this.y.style.display=""),this.X()}X(s=!1){s?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((a,e)=>a+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(s){this.inputBox.value!==s&&(this.inputBox.value=s)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(s){this.M&&(this.M.checked=s)}getWholeWords(){return this.L?.checked??!1}setWholeWords(s){this.L&&(this.L.checked=s)}getRegex(){return this.J?.checked??!1}setRegex(s){this.J&&(this.J.checked=s,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(s){this.inputBox.showMessage(s)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$rS=f}),define($e[130],we([1,0,3,22,15,64,129,65,61,39,66,58,25,36,11,9,18,19,32,4,34,2,46,7,109,101]),function(le,t,v,T,i,U,w,y,c,g,f,L,s,a,e,h,l,m,n,r,b,u,o,F,j){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2S=t.TreeFindMatchType=t.TreeFindMode=t.$1S=t.$ZS=t.RenderIndentGuides=t.$YS=t.$XS=void 0;class R extends c.$6Q{set context($){this.c.context=$}get context(){return this.c.context}constructor($){super($.elements.map(W=>W.element)),this.c=$}}function d(q){return q instanceof c.$6Q?new R(q):q}class D{constructor($,W){this.d=$,this.f=W,this.b=u.$Rc.None,this.c=new u.$Qc}getDragURI($){return this.f.getDragURI($.element)}getDragLabel($,W){if(this.f.getDragLabel)return this.f.getDragLabel($.map(_=>_.element),W)}onDragStart($,W){this.f.onDragStart?.(d($),W)}onDragOver($,W,_,p,A=!0){const E=this.f.onDragOver(d($),W&&W.element,_,p),M=this.a!==W;if(M&&(this.b.dispose(),this.a=W),typeof W>"u")return E;if(M&&typeof E!="boolean"&&E.autoExpand&&(this.b=(0,h.$Vg)(()=>{const z=this.d(),x=z.getNodeLocation(W);z.isCollapsed(x)&&z.setCollapsed(x,!1),this.a=void 0},500,this.c)),typeof E=="boolean"||!E.accept||typeof E.bubble>"u"||E.feedback){if(!A){const z=typeof E=="boolean"?E:E.accept,x=typeof E=="boolean"?void 0:E.effect;return{accept:z,effect:x,feedback:[_]}}return E}if(E.bubble===1){const z=this.d(),x=z.getNodeLocation(W),ee=z.getParentNodeLocation(x),se=z.getNode(ee),ge=ee&&z.getListIndex(ee);return this.onDragOver($,se,ge,p,!1)}const k=this.d(),I=k.getNodeLocation(W),S=k.getListIndex(I),N=k.getListRenderCount(I);return{...E,feedback:(0,e.$Rb)(S,S+N)}}drop($,W,_,p){this.b.dispose(),this.a=void 0,this.f.drop(d($),W&&W.element,_,p)}onDragEnd($){this.f.onDragEnd?.($)}dispose(){this.c.dispose(),this.f.dispose()}}function B(q,$){return $&&{...$,identityProvider:$.identityProvider&&{getId(W){return $.identityProvider.getId(W.element)}},dnd:$.dnd&&new D(q,$.dnd),multipleSelectionController:$.multipleSelectionController&&{isSelectionSingleChangeEvent(W){return $.multipleSelectionController.isSelectionSingleChangeEvent({...W,element:W.element})},isSelectionRangeChangeEvent(W){return $.multipleSelectionController.isSelectionRangeChangeEvent({...W,element:W.element})}},accessibilityProvider:$.accessibilityProvider&&{...$.accessibilityProvider,getSetSize(W){const _=q(),p=_.getNodeLocation(W),A=_.getParentNodeLocation(p);return _.getNode(A).visibleChildrenCount},getPosInSet(W){return W.visibleChildIndex+1},isChecked:$.accessibilityProvider&&$.accessibilityProvider.isChecked?W=>$.accessibilityProvider.isChecked(W.element):void 0,getRole:$.accessibilityProvider&&$.accessibilityProvider.getRole?W=>$.accessibilityProvider.getRole(W.element):()=>"treeitem",getAriaLabel(W){return $.accessibilityProvider.getAriaLabel(W.element)},getWidgetAriaLabel(){return $.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:$.accessibilityProvider&&$.accessibilityProvider.getWidgetRole?()=>$.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:$.accessibilityProvider&&$.accessibilityProvider.getAriaLevel?W=>$.accessibilityProvider.getAriaLevel(W.element):W=>W.depth,getActiveDescendantId:$.accessibilityProvider.getActiveDescendantId&&(W=>$.accessibilityProvider.getActiveDescendantId(W.element))},keyboardNavigationLabelProvider:$.keyboardNavigationLabelProvider&&{...$.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(W){return $.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(W.element)}}}}class H{constructor($){this.a=$}getHeight($){return this.a.getHeight($.element)}getTemplateId($){return this.a.getTemplateId($.element)}hasDynamicHeight($){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight($.element)}setDynamicHeight($,W){this.a.setDynamicHeight?.($.element,W)}}t.$XS=H;class X{static lift($){return $ instanceof X?$:new X($)}static empty($=0){return new X({focus:[],selection:[],expanded:Object.create(null),scrollTop:$})}constructor($){if(this.focus=new Set($.focus),this.selection=new Set($.selection),$.expanded instanceof Array){this.expanded=Object.create(null);for(const W of $.expanded)this.expanded[W]=1}else this.expanded=$.expanded;this.expanded=$.expanded,this.scrollTop=$.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$YS=X;var P;(function(q){q.None="none",q.OnHover="onHover",q.Always="always"})(P||(t.RenderIndentGuides=P={}));class O{get elements(){return this.b}constructor($,W=[]){this.b=W,this.a=new u.$Qc,this.onDidChange=r.Event.forEach($,_=>this.b=_,this.a)}dispose(){this.a.dispose()}}class Q{static{this.a=8}constructor($,W,_,p,A,E={}){this.o=$,this.p=W,this.q=p,this.s=A,this.b=new Map,this.c=new Map,this.d=Q.a,this.f=!1,this.g=!1,this.j=new Set,this.k=u.$Rc.None,this.m=new u.$Qc,this.templateId=$.templateId,this.updateOptions(E),r.Event.map(_,M=>M.node)(this.u,this,this.m),$.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions($={}){if(typeof $.indent<"u"){const W=(0,o.$Pl)($.indent,0,40);if(W!==this.d){this.d=W;for(const[_,p]of this.c)this.v(_,p)}}if(typeof $.renderIndentGuides<"u"){const W=$.renderIndentGuides!==P.None;if(W!==this.g){this.g=W;for(const[_,p]of this.c)this.w(_,p);if(this.k.dispose(),W){const _=new u.$Qc;this.q.onDidChange(this.x,this,_),this.k=_,this.x(this.q.elements)}}}typeof $.hideTwistiesOfChildlessElements<"u"&&(this.f=$.hideTwistiesOfChildlessElements)}renderTemplate($){const W=(0,v.$RP)($,(0,v.$)(".monaco-tl-row")),_=(0,v.$RP)(W,(0,v.$)(".monaco-tl-indent")),p=(0,v.$RP)(W,(0,v.$)(".monaco-tl-twistie")),A=(0,v.$RP)(W,(0,v.$)(".monaco-tl-contents")),E=this.o.renderTemplate(A);return{container:$,indent:_,twistie:p,indentGuidesDisposable:u.$Rc.None,templateData:E}}renderElement($,W,_,p){this.c.set($,_),this.b.set($.element,$),this.v($,_),this.o.renderElement($,W,_.templateData,p)}disposeElement($,W,_,p){_.indentGuidesDisposable.dispose(),this.o.disposeElement?.($,W,_.templateData,p),typeof p=="number"&&(this.c.delete($),this.b.delete($.element))}disposeTemplate($){this.o.disposeTemplate($.templateData)}t($){const W=this.b.get($);W&&this.u(W)}u($){const W=this.c.get($);W&&(this.x(this.q.elements),this.v($,W))}v($,W){const _=Q.a+($.depth-1)*this.d;W.twistie.style.paddingLeft=`${_}px`,W.indent.style.width=`${_+this.d-16}px`,$.collapsible?W.container.setAttribute("aria-expanded",String(!$.collapsed)):W.container.removeAttribute("aria-expanded"),W.twistie.classList.remove(...m.ThemeIcon.asClassNameArray(l.$Vj.treeItemExpanded));let p=!1;this.o.renderTwistie&&(p=this.o.renderTwistie($.element,W.twistie)),$.collapsible&&(!this.f||$.visibleChildrenCount>0)?(p||W.twistie.classList.add(...m.ThemeIcon.asClassNameArray(l.$Vj.treeItemExpanded)),W.twistie.classList.add("collapsible"),W.twistie.classList.toggle("collapsed",$.collapsed)):W.twistie.classList.remove("collapsible","collapsed"),this.w($,W)}w($,W){if((0,v.$UO)(W.indent),W.indentGuidesDisposable.dispose(),!this.g)return;const _=new u.$Qc,p=this.p();for(;;){const A=p.getNodeLocation($),E=p.getParentNodeLocation(A);if(!E)break;const M=p.getNode(E),k=(0,v.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(M)&&k.classList.add("active"),W.indent.childElementCount===0?W.indent.appendChild(k):W.indent.insertBefore(k,W.indent.firstElementChild),this.s.add(M,k),_.add((0,u.$Pc)(()=>this.s.delete(M,k))),$=M}W.indentGuidesDisposable=_}x($){if(!this.g)return;const W=new Set,_=this.p();$.forEach(p=>{const A=_.getNodeLocation(p);try{const E=_.getParentNodeLocation(A);p.collapsible&&p.children.length>0&&!p.collapsed?W.add(p):E&&W.add(_.getNode(E))}catch{}}),this.j.forEach(p=>{W.has(p)||this.s.forEach(p,A=>A.classList.remove("active"))}),W.forEach(p=>{this.j.has(p)||this.s.forEach(p,A=>A.classList.add("active"))}),this.j=W}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,u.$Mc)(this.m)}}class te{get totalCount(){return this.a}get matchCount(){return this.b}set pattern($){this.c=$,this.d=$.toLowerCase()}constructor($,W,_){this.g=$,this.j=W,this.k=_,this.a=0,this.b=0,this.c="",this.d="",this.f=new u.$Qc,$.onWillRefilter(this.m,this,this.f)}filter($,W){let _=1;if(this.k){const E=this.k.filter($,W);if(typeof E=="boolean"?_=E?1:0:(0,L.$US)(E)?_=(0,L.$VS)(E.visibility):_=E,_===0)return!1}if(this.a++,!this.c)return this.b++,{data:b.FuzzyScore.Default,visibility:_};const p=this.j.getKeyboardNavigationLabel($),A=Array.isArray(p)?p:[p];for(const E of A){const M=E&&E.toString();if(typeof M>"u")return{data:b.FuzzyScore.Default,visibility:_};let k;if(this.g.findMatchType===be.Contiguous){const I=M.toLowerCase().indexOf(this.d);if(I>-1){k=[Number.MAX_SAFE_INTEGER,0];for(let S=this.d.length;S>0;S--)k.push(I+S-1)}}else k=(0,b.$Qj)(this.c,this.d,0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(k)return this.b++,A.length===1?{data:k,visibility:_}:{data:{label:M,score:k},visibility:_}}return this.g.findMode===oe.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility($):2:{data:b.FuzzyScore.Default,visibility:_}}m(){this.a=0,this.b=0}dispose(){(0,u.$Mc)(this.f)}}class re extends f.$uR{constructor($){super({icon:l.$Vj.listFilter,title:(0,j.localize)(0,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$ZS=re;class fe extends f.$uR{constructor($){super({icon:l.$Vj.searchFuzzy,title:(0,j.localize)(1,null),isChecked:$.isChecked??!1,inputActiveOptionBorder:$.inputActiveOptionBorder,inputActiveOptionForeground:$.inputActiveOptionForeground,inputActiveOptionBackground:$.inputActiveOptionBackground})}}t.$1S=fe;const ie={inputBoxStyles:y.$bS,toggleStyles:f.$sR,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var oe;(function(q){q[q.Highlight=0]="Highlight",q[q.Filter=1]="Filter"})(oe||(t.TreeFindMode=oe={}));var be;(function(q){q[q.Fuzzy=0]="Fuzzy",q[q.Contiguous=1]="Contiguous"})(be||(t.TreeFindMatchType=be={}));class Se extends u.$Rc{set mode($){this.b.checked=$===oe.Filter,this.f.inputBox.setPlaceHolder($===oe.Filter?(0,j.localize)(2,null):(0,j.localize)(3,null))}set matchType($){this.c.checked=$===be.Fuzzy}get value(){return this.f.inputBox.value}set value($){this.f.inputBox.value=$}constructor($,W,_,p,A,E){super(),this.t=W,this.a=(0,v.h)(".monaco-tree-type-filter",[(0,v.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,v.h)(".monaco-tree-type-filter-input@findInput"),(0,v.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new r.$Nd,this.onDidDisable=this._onDidDisable.event,$.appendChild(this.a.root),this.B((0,u.$Pc)(()=>$.removeChild(this.a.root)));const M=E?.styles??ie;M.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=M.listFilterWidgetBackground),M.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${M.listFilterWidgetShadow}`),this.b=this.B(new re({...M.toggleStyles,isChecked:p===oe.Filter})),this.c=this.B(new fe({...M.toggleStyles,isChecked:A===be.Fuzzy})),this.onDidChangeMode=r.Event.map(this.b.onChange,()=>this.b.checked?oe.Filter:oe.Highlight,this.q),this.onDidChangeMatchType=r.Event.map(this.c.onChange,()=>this.c.checked?be.Fuzzy:be.Contiguous,this.q),this.f=this.B(new w.$rS(this.a.findInput,_,{label:(0,j.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:M.inputBoxStyles,toggleStyles:M.toggleStyles,history:E?.history})),this.g=this.B(new U.$KQ(this.a.actionbar)),this.mode=p;const k=this.B(new T.$SQ(this.f.inputBox.inputElement,"keydown")),I=r.Event.chain(k.event,x=>x.map(ee=>new i.$SO(ee)));this.B(I(x=>{if(x.equals(3)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(x.equals(18)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(x.equals(16)){x.preventDefault(),x.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const S=this.B(new a.$vi("close",(0,j.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(S,{icon:!0,label:!1});const N=this.B(new T.$SQ(this.a.grab,"mousedown"));this.B(N.event(x=>{const ee=new u.$Qc,se=ee.add(new T.$SQ((0,v.$xP)(x),"mousemove")),ge=ee.add(new T.$SQ((0,v.$xP)(x),"mouseup")),pe=this.m,Pe=x.pageX,Ae=this.s,De=x.pageY;this.a.grab.classList.add("grabbing");const Re=this.a.root.style.transition;this.a.root.style.transition="unset";const Oe=_e=>{const He=_e.pageX-Pe;this.m=pe-He;const Me=_e.pageY-De;this.s=Ae+Me,this.layout()};ee.add(se.event(Oe)),ee.add(ge.event(_e=>{Oe(_e),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Re,ee.dispose()}))}));const z=r.Event.chain(this.B(new T.$SQ(this.a.grab,"keydown")).event,x=>x.map(ee=>new i.$SO(ee)));this.B(z(x=>{let ee,se;if(x.keyCode===15?ee=Number.POSITIVE_INFINITY:x.keyCode===17?ee=0:x.keyCode===10&&(ee=this.m===0?Number.POSITIVE_INFINITY:0),x.keyCode===16?se=0:x.keyCode===18&&(se=Number.POSITIVE_INFINITY),ee!==void 0&&(x.preventDefault(),x.stopPropagation(),this.m=ee,this.layout()),se!==void 0){x.preventDefault(),x.stopPropagation(),this.s=se;const ge=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ge},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout($=this.j){this.j=$,this.m=(0,o.$Pl)(this.m,0,Math.max(0,$-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,o.$Pl)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage($){this.f.showMessage($)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,h.$Ug)(300),super.dispose()}}class Te{get pattern(){return this.b}get mode(){return this.d}set mode($){$!==this.d&&(this.d=$,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire($))}get matchType(){return this.f}set matchType($){$!==this.f&&(this.f=$,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire($))}constructor($,W,_,p,A,E={}){this.t=$,this.u=_,this.v=p,this.w=A,this.x=E,this.b="",this.c="",this.j=0,this.k=new r.$Nd,this.onDidChangeMode=this.k.event,this.m=new r.$Nd,this.onDidChangeMatchType=this.m.event,this.o=new r.$Nd,this.onDidChangePattern=this.o.event,this.p=new r.$Nd,this.onDidChangeOpenState=this.p.event,this.q=new u.$Qc,this.s=new u.$Qc,this.d=$.options.defaultFindMode??oe.Highlight,this.f=$.options.defaultFindMatchType??be.Fuzzy,W.onDidSplice(this.z,this,this.s)}updateOptions($={}){$.defaultFindMode!==void 0&&(this.mode=$.defaultFindMode),$.defaultFindMatchType!==void 0&&(this.matchType=$.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Se(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode($=>this.mode=$,void 0,this.q),this.g.onDidChangeMatchType($=>this.matchType=$,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y($){this.b=$,this.o.fire($),this.v.pattern=$,this.t.refilter(),$&&this.t.focusNext(0,!0,void 0,_=>!b.FuzzyScore.isDefault(_.filterData));const W=this.t.getFocus();if(W.length>0){const _=W[0];this.t.getRelativeTop(_)===null&&this.t.reveal(_,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const $=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&$?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,j.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus($){return!this.g||!this.pattern||this.d===oe.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!b.FuzzyScore.isDefault($.filterData)}layout($){this.j=$,this.g?.layout($)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Fe(q){let $=s.TreeMouseEventTarget.Unknown;return(0,v.$nP)(q.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?$=s.TreeMouseEventTarget.Twistie:(0,v.$nP)(q.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?$=s.TreeMouseEventTarget.Element:(0,v.$nP)(q.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&($=s.TreeMouseEventTarget.Filter),{browserEvent:q.browserEvent,element:q.element?q.element.element:null,target:$}}function de(q){return{element:q.element?q.element.element:null,browserEvent:q.browserEvent,anchor:q.anchor}}function ne(q,$){$(q),q.children.forEach(W=>ne(W,$))}class ce{get f(){return this.d||(this.d=this.m()),this.d}constructor($,W){this.g=$,this.j=W,this.a=[],this.c=new r.$Nd,this.onDidChange=this.c.event}set($,W){!W?.__forceEvent&&(0,e.$tb)(this.a,$)||this.k($,!1,W)}k($,W,_){if(this.a=[...$],this.b=void 0,this.d=void 0,!W){const p=this;this.c.fire({get elements(){return p.get()},browserEvent:_})}}get(){return this.b||(this.b=this.a.map($=>$.element)),[...this.b]}getNodes(){return this.a}has($){return this.f.has($)}onDidModelSplice({insertedNodes:$,deletedNodes:W}){if(!this.j){const k=this.m(),I=S=>k.delete(S);W.forEach(S=>ne(S,I)),this.set([...k.values()]);return}const _=new Set,p=k=>_.add(this.j.getId(k.element).toString());W.forEach(k=>ne(k,p));const A=new Map,E=k=>A.set(this.j.getId(k.element).toString(),k);$.forEach(k=>ne(k,E));const M=[];for(const k of this.a){const I=this.j.getId(k.element).toString();if(!_.has(I))M.push(k);else{const N=A.get(I);N&&N.visible&&M.push(N)}}if(this.a.length>0&&M.length===0){const k=this.g();k&&M.push(k)}this.k(M,!0)}m(){const $=new Set;for(const W of this.a)$.add(W);return $}}class Z extends g.$dR{constructor($,W){super($),this.x=W}u($){if((0,g.$_Q)($.browserEvent.target)||(0,g.$0Q)($.browserEvent.target)||(0,g.$$Q)($.browserEvent.target)||$.browserEvent.isHandledByList)return;const W=$.element;if(!W)return super.u($);if(this.p($)||this.o($))return super.u($);const _=$.browserEvent.target,p=_.classList.contains("monaco-tl-twistie")||_.classList.contains("monaco-icon-label")&&_.classList.contains("folder-icon")&&$.browserEvent.offsetX<16;let A=!1;if(typeof this.x.expandOnlyOnTwistieClick=="function"?A=this.x.expandOnlyOnTwistieClick(W.element):A=!!this.x.expandOnlyOnTwistieClick,A&&!p&&$.browserEvent.detail!==2)return super.u($);if(!this.x.expandOnDoubleClick&&$.browserEvent.detail===2)return super.u($);if(W.collapsible){const E=this.x.getNodeLocation(W),M=$.browserEvent.altKey;if(this.x.setFocus([E]),this.x.toggleCollapsed(E,M),A&&p){$.browserEvent.isHandledByList=!0;return}}super.u($)}v($){$.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||$.browserEvent.isHandledByList||super.v($)}}class V extends g.$gR{constructor($,W,_,p,A,E,M,k){super($,W,_,p,k),this.p=A,this.s=E,this.K=M}D($){return new Z(this,$.tree)}splice($,W,_=[]){if(super.splice($,W,_),_.length===0)return;const p=[],A=[];let E;_.forEach((M,k)=>{this.p.has(M)&&p.push($+k),this.s.has(M)&&A.push($+k),this.K.has(M)&&(E=$+k)}),p.length>0&&super.setFocus((0,e.$Lb)([...super.getFocus(),...p])),A.length>0&&super.setSelection((0,e.$Lb)([...super.getSelection(),...A])),typeof E=="number"&&super.setAnchor(E)}setFocus($,W,_=!1){super.setFocus($,W),_||this.p.set($.map(p=>this.element(p)),W)}setSelection($,W,_=!1){super.setSelection($,W),_||this.s.set($.map(p=>this.element(p)),W)}setAnchor($,W=!1){super.setAnchor($),W||(typeof $>"u"?this.K.set([]):this.K.set([this.element($)]))}}class Y{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return r.Event.map(this.j.onMouseClick,Fe)}get onMouseDblClick(){return r.Event.filter(r.Event.map(this.j.onMouseDblClick,Fe),$=>$.target!==s.TreeMouseEventTarget.Filter)}get onContextMenu(){return r.Event.map(this.j.onContextMenu,de)}get onTap(){return r.Event.map(this.j.onTap,Fe)}get onPointer(){return r.Event.map(this.j.onPointer,Fe)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return r.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??oe.Highlight}set findMode($){this.x&&(this.x.mode=$)}get findMatchType(){return this.x?.matchType??be.Fuzzy}set findMatchType($){this.x&&(this.x.matchType=$)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:r.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor($,W,_,p,A={}){this.D=$,this.E=A,this.w=new r.$Vd,this.onDidChangeFindOpenState=r.Event.None,this.A=new u.$Qc,this.B=new r.$Nd,this.onWillRefilter=this.B.event,this.C=new r.$Nd,this.onDidUpdateOptions=this.C.event;const E=new H(_),M=new r.$Wd,k=new r.$Wd,I=this.A.add(new O(k.event)),S=new n.$Fc;this.k=p.map(se=>new Q(se,()=>this.o,M.event,I,S,A));for(const se of this.k)this.A.add(se);let N;A.keyboardNavigationLabelProvider&&(N=new te(this,A.keyboardNavigationLabelProvider,A.filter),A={...A,filter:N},this.A.add(N)),this.p=new ce(()=>this.j.getFocusedElements()[0],A.identityProvider),this.q=new ce(()=>this.j.getSelectedElements()[0],A.identityProvider),this.u=new ce(()=>this.j.getAnchorElement(),A.identityProvider),this.j=new V($,W,E,this.k,this.p,this.q,this.u,{...B(()=>this.o,A),tree:this}),this.o=this.I($,this.j,A),M.input=this.o.onDidChangeCollapseState;const z=r.Event.forEach(this.o.onDidSplice,se=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(se),this.q.onDidModelSplice(se)})},this.A);z(()=>null,null,this.A);const x=this.A.add(new r.$Nd),ee=this.A.add(new h.$Qg(0));if(this.A.add(r.Event.any(z,this.p.onDidChange,this.q.onDidChange)(()=>{ee.trigger(()=>{const se=new Set;for(const ge of this.p.getNodes())se.add(ge);for(const ge of this.q.getNodes())se.add(ge);x.fire([...se.values()])})})),k.input=x.event,A.keyboardSupport!==!1){const se=r.Event.chain(this.j.onKeyDown,ge=>ge.filter(pe=>!(0,g.$0Q)(pe.target)).map(pe=>new i.$SO(pe)));r.Event.chain(se,ge=>ge.filter(pe=>pe.keyCode===15))(this.F,this,this.A),r.Event.chain(se,ge=>ge.filter(pe=>pe.keyCode===17))(this.G,this,this.A),r.Event.chain(se,ge=>ge.filter(pe=>pe.keyCode===10))(this.H,this,this.A)}if((A.findWidgetEnabled??!0)&&A.keyboardNavigationLabelProvider&&A.contextViewProvider){const se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Te(this,this.o,this.j,N,A.contextViewProvider,se),this.y=ge=>this.x.shouldAllowFocus(ge),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=r.Event.None,this.onDidChangeFindMatchType=r.Event.None;this.z=(0,v.$AP)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===P.Always)}updateOptions($={}){this.E={...this.E,...$};for(const W of this.k)W.updateOptions($);this.j.updateOptions(this.E),this.x?.updateOptions($),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===P.Always)}get options(){return this.E}updateWidth($){const W=this.o.getListIndex($);W!==-1&&this.j.updateWidth(W)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop($){this.j.scrollTop=$}get scrollLeft(){return this.j.scrollLeft}set scrollLeft($){this.j.scrollLeft=$}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const $=this.j.firstVisibleIndex;return $<0||$>=this.j.length?void 0:this.j.element($).element}get lastVisibleElement(){const $=this.j.lastVisibleIndex;return this.j.element($).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel($){this.j.ariaLabel=$}get selectionSize(){return this.q.getNodes().length}domFocus(){this.j.domFocus()}isDOMFocused(){return(0,v.$sP)(this.getHTMLElement())}layout($,W){this.j.layout($,W),(0,F.$Cf)(W)&&this.x?.layout(W)}style($){const W=`.${this.j.domId}`,_=[];$.treeIndentGuidesStroke&&(_.push(`.monaco-list${W}:hover .monaco-tl-indent > .indent-guide, .monaco-list${W}.always .monaco-tl-indent > .indent-guide  { border-color: ${$.treeInactiveIndentGuidesStroke}; }`),_.push(`.monaco-list${W} .monaco-tl-indent > .indent-guide.active { border-color: ${$.treeIndentGuidesStroke}; }`)),this.z.textContent=_.join(`
`),this.j.style($)}getParentElement($){const W=this.o.getParentNodeLocation($);return this.o.getNode(W).element}getFirstElementChild($){return this.o.getFirstElementChild($)}getNode($){return this.o.getNode($)}getNodeLocation($){return this.o.getNodeLocation($)}collapse($,W=!1){return this.o.setCollapsed($,!0,W)}expand($,W=!1){return this.o.setCollapsed($,!1,W)}toggleCollapsed($,W=!1){return this.o.setCollapsed($,void 0,W)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible($){return this.o.isCollapsible($)}setCollapsible($,W){return this.o.setCollapsible($,W)}isCollapsed($){return this.o.isCollapsed($)}expandTo($){this.o.expandTo($)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor($){if(typeof $>"u")return this.j.setAnchor(void 0);const W=this.o.getNode($);this.u.set([W]);const _=this.o.getListIndex($);_>-1&&this.j.setAnchor(_,!0)}getAnchor(){return(0,e.$Nb)(this.u.get(),void 0)}setSelection($,W){const _=$.map(A=>this.o.getNode(A));this.q.set(_,W);const p=$.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setSelection(p,W,!0)}getSelection(){return this.q.get()}setFocus($,W){const _=$.map(A=>this.o.getNode(A));this.p.set(_,W);const p=$.map(A=>this.o.getListIndex(A)).filter(A=>A>-1);this.j.setFocus(p,W,!0)}focusNext($=1,W=!1,_,p=this.y){this.j.focusNext($,W,_,p)}focusPrevious($=1,W=!1,_,p=this.y){this.j.focusPrevious($,W,_,p)}focusNextPage($,W=this.y){return this.j.focusNextPage($,W)}focusPreviousPage($,W=this.y){return this.j.focusPreviousPage($,W)}focusLast($,W=this.y){this.j.focusLast($,W)}focusFirst($,W=this.y){this.j.focusFirst($,W)}getFocus(){return this.p.get()}reveal($,W){this.o.expandTo($);const _=this.o.getListIndex($);_!==-1&&this.j.reveal(_,W)}getRelativeTop($){const W=this.o.getListIndex($);return W===-1?null:this.j.getRelativeTop(W)}getViewState($=this.options.identityProvider){if(!$)throw new s.$SS(this.D,"Can't get tree view state without an identity provider");const W=E=>$.getId(E).toString(),_=X.empty(this.scrollTop);for(const E of this.getFocus())_.focus.add(W(E));for(const E of this.getSelection())_.selection.add(W(E));const p=this.o.getNode(),A=[p];for(;A.length>0;){const E=A.shift();E!==p&&E.collapsible&&(_.expanded[W(E.element)]=E.collapsed?0:1),A.push(...E.children)}return _}F($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const _=W[0],p=this.o.getNodeLocation(_);if(!this.o.setCollapsed(p,!0)){const E=this.o.getParentNodeLocation(p);if(!E)return;const M=this.o.getListIndex(E);this.j.reveal(M),this.j.setFocus([M])}}G($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const _=W[0],p=this.o.getNodeLocation(_);if(!this.o.setCollapsed(p,!1)){if(!_.children.some(k=>k.visible))return;const[E]=this.j.getFocus(),M=E+1;this.j.reveal(M),this.j.setFocus([M])}}H($){$.preventDefault(),$.stopPropagation();const W=this.j.getFocusedElements();if(W.length===0)return;const _=W[0],p=this.o.getNodeLocation(_),A=$.browserEvent.altKey;this.o.setCollapsed(p,void 0,A)}navigate($){return new C(this.j,this.o,$)}dispose(){(0,u.$Mc)(this.A),this.j.dispose()}}t.$2S=Y;class C{constructor($,W,_){this.b=$,this.c=W,_?this.a=this.c.getListIndex(_):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define($e[131],we([1,0,130,121,25,27]),function(le,t,v,T,i,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aT=void 0;class w extends v.$2S{constructor(c,g,f,L,s,a={}){super(c,g,f,L,a),this.f=c,this.g=s,this.d=new Map,this.c=a.identityProvider}getInput(){return this.b}setInput(c,g){if(g&&!this.c)throw new i.$SS(this.f,"Can't restore tree view state without an identity provider");if(this.b=c,!c){this.d.clear(),this.o.setChildren(null,U.Iterable.empty());return}if(!g){this.m(c);return}const f=[],L=[],s=e=>{const h=this.c.getId(e).toString();return!g.expanded[h]},a=e=>{const h=this.c.getId(e.element).toString();g.focus.has(h)&&f.push(e.element),g.selection.has(h)&&L.push(e.element)};this.m(c,s,a),this.setFocus(f),this.setSelection(L),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(c=this.b){if(typeof this.b>"u")throw new i.$SS(this.f,"Tree input not set");let g;this.c&&(g=f=>{const L=this.c.getId(f).toString(),s=this.d.get(L);if(s)return s.collapsed}),this.m(c,g)}resort(c=this.b,g=!0){this.o.resort(c===this.b?null:c,g)}refresh(c){if(c===void 0){this.j.rerender();return}this.o.rerender(c)}m(c,g,f){let L;if(this.c){const s=new Set,a=f;f=e=>{const h=this.c.getId(e.element).toString();s.add(h),this.d.set(h,e),a?.(e)},L=e=>{const h=this.c.getId(e.element).toString();s.has(h)||this.d.delete(h)}}this.o.setChildren(c===this.b?null:c,this.s(c,g).elements,{onDidCreateNode:f,onDidDeleteNode:L})}s(c,g){const f=[...this.g.getChildren(c)];return{elements:U.Iterable.map(f,s=>{const{elements:a,size:e}=this.s(s,g),h=this.g.hasChildren?this.g.hasChildren(s):void 0,l=e===0?void 0:g&&g(s);return{element:s,children:a,collapsible:h,collapsed:l}}),size:f.length}}I(c,g,f){return new T.$3S(c,g,f)}}t.$aT=w}),define($e[67],we([1,0,11,9,33,29,26,6,4,2,53,12,7]),function(le,t,v,T,i,U,w,y,c,g,f,L,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zh=t.ProxyChannel=t.$yh=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=t.RequestInitiator=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=void 0;var a;(function(de){de[de.Promise=100]="Promise",de[de.PromiseCancel=101]="PromiseCancel",de[de.EventListen=102]="EventListen",de[de.EventDispose=103]="EventDispose"})(a||(a={}));function e(de){switch(de){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(de){de[de.Initialize=200]="Initialize",de[de.PromiseSuccess=201]="PromiseSuccess",de[de.PromiseError=202]="PromiseError",de[de.PromiseErrorObj=203]="PromiseErrorObj",de[de.EventFire=204]="EventFire"})(h||(h={}));function l(de){switch(de){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(de){de[de.Uninitialized=0]="Uninitialized",de[de.Idle=1]="Idle"})(m||(m={}));function n(de){let ne=0;for(let ce=0;;ce+=7){const Z=de.read(1);if(ne|=(Z.buffer[0]&127)<<ce,!(Z.buffer[0]&128))return ne}}const r=j(0);function b(de,ne){if(ne===0){de.write(r);return}let ce=0;for(let V=ne;V!==0;V=V>>>7)ce++;const Z=i.$be.alloc(ce);for(let V=0;ne!==0;V++)Z.buffer[V]=ne&127,ne=ne>>>7,ne>0&&(Z.buffer[V]|=128);de.write(Z)}class u{constructor(ne){this.b=ne,this.a=0}read(ne){const ce=this.b.slice(this.a,this.a+ne);return this.a+=ce.byteLength,ce}}t.$oh=u;class o{constructor(){this.a=[]}get buffer(){return i.$be.concat(this.a)}write(ne){this.a.push(ne)}}t.$ph=o;var F;(function(de){de[de.Undefined=0]="Undefined",de[de.String=1]="String",de[de.Buffer=2]="Buffer",de[de.VSBuffer=3]="VSBuffer",de[de.Array=4]="Array",de[de.Object=5]="Object",de[de.Int=6]="Int"})(F||(F={}));function j(de){const ne=i.$be.alloc(1);return ne.writeUInt8(de,0),ne}const R={Undefined:j(F.Undefined),String:j(F.String),Buffer:j(F.Buffer),VSBuffer:j(F.VSBuffer),Array:j(F.Array),Object:j(F.Object),Uint:j(F.Int)},d=typeof Buffer<"u";function D(de,ne){if(typeof ne>"u")de.write(R.Undefined);else if(typeof ne=="string"){const ce=i.$be.fromString(ne);de.write(R.String),b(de,ce.byteLength),de.write(ce)}else if(d&&Buffer.isBuffer(ne)){const ce=i.$be.wrap(ne);de.write(R.Buffer),b(de,ce.byteLength),de.write(ce)}else if(ne instanceof i.$be)de.write(R.VSBuffer),b(de,ne.byteLength),de.write(ne);else if(Array.isArray(ne)){de.write(R.Array),b(de,ne.length);for(const ce of ne)D(de,ce)}else if(typeof ne=="number"&&(ne|0)===ne)de.write(R.Uint),b(de,ne);else{const ce=i.$be.fromString(JSON.stringify(ne));de.write(R.Object),b(de,ce.byteLength),de.write(ce)}}t.$qh=D;function B(de){switch(de.read(1).readUInt8(0)){case F.Undefined:return;case F.String:return de.read(n(de)).toString();case F.Buffer:return de.read(n(de)).buffer;case F.VSBuffer:return de.read(n(de));case F.Array:{const ce=n(de),Z=[];for(let V=0;V<ce;V++)Z.push(B(de));return Z}case F.Object:return JSON.parse(de.read(n(de)).toString());case F.Int:return n(de)}}t.$rh=B;class H{constructor(ne,ce,Z=null,V=1e3){this.h=ne,this.j=ce,this.k=Z,this.l=V,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(Y=>this.q(Y)),this.m({type:200})}registerChannel(ne,ce){this.b.set(ne,ce),setTimeout(()=>this.w(ne),0)}m(ne){switch(ne.type){case 200:{const ce=this.o([ne.type]);this.k?.logOutgoing(ce,0,1,l(ne.type));return}case 201:case 202:case 204:case 203:{const ce=this.o([ne.type,ne.id],ne.data);this.k?.logOutgoing(ce,ne.id,1,l(ne.type),ne.data);return}}}o(ne,ce=void 0){const Z=new o;return D(Z,ne),D(Z,ce),this.p(Z.buffer)}p(ne){try{return this.h.send(ne),ne.byteLength}catch{return 0}}q(ne){const ce=new u(ne),Z=B(ce),V=B(ce),Y=Z[0];switch(Y){case 100:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(Y)}: ${Z[2]}.${Z[3]}`,V),this.s({type:Y,id:Z[1],channelName:Z[2],name:Z[3],arg:V});case 102:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(Y)}: ${Z[2]}.${Z[3]}`,V),this.t({type:Y,id:Z[1],channelName:Z[2],name:Z[3],arg:V});case 101:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(Y)}`),this.u({type:Y,id:Z[1]});case 103:return this.k?.logIncoming(ne.byteLength,Z[1],1,`${e(Y)}`),this.u({type:Y,id:Z[1]})}}s(ne){const ce=this.b.get(ne.channelName);if(!ce){this.v(ne);return}const Z=new U.$Xd;let V;try{V=ce.call(this.j,ne.name,ne.arg,Z.token)}catch(q){V=Promise.reject(q)}const Y=ne.id;V.then(q=>{this.m({id:Y,data:q,type:201})},q=>{q instanceof Error?this.m({id:Y,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:Y,data:q,type:203})}).finally(()=>{C.dispose(),this.d.delete(ne.id)});const C=(0,g.$Pc)(()=>Z.cancel());this.d.set(ne.id,C)}t(ne){const ce=this.b.get(ne.channelName);if(!ce){this.v(ne);return}const Z=ne.id,Y=ce.listen(this.j,ne.name,ne.arg)(C=>this.m({id:Z,data:C,type:204}));this.d.set(ne.id,Y)}u(ne){const ce=this.d.get(ne.id);ce&&(ce.dispose(),this.d.delete(ne.id))}v(ne){let ce=this.g.get(ne.channelName);ce||(ce=[],this.g.set(ne.channelName,ce));const Z=setTimeout(()=>{console.error(`Unknown channel: ${ne.channelName}`),ne.type===100&&this.m({id:ne.id,data:{name:"Unknown channel",message:`Channel name '${ne.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ce.push({request:ne,timeoutTimer:Z})}w(ne){const ce=this.g.get(ne);if(ce){for(const Z of ce)switch(clearTimeout(Z.timeoutTimer),Z.request.type){case 100:this.s(Z.request);break;case 102:this.t(Z.request);break}this.g.delete(ne)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}t.$sh=H;var X;(function(de){de[de.LocalSide=0]="LocalSide",de[de.OtherSide=1]="OtherSide"})(X||(t.RequestInitiator=X={}));class P{constructor(ne,ce=null){this.l=ne,this.a=!1,this.b=m.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new c.$Nd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Z=>this.s(Z)),this.j=ce}getChannel(ne){const ce=this;return{call(Z,V,Y){return ce.a?Promise.reject(new y.$4):ce.m(ne,Z,V,Y)},listen(Z,V){return ce.a?c.Event.None:ce.o(ne,Z,V)}}}m(ne,ce,Z,V=U.CancellationToken.None){const Y=this.g++,q={id:Y,type:100,channelName:ne,name:ce,arg:Z};if(V.isCancellationRequested)return Promise.reject(new y.$4);let $;return new Promise((_,p)=>{if(V.isCancellationRequested)return p(new y.$4);const A=()=>{const I=S=>{switch(S.type){case 201:this.f.delete(Y),_(S.data);break;case 202:{this.f.delete(Y);const N=new Error(S.data.message);N.stack=Array.isArray(S.data.stack)?S.data.stack.join(`
`):S.data.stack,N.name=S.data.name,p(N);break}case 203:this.f.delete(Y),p(S.data);break}};this.f.set(Y,I),this.p(q)};let E=null;this.b===m.Idle?A():(E=(0,T.$Hg)(I=>this.u()),E.then(()=>{E=null,A()}));const M=()=>{E?(E.cancel(),E=null):this.p({id:Y,type:101}),p(new y.$4)},k=V.onCancellationRequested(M);$=(0,g.$Oc)((0,g.$Pc)(M),k),this.d.add($)}).finally(()=>{$.dispose(),this.d.delete($)})}o(ne,ce,Z){const V=this.g++,C={id:V,type:102,channelName:ne,name:ce,arg:Z};let q=null;const $=new c.$Nd({onWillAddFirstListener:()=>{q=(0,T.$Hg)(_=>this.u()),q.then(()=>{q=null,this.d.add($),this.p(C)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete($),this.p({id:V,type:103}))}}),W=_=>$.fire(_.data);return this.f.set(V,W),$.event}p(ne){switch(ne.type){case 100:case 102:{const ce=this.q([ne.type,ne.id,ne.channelName,ne.name],ne.arg);this.j?.logOutgoing(ce,ne.id,0,`${e(ne.type)}: ${ne.channelName}.${ne.name}`,ne.arg);return}case 101:case 103:{const ce=this.q([ne.type,ne.id]);this.j?.logOutgoing(ce,ne.id,0,e(ne.type));return}}}q(ne,ce=void 0){const Z=new o;return D(Z,ne),D(Z,ce),this.r(Z.buffer)}r(ne){try{return this.l.send(ne),ne.byteLength}catch{return 0}}s(ne){const ce=new u(ne),Z=B(ce),V=B(ce),Y=Z[0];switch(Y){case 200:return this.j?.logIncoming(ne.byteLength,0,0,l(Y)),this.t({type:Z[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(ne.byteLength,Z[1],0,l(Y),V),this.t({type:Z[0],id:Z[1],data:V})}}t(ne){if(ne.type===200){this.b=m.Idle,this.k.fire();return}this.f.get(ne.id)?.(ne)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}u(){return this.b===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Mc)(this.d.values()),this.d.clear()}}t.$th=P,Ye([w.$ih],P.prototype,"onDidInitializePromise",null);class O{get connections(){const ne=[];return this.f.forEach(ce=>ne.push(ce)),ne}constructor(ne){this.a=new Map,this.f=new Set,this.g=new c.$Nd,this.onDidAddConnection=this.g.event,this.h=new c.$Nd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Qc,this.j.add(ne(({protocol:ce,onDidClientDisconnect:Z})=>{const V=c.Event.once(ce.onMessage);this.j.add(V(Y=>{const C=new u(Y),q=B(C),$=new H(ce,q),W=new P(ce);this.a.forEach((p,A)=>$.registerChannel(A,p));const _={channelServer:$,channelClient:W,ctx:q};this.f.add(_),this.g.fire(_),this.j.add(Z(()=>{$.dispose(),W.dispose(),this.f.delete(_),this.h.fire(_)}))}))}))}getChannel(ne,ce){const Z=this;return{call(V,Y,C){let q;if((0,s.$Mf)(ce)){const W=(0,v.$3b)(Z.connections.filter(ce));q=W?Promise.resolve(W):c.Event.toPromise(c.Event.filter(Z.onDidAddConnection,ce))}else q=ce.routeCall(Z,V,Y);const $=q.then(W=>W.channelClient.getChannel(ne));return te($).call(V,Y,C)},listen(V,Y){if((0,s.$Mf)(ce))return Z.k(ne,ce,V,Y);const C=ce.routeEvent(Z,V,Y).then(q=>q.channelClient.getChannel(ne));return te(C).listen(V,Y)}}}k(ne,ce,Z,V){const Y=this;let C;const q=new c.$Nd({onWillAddFirstListener:()=>{C=new g.$Qc;const $=new c.$Td,W=new Map,_=A=>{const M=A.channelClient.getChannel(ne).listen(Z,V),k=$.add(M);W.set(A,k)},p=A=>{const E=W.get(A);E&&(E.dispose(),W.delete(A))};Y.connections.filter(ce).forEach(_),c.Event.filter(Y.onDidAddConnection,ce)(_,void 0,C),Y.onDidRemoveConnection(p,void 0,C),$.event(q.fire,q,C),C.add($)},onDidRemoveLastListener:()=>{C?.dispose(),C=void 0}});return q.event}registerChannel(ne,ce){this.a.set(ne,ce);for(const Z of this.f)Z.channelServer.registerChannel(ne,ce)}dispose(){this.j.dispose();for(const ne of this.f)ne.channelClient.dispose(),ne.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$uh=O;class Q{constructor(ne,ce,Z=null){const V=new o;D(V,ce),ne.send(V.buffer),this.a=new P(ne,Z),this.d=new H(ne,ce,Z)}getChannel(ne){return this.a.getChannel(ne)}registerChannel(ne,ce){this.d.registerChannel(ne,ce)}dispose(){this.a.dispose(),this.d.dispose()}}t.$vh=Q;function te(de){return{call(ne,ce,Z){return de.then(V=>V.call(ne,ce,Z))},listen(ne,ce){const Z=new c.$Wd;return de.then(V=>Z.input=V.listen(ne,ce)),Z.event}}}t.$wh=te;function re(de){let ne=!1;return{call(ce,Z,V){return ne?de.call(ce,Z,V):(0,T.$Ug)(0).then(()=>ne=!0).then(()=>de.call(ce,Z,V))},listen(ce,Z){if(ne)return de.listen(ce,Z);const V=new c.$Wd;return(0,T.$Ug)(0).then(()=>ne=!0).then(()=>V.input=de.listen(ce,Z)),V.event}}}t.$xh=re;class fe{constructor(ne){this.a=ne}routeCall(ne){return this.b(ne)}routeEvent(ne){return this.b(ne)}async b(ne){for(const ce of ne.connections)if(await Promise.resolve(this.a(ce.ctx)))return Promise.resolve(ce);return await c.Event.toPromise(ne.onDidAddConnection),await this.b(ne)}}t.$yh=fe;var ie;(function(de){function ne(Y,C,q){const $=Y,W=q&&q.disableMarshalling,_=new Map;for(const p in $)Z(p)&&_.set(p,c.Event.buffer($[p],!0,void 0,C));return new class{listen(p,A,E){const M=_.get(A);if(M)return M;if(V(A)){const k=$[A];if(typeof k=="function")return k.call($,E)}throw new y.$ab(`Event not found: ${A}`)}call(p,A,E){const M=$[A];if(typeof M=="function"){if(!W&&Array.isArray(E))for(let I=0;I<E.length;I++)E[I]=(0,f.$nh)(E[I]);let k=M.apply($,E);return k instanceof Promise||(k=Promise.resolve(k)),k}throw new y.$ab(`Method not found: ${A}`)}}}de.fromService=ne;function ce(Y,C){const q=C&&C.disableMarshalling;return new Proxy({},{get($,W){if(typeof W=="string")return C?.properties?.has(W)?C.properties.get(W):V(W)?function(_){return Y.listen(W,_)}:Z(W)?Y.listen(W):async function(..._){let p;C&&!(0,s.$Hf)(C.context)?p=[C.context,..._]:p=_;const A=await Y.call(W,p);return q?A:(0,f.$nh)(A)};throw new y.$ab(`Property not found: ${String(W)}`)}})}de.toService=ce;function Z(Y){return Y[0]==="o"&&Y[1]==="n"&&L.$1e(Y.charCodeAt(2))}function V(Y){return/^onDynamic/.test(Y)&&L.$1e(Y.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function be(de){if(Array.isArray(de))return de;if(de&&typeof de=="object"&&typeof de.toString=="function"){const ne=de.toString();if(ne!=="[object Object]")return ne}return de}function Se(de){return Array.isArray(de)?de.map(be):be(de)}function Te(de,ne,ce,Z,V,Y,C){C=Se(C);const q=oe[V],$=q[Z%q.length];let W=[`%c[${de}]%c[${String(ne).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(Z).padStart(5," ")} - ${Y}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(Y)?(W=W.concat(C),W.push(")")):W.push(C),console.log.apply(console,W)}class Fe{constructor(ne,ce){this.d=ne,this.f=ce,this.a=0,this.b=0}logOutgoing(ne,ce,Z,V,Y){this.b+=ne,Te(this.d,this.b,ne,ce,Z,V,Y)}logIncoming(ne,ce,Z,V,Y){this.a+=ne,Te(this.f,this.a,ne,ce,Z,V,Y)}}t.$zh=Fe}),define($e[31],we([1,0,5]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$R=t.$Q=t.$P=t.$O=t.$N=void 0,t.$N=v.$h.vscode.ipcRenderer,t.$O=v.$h.vscode.ipcMessagePort,t.$P=v.$h.vscode.webFrame,t.$Q=v.$h.vscode.process,t.$R=v.$h.vscode.context}),define($e[132],we([1,0,88,31]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LT=void 0;let i=0;function U(y,c,g){const f=[],L=i++,s=`vscode:onContextMenu${L}`,a=(e,h,l)=>{f[h].click?.(l)};T.$N.once(s,a),T.$N.once(v.$IT,(e,h)=>{h===L&&(T.$N.removeListener(s,a),g?.())}),T.$N.send(v.$HT,L,y.map(e=>w(e,f)),s,c)}t.$LT=U;function w(y,c){const g={id:c.length,label:y.label,type:y.type,accelerator:y.accelerator,checked:y.checked,enabled:typeof y.enabled=="boolean"?y.enabled:!0,visible:typeof y.visible=="boolean"?y.visible:!0};return c.push(y),Array.isArray(y.submenu)&&(g.submenu=y.submenu.map(f=>w(f,c))),g}}),define($e[133],we([1,0,33,4,67,89,31]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TT=void 0;class y extends i.$vh{static f(){const g=T.Event.fromNodeEventEmitter(w.$N,"vscode:message",(f,L)=>v.$be.wrap(L));return w.$N.send("vscode:hello"),new U.$PT(w.$N,g)}constructor(g){const f=y.f();super(f,g),this.b=f}dispose(){this.b.disconnect()}}t.$TT=y}),define($e[134],we([13,10]),function(le,t){return le.create("vs/platform/files/common/files",t)}),define($e[135],we([13,10]),function(le,t){return le.create("vs/platform/theme/common/iconRegistry",t)}),define($e[40],we([1,0]),function(le,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rh=t.$Qh=t.$Ph=t._util=void 0;var v;(function(w){w.serviceIds=new Map,w.DI_TARGET="$di$target",w.DI_DEPENDENCIES="$di$dependencies";function y(c){return c[w.DI_DEPENDENCIES]||[]}w.getServiceDependencies=y})(v||(t._util=v={})),t.$Ph=i("instantiationService");function T(w,y,c){y[v.DI_TARGET]===y?y[v.DI_DEPENDENCIES].push({id:w,index:c}):(y[v.DI_DEPENDENCIES]=[{id:w,index:c}],y[v.DI_TARGET]=y)}function i(w){if(v.serviceIds.has(w))return v.serviceIds.get(w);const y=function(c,g,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(y,c,f)};return y.toString=()=>w,v.serviceIds.set(w,y),y}t.$Qh=i;function U(w){return w}t.$Rh=U}),define($e[136],we([1,0,40]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tm=t.$sm=t.$rm=t.ID=void 0,t.ID="diagnosticsService",t.$rm=(0,v.$Qh)(t.ID);function T(U){return!!U.hostName&&!!U.errorMessage}t.$sm=T;class i{async getPerformanceInfo(w,y){return{}}async getSystemInfo(w,y){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(w,y){return""}async getWorkspaceFileExtensions(w){return{extensions:[]}}async reportWorkspaceStats(w){}}t.$tm=i}),define($e[137],we([1,0,87,23,12,7,16,134,40,5,30,28]),function(le,t,v,T,i,U,w,y,c,g,f,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ik=t.$Hk=t.$Gk=t.$Fk=t.$Ek=t.FileKind=t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.$zk=t.$yk=t.$xk=t.FileOperationResult=t.$wk=t.$vk=t.$uk=t.$tk=t.$sk=t.FileChangeType=t.$rk=t.FileOperation=t.$qk=t.$pk=t.$ok=t.$nk=t.$mk=t.$lk=t.FileSystemProviderErrorCode=t.$kk=t.$jk=t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=t.$ck=t.FileSystemProviderCapabilities=t.$bk=t.FilePermission=t.FileType=t.$ak=t.$_j=void 0,t.$_j=(0,c.$Qh)("fileService");function s(V){return V.create===!0}t.$ak=s;var a;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(a||(t.FileType=a={}));var e;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function h(V){const Y=V;return!!Y&&typeof Y.onDidChange=="function"}t.$bk=h;var l;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function m(V){return!!(V.capabilities&2)}t.$ck=m;function n(V){return!!(V.capabilities&8)}t.$dk=n;function r(V){return!!(V.capabilities&131072)}t.$ek=r;function b(V){return!!(V.capabilities&4)}t.$fk=b;function u(V){return!!(V.capabilities&16)}t.$gk=u;function o(V){return m(V)?!!(V.capabilities&16384):!1}t.$hk=o;function F(V){return m(V)?!!(V.capabilities&32768):!1}t.$ik=F;function j(V){return!!(V.capabilities&65536)}t.$jk=j;function R(V){return!!(V.capabilities&2048)}t.$kk=R;var d;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(d||(t.FileSystemProviderErrorCode=d={}));class D extends Error{static create(Y,C){const q=new D(Y.toString(),C);return X(q,C),q}constructor(Y,C){super(Y),this.code=C}}t.$lk=D;function B(V,Y){return D.create(V,Y)}t.$mk=B;function H(V){return V||B((0,y.localize)(0,null),d.Unknown)}t.$nk=H;function X(V,Y){return V.name=Y?`${Y} (FileSystemError)`:"FileSystemError",V}t.$ok=X;function P(V){if(!V)return d.Unknown;if(V instanceof D)return V.code;const Y=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!Y)return d.Unknown;switch(Y[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}t.$pk=P;function O(V){if(V instanceof oe)return V.fileOperationResult;switch(P(V)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 9;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileTooLarge:return 7;default:return 10}}t.$qk=O;var Q;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(Q||(t.FileOperation=Q={}));class te{constructor(Y,C,q){this.resource=Y,this.operation=C,this.target=q}isOperation(Y){return this.operation===Y}}t.$rk=te;var re;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(re||(t.FileChangeType=re={}));class fe{static{this.a=null}constructor(Y,C){this.c=C,this.b=void 0,this.d=new L.$U(()=>{const q=v.$Wh.forUris(()=>this.c);return q.fill(this.rawAdded.map($=>[$,!0])),q}),this.f=new L.$U(()=>{const q=v.$Wh.forUris(()=>this.c);return q.fill(this.rawUpdated.map($=>[$,!0])),q}),this.g=new L.$U(()=>{const q=v.$Wh.forUris(()=>this.c);return q.fill(this.rawDeleted.map($=>[$,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of Y){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==fe.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=fe.a):this.b!==void 0&&(this.b=fe.a))}}contains(Y,...C){return this.h(Y,{includeChildren:!1},...C)}affects(Y,...C){return this.h(Y,{includeChildren:!0},...C)}h(Y,C,...q){if(!Y)return!1;const $=q.length>0;return!!((!$||q.includes(1))&&(this.d.value.get(Y)||C.includeChildren&&this.d.value.findSuperstr(Y))||(!$||q.includes(0))&&(this.f.value.get(Y)||C.includeChildren&&this.f.value.findSuperstr(Y))||(!$||q.includes(2))&&(this.g.value.findSubstr(Y)||C.includeChildren&&this.g.value.findSuperstr(Y)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Y){return this.b===Y}hasCorrelation(){return typeof this.b=="number"}}t.$sk=fe;function ie(V,Y,C){return!V||!Y||V===Y||Y.length>V.length?!1:(Y.charAt(Y.length-1)!==T.sep&&(Y+=T.sep),C?(0,i.$3e)(V,Y):V.indexOf(Y)===0)}t.$tk=ie;class oe extends Error{constructor(Y,C,q){super(Y),this.fileOperationResult=C,this.options=q}}t.$uk=oe;class be extends oe{constructor(Y,C,q,$){super(Y,C,$),this.fileOperationResult=C,this.size=q}}t.$vk=be;class Se extends oe{constructor(Y,C,q){super(Y,2,q),this.stat=C}}t.$wk=Se;var Te;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Te||(t.FileOperationResult=Te={})),t.$xk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$yk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$zk="files.associations",t.$Ak="files.exclude",t.$Bk="files.readonlyInclude",t.$Ck="files.readonlyExclude",t.$Dk="files.readonlyFromPermissions";var Fe;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(Fe||(t.FileKind=Fe={})),t.$Ek="";function de(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}t.$Fk=de;async function ne(V,Y){if(!Y.hasProvider(w.URI.from({scheme:V.scheme})))return new Promise(C=>{const q=Y.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===V.scheme&&$.added&&(q.dispose(),C())})})}t.$Gk=ne;class ce{static{this.KB=1024}static{this.MB=ce.KB*ce.KB}static{this.GB=ce.MB*ce.KB}static{this.TB=ce.GB*ce.KB}static formatSize(Y){return(0,U.$Cf)(Y)||(Y=0),Y<ce.KB?(0,y.localize)(1,null,Y.toFixed(0)):Y<ce.MB?(0,y.localize)(2,null,(Y/ce.KB).toFixed(2)):Y<ce.GB?(0,y.localize)(3,null,(Y/ce.MB).toFixed(2)):Y<ce.TB?(0,y.localize)(4,null,(Y/ce.GB).toFixed(2)):(0,y.localize)(5,null,(Y/ce.TB).toFixed(2))}}t.$Hk=ce;function Z(V){const Y=typeof V=="string"||V?.scheme===f.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===f.Schemas.file?1024*ce.MB:Y?10*ce.MB:g.$p?50*ce.MB:1024*ce.MB}t.$Ik=Z}),define($e[138],we([1,0,40]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$08b=t.$98b=void 0,t.$98b=(0,v.$Qh)("mainProcessService");class T{constructor(U,w){this.a=U,this.b=w}getChannel(U){return this.a.getChannel(U,this.b)}registerChannel(U,w){this.a.registerChannel(U,w)}}t.$08b=T}),define($e[139],we([1,0,2,133]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$8b=void 0;class i extends v.$Rc{constructor(w){super(),this.a=this.B(new T.$TT(`window:${w}`))}getChannel(w){return this.a.getChannel(w)}registerChannel(w,y){this.a.registerChannel(w,y)}}t.$$8b=i});var Di=this&&this.__param||function(le,t){return function(v,T){t(v,T,le)}};define($e[140],we([1,0,67,138]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$c9b=void 0;let i=class{constructor(w,y){return this.windowId=w,v.ProxyChannel.toService(y.getChannel("nativeHost"),{context:w,properties:(()=>{const c=new Map;return c.set("windowId",w),c})()})}};t.$c9b=i,t.$c9b=i=Ye([Di(1,T.$98b)],i)}),define($e[68],we([1,0,76,7]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hn=void 0;class i{constructor(){this.a=new Map}add(w,y){v.ok(T.$yf(w)),v.ok(T.$Af(y)),v.ok(!this.a.has(w),"There is already an extension with this id"),this.a.set(w,y)}knows(w){return this.a.has(w)}as(w){return this.a.get(w)||null}}t.$hn=new i}),define($e[141],we([1,0,4,68]),function(le,t,v,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$in=void 0,t.$in={JSONContribution:"base.contributions.json"};function i(y){return y.length>0&&y.charAt(y.length-1)==="#"?y.substring(0,y.length-1):y}class U{constructor(){this.b=new v.$Nd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(c,g){this.a[i(c)]=g,this.b.fire(c)}notifySchemaChanged(c){this.b.fire(c)}getSchemaContributions(){return{schemas:this.a}}}const w=new U;T.$hn.add(t.$in.JSONContribution,w)}),define($e[142],we([1,0,9,18,19,4,7,16,135,141,68]),function(le,t,v,T,i,U,w,y,c,g,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bw=t.$aw=t.$_v=t.$$v=t.$0v=t.$9v=t.$8v=t.$7v=t.IconFontDefinition=t.IconContribution=t.$6v=void 0,t.$6v={IconContribution:"base.contributions.icons"};var L;(function(b){function u(o,F){let j=o.defaults;for(;i.ThemeIcon.isThemeIcon(j);){const R=e.getIcon(j.id);if(!R)return;j=R.defaults}return j}b.getDefinition=u})(L||(t.IconContribution=L={}));var s;(function(b){function u(F){return{weight:F.weight,style:F.style,src:F.src.map(j=>({format:j.format,location:j.location.toString()}))}}b.toJSONObject=u;function o(F){const j=R=>(0,w.$yf)(R)?R:void 0;if(F&&Array.isArray(F.src)&&F.src.every(R=>(0,w.$yf)(R.format)&&(0,w.$yf)(R.location)))return{weight:j(F.weight),style:j(F.style),src:F.src.map(R=>({format:R.format,location:y.URI.parse(R.location)}))}}b.fromJSONObject=o})(s||(t.IconFontDefinition=s={}));class a{constructor(){this.a=new U.$Nd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,c.localize)(0,null)},fontCharacter:{type:"string",description:(0,c.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,o,F,j){const R=this.b[u];if(R){if(F&&!R.description){R.description=F,this.d.properties[u].markdownDescription=`${F} $(${u})`;const B=this.e.enum.indexOf(u);B!==-1&&(this.e.enumDescriptions[B]=F),this.a.fire()}return R}const d={id:u,description:F,defaults:o,deprecationMessage:j};this.b[u]=d;const D={$ref:"#/definitions/icons"};return j&&(D.deprecationMessage=j),F&&(D.markdownDescription=`${F}: $(${u})`),this.d.properties[u]=D,this.e.enum.push(u),this.e.enumDescriptions.push(F||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const o=this.e.enum.indexOf(u);o!==-1&&(this.e.enum.splice(o,1),this.e.enumDescriptions.splice(o,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,o){const F=this.f[u];return F||(this.f[u]=o,this.a.fire(),o)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(R,d)=>R.id.localeCompare(d.id),o=R=>{for(;i.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},F=[];F.push("| preview     | identifier                        | default codicon ID                | description"),F.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const j=Object.keys(this.b).map(R=>this.b[R]);for(const R of j.filter(d=>!!d.description).sort(u))F.push(`|<i class="${o(R)}"></i>|${R.id}|${i.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);F.push("| preview     | identifier                        "),F.push("| ----------- | --------------------------------- |");for(const R of j.filter(d=>!i.ThemeIcon.isThemeIcon(d.defaults)).sort(u))F.push(`|<i class="${o(R)}"></i>|${R.id}|`);return F.join(`
`)}}const e=new a;f.$hn.add(t.$6v.IconContribution,e);function h(b,u,o,F){return e.registerIcon(b,u,o,F)}t.$7v=h;function l(){return e}t.$8v=l;function m(){const b=(0,T.$Tj)();for(const u in b){const o="\\"+b[u].toString(16);e.registerIcon(u,{fontCharacter:o})}}m(),t.$9v="vscode://schemas/icons";const n=f.$hn.as(g.$in.JSONContribution);n.registerSchema(t.$9v,e.getIconSchema());const r=new v.$7g(()=>n.notifySchemaChanged(t.$9v),200);e.onDidChange(()=>{r.isScheduled()||r.schedule()}),t.$0v=h("widget-close",T.$Vj.close,(0,c.localize)(2,null)),t.$$v=h("goto-previous-location",T.$Vj.arrowUp,(0,c.localize)(3,null)),t.$_v=h("goto-next-location",T.$Vj.arrowDown,(0,c.localize)(4,null)),t.$aw=i.ThemeIcon.modify(T.$Vj.sync,"spin"),t.$bw=i.ThemeIcon.modify(T.$Vj.loading,"spin")}),define($e[143],we([1,0,3,4,2,19,142]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aDb=t.$_Cb=void 0;function y(g){const f=new i.$Qc,L=f.add(new T.$Nd),s=(0,w.$8v)();return f.add(s.onDidChange(()=>L.fire())),g&&f.add(g.onDidProductIconThemeChange(()=>L.fire())),{dispose:()=>f.dispose(),onDidChange:L.event,getCSS(){const a=g?g.getProductIconTheme():new c,e={},h=m=>{const n=a.getIcon(m);if(!n)return;const r=n.font;return r?(e[r.id]=r.definition,`.codicon-${m.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,v.$9P)(r.id)}; }`):`.codicon-${m.id}:before { content: '${n.fontCharacter}'; }`},l=[];for(const m of s.getIcons()){const n=h(m);n&&l.push(n)}for(const m in e){const n=e[m],r=n.weight?`font-weight: ${n.weight};`:"",b=n.style?`font-style: ${n.style};`:"",u=n.src.map(o=>`${(0,v.$8P)(o.location)} format('${o.format}')`).join(", ");l.push(`@font-face { src: ${u}; font-family: ${(0,v.$9P)(m)};${r}${b} font-display: block; }`)}return l.join(`
`)}}}t.$_Cb=y;class c{getIcon(f){const L=(0,w.$8v)();let s=f.defaults;for(;U.ThemeIcon.isThemeIcon(s);){const a=L.getIcon(s.id);if(!a)return;s=a.defaults}return s}}t.$aDb=c}),define($e[144],we([1,0,5]),function(le,t,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oC=t.$nC=t.$mC=t.$lC=t.$kC=t.$jC=t.$iC=t.$hC=t.$gC=void 0,t.$gC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function T(L){return typeof L.parentId=="number"}t.$hC=T;function i(L){return!!L.workspaceUri}t.$iC=i;function U(L){return!!L.folderUri}t.$jC=U;function w(L){return!!L.fileUri}t.$kC=w;function y(L){const s=c(L),a=L.getValue("window.menuBarVisibility");return a==="default"||s==="native"&&a==="compact"||v.$k&&v.$n?"classic":a}t.$lC=y;function c(L){if(v.$p)return"custom";const s=L.getValue("window");if(s){if(v.$k&&s.nativeTabs===!0||v.$k&&s.nativeFullScreen===!1)return"native";const h=s.titleBarStyle;if(h==="native"||h==="custom")return h}return v.$l?"native":"custom"}t.$mC=c;function g(L){return!(!v.$j||v.$p||c(L)==="native")}t.$nC=g;function f(L=0){return Math.pow(1.2,L)}t.$oC=f}),define($e[145],we([1,0,17,3,14,31,144]),function(le,t,v,T,i,U,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$g9b=t.$f9b=t.$e9b=void 0;function y(L){for(const{window:s}of(0,T.getWindows)())c(s)?.webFrame?.setZoomLevel(L);(0,v.$xO)((0,w.$oC)(L)),(0,v.$uO)(L)}t.$e9b=y;function c(L){if(L===i.$pO)return{ipcRenderer:U.$N,webFrame:U.$P};{const s=L;if(s?.vscode?.ipcRenderer&&s?.vscode?.webFrame)return s.vscode}}function g(){y((0,v.$vO)()+1)}t.$f9b=g;function f(){y((0,v.$vO)()-1)}t.$g9b=f}),define($e[146],we([1,0,10,3,131,9,132,31,136,137,139,140,143,145,15,14,102,93]),function(le,t,v,T,i,U,w,y,c,g,f,L,s,a,e,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const l=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,m=/\s--inspect-port=(?<port>\d+)/;class n{getHeight(P){return 22}getTemplateId(P){return d(P)?"process":j(P)?"machine":(0,c.$sm)(P)?"error":R(P)?"header":""}}class r{hasChildren(P){return(0,c.$sm)(P)?!1:d(P)?!!P.children?.length:!0}getChildren(P){return d(P)?P.children?P.children:[]:(0,c.$sm)(P)?[]:R(P)?P.processRoots.length>1?P.processRoots:[P.processRoots[0].rootProcess]:j(P)?[P.rootProcess]:[P.processes]}}class b{constructor(){this.templateId="header"}renderTemplate(P){const O=(0,T.$RP)(P,(0,T.$)(".row")),Q=(0,T.$RP)(O,(0,T.$)(".nameLabel")),te=(0,T.$RP)(O,(0,T.$)(".cpu")),re=(0,T.$RP)(O,(0,T.$)(".memory")),fe=(0,T.$RP)(O,(0,T.$)(".pid"));return{name:Q,CPU:te,memory:re,PID:fe}}renderElement(P,O,Q,te){Q.name.textContent=(0,v.localize)(0,null),Q.CPU.textContent=(0,v.localize)(1,null),Q.PID.textContent=(0,v.localize)(2,null),Q.memory.textContent=(0,v.localize)(3,null)}disposeTemplate(P){}}class u{constructor(){this.templateId="machine"}renderTemplate(P){const O=Object.create(null),Q=(0,T.$RP)(P,(0,T.$)(".row"));return O.name=(0,T.$RP)(Q,(0,T.$)(".nameLabel")),O}renderElement(P,O,Q,te){Q.name.textContent=P.element.name}disposeTemplate(P){}}class o{constructor(){this.templateId="error"}renderTemplate(P){const O=Object.create(null),Q=(0,T.$RP)(P,(0,T.$)(".row"));return O.name=(0,T.$RP)(Q,(0,T.$)(".nameLabel")),O}renderElement(P,O,Q,te){Q.name.textContent=P.element.errorMessage}disposeTemplate(P){}}class F{constructor(P,O,Q){this.a=P,this.b=O,this.c=Q,this.templateId="process"}renderTemplate(P){const O=(0,T.$RP)(P,(0,T.$)(".row")),Q=(0,T.$RP)(O,(0,T.$)(".nameLabel")),te=(0,T.$RP)(O,(0,T.$)(".cpu")),re=(0,T.$RP)(O,(0,T.$)(".memory")),fe=(0,T.$RP)(O,(0,T.$)(".pid"));return{name:Q,CPU:te,PID:fe,memory:re}}renderElement(P,O,Q,te){const{element:re}=P,fe=re.pid.toFixed(0);let ie=re.name;this.c.has(re.pid)&&(ie=this.c.get(re.pid)),Q.name.textContent=ie,Q.name.title=re.cmd,Q.CPU.textContent=re.load.toFixed(0),Q.PID.textContent=fe,Q.PID.parentElement.id=`pid-${fe}`;const oe=this.a==="win32"?re.mem:this.b*(re.mem/100);Q.memory.textContent=(oe/g.$Hk.MB).toFixed(0)}disposeTemplate(P){}}function j(X){return!!X.name&&!!X.rootProcess}function R(X){return!!X.processRoots}function d(X){return!!X.pid}class D{constructor(P,O){this.f=O,this.b=new Map;const Q=new f.$$8b(P);this.c=new L.$c9b(P,Q),this.k(O.styles),this.g(O),y.$N.on("vscode:pidToNameResponse",(te,re)=>{this.b=new Map;for(const[fe,ie]of re)this.b.set(fe,ie)}),y.$N.on("vscode:listProcessesResponse",async(te,re)=>{re.forEach((fe,ie)=>{d(fe.rootProcess)&&(fe.rootProcess.name=ie===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:re}}),this.d.layout(h.$pO.innerHeight,h.$pO.innerWidth)):await this.h(re),this.m(0)}),this.a=Date.now(),y.$N.send("vscode:pidToNameRequest"),y.$N.send("vscode:listProcesses")}g(P){document.onkeydown=O=>{const Q=P.platform==="darwin"?O.metaKey:O.ctrlKey;Q&&O.keyCode===87&&(O.stopPropagation(),O.preventDefault(),y.$N.send("vscode:closeProcessExplorer")),Q&&O.keyCode===187&&(0,a.$f9b)(),Q&&O.keyCode===189&&(0,a.$g9b)()}}async h(P){const O=document.getElementById("process-list");if(!O)return;const{totalmem:Q}=await this.c.getOSStatistics(),te=[new F(this.f.platform,Q,this.b),new b,new u,new o];this.d=new i.$aT("processExplorer",O,new n,te,new r,{identityProvider:{getId:re=>d(re)?re.pid.toString():(0,c.$sm)(re)?re.hostName:R(re)?"processes":j(re)?re.name:"header"}}),this.d.setInput({processes:{processRoots:P}}),this.d.layout(h.$pO.innerHeight,h.$pO.innerWidth),this.d.onKeyDown(re=>{const fe=new e.$SO(re);if(fe.keyCode===35&&fe.altKey){const ie=this.n();Promise.all(ie.map(oe=>this.c.killProcess(oe,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(re=>{d(re.element)&&this.l(re.element,!0)}),O.style.height=`${h.$pO.innerHeight}px`,h.$pO.addEventListener("resize",()=>{O.style.height=`${h.$pO.innerHeight}px`,this.d?.layout(h.$pO.innerHeight,h.$pO.innerWidth)})}i(P){const O=l.exec(P);return O&&O.groups.port!=="0"||P.indexOf("node ")>=0||P.indexOf("node.exe")>=0}j(P){const O={type:"node",request:"attach",name:`process ${P.pid}`};let Q=l.exec(P.cmd);Q?O.port=Number(Q.groups.port):O.processId=String(P.pid),Q=m.exec(P.cmd),Q&&(O.port=Number(Q.groups.port)),y.$N.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[O]})}k(P){const O=(0,T.$AP)(),Q=[];P.listFocusBackground&&(Q.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${P.listFocusBackground}; }`),Q.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${P.listFocusBackground}; }`)),P.listFocusForeground&&Q.push(`.monaco-list:focus .monaco-list-row.focused { color: ${P.listFocusForeground}; }`),P.listActiveSelectionBackground&&(Q.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${P.listActiveSelectionBackground}; }`),Q.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${P.listActiveSelectionBackground}; }`)),P.listActiveSelectionForeground&&Q.push(`.monaco-list:focus .monaco-list-row.selected { color: ${P.listActiveSelectionForeground}; }`),P.listHoverBackground&&Q.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${P.listHoverBackground}; }`),P.listHoverForeground&&Q.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${P.listHoverForeground}; }`),P.listFocusOutline&&Q.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${P.listFocusOutline}; outline-offset: -1px; }`),P.listHoverOutline&&Q.push(`.monaco-list-row:hover { outline: 1px dashed ${P.listHoverOutline}; outline-offset: -1px; }`),P.scrollbarShadowColor&&Q.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${P.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${P.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${P.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),P.scrollbarSliderBackgroundColor&&Q.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${P.scrollbarSliderBackgroundColor};
				}
			`),P.scrollbarSliderHoverBackgroundColor&&Q.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${P.scrollbarSliderHoverBackgroundColor};
				}
			`),P.scrollbarSliderActiveBackgroundColor&&Q.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${P.scrollbarSliderActiveBackgroundColor};
				}
			`),O.textContent=Q.join(`
`),P.color&&(document.body.style.color=P.color)}l(P,O){const Q=[],te=Number(P.pid);O&&(Q.push({accelerator:"Alt+E",label:(0,v.localize)(4,null),click:()=>{this.c.killProcess(te,"SIGTERM")}}),Q.push({label:(0,v.localize)(5,null),click:()=>{this.c.killProcess(te,"SIGKILL")}}),Q.push({type:"separator"})),Q.push({label:(0,v.localize)(6,null),click:()=>{const re=this.n();re?.includes(te)||(re.length=0,re.push(te));const fe=re?.map(ie=>document.getElementById(`pid-${ie}`)).filter(ie=>!!ie);if(fe){const ie=fe.map(oe=>oe.innerText).filter(oe=>!!oe);this.c.writeClipboardText(ie.join(`
`))}}}),Q.push({label:(0,v.localize)(7,null),click:()=>{const re=document.getElementById("process-list");re&&this.c.writeClipboardText(re.innerText)}}),P&&O&&this.i(P.cmd)&&(Q.push({type:"separator"}),Q.push({label:(0,v.localize)(8,null),click:()=>{this.j(P)}})),(0,w.$LT)(Q)}m(P){setTimeout(()=>{const O=Date.now(),Q=P+O-this.a;this.a=O,Q>1e3?(y.$N.send("vscode:pidToNameRequest"),y.$N.send("vscode:listProcesses")):this.m(Q)},200)}n(){return this.d?.getSelection()?.map(P=>{if(!(!P||!("pid"in P)))return P.pid}).filter(P=>!!P)}}function B(){const X=(0,T.$AP)();X.id="codiconStyles";const P=(0,s.$_Cb)(void 0);function O(){X.textContent=P.getCSS()}const Q=new U.$7g(O,0);P.onDidChange(()=>Q.schedule()),Q.schedule()}function H(X){const P=X.data.platform==="win32"?"windows":X.data.platform==="linux"?"linux":"mac";document.body.classList.add(P),B(),(0,a.$e9b)(X.data.zoomLevel),new D(X.windowId,X.data)}t.startup=H})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/400eedf5fab7482b58db3ef9d1a66962b2491a0e/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
